"use strict";

/* jshint ignore:start */



/* jshint ignore:end */

define('pilas-engine-bloques/actividades/LaberintoConQueso', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula) {
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Si = _pilasEngineBloquesActividadesBloques['default'].Si;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var IrDerecha = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrDerecha;
  var IrAbajo = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrAbajo;

  var actividadLaberintoConQueso = {
    nombre: 'El alien y las tuercas',
    enunciado: 'Definí un programa para que el alien junte todas las tuercas.',
    consignaInicial: 'Una buena estrategia de resolución de este desafío es la división del procedimiento en sub tareas.',

    escena: LaberintoConQueso, // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,
    procedimientos: [Procedimiento],

    // TODO: aca irian atributos iniciales que se desean para un personaje
    variables: [],

    control: [Repetir, Si],
    expresiones: [],
    acciones: [IrDerecha, IrAbajo],
    sensores: []
  };

  exports['default'] = actividadLaberintoConQueso;
});
define('pilas-engine-bloques/actividades/actividad', ['exports', 'ember', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/lenguaje'], function (exports, _ember, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesLenguaje) {
  var /*Bloque, CambioDeJSDeBlocky,*/VariableGet = /*Accion,
                                                   Sensor*/_pilasEngineBloquesActividadesBloques['default'].VariableGet;
  var VariableSet = _pilasEngineBloquesActividadesBloques['default'].VariableSet;
  var VariableLocalGet = _pilasEngineBloquesActividadesBloques['default'].VariableLocalGet;
  var VariableLocalSet = _pilasEngineBloquesActividadesBloques['default'].VariableLocalSet;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var Funcion = _pilasEngineBloquesActividadesBloques['default'].Funcion;
  var CallNoReturn = _pilasEngineBloquesActividadesBloques['default'].CallNoReturn;
  var CallReturn = _pilasEngineBloquesActividadesBloques['default'].CallReturn;
  var ParamGet = _pilasEngineBloquesActividadesBloques['default'].ParamGet;
  var AlEmpezar = _pilasEngineBloquesActividadesBloques['default'].AlEmpezar;

  /* ============================================== */

  /**
    Modelo de actividad
  **/
  var Actividad = _ember['default'].Object.extend({
    init: function init() {
      var actividad = this.get('actividad');
      this.set('nombre', actividad.nombre);
      this.set('id', actividad.id);
      this.set('enunciado', actividad.enunciado);
      this.set('escena', actividad.escena);
      this.set('puedeComentar', actividad.puedeComentar);
      this.set('puedeDesactivar', actividad.puedeDesactivar);
      this.set('puedeDuplicar', actividad.puedeDuplicar);
      this.set('esDeExploracion', actividad.esDeExploracion);
      this.setColours();
      this.pisar_bloques_blockly();
    },

    /*
      iniciarEscena() {
        var Esc = this.get('escena');
        var esc_instance = new Esc();
        this.set('escena_instanciada', esc_instance);
        pilas.mundo.gestor_escenas.cambiar_escena(esc_instance);
      },
      */

    obtenerLenguaje: function obtenerLenguaje() {
      var act = this.get('actividad');
      var leng = _pilasEngineBloquesActividadesLenguaje['default'].create();

      act.bloques.forEach(function (claseBloque) {
        return leng.agregarBloque(claseBloque);
      });

      return leng.build();
    },

    bloques_iniciales: function bloques_iniciales() {
      return [AlEmpezar];
    },

    crear_bloques_iniciales: function crear_bloques_iniciales() {
      this.bloques_iniciales().forEach(function (b) {
        b.create().instanciar_para_workspace();
      });
    },

    pisar_bloques_blockly: function pisar_bloques_blockly() {
      CallReturn.create().registrar_en_blockly();
      CallNoReturn.create().registrar_en_blockly();
      ParamGet.create().registrar_en_blockly();
      VariableGet.create().registrar_en_blockly();
      VariableSet.create().registrar_en_blockly();
      VariableLocalGet.create().registrar_en_blockly();
      VariableLocalSet.create().registrar_en_blockly();
    },

    usa_procedimientos: function usa_procedimientos() {
      return this.get('actividad').bloques.indexOf(Procedimiento) > -1;
    },

    usa_funciones: function usa_funciones() {
      return this.get('actividad').bloques.indexOf(Funcion) > -1;
    },

    iniciarBlockly: function iniciarBlockly(contenedor) {

      Blockly.inject(contenedor, {
        collapse: false,
        duplicate: this.get('puedeDuplicar'),
        trashOnlyDelete: true,
        disable: this.get('puedeDesactivar'),
        comments: this.get('puedeComentar'),
        defsOnly: true,
        def_procedures: this.usa_procedimientos(),
        def_functions: this.usa_funciones(),
        globalVariables: false,
        oneReturnOnly: true,
        defsNames: ['al_empezar_a_ejecutar', 'procedures_defnoreturn', 'procedures_defreturn'],
        path: './libs/blockly/',
        toolbox: Blockly.Xml.textToDom(this.obtenerLenguaje())
      });

      this.crear_bloques_iniciales();

      var event = new Event('terminaCargaInicial');
      window.dispatchEvent(event);
    },

    generarCodigo: function generarCodigo() {
      // variable global con la que se accede al receptor del programa
      //window.receptor = this.get('escena_instanciada').automata;

      var comienzo = ['var receptor = pilas.escena_actual().automata;                      // generarCodigo()', 'var programa = new pilas.comportamientos.ConstructorDePrograma();   // generarCodigo()', '', ''].join('\n');

      var code = Blockly.JavaScript.workspaceToCode();
      return comienzo + code;
    },

    generarCodigoXML: function generarCodigoXML() {
      var code = Blockly.Xml.workspaceToDom(Blockly.mainWorkspace);
      return code;
    },

    generarCodigoXMLComoString: function generarCodigoXMLComoString() {
      Blockly.JavaScript.INFINITE_LOOP_TRAP = null;
      var codigo = this.generarCodigoXML();

      function xml2string(node) {
        if (typeof XMLSerializer !== 'undefined') {
          var serializer = new XMLSerializer();
          return serializer.serializeToString(node);
        } else if (node.xml) {
          return node.xml;
        }
      }

      return xml2string(codigo);
    },

    cargarCodigoDesdeStringXML: function cargarCodigoDesdeStringXML(codigo) {
      var workspace = Blockly.getMainWorkspace();
      workspace.clear();
      var xml = Blockly.Xml.textToDom(codigo);
      Blockly.Xml.domToWorkspace(workspace, xml);
    },

    debeFelicitarse: function debeFelicitarse() {
      return !this.get('esDeExploracion');
    },

    // Scratch style colours
    setColours: function setColours() {
      /*global goog */
      Blockly.Blocks.primitivas.COLOUR = goog.color.hexToHsv('#4a6cd4');
      Blockly.Blocks.sensores.COLOUR = goog.color.hexToHsv('#2ca5e2');
      Blockly.Blocks.eventos.COLOUR = goog.color.hexToHsv('#00a65a'); // == boton ejecutar
      Blockly.Blocks.math.COLOUR = goog.color.hexToHsv('#49930e');
      Blockly.Blocks.logic.COLOUR = goog.color.hexToHsv('#5cb712');
      Blockly.Blocks.loops.COLOUR = goog.color.hexToHsv('#ee7d16');

      Blockly.Blocks.procedures.COLOUR = goog.color.hexToHsv('#6C52EB');
      //Blockly.Blocks.procedures.vars.COLOUR = '#8a55d7';
      //Blockly.Blocks.procedures.params.COLOUR = '#6C52EB';

      Blockly.Blocks.variables.COLOUR = goog.color.hexToHsv('#cc5b22');

      Blockly.Blocks.texts.COLOUR = goog.color.hexToHsv('#4a6cd4');
      Blockly.Blocks.lists.COLOUR = goog.color.hexToHsv('#cc5b22');
      Blockly.Blocks.colour.COLOUR = goog.color.hexToHsv('#4a6cd4');

      // IN SCRATCH THE COLOURS ARE
      // 4a6cd4 MOTION
      // 8a55d7 LOOKS
      // bb42c3 SOUND
      // 0e9a6c PEN
      // ee7d16 DATA Variables
      // cc5b22 DATA Lists
      // c88330 EVENTS
      // e1a91a CONTROL
      // 2ca5e2 SENSING
      // 5cb712 OPERATORS
      // 49930e OPERATORS dark
      // 632d99 MORE BLOCKS
      // 5e4db3 PARAMS
    },

    obtener_codigo_en_texto: function obtener_codigo_en_texto() {
      var xml = Blockly.Xml.workspaceToDom(Blockly.getMainWorkspace());
      return Blockly.Xml.domToText(xml);
    }

  });

  exports['default'] = Actividad;
});
define('pilas-engine-bloques/actividades/actividadAlien', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula) {
  var AccionBuilder = _pilasEngineBloquesActividadesBloques['default'].AccionBuilder;
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var IrDerecha = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrDerecha;
  var IrIzquierda = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrIzquierda;
  var IrArriba = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrArriba;
  var IrAbajo = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrAbajo;

  var LevantarTuerca = AccionBuilder.build({
    descripcion: 'Levantar tuerca',
    id: 'LevantaTuerca',
    icono: 'tuerca.png',
    comportamiento: 'RecogerPorEtiqueta',
    argumentos: '{etiqueta: "TuercaAnimada", mensajeError: "No hay tuerca aquí", pasos: 50}'
  });

  var actividadAlien = {
    // DEPRECATED: nombre: 'El alien y las tuercas',
    id: 'ElAlienYLasTuercas',
    // DEPRECATED: enunciado: 'Definí un programa para que el alien junte todas las tuercas. Pista: ¿El alien no puede moverse en diagonal? Podés crear tu propio procedimiento para que lo haga',

    // DEPRECATED: escena: AlienLevantaTuercas,
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, Repetir, IrDerecha, IrIzquierda, IrArriba, IrAbajo, LevantarTuerca]
  };

  exports['default'] = actividadAlien;
});
define('pilas-engine-bloques/actividades/actividadAlienTocaBoton', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula) {
  var IrDerecha = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrDerecha;

  var ApretarBoton = _pilasEngineBloquesActividadesBloques.AccionBuilder.build({
    descripcion: 'Apretar botón',
    id: 'ApretarBoton',
    icono: 'iconos.botonRojo.png',
    comportamiento: 'DesencadenarAnimacionSiColisiona',
    argumentos: '{\'animacionColisionado\':\'prendida\',\'nombreAnimacion\':\'apretar\',\'etiqueta\':\'BotonAnimado\',\'mensajeError\': \'No hay un botón aquí\',\'idTransicion\':\'apretarBoton\'}'
  });

  var actividadAlienTocaBoton = {
    nombre: 'El alien toca el botón',
    id: 'AlienTocaBoton',
    enunciado: 'Ayudá a nuestro Alien a presionar el botón de su laboratorio. \n' + 'Pistas: mirá las acciones disponibles. ¡Vas a tener que avanzar varias veces!',

    consignaInicial: 'Los bloques te permiten formar secuencias de acciones para resolver los desafíos que te proponemos en Pilas Bloques.',

    // la escena proviene de ejerciciosPilas
    // DEPRECATED: escena: 'AlienInicial', // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [IrDerecha, ApretarBoton]
  };

  exports['default'] = actividadAlienTocaBoton;
});
define('pilas-engine-bloques/actividades/actividadAlimentandoALosPeces', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula) {
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var AccionBuilder = _pilasEngineBloquesActividadesBloques['default'].AccionBuilder;
  var IrDerecha = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrDerecha;
  var IrIzquierda = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrIzquierda;
  var IrAbajo = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrAbajo;
  var IrArriba = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrArriba;

  var AlimentarPez = AccionBuilder.build({
    descripcion: 'Alimentar pez',
    id: 'AlimentarPez',
    icono: 'icono.pez.png',
    comportamiento: 'RecogerPorEtiqueta',
    argumentos: '{etiqueta: "PezAnimado", idTransicion: "alimentarPez"}'
  });

  var AgarrarComida = AccionBuilder.build({
    descripcion: 'Agarrar comida',
    id: 'AgarrarComida',
    icono: 'icono.alimento_pez.png',
    comportamiento: 'RecogerPorEtiqueta',
    argumentos: '{etiqueta: "AlimentoAnimado", idTransicion: "recogerComida"}'
  });

  var actividadAlimentandoALosPeces = {
    nombre: 'Alimentando a los peces',
    id: 'AlimentandoALosPeces',
    enunciado: 'Nuestro buzo debe alimentar con lombrices a los 7 peces que hay en esta escena. Buscá primero a las lombrices y luego pasá por cada pez alimentándolo. Pista: pensá en una estrategia de 3 partes.',

    // la escena proviene de ejerciciosPilas
    // DEPRECATED: escena: AlimentandoALosPeces,
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, Repetir, IrDerecha, IrIzquierda, IrAbajo, IrArriba, AlimentarPez, AgarrarComida]
  };

  exports['default'] = actividadAlimentandoALosPeces;
});
define('pilas-engine-bloques/actividades/actividadElCangrejoAguafiestas', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula', 'pilas-engine-bloques/actividades/expresiones'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula, _pilasEngineBloquesActividadesExpresiones) {

  var ExplotarGlobo = _pilasEngineBloquesActividadesBloques.AccionBuilder.build({
    id: 'ExplotarGlobo',
    descripcion: 'Explotar globo',
    icono: 'icono.globo.png',
    comportamiento: 'ComportamientoColision',
    argumentos: '{etiqueta:"GloboAnimado", nombreAnimacion:"recoger", idTransicion: "explotar", comportamientoAdicional: Eliminar, argumentosComportamiento: {nombreAnimacion:"explotar"}}'
  });

  exports['default'] = {
    // DEPRECATED: nombre: 'El cangrejo aguafiestas',
    id: 'ElCangrejoAguafiestas',
    // DEPRECATED: enunciado: 'El cangrejo quiere pinchar todos los globos de la fiesta. Tené en cuenta que estos no cambian de lugar. Pista: ¿la cantidad de globos y la dirección podrían ser parámetros?',
    // DEPRECATED: consignaInicial: 'Se pueden combinar parámetros numéricos (cantidades, longitudes) con parámetros de texto (direcciones, nombres).',

    // DEPRECATED: escena: ElCangrejoAguafiestas,
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [_pilasEngineBloquesActividadesBloques.Procedimiento, _pilasEngineBloquesActividadesBloques.Repetir, _pilasEngineBloquesActividadesBloques.Si, _pilasEngineBloquesActividadesBloques.Sino, _pilasEngineBloquesActividadesBloques.Hasta, _pilasEngineBloquesActividadesDireccionesCuadricula.ParaLaDerecha, _pilasEngineBloquesActividadesDireccionesCuadricula.ParaLaIzquierda, _pilasEngineBloquesActividadesDireccionesCuadricula.ParaArriba, _pilasEngineBloquesActividadesDireccionesCuadricula.ParaAbajo, _pilasEngineBloquesActividadesDireccionesCuadricula.MoverA, ExplotarGlobo, _pilasEngineBloquesActividadesExpresiones.Numero, _pilasEngineBloquesActividadesExpresiones.OpAritmetica]
  };
});
define('pilas-engine-bloques/actividades/actividadElDetectiveChaparro', ['exports', 'pilas-engine-bloques/actividades/bloques'], function (exports, _pilasEngineBloquesActividadesBloques) {
  var AccionBuilder = _pilasEngineBloquesActividadesBloques['default'].AccionBuilder;
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Si = _pilasEngineBloquesActividadesBloques['default'].Si;
  var Sino = _pilasEngineBloquesActividadesBloques['default'].Sino;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var Hasta = _pilasEngineBloquesActividadesBloques['default'].Hasta;

  var PrimerSospechoso = AccionBuilder.build({
    id: 'Primersospechoso',
    descripcion: 'Ir al primer sospechoso',
    icono: '../../iconos/izquierda.png',
    comportamiento: 'MoverTodoAIzquierda',
    argumentos: '{}'
  });

  var SiguienteSospechoso = AccionBuilder.build({
    id: 'Siguientesospechoso',
    descripcion: 'Pasar al siguiente sospechoso',
    icono: '../../iconos/derecha.png',
    comportamiento: 'MoverACasillaDerecha',
    argumentos: '{}'
  });

  var SacarDisfraz = AccionBuilder.build({
    descripcion: 'Interrogar sospechoso',
    id: 'Sacardisfraz',
    icono: 'icono.sacar.disfraz.png',
    comportamiento: 'SacarDisfraz',
    argumentos: '{}'
  });

  var EsCulpable = AccionBuilder.buildSensor({
    id: 'Descubralculpable',
    descripcion: 'Estoy frente al culpable',
    icono: 'icono.culpable.png',
    funcionSensor: 'colisionaConElCulpable() && pilas.escena_actual().culpable.teEncontraron()'
  });

  exports['default'] = {
    // DEPRECATED: nombre: 'El detective Chaparro',
    id: 'ElDetectiveChaparro',
    // DEPRECATED: enunciado: 'El detective debe descubrir al culpable de un crimen, quitándole el disfraz que lo camufla. Comenzando por el primero de la izquierda, ¡interrogá a cada uno de los sospechosos hasta encontrar al culpable!',
    // DEPRECATED: consignaInicial: 'El bloque "Repetir hasta que" nos permite terminar el programa cuando encontramos al culpable sin tener que interrogar a todos los sospechosos de la fila.',

    // la escena proviene de ejerciciosPilas
    // DEPRECATED: escena: ElDetectiveChaparro,  // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Repetir, Si, Sino, Hasta, Procedimiento, PrimerSospechoso, SiguienteSospechoso, SacarDisfraz, EsCulpable]
  };
});
define('pilas-engine-bloques/actividades/actividadElGatoEnLaCalle', ['exports', 'pilas-engine-bloques/actividades/bloques'], function (exports, _pilasEngineBloquesActividadesBloques) {
  var AccionBuilder = _pilasEngineBloquesActividadesBloques['default'].AccionBuilder;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;

  var Saludar = AccionBuilder.build({
    descripcion: 'Saludar',
    icono: 'icono.saludar.png',
    comportamiento: 'ComportamientoAnimado',
    argumentos: '{nombreAnimacion: "saludando", idTransicion: "saludar"}'
  });

  var AbrirOjos = AccionBuilder.build({
    descripcion: 'Abrir ojos',
    icono: 'icono.abrirOjos.png',
    comportamiento: 'AnimarSiNoEstoyYa',
    argumentos: '{nombreAnimacion: "abrirOjos", valorEstar: "con los ojos abiertos", descripcionEstar: "estadoOjos", nombreAnimacionSiguiente: "parado", arrancoAsi:true, idTransicion: "abrirOjos"}'
  });

  var CerrarOjos = AccionBuilder.build({
    descripcion: 'Cerrar ojos',
    icono: 'icono.cerrarOjos.png',
    comportamiento: 'AnimarSiNoEstoyYa',
    argumentos: '{nombreAnimacion: "cerrarOjos", valorEstar: "con los ojos cerrados", descripcionEstar: "estadoOjos", nombreAnimacionSiguiente: "ojosCerrados", idTransicion: "cerrarOjos"}'
  });

  var Acostarse = AccionBuilder.build({
    descripcion: 'Acostarse',
    icono: 'icono.acostarse.png',
    comportamiento: 'ModificarRotacionYAltura',
    argumentos: '{alturaIr: -180 ,rotacionIr: 90, nombreAnimacion:"acostado", valorEstar: "acostado", descripcionEstar: "posicionCuerpo", idTransicion: "acostarse"}'
  });

  var Pararse = AccionBuilder.build({
    descripcion: 'Pararse',
    icono: 'icono.pararse.png',
    comportamiento: 'ModificarRotacionYAltura',
    argumentos: '{alturaIr: -150 ,rotacionIr: 0, nombreAnimacion:"acostado", valorEstar: "parado", descripcionEstar: "posicionCuerpo", arrancoAsi:true, idTransicion: "levantarse"}'
  });

  var Volver = AccionBuilder.build({
    descripcion: 'Volver',
    icono: '../../iconos/izquierda.png',
    comportamiento: 'MovimientoAnimado',
    argumentos: '{direccion: new Direct(-1,0), distancia: 50, idTransicion: "volver"}'
  });

  var Avanzar = AccionBuilder.build({
    descripcion: 'Avanzar',
    icono: '../../iconos/derecha.png',
    comportamiento: 'MovimientoAnimado',
    argumentos: '{direccion: new Direct(1,0), distancia: 50, idTransicion: "avanzar"}'
  });

  var Soniar = AccionBuilder.build({
    descripcion: 'Soñar',
    icono: 'icono.soniar.png',
    comportamiento: 'Pensar',
    argumentos: '{mensaje: "ZZzzZzZ...", hayQueAnimar: false, idTransicion: "soniar"}'
  });

  exports['default'] = {
    // DEPRECATED: nombre: 'El gato en la calle',
    id: 'ElGatoEnLaCalle',
    // DEPRECATED: enunciado: 'Hacé que el gato avance un paso, se duerma, se despierte, salude y vuelva a su lugar.',
    // DEPRECATED: consignaInicial: 'Se pueden crear nuevas acciones en Procedimientos definiendo nuevos bloques que incluyan otras acciones.',

    // DEPRECATED: escena: ElGatoEnLaCalle,
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, Saludar, Avanzar, Volver, AbrirOjos, CerrarOjos, Acostarse, Pararse, Soniar]
  };
});
define('pilas-engine-bloques/actividades/actividadElMarcianoEnElDesierto', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula', 'pilas-engine-bloques/actividades/comer'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula, _pilasEngineBloquesActividadesComer) {
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var IrDerecha = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrDerecha;
  var IrIzquierda = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrIzquierda;
  var IrArriba = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrArriba;
  var IrAbajo = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrAbajo;
  var ComerManzana = _pilasEngineBloquesActividadesComer['default'].ComerManzana;

  var actividadElMarcianoEnElDesierto = {
    // DEPRECATED: nombre: 'El marciano en el desierto',
    id: 'ElMarcianoEnElDesierto',
    // DEPRECATED: enunciado: 'El marciano está perdido en el desierto y necesita alimentarse de su comida favorita: ¡las manzanas! Ayudalo a comer las frutas. Pista: Crear un procedimiento (bloque) para cada conjunto de manzanas',
    // DEPRECATED: consignaInicial: 'Hay muchas formas de comer las manzanas. Podés empezar por las de la derecha, ¡o podés empezar por arriba! ¿Se te ocurre otra estrategia? Pensala siempre antes de programar',

    // DEPRECATED: escena: ElMarcianoEnElDesierto,
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Repetir, Procedimiento, IrDerecha, IrIzquierda, IrArriba, IrAbajo, ComerManzana]
  };

  exports['default'] = actividadElMarcianoEnElDesierto;
});
define('pilas-engine-bloques/actividades/actividadElMonoCuentaDeNuevo', ['exports', 'pilas-engine-bloques/actividades/bloquesMonoContando', 'pilas-engine-bloques/actividades/bloques'], function (exports, _pilasEngineBloquesActividadesBloquesMonoContando, _pilasEngineBloquesActividadesBloques) {
  exports['default'] = {
    // DEPRECATED: nombre: 'El mono cuenta de nuevo',
    id: 'ElMonoCuentaDeNuevo',
    // DEPRECATED: enunciado: 'El mono tiene que contar otra vez las frutas, ¡pero ahora no puede verificar si ya llegó al final de una columna! Pista: mirá en la categoría "Variables" si hay algo que te pueda servir.',
    // DEPRECATED: consignaInicial: 'Una variable nos permite guardar información que puede cambiar en cada ejecución del programa, incluso en una misma ejecución. Por ejemplo, el largo de cada columna varía dependiendo en qué columna esté parado el mono.',

    // la escena proviene de ejerciciosPilas
    // DEPRECATED: escena: ElMonoCuentaDeNuevo,  // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [_pilasEngineBloquesActividadesBloques.RepetirVacio, _pilasEngineBloquesActividadesBloquesMonoContando.LargoColumnaActual].concat(_pilasEngineBloquesActividadesBloquesMonoContando.comunes)

  };
});
define('pilas-engine-bloques/actividades/actividadElMonoQueSabeContar', ['exports', 'pilas-engine-bloques/actividades/bloquesMonoContando'], function (exports, _pilasEngineBloquesActividadesBloquesMonoContando) {
  exports['default'] = {
    // DEPRECATED: nombre: 'El mono que sabe contar',
    id: 'ElMonoQueSabeContar',
    // DEPRECATED: enunciado: 'El mono debe recorrer todas las casillas y contar cuántas bananas y manzanas hay en total. Pista: primero pensá cómo contarías si hay una manzana o una banana en una casilla determinada. Luego pensá cómo harías para contar todas las frutas de una sola columna.',
    // DEPRECATED: consignaInicial: 'Subdividir un problema grande en problemas más pequeños ayuda a comprender mejor cada una de las partes que lo componen. Además nos permite concentrarnos en resolver cuestiones más sencillas al problema original.',

    // la escena proviene de ejerciciosPilas
    // DEPRECATED: escena: ElMonoQueSabeContar,  // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: _pilasEngineBloquesActividadesBloquesMonoContando.comunes.concat([_pilasEngineBloquesActividadesBloquesMonoContando.EstoyAlFin])

  };
});
define('pilas-engine-bloques/actividades/actividadElMonoYLasBananas', ['exports', 'pilas-engine-bloques/actividades/bloques'], function (exports, _pilasEngineBloquesActividadesBloques) {
  var AccionBuilder = _pilasEngineBloquesActividadesBloques['default'].AccionBuilder;
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Si = _pilasEngineBloquesActividadesBloques['default'].Si;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;

  var Avanzar = AccionBuilder.build({
    id: 'Avanzar',
    descripcion: 'Mover a la derecha',
    icono: '../../iconos/derecha.png',
    comportamiento: 'MoverACasillaDerecha',
    argumentos: '{velocidad: 25}'
  });

  var ComerBanana = AccionBuilder.build({
    id: 'Comerbanana',
    descripcion: 'Comer banana',
    icono: 'iconos.banana.png',
    comportamiento: 'RecogerPorEtiqueta',
    argumentos: '{etiqueta: "BananaAnimada", nombreAnimacion: "comerBanana" }'
  });

  var TocandoBanana = AccionBuilder.buildSensor({
    id: 'Tocandobanana',
    descripcion: 'Hay banana acá',
    icono: 'iconos.banana.png',
    funcionSensor: 'tocando("BananaAnimada")'
  });

  exports['default'] = {
    // DEPRECATED: nombre: 'El mono y las bananas',
    id: 'ElMonoYLasBananas',
    // DEPRECATED: enunciado:
    //  '¿Podés hacer que el mono avance al casillero de enfrente?'+
    //  ' Si hay una banana debe comérsela. Si no, es feliz con sólo llegar. \n '+
    //  'Ejecutá el programa varias veces para asegurarte que siempre funciona. \n' +
    //  'Pista: mirá la categoría "Sensores" y la categoría "Control".',

    // DEPRECATED: consignaInicial: 'El bloque "Si... Entonces" ejecuta una secuencia de instrucciones solamente cuando la condición es verdadera. Esto se llama "alternativa condicional".',
    // la escena proviene de ejerciciosPilas
    // DEPRECATED: escena: ElMonoYLasBananas,  // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, ComerBanana, Avanzar, TocandoBanana, Repetir, Si]
  };
});
define('pilas-engine-bloques/actividades/actividadElObreroCopado', ['exports', 'pilas-engine-bloques/actividades/bloques'], function (exports, _pilasEngineBloquesActividadesBloques) {
  var AccionBuilder = _pilasEngineBloquesActividadesBloques['default'].AccionBuilder;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;

  var Avanzar = AccionBuilder.build({
    descripcion: 'Avanzar',
    id: 'avanzar',
    icono: 'izquierda.png',
    comportamiento: 'CaminaIzquierda',
    argumentos: '{pasos: 2}'
  });

  var Retroceder = AccionBuilder.build({
    descripcion: 'Retroceder',
    id: 'retroceder',
    icono: 'derecha.png',
    comportamiento: 'CaminaDerecha',
    argumentos: '{pasos: 2}'
  });

  var Martillar = AccionBuilder.build({
    descripcion: 'Martillar',
    id: 'martillar',
    icono: 'martillar.png',
    comportamiento: 'Martillar',
    argumentos: '{veces: 20}'
  });

  var actividadElObreroCopado = {
    nombre: 'El obrero copado',
    id: 'ElObreroCopado',
    enunciado: 'Ayudá a nuestro obrero a martillar un poco por allí.',

    // la escena proviene de ejerciciosPilas
    escena: ElObreroCopado, // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, Avanzar, Retroceder, Martillar]
  };

  exports['default'] = actividadElObreroCopado;
});
define('pilas-engine-bloques/actividades/actividadElPlanetaDeNano', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula', 'pilas-engine-bloques/actividades/expresiones'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula, _pilasEngineBloquesActividadesExpresiones) {

  var ComerBanana = _pilasEngineBloquesActividadesBloques.AccionBuilder.build({
    descripcion: 'Comer banana',
    id: 'ComerBanana',
    icono: 'iconos.banana.png',
    comportamiento: 'RecogerPorEtiqueta',
    argumentos: '{etiqueta:"BananaAnimada"}'
  });

  var VolverAlBordeIzquierdo = _pilasEngineBloquesActividadesBloques.AccionBuilder.build({
    descripcion: 'Volver al borde izquierdo',
    id: 'Volveralbordeizquierdo',
    icono: '../../iconos/izquierda.png',
    comportamiento: 'MoverTodoAIzquierda',
    argumentos: '{}'
  });

  exports['default'] = {
    // DEPRECATED: nombre: 'El planeta de Nano',
    // DEPRECATED: enunciado: 'Ayudá a Nano a recoger todas sus frutas. ¡Cuidado! No se puede bajar... \n ¡Tené en cuenta que el escenario no cambia, las bananas están siempre en las mismas casillas!',
    // DEPRECATED: consignaInicial: 'A los procedimientos se les pueden agregar parámetros para que resulten más generales. Por ejemplo, si creamos los procedimientos "Avanzar 2 casillas", "Avanzar 3 casillas" y "Avanzar 4 casillas", podemos reemplazar a los 3 por un solo procedimiento que reciba como parámetro la cantidad de casillas que queremos avanzar: "Avanzar [cantidad] casillas".',
    id: 'ElPlanetaDeNano',
    // la escena proviene de ejerciciosPilas
    // DEPRECATED: escena: ElPlanetaDeNano, // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    usaParametros: true,
    bloques: [_pilasEngineBloquesActividadesBloques.Procedimiento, _pilasEngineBloquesActividadesDireccionesCuadricula.IrDerecha, _pilasEngineBloquesActividadesDireccionesCuadricula.IrArriba, VolverAlBordeIzquierdo, ComerBanana, _pilasEngineBloquesActividadesBloques.Repetir, _pilasEngineBloquesActividadesBloques.Si, _pilasEngineBloquesActividadesBloques.Sino, _pilasEngineBloquesActividadesBloques.Hasta, _pilasEngineBloquesActividadesExpresiones.Numero]
  };
});
define('pilas-engine-bloques/actividades/actividadElRecolectorDeEstrellas', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula) {
  var AccionBuilder = _pilasEngineBloquesActividadesBloques['default'].AccionBuilder;
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var IrDerecha = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrDerecha;
  var IrArriba = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrArriba;

  var VolverABordeIzquierdo = AccionBuilder.build({
    descripcion: 'Ir al borde izquierdo',
    id: 'VolverABordeIzquierdo',
    icono: '../../iconos/izquierda.png',
    comportamiento: 'MoverTodoAIzquierda',
    argumentos: '{}'
  });

  var TomarEstrella = AccionBuilder.build({
    descripcion: 'Agarrar estrella',
    id: 'TomarEstrella',
    icono: 'icono.estrella.png',
    comportamiento: 'RecogerPorEtiqueta',
    argumentos: '{etiqueta: "EstrellaAnimada", "mensajeError": "Acá no hay una estrella"}'
  });

  var actividadElRecolectorDeEstrellas = {
    // DEPRECATED: nombre: 'El recolector de estrellas',
    id: 'ElRecolectorDeEstrellas',
    // DEPRECATED: enunciado: 'Ayudá a nuestro personaje a recolectar todas las estrellas. Pista: podés hacer un procedimiento que tome una fila de estrellas.',
    // DEPRECATED: consignaInicial: 'Usar muchas veces un procedimiento te ahorra trabajo.',
    // DEPRECATED: escena: ElRecolectorDeEstrellas,
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, Repetir, IrDerecha, IrArriba, VolverABordeIzquierdo, TomarEstrella]
  };

  exports['default'] = actividadElRecolectorDeEstrellas;
});
define('pilas-engine-bloques/actividades/actividadElSuperviaje', ['exports', 'pilas-engine-bloques/actividades/bloques'], function (exports, _pilasEngineBloquesActividadesBloques) {

  var Avanzar1km = _pilasEngineBloquesActividadesBloques.AccionBuilder.build({
    descripcion: 'Avanzar 1 Km',
    icono: '../../iconos/derecha.png',
    comportamiento: 'VolarHeroicamente',
    argumentos: '{}'
  });

  var KmsTotales = _pilasEngineBloquesActividadesBloques.AccionBuilder.buildSensorNumerico({
    id: 'KmsTotales',
    descripcion: 'Kilómetros a recorrer',
    icono: 'icono.kms.png',
    funcionSensor: 'kmsTotales()'
  });

  exports['default'] = {
    // DEPRECATED: nombre: 'El Superviaje',
    id: 'ElSuperviaje',
    // DEPRECATED: enunciado: 'Nuestro superhéroe debe realizar su súper paseo matutino que consiste en recorrer una cierta cantidad de kilómetros que varía día a día (entre 15 y 45 km). ¡Lográ que nuestro súper amigo llegue siempre a destino!',
    // DEPRECATED: consignaInicial: 'Se puede usar un bloque "Repetir" con el valor de una variable. Esto permite repetir una secuencia de código la cantidad de veces que indique la variable.',

    // la escena proviene de ejerciciosPilas
    // DEPRECATED: escena: SuperViaje,  // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [_pilasEngineBloquesActividadesBloques.Procedimiento, KmsTotales, Avanzar1km, _pilasEngineBloquesActividadesBloques.RepetirVacio, _pilasEngineBloquesActividadesBloques.Repetir, _pilasEngineBloquesActividadesBloques.Si, _pilasEngineBloquesActividadesBloques.Sino, _pilasEngineBloquesActividadesBloques.Hasta]
  };
});
define('pilas-engine-bloques/actividades/actividadFutbolRobots', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula) {
  var AccionBuilder = _pilasEngineBloquesActividadesBloques['default'].AccionBuilder;
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Si = _pilasEngineBloquesActividadesBloques['default'].Si;
  var Sino = _pilasEngineBloquesActividadesBloques['default'].Sino;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var Hasta = _pilasEngineBloquesActividadesBloques['default'].Hasta;
  var IrDerecha = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrDerecha;
  var IrIzquierda = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrIzquierda;
  var SiguienteFila = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].SiguienteFila;

  var PatearPelota = AccionBuilder.build({
    id: 'PatearPelota',
    descripcion: 'Patear pelota',
    icono: 'iconos.pelota.png',
    comportamiento: 'DesencadenarComportamientoSiColisiona',
    argumentos: '{"comportamiento":SerPateado, idTransicion:"patear", etiqueta:"PelotaAnimada", argumentosComportamiento: {tiempoEnElAire:25,aceleracion:0.0025,elevacionMaxima:25,gradosDeAumentoStep:-2}}'
  });

  var TocandoInicio = AccionBuilder.buildSensor({
    id: 'tocandoInicio',
    descripcion: 'Estoy al inicio',
    icono: 'iconos.futbolInicio.png',
    funcionSensor: 'tocandoInicio()'
  });

  var TocandoPelota = AccionBuilder.buildSensor({
    id: 'tocandoPelota',
    descripcion: 'Llegué a la pelota',
    icono: 'iconos.pelota.png',
    funcionSensor: 'tocando("PelotaAnimada")'
  });

  exports['default'] = {
    // DEPRECATED: nombre: 'Fútbol para robots',
    id: 'FutbolRobots',
    // DEPRECATED: enunciado: 'Ayudá a nuestro robot futbolista a patear todas las pelotas. ' +
    //  'Recordá siempre que una buena división en procedimientos puede ayudarte a encarar '+
    //  'mejor el problema.',

    // DEPRECATED: consignaInicial: 'El procedimiento que se defina debe considerar el escenario variable y ofrecer una solución con poca cantidad de bloques. Es importante tener en cuenta que la acción se repite varias veces y que la longitud de las filas varía.',

    // la escena proviene de ejerciciosPilas
    // DEPRECATED: escena: FutbolRobots, // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, IrDerecha, IrIzquierda, SiguienteFila, PatearPelota, TocandoInicio, TocandoPelota, Repetir, Si, Sino, Hasta]
  };
});
define('pilas-engine-bloques/actividades/actividadInstalandoJuegos', ['exports', 'pilas-engine-bloques/actividades/bloques'], function (exports, _pilasEngineBloquesActividadesBloques) {
  var AccionBuilder = _pilasEngineBloquesActividadesBloques['default'].AccionBuilder;
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;

  var SiguienteCompu = AccionBuilder.build({
    descripcion: 'Pasar a la siguiente compu',
    id: 'SiguienteCompu',
    icono: '../../iconos/derecha.png',
    comportamiento: 'MoverACasillaDerecha',
    argumentos: '{}'
  });

  var PrenderCompu = AccionBuilder.build({
    descripcion: 'Prender compu',
    id: 'PrenderCompu',
    icono: 'icono.computadora.png',
    comportamiento: 'PrenderCompuParaInstalar',
    argumentos: '{\'etiqueta\' : \'CompuAnimada\',  \'mensajeError\' : \'No hay una compu aqui\', \'idTransicion\' : \'prender\',\'animacionColisionado\' : \'prendida\',\'nombreAnimacion\' : \'escribir\'  }'
  });

  var ApagarCompu = AccionBuilder.build({
    descripcion: 'Apagar compu',
    id: 'ApagarCompu',
    icono: 'icono.computadora.png',
    comportamiento: 'DesencadenarAnimacionSiColisiona',
    argumentos: '{\'etiqueta\' : \'CompuAnimada\',  \'mensajeError\' : \'No hay una compu aqui\', \'idTransicion\' : \'apagar\',\'animacionColisionado\' : \'parado\',\'nombreAnimacion\' : \'escribir\'  }'
  });

  var InstalarJuego = AccionBuilder.build({
    descripcion: 'Instalar juego',
    id: 'InstalarJuego',
    comportamiento: 'DesencadenarAnimacionSiColisiona',
    argumentos: '{\'etiqueta\' : \'CompuAnimada\',  \'mensajeError\' : \'No hay una compu aqui\', \'idTransicion\' : \'instalar\',\'animacionColisionado\' : \'instalado\',\'nombreAnimacion\' : \'escribir\'  }'
  });

  var EscribirC = AccionBuilder.build({
    descripcion: 'Escribir "C"',
    id: 'EscribirC',
    comportamiento: 'EscribirEnCompuAnimada',
    argumentos: '{\'etiqueta\' : \'CompuAnimada\',  \'mensajeError\' : \'No hay una compu aqui\', \'idTransicion\' : \'escribirC\'}'
  });

  var EscribirB = AccionBuilder.build({
    descripcion: 'Escribir "B"',
    id: 'EscribirB',
    comportamiento: 'EscribirEnCompuAnimada',
    argumentos: '{\'etiqueta\' : \'CompuAnimada\',  \'mensajeError\' : \'No hay una compu aqui\', \'idTransicion\' : \'escribirB\'}'
  });

  var EscribirA = AccionBuilder.build({
    descripcion: 'Escribir "A"',
    id: 'EscribirA',
    comportamiento: 'EscribirEnCompuAnimada',
    argumentos: '{\'etiqueta\' : \'CompuAnimada\',  \'mensajeError\' : \'No hay una compu aqui\', \'idTransicion\' : \'escribirA\'}'
  });

  var actividadInstalandoJuegos = {
    // DEPRECATED: nombre: 'Instalando juegos',
    id: 'InstalandoJuegos',
    // DEPRECATED: enunciado: 'Ramiro tiene que instalar un juego en 3 compus para divertirse con sus amigos. Los pasos para instalarlo en cada una son: encenderla, ingresar la contraseña ("ABC"), instalar el juego y apagar la máquina. Pista: aprovechá que en cada compu hay que hacer el mismo trabajo.',

    // la escena proviene de ejerciciosPilas
    // DEPRECATED: escena: InstalandoJuegos, // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, Repetir, SiguienteCompu, PrenderCompu, ApagarCompu, EscribirC, EscribirB, EscribirA, InstalarJuego]
  };

  exports['default'] = actividadInstalandoJuegos;
});
define('pilas-engine-bloques/actividades/actividadLaEleccionDelMono', ['exports', 'pilas-engine-bloques/actividades/bloques'], function (exports, _pilasEngineBloquesActividadesBloques) {
  var AccionBuilder = _pilasEngineBloquesActividadesBloques['default'].AccionBuilder;
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Si = _pilasEngineBloquesActividadesBloques['default'].Si;
  var Sino = _pilasEngineBloquesActividadesBloques['default'].Sino;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;

  var Avanzar = AccionBuilder.build({
    descripcion: 'Mover a la derecha',
    id: 'Avanzar',
    icono: '../../iconos/derecha.png',
    comportamiento: 'MoverACasillaDerecha',
    argumentos: '{}'
  });

  var ComerManzana = AccionBuilder.build({
    descripcion: 'Comer manzana',
    id: 'ComerManzana',
    icono: 'iconos.manzana.png',
    comportamiento: 'RecogerPorEtiqueta',
    argumentos: '{\'etiqueta\' : \'ManzanaAnimada\',  nombreAnimacion: "comerManzana"}'
  });

  var ComerBanana = AccionBuilder.build({
    descripcion: 'Comer banana',
    id: 'ComerBanana',
    icono: 'iconos.banana.png',
    comportamiento: 'RecogerPorEtiqueta',
    argumentos: '{\'etiqueta\' : \'BananaAnimada\',  nombreAnimacion: "comerBanana"}'
  });

  var TocandoManzana = AccionBuilder.buildSensor({
    descripcion: 'Hay una manzana acá',
    id: 'tocandoManzana',
    icono: 'iconos.manzana.png',
    funcionSensor: 'tocando("ManzanaAnimada")'
  });

  var TocandoBanana = AccionBuilder.buildSensor({
    descripcion: 'Hay una banana acá',
    id: 'tocandoBanana',
    icono: 'iconos.banana.png',
    funcionSensor: 'tocando("BananaAnimada")'
  });

  var actividadLaEleccionDelMono = {
    // DEPRECATED: nombre: 'La elección del mono',
    id: 'LaEleccionDelMono',
    // DEPRECATED: enunciado: '¿Podés ayudar nuevamente a nuestro mono? Esta vez tiene '+
    //   'que elegir qué fruta comer. \n'+
    //  'Ejecutá el programa varias veces para asegurarte que siempre funciona. \n' +
    //  'Pista: ésta vez no alcanza con el bloque "Si".',

    // DEPRECATED: consignaInicial: 'Cuando sólo hay 2 opciones, alcanza con hacer una sola pregunta. En esos casos se puede usar el bloque "Si... si no".',

    // la escena proviene de ejerciciosPilas
    // DEPRECATED: escena: LaEleccionDelMono, // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, ComerManzana, ComerBanana, Avanzar, TocandoManzana, TocandoBanana, Repetir, Si, Sino]
  };

  exports['default'] = actividadLaEleccionDelMono;
});
define('pilas-engine-bloques/actividades/actividadLaFiestaDeDracula', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/expresiones'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesExpresiones) {

  var CambiarColor = _pilasEngineBloquesActividadesBloques.AccionBuilder.build({
    descripcion: 'Cambiar color del foco',
    id: 'cambiarColor',
    icono: 'icono.cambiar.color.png',
    comportamiento: 'CambiarColor',
    argumentos: '{}'
  });

  var SiguienteFoco = _pilasEngineBloquesActividadesBloques.AccionBuilder.build({
    descripcion: 'Pasar al siguiente foco',
    id: 'siguienteFoco',
    icono: '../../iconos/derecha.png',
    comportamiento: 'MoverACasillaDerecha',
    argumentos: '{}'
  });

  var EmpezarFiesta = _pilasEngineBloquesActividadesBloques.AccionBuilder.build({
    descripcion: 'Empezar fiesta',
    id: 'empezarFiesta',
    icono: 'icono.empezar.fiesta.png',
    comportamiento: 'EmpezarFiesta',
    argumentos: '{idTransicion:"empezarFiesta"}'
  });

  exports['default'] = {
    // DEPRECATED: nombre: 'La fiesta de Drácula',
    id: 'LaFiestaDeDracula',
    // DEPRECATED: enunciado: 'Para que la fiesta de Drácula comience debemos cambiar el color de las 3 lámparas una cierta cantidad de veces: 5 veces la primera, 8 la segunda y 12 la tercera.',

    // DEPRECATED: escena: LaFiestaDeDracula,
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [_pilasEngineBloquesActividadesBloques.Procedimiento, _pilasEngineBloquesActividadesBloques.Repetir, _pilasEngineBloquesActividadesBloques.Si, _pilasEngineBloquesActividadesBloques.Sino, _pilasEngineBloquesActividadesBloques.Hasta, _pilasEngineBloquesActividadesExpresiones.Numero, _pilasEngineBloquesActividadesExpresiones.OpAritmetica, CambiarColor, SiguienteFoco, EmpezarFiesta]
  };
});
define('pilas-engine-bloques/actividades/actividadLaGranAventuraDelMarEncantado', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula) {
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var AccionBuilder = _pilasEngineBloquesActividadesBloques['default'].AccionBuilder;
  var IrDerecha = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrDerecha;
  var IrIzquierda = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrIzquierda;
  var IrArriba = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrArriba;
  var IrAbajo = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrAbajo;

  var AgarrarLlave = AccionBuilder.build({
    id: 'Agarrarllave',
    descripcion: 'Agarrar la llave',
    icono: 'llave.png',
    comportamiento: 'Sostener',
    argumentos: '{etiqueta:"LlaveAnimado", idTransicion:"agarrarLlave"}'
  });

  var AbrirCofre = AccionBuilder.build({
    id: 'Abrircofre',
    descripcion: 'Abrir el cofre',
    icono: 'icono.cofre.png',
    comportamiento: 'Soltar',
    argumentos: '{etiqueta:"CofreAnimado", queSoltar:"LlaveAnimado", animacionColisionado:"abrir", idTransicion:"abrirCofre"}' });

  //nombreAnimacion:"agarrarSombrero"
  var DarSombrero = AccionBuilder.build({
    id: 'Darsombrero',
    descripcion: 'Dar el sombrero',
    icono: 'icono.sombrero.png',
    comportamiento: 'ComportamientoColision',
    argumentos: '{etiqueta:"MagoAnimado", nombreAnimacion:"cambiarSombreroPorEspada", animacionColisionado:"darEspada", idTransicion:"darSombrero"}'
  });

  var AtacarConEspada = AccionBuilder.build({
    id: 'Atacarconespada',
    descripcion: 'Atacar con la espada',
    icono: 'icono.espada.png',
    comportamiento: 'SecuenciaAnimada',
    argumentos: '{idTransicion: "atacarConEspada", secuencia: [new ComportamientoColision({etiqueta: "CaballeroAnimado", animacionColisionado: "defender", nombreAnimacion:"atacar"}), new Sostener({etiqueta:"Principe"})]}'
  });

  var EscaparEnUnicornio = AccionBuilder.build({
    id: 'Escaparenunicornio',
    descripcion: 'Escapar en unicornio',
    icono: 'icono.unicornio.png',
    comportamiento: 'Escapar',
    argumentos: '{escaparCon: pilas.escena_actual().unicornio}'
  });

  exports['default'] = {
    // DEPRECATED: nombre: 'La gran aventura del mar encantado',
    id: 'LaGranAventuraDelMarEncantado',
    // DEPRECATED: enunciado:  'Ayuda a la heroína a rescatar a su príncipe. Para ello debe superar en orden cada una de las siguientes pruebas:\n' +
    //            '1) Buscar la llave.\n'+
    //            '2) Abrir el cofre con la llave y tomar el sombrero mágico que está dentro.\n'+
    //            '3) Entregarle el sombrero al mago para recibir la espada a cambio.\n'+
    //            '4) Luchar con la espada contra el caballero oscuro.\n'+
    //            '5) Ir con el príncipe hasta el unicornio y escapar.',
    // DEPRECATED: consignaInicial: '',
    // DEPRECATED: escena: LaGranAventuraDelMarEncantado, // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, Repetir, IrDerecha, IrIzquierda, IrArriba, IrAbajo, AgarrarLlave, AbrirCofre, DarSombrero, AtacarConEspada, EscaparEnUnicornio]
  };
});
define('pilas-engine-bloques/actividades/actividadLaberintoConQueso', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula', 'pilas-engine-bloques/actividades/tocando', 'pilas-engine-bloques/actividades/comer'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula, _pilasEngineBloquesActividadesTocando, _pilasEngineBloquesActividadesComer) {
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Si = _pilasEngineBloquesActividadesBloques['default'].Si;
  var Sino = _pilasEngineBloquesActividadesBloques['default'].Sino;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var Hasta = _pilasEngineBloquesActividadesBloques['default'].Hasta;
  var IrDerecha = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrDerecha;
  var IrAbajo = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrAbajo;
  var TocandoAbajo = _pilasEngineBloquesActividadesTocando['default'].TocandoAbajo;
  var TocandoDerecha = _pilasEngineBloquesActividadesTocando['default'].TocandoDerecha;
  var TocandoFinCamino = _pilasEngineBloquesActividadesTocando['default'].TocandoFinCamino;
  var TocandoQueso = _pilasEngineBloquesActividadesTocando['default'].TocandoQueso;
  var ComerQueso = _pilasEngineBloquesActividadesComer['default'].ComerQueso;

  var actividadLaberintoConQueso = {
    // DEPRECATED: nombre: 'Laberinto con queso',
    id: 'LaberintoConQueso',
    // DEPRECATED: enunciado: '¡El ratón está más hambriento que nunca! Guialo por el laberinto para que pueda comer todos los trozos de queso. Pista: antes de empezar, apretá varias veces el botón Ejecutar para conocer cómo varía el escenario.',
    // DEPRECATED: consignaInicial: 'Es importante pensar si en algún momento se cumple la condición del bloque "Repetir hasta qué". Sino, ¡el programa podría no terminar nunca!',

    // la escena proviene de ejerciciosPilas
    // DEPRECATED: escena: LaberintoConQueso, // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, IrDerecha, IrAbajo, ComerQueso, Repetir, Si, Sino, Hasta, TocandoAbajo, TocandoDerecha, TocandoFinCamino, TocandoQueso]
  };

  exports['default'] = actividadLaberintoConQueso;
});
define('pilas-engine-bloques/actividades/actividadLaberintoCorto', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula', 'pilas-engine-bloques/actividades/tocando'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula, _pilasEngineBloquesActividadesTocando) {
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Si = _pilasEngineBloquesActividadesBloques['default'].Si;
  var Sino = _pilasEngineBloquesActividadesBloques['default'].Sino;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var IrDerecha = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrDerecha;
  var IrAbajo = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrAbajo;
  var TocandoAbajo = _pilasEngineBloquesActividadesTocando['default'].TocandoAbajo;
  var TocandoDerecha = _pilasEngineBloquesActividadesTocando['default'].TocandoDerecha;

  var actividadLaberintoCorto = {
    //DEPRECATED: nombre: 'Laberinto corto',
    id: 'LaberintoCorto',
    // DEPRECATED: enunciado: 'Guiá al ratón para llegar a la meta. Para lograrlo, debe avanzar una casilla en la dirección que indica la flecha. Pista: mirá en la categoría "Sensores" qué preguntas podés hacer.',

    // la escena proviene de ejerciciosPilas
    // DEPRECATED: escena: LaberintoCorto, // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, Repetir, Si, Sino, IrDerecha, IrAbajo, TocandoAbajo, TocandoDerecha]
  };

  exports['default'] = actividadLaberintoCorto;
});
define('pilas-engine-bloques/actividades/actividadLaberintoLargo', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula', 'pilas-engine-bloques/actividades/tocando'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula, _pilasEngineBloquesActividadesTocando) {
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Si = _pilasEngineBloquesActividadesBloques['default'].Si;
  var Sino = _pilasEngineBloquesActividadesBloques['default'].Sino;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var IrDerecha = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrDerecha;
  var IrAbajo = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrAbajo;
  var TocandoAbajo = _pilasEngineBloquesActividadesTocando['default'].TocandoAbajo;
  var TocandoDerecha = _pilasEngineBloquesActividadesTocando['default'].TocandoDerecha;

  var actividadLaberintoLargo = {
    // DEPRECATED: nombre: 'Laberinto largo',
    id: 'LaberintoLargo',
    // DEPRECATED: enunciado: 'Ayudá al ratón a salir del laberinto. A diferencia del laberinto anterior, aquí la cantidad de casillas que debe avanzar son muchas. ¿Cuántas? ¿Es siempre la misma? Pista: pensá primero cómo avanzar una sola casilla.',

    // la escena proviene de ejerciciosPilas
    // DEPRECATED: escena: LaberintoLargo, // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, IrDerecha, IrAbajo, Repetir, Si, Sino, TocandoAbajo, TocandoDerecha]
  };

  exports['default'] = actividadLaberintoLargo;
});
define('pilas-engine-bloques/actividades/actividadMariaLaComeSandias', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula) {
  var AccionBuilder = _pilasEngineBloquesActividadesBloques['default'].AccionBuilder;
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var IrDerecha = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrDerecha;
  var IrIzquierda = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrIzquierda;
  var IrArriba = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrArriba;
  var IrAbajo = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrAbajo;

  var MorderSandia = AccionBuilder.build({
    descripcion: 'Morder sandía',
    id: 'MorderSandia',
    icono: 'icono.sandia.png',
    comportamiento: 'RecogerPorEtiqueta',
    argumentos: '{\'etiqueta\':\'SandiaAnimada\', \'mensajeError\': \'Acá no hay una sandia\'}'
  });

  var actividadMariaLaComeSandias = {
    // DEPRECATED: nombre: 'María la come sandías',
    id: 'MariaLaComeSandias',
    // DEPRECATED: enunciado: 'María necesita comer todas las sandías de la cuadrícula. Pensá de qué manera puede hacerlo creando los bloques necesarios. Pista: la forma en que las sandías están distribuidas en la cuadrícula, es clave para crear la menor cantidad de procedimientos.',

    // DEPRECATED: escena: MariaLaComeSandias,
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, Repetir, IrDerecha, IrIzquierda, IrArriba, IrAbajo, MorderSandia]
  };

  exports['default'] = actividadMariaLaComeSandias;
});
define('pilas-engine-bloques/actividades/actividadNoMeCansoDeSaltar', ['exports', 'pilas-engine-bloques/actividades/bloques'], function (exports, _pilasEngineBloquesActividadesBloques) {
  var AccionBuilder = _pilasEngineBloquesActividadesBloques['default'].AccionBuilder;
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;

  var Saltar = AccionBuilder.build({
    descripcion: 'Saltar',
    id: 'saltar1',
    icono: '../../iconos/arriba.png',
    comportamiento: 'SaltarHablando',
    argumentos: '{ velocidad_inicial: 30, alturaDeseada: 150, cantPasos: 20, velocidad:50 }'
  });

  var actividadNoMeCansoDeSaltar = {
    // DEPRECATED: nombre: 'No me canso de saltar',
    id: 'NoMeCansoDeSaltar',
    // DEPRECATED: enunciado: 'Ayudá al gato a quitarse la pereza saltando 30 veces seguidas. Pista: se puede resolver con menos de 30 bloques.',
    // DEPRECATED: consignaInicial: 'El bloque Repetir permite elegir la cantidad de veces que se desea repetir una secuencia de acciones. Esto se llama "Repetición simple".',

    // DEPRECATED: escena: NoMeCansoDeSaltar,
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, Repetir, Saltar]
  };

  exports['default'] = actividadNoMeCansoDeSaltar;
});
define('pilas-engine-bloques/actividades/actividadPrendiendoLasCompus-conParametros', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula', 'pilas-engine-bloques/actividades/expresiones', 'pilas-engine-bloques/actividades/bloquesCompus'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula, _pilasEngineBloquesActividadesExpresiones, _pilasEngineBloquesActividadesBloquesCompus) {
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Si = _pilasEngineBloquesActividadesBloques['default'].Si;
  var Sino = _pilasEngineBloquesActividadesBloques['default'].Sino;
  var Hasta = _pilasEngineBloquesActividadesBloques['default'].Hasta;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  exports['default'] = {
    // DEPRECATED: nombre: 'Prendiendo las compus parametrizado',
    id: 'PrendiendoLasCompusParametrizado',
    // DEPRECATED: enunciado: 'Al igual que antes, debemos prender todas las compus. Pero esta vez tenés que definir un único procedimiento que prenda cualquiera de los lados.',
    // DEPRECATED: consignaInicial: 'Los parámetros pueden ser de texto además de numéricos. Por ejemplo, un parámetro podría ser la dirección en que el autómata debe moverse.',

    // la escena proviene de ejerciciosPilas
    // DEPRECATED: escena: PrendiendoLasCompus,  // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [_pilasEngineBloquesActividadesDireccionesCuadricula.ParaLaDerecha, _pilasEngineBloquesActividadesDireccionesCuadricula.ParaLaIzquierda, _pilasEngineBloquesActividadesDireccionesCuadricula.ParaArriba, _pilasEngineBloquesActividadesDireccionesCuadricula.ParaAbajo, _pilasEngineBloquesActividadesDireccionesCuadricula.MoverA, Procedimiento, Repetir, Si, Sino, Hasta, _pilasEngineBloquesActividadesBloquesCompus.PrenderCompu, _pilasEngineBloquesActividadesBloquesCompus.EstoyEnEsquina, _pilasEngineBloquesActividadesExpresiones.Numero, _pilasEngineBloquesActividadesExpresiones.OpAritmetica]
  };
});
define('pilas-engine-bloques/actividades/actividadPrendiendoLasCompus', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula', 'pilas-engine-bloques/actividades/bloquesCompus'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula, _pilasEngineBloquesActividadesBloquesCompus) {
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Si = _pilasEngineBloquesActividadesBloques['default'].Si;
  var Sino = _pilasEngineBloquesActividadesBloques['default'].Sino;
  var Hasta = _pilasEngineBloquesActividadesBloques['default'].Hasta;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var IrIzquierda = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrIzquierda;
  var IrDerecha = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrDerecha;
  var IrArriba = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrArriba;
  var IrAbajo = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrAbajo;
  exports['default'] = {
    // DEPRECATED: nombre: 'Prendiendo las compus',
    id: 'PrendiendoLasCompus',
    // DEPRECATED: enunciado:
    //  'Debemos prender todas las compus teniendo en cuenta que el ancho y el alto del escenario cambian en cada ejecución. Pista: pensá cómo harías para prender las compus de un solo lado del rectángulo y después repetilo para el resto de los lados.',

    // la escena proviene de ejerciciosPilas
    // DEPRECATED: escena: PrendiendoLasCompus,  // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, Repetir, Si, Sino, Hasta, IrDerecha, IrArriba, IrAbajo, IrIzquierda, _pilasEngineBloquesActividadesBloquesCompus.PrenderCompu, _pilasEngineBloquesActividadesBloquesCompus.EstoyEnEsquina]
  };
});
define('pilas-engine-bloques/actividades/actividadPrendiendoLasFogatas', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula', 'pilas-engine-bloques/actividades/expresiones'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula, _pilasEngineBloquesActividadesExpresiones) {
  var AccionBuilder = _pilasEngineBloquesActividadesBloques['default'].AccionBuilder;
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Si = _pilasEngineBloquesActividadesBloques['default'].Si;
  var Sino = _pilasEngineBloquesActividadesBloques['default'].Sino;
  var Hasta = _pilasEngineBloquesActividadesBloques['default'].Hasta;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var ParaLaDerecha = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].ParaLaDerecha;
  var ParaLaIzquierda = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].ParaLaIzquierda;
  var ParaArriba = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].ParaArriba;
  var ParaAbajo = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].ParaAbajo;
  var IrAbajo = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrAbajo;
  var IrArriba = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrArriba;
  var IrIzquierda = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrIzquierda;
  var IrDerecha = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrDerecha;

  var PrenderFogata = AccionBuilder.build({
    descripcion: 'Prender fogata',
    icono: 'icono.FogataApagada.png',
    comportamiento: 'DesencadenarAnimacionSiColisiona',
    argumentos: '{etiqueta: "FogataAnimada", animacionColisionado: "prendida", nombreAnimacion: "prender" }'
  });

  var TocandoFogata = AccionBuilder.buildSensor({
    id: 'tocandoFogata',
    descripcion: 'Hay fogata acá ',
    icono: 'icono.FogataApagada.png',
    funcionSensor: 'tocando(\'FogataAnimada\')'
  });

  exports['default'] = {
    // DEPRECATED nombre: 'Prendiendo las fogatas',
    id: 'PrendiendoLasFogatas',
    // DEPRECATED enunciado: 'En este caso debemos encender todas las fogatas del cuadrado pero en cada ejecución están distribuidas de una manera diferente. Tené en cuenta que las casillas de la esquina nunca se prenden y que el tamaño del cuadrado no varía de una ejecución a la otra.',

    // la escena proviene de ejerciciosPilas
    // DEPRECATED escena: PrendiendoLasFogatas,  // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, Repetir, Si, Sino, Hasta, TocandoFogata, PrenderFogata, IrAbajo, IrArriba, IrIzquierda, IrDerecha, _pilasEngineBloquesActividadesExpresiones.Numero, _pilasEngineBloquesActividadesExpresiones.OpComparacion, _pilasEngineBloquesActividadesExpresiones.OpAritmetica, ParaLaDerecha, ParaLaIzquierda, ParaArriba, ParaAbajo]
  };
});
define('pilas-engine-bloques/actividades/actividadReparandoLaNave', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula) {
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var AccionBuilder = _pilasEngineBloquesActividadesBloques['default'].AccionBuilder;
  var IrDerecha = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrDerecha;
  var IrIzquierda = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrIzquierda;
  var IrArriba = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrArriba;
  var IrAbajo = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrAbajo;

  var TomarHierro = AccionBuilder.build({
    descripcion: 'Agarrar hierro',
    id: 'TomarHierro',
    icono: 'icono.hierro.png',
    comportamiento: 'Sostener',
    argumentos: '{etiqueta: "HierroAnimado", nombreAnimacion: "recogerHierro"}'
  });

  var TomarCarbon = AccionBuilder.build({
    descripcion: 'Agarrar carbón',
    id: 'TomarCarbon',
    icono: 'icono.carbon.png',
    comportamiento: 'Sostener',
    argumentos: '{etiqueta: "CarbonAnimado", nombreAnimacion: "recogerCarbon"}'
  });

  var Depositar = AccionBuilder.build({
    descripcion: 'Poner en la nave',
    id: 'Depositar',
    comportamiento: 'Soltar',
    argumentos: '{idTransicion: "depositar", etiqueta: "NaveAnimada"}'
  });

  var Escapar = AccionBuilder.build({
    descripcion: 'Escapar',
    id: 'Escapar',
    comportamiento: 'Escapar',
    argumentos: '{receptor: pilas.escena_actual().nave, escaparCon: pilas.escena_actual().automata}'
  });

  var actividadReparandoLaNave = {
    // DEPRECATED: nombre: 'Reparando la nave',
    id: 'ReparandoLaNave',
    // DEPRECATED: enunciado: 'El marciano debe arreglar su nave para poder volver a su hogar. Para lograrlo debe llevar 3 unidades de carbón y 3 de hierro a la nave, pero no puede cargar más de una unidad a la vez.',

    // DEPRECATED: escena: ReparandoLaNave,
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, Repetir, IrDerecha, IrIzquierda, IrArriba, IrAbajo, TomarHierro, TomarCarbon, Depositar, Escapar]
  };

  exports['default'] = actividadReparandoLaNave;
});
define('pilas-engine-bloques/actividades/actividadSalvandoLaNavidad', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula', 'pilas-engine-bloques/actividades/expresiones'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula, _pilasEngineBloquesActividadesExpresiones) {

  var DejarRegalo = _pilasEngineBloquesActividadesBloques.AccionBuilder.build({
    id: 'Dejarregalo',
    descripcion: 'Dejar un regalo',
    icono: 'icono.regalo.png',
    comportamiento: 'Depositar',
    argumentos: '{claseADepositar: RegaloAnimado}'
  });

  exports['default'] = {
    // DEPRECATED: nombre: 'Salvando la Navidad',
    id: 'SalvandoLaNavidad',
    // DEPRECATED: enunciado: 'Ayudá a Papá Noel a dejar un regalo al final de cada fila. ¡Tené en cuenta que el escenario no cambia de una ejecución a la otra! Pista: si tuvieses que elegir un parámetro para tu procedimiento... ¿Cuál eligirías?',

    // la escena proviene de ejerciciosPilas
    // DEPRECATED: escena: SalvandoLaNavidad,  // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [_pilasEngineBloquesActividadesBloques.Procedimiento, _pilasEngineBloquesActividadesBloques.Repetir, _pilasEngineBloquesActividadesBloques.Si, _pilasEngineBloquesActividadesBloques.Sino, _pilasEngineBloquesActividadesBloques.Hasta, _pilasEngineBloquesActividadesDireccionesCuadricula.IrDerecha, DejarRegalo, _pilasEngineBloquesActividadesDireccionesCuadricula.SiguienteFilaTotal, _pilasEngineBloquesActividadesExpresiones.Numero, _pilasEngineBloquesActividadesExpresiones.OpAritmetica]
  };
});
define('pilas-engine-bloques/actividades/actividadSuperTito1', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula', 'pilas-engine-bloques/actividades/bloquesTito'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula, _pilasEngineBloquesActividadesBloquesTito) {
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Si = _pilasEngineBloquesActividadesBloques['default'].Si;
  var Sino = _pilasEngineBloquesActividadesBloques['default'].Sino;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var Hasta = _pilasEngineBloquesActividadesBloques['default'].Hasta;
  var IrAbajo = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrAbajo;
  var EncenderLuz = _pilasEngineBloquesActividadesBloquesTito['default'].EncenderLuz;
  var TocandoFinal = _pilasEngineBloquesActividadesBloquesTito['default'].TocandoFinal;

  var actividadSuperTito1 = {
    // DEPRECATED: nombre: 'Súper Tito 1 ',
    id: 'SuperTito1',
    // DEPRECATED: enunciado: ' Ayudá a Tito a encender las luces. \n ¡Ojo! En todas las celdas hay una luz, pero no sabés cuántas celdas hay en cada ejecución.',
    // DEPRECATED: consignaInicial: 'Hay nuevos bloques que pueden ayudarte a resolver el desafío de manera muy sencilla. ¡Aprovechalos!',

    // DEPRECATED: escena: SuperTito1,  // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, EncenderLuz, IrAbajo, TocandoFinal, Repetir, Si, Sino, Hasta]
  };

  exports['default'] = actividadSuperTito1;
});
define('pilas-engine-bloques/actividades/actividadSuperTito2', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula', 'pilas-engine-bloques/actividades/bloquesTito'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula, _pilasEngineBloquesActividadesBloquesTito) {
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Si = _pilasEngineBloquesActividadesBloques['default'].Si;
  var Sino = _pilasEngineBloquesActividadesBloques['default'].Sino;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var Hasta = _pilasEngineBloquesActividadesBloques['default'].Hasta;
  var IrAbajo = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrAbajo;
  var EncenderLuz = _pilasEngineBloquesActividadesBloquesTito['default'].EncenderLuz;
  var TocandoLuz = _pilasEngineBloquesActividadesBloquesTito['default'].TocandoLuz;
  var TocandoFinal = _pilasEngineBloquesActividadesBloquesTito['default'].TocandoFinal;

  var actividadSuperTito2 = {
    // DEPRECATED: nombre: 'Súper Tito 2',
    id: 'SuperTito2',
    // DEPRECATED: enunciado: 'Súper Tito debe encender todas las luces, pero a diferencia del desafío anterior, hay celdas sin luz. ¿Podrás utilizar el mismo procedimiento que en Súper Tito 1? \n',
    // DEPRECATED: consignaInicial: 'El bloque "repetir hasta que" repite una secuencia de acciones hasta que se cumple una condición. Esto se llama "repetición condicional".',

    // DEPRECATED: escena: SuperTito2,  // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, TocandoFinal, TocandoLuz, EncenderLuz, IrAbajo, Repetir, Si, Sino, Hasta]
  };

  exports['default'] = actividadSuperTito2;
});
define('pilas-engine-bloques/actividades/actividadTitoCuadrado', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula', 'pilas-engine-bloques/actividades/bloquesTito', 'pilas-engine-bloques/actividades/expresiones'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula, _pilasEngineBloquesActividadesBloquesTito, _pilasEngineBloquesActividadesExpresiones) {
  exports['default'] = {
    // DEPRECATED: nombre: 'Tito cuadrado',
    id: 'TitoCuadrado',
    // DEPRECATED: enunciado: 'Tito debe encender todas las luces del cuadrado pero en cada ejecución están distribuidas de una manera diferente. Tené en cuenta que las casillas de la esquina nunca se prenden y que el tamaño del cuadrado no varía de una ejecución a la otra.',

    // DEPRECATED: escena: TitoCuadrado,  // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [_pilasEngineBloquesActividadesDireccionesCuadricula.ParaLaDerecha, _pilasEngineBloquesActividadesDireccionesCuadricula.ParaLaIzquierda, _pilasEngineBloquesActividadesDireccionesCuadricula.ParaArriba, _pilasEngineBloquesActividadesDireccionesCuadricula.ParaAbajo, _pilasEngineBloquesActividadesDireccionesCuadricula.MoverA, _pilasEngineBloquesActividadesBloques.Procedimiento, _pilasEngineBloquesActividadesBloques.Repetir, _pilasEngineBloquesActividadesBloques.Si, _pilasEngineBloquesActividadesBloques.Sino, _pilasEngineBloquesActividadesBloques.Hasta, _pilasEngineBloquesActividadesBloquesTito.TocandoLuz, _pilasEngineBloquesActividadesBloquesTito.EncenderLuz, _pilasEngineBloquesActividadesExpresiones.Numero, _pilasEngineBloquesActividadesExpresiones.OpAritmetica]
  };
});
define('pilas-engine-bloques/actividades/actividadTitoEnciendeLuces', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula', 'pilas-engine-bloques/actividades/bloquesTito'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula, _pilasEngineBloquesActividadesBloquesTito) {
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var IrDerecha = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrDerecha;
  var IrIzquierda = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrIzquierda;
  var IrArriba = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrArriba;
  var IrAbajo = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrAbajo;
  var EncenderLuz = _pilasEngineBloquesActividadesBloquesTito['default'].EncenderLuz;

  var actividadTitoEnciendeLuces = {
    // DEPRECATED: nombre: 'Tito enciende las luces',
    id: 'TitoEnciendeLuces',
    // DEPRECATED: enunciado: 'Ayudá a Tito a encender todas las luces. \n'+
    //  'Pista: creá un procedimiento para prender todas las luces de una diagonal.',
    // DEPRECATED: consignaInicial: 'Se puede crear un procedimiento una vez y usarlo todas las veces que quieras dentro de un programa.',

    // la escena proviene de ejerciciosPilas
    // DEPRECATED: escena: TitoEnciendeLuces,  // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, Repetir, EncenderLuz, IrDerecha, IrArriba, IrAbajo, IrIzquierda]
  };

  exports['default'] = actividadTitoEnciendeLuces;
});
define('pilas-engine-bloques/actividades/actividadTitoRecargado', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula', 'pilas-engine-bloques/actividades/bloquesTito'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula, _pilasEngineBloquesActividadesBloquesTito) {
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Si = _pilasEngineBloquesActividadesBloques['default'].Si;
  var Sino = _pilasEngineBloquesActividadesBloques['default'].Sino;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var IrAbajo = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrAbajo;
  var EncenderLuz = _pilasEngineBloquesActividadesBloquesTito['default'].EncenderLuz;
  var TocandoLuz = _pilasEngineBloquesActividadesBloquesTito['default'].TocandoLuz;

  var actividadTitoRecargado = {
    // DEPRECATED: nombre: 'Tito recargado',
    id: 'TitoRecargado',
    // DEPRECATED: enunciado: 'Tito necesita encender las luces para poder conocer el camino... ¡Pero en cada ejecución cambian de lugar! Podés utlizar los procedimientos y bloques de control.',
    //consignaInicial:'El procedimiento construido debe considerar el escenario y poder responder a cada cambio propuesto.',

    // la escena proviene de ejerciciosPilas
    // DEPRECATED: escena: TitoRecargado,  // jshint ignore:line
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, TocandoLuz, EncenderLuz, IrAbajo, Repetir, Si, Sino]
  };

  exports['default'] = actividadTitoRecargado;
});
define('pilas-engine-bloques/actividades/actividadTresNaranjas', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula', 'pilas-engine-bloques/actividades/comer', 'pilas-engine-bloques/actividades/tocando'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula, _pilasEngineBloquesActividadesComer, _pilasEngineBloquesActividadesTocando) {
  var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
  var Si = _pilasEngineBloquesActividadesBloques['default'].Si;
  var Sino = _pilasEngineBloquesActividadesBloques['default'].Sino;
  var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
  var IrDerecha = _pilasEngineBloquesActividadesDireccionesCuadricula['default'].IrDerecha;
  var ComerNaranja = _pilasEngineBloquesActividadesComer['default'].ComerNaranja;
  var TocandoNaranja = _pilasEngineBloquesActividadesTocando['default'].TocandoNaranja;

  var actividadTresNaranjas = {
    // DEPRECATED: nombre: 'Tres naranjas',
    id: 'TresNaranjas',
    // DEPRECATED: enunciado: 'El alien debe comer todos los gajos de naranja que aparezcan en las casillas violetas. ¡Pero no siempre aparecen en los mismos lugares ni la misma cantidad de naranjas! Pista: pensá primero cómo harías un procedimiento para comer una sola naranja si es que la hay.',

    // DEPRECATED: escena: TresNaranjas,
    puedeComentar: false,
    puedeDesactivar: false,
    puedeDuplicar: false,

    bloques: [Procedimiento, IrDerecha, ComerNaranja, Repetir, Si, Sino, TocandoNaranja]
  };
  exports['default'] = actividadTresNaranjas;
});
define('pilas-engine-bloques/actividades/actividadesDibujandoFiguras', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/expresiones'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesExpresiones) {
    var Accion = _pilasEngineBloquesActividadesBloques['default'].Accion;
    var Repetir = _pilasEngineBloquesActividadesBloques['default'].Repetir;
    var Si = _pilasEngineBloquesActividadesBloques['default'].Si;
    var Sino = _pilasEngineBloquesActividadesBloques['default'].Sino;
    var Hasta = _pilasEngineBloquesActividadesBloques['default'].Hasta;
    var Procedimiento = _pilasEngineBloquesActividadesBloques['default'].Procedimiento;
    var ParamValor = _pilasEngineBloquesActividadesBloques['default'].ParamValor;

    var DibujarLado = Accion.extend({
        init: function init() {
            this._super();
            this.set('id', 'DibujarLado');
        },

        block_init: function block_init(block) {
            this._super(block);
            block.appendValueInput('longitud').setCheck('Number').appendField(this.obtener_icono('../libs/data/icono.DibujarLinea.png')).appendField('Dibujar lado de ');
        },

        nombre_comportamiento: function nombre_comportamiento() {
            return 'DibujarHaciaAdelante';
        },

        argumentos: function argumentos(block) {
            var longitud = Blockly.JavaScript.valueToCode(block, 'longitud', Blockly.JavaScript.ORDER_ATOMIC);
            return '{distancia: (' + longitud + '), voltearAlIrAIzquierda: false}';
        },

        get_parametros: function get_parametros() {
            return [ParamValor.create({
                nombre_param: 'longitud',
                tipo_bloque: 'math_number',
                nombre_valor: 'NUM',
                valor: '100'
            })];
        }
    });

    var GirarGrados = Accion.extend({
        init: function init() {
            this._super();
            this.set('id', 'GirarGrados');
        },

        block_init: function block_init(block) {
            this._super(block);
            block.appendValueInput('grados').setCheck('Number').appendField(this.obtener_icono('../libs/data/icono.Girar.png')).appendField('Girar');
            block.appendDummyInput().appendField('grados');
        },

        nombre_comportamiento: function nombre_comportamiento() {
            return 'Rotar';
        },

        argumentos: function argumentos(block) {
            var grados = Blockly.JavaScript.valueToCode(block, 'grados', Blockly.JavaScript.ORDER_ATOMIC);
            return '{angulo: (-(' + grados + '))}';
        },

        get_parametros: function get_parametros() {
            return [ParamValor.create({
                nombre_param: 'grados',
                tipo_bloque: 'math_number',
                nombre_valor: 'NUM',
                valor: '90'
            })];
        }
    });

    // ---------------------------------------------------------------------------
    var actividadesDibujando = [{
        id: 'DibujandoAlCuadrado'
    }, {
        id: 'DibujandoRayuelaRobotica'
    }, {
        id: 'DibujandoCortoPorLaDiagonal'
    }, {
        id: 'DibujandoMamushkaCuadrada'
    }, {
        id: 'DibujandoEscaleraCuadrada'
    }, {
        id: 'DibujandoHexagono'
    }, {
        id: 'DibujandoPiramideInvertida'
    }, {
        id: 'DibujandoFigurasDentroDeFiguras'
    }, {
        id: 'DibujandoLaCuevaDeEstalagtitas'
    }];

    actividadesDibujando.forEach(function (act) {
        act.puedeComentar = false;
        act.puedeDesactivar = false;
        act.puedeDuplicar = false;
        act.usaParametros = true;
        act.bloques = [Procedimiento, Repetir, Si, Sino, Hasta, DibujarLado, GirarGrados, _pilasEngineBloquesActividadesExpresiones.Numero, _pilasEngineBloquesActividadesExpresiones.OpAritmetica];
    });

    exports['default'] = actividadesDibujando;
});
define('pilas-engine-bloques/actividades/bloque', ['exports', 'ember', 'pilas-engine-bloques/actividades/categorias'], function (exports, _ember, _pilasEngineBloquesActividadesCategorias) {

  Blockly.Blocks.primitivas = {};
  Blockly.Blocks.sensores = {};
  Blockly.Blocks.eventos = {};

  /*
   * Representa un bloque
   * para el lenguaje de la actividad
   */
  var Bloque = _ember['default'].Object.extend({
    init: function init() {
      // espera:
      // + id
      // + categoria
    },

    block_init: function block_init() {
      // abstracta
    },

    /*jshint unused: vars*/
    block_javascript: function block_javascript(block) {
      // abstracta
    },

    registrar_en_blockly: function registrar_en_blockly() {
      this.registrarVista();
      this.registrarGeneracionJS();
    },

    registrarVista: function registrarVista() {
      var myThis = this;
      Blockly.Blocks[this.get('id')] = {
        init: function init() {
          myThis.block_init(this);
        }
      };
    },

    registrarGeneracionJS: function registrarGeneracionJS() {
      var myThis = this;
      Blockly.JavaScript[this.get('id')] = function (block) {
        return myThis.block_javascript(block);
      };
    },

    instanciar_para_workspace: function instanciar_para_workspace() {
      this.registrar_en_blockly();

      var block_dom = Blockly.Xml.textToDom('<xml>' + this.build() + '</xml>');

      Blockly.Xml.domToWorkspace(Blockly.getMainWorkspace(), block_dom);
    },

    // reimplementar si se desean parametros ya aplicados
    get_parametros: function get_parametros() {
      return [];
    },

    obtener_icono: function obtener_icono(nombre) {
      return new Blockly.FieldImage('iconos/' + nombre, 16, 16, '<');
    },

    categoria: function categoria() {
      return this._categoria;
    },

    _categoria: _pilasEngineBloquesActividadesCategorias.Comandos,

    // Escupe el código que va en el toolbox para el bloque
    build: function build() {
      var str_block = '';
      str_block += '<block type="TIPO">'.replace('TIPO', this.get('id'));

      this.get_parametros().forEach(function (item) {
        str_block += item.build();
      });

      str_block += '</block>';
      return str_block;
    }
  });

  Bloque.reopenClass({
    categoria: function categoria() {
      return this.create().categoria();
    }
  });

  exports['default'] = Bloque;
});
define('pilas-engine-bloques/actividades/bloques', ['exports', 'ember', 'pilas-engine-bloques/actividades/bloque', 'pilas-engine-bloques/actividades/categorias'], function (exports, _ember, _pilasEngineBloquesActividadesBloque, _pilasEngineBloquesActividadesCategorias) {

  /*
   * Pide implementar sólo block_javascript
   * Sirve para pisar el JS que produce blockly
   */
  var CambioDeJSDeBlocky = _pilasEngineBloquesActividadesBloque['default'].extend({
    registrar_en_blockly: function registrar_en_blockly() {
      // La vista ya está registrada originalmente por el lenguaje Javascript.
      // Sólo registro la generación diferente de código
      this.registrarGeneracionJS();
    }
  });

  var VariableGet = CambioDeJSDeBlocky.extend({

    _categoria: _pilasEngineBloquesActividadesCategorias.Variables,

    init: function init() {
      this._super();
      this.set('id', 'variables_get');
    },

    block_javascript: function block_javascript(block) {
      // Variable getter.
      var code = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
      return ['receptor.atributo("' + code + '")', Blockly.JavaScript.ORDER_ATOMIC];
    }

  });

  var VariableSet = CambioDeJSDeBlocky.extend({

    _categoria: _pilasEngineBloquesActividadesCategorias.Variables,

    init: function init() {
      this._super();
      this.set('id', 'variables_set');
    },

    block_javascript: function block_javascript(block) {
      // Variable setter.
      var argument0 = Blockly.JavaScript.valueToCode(block, 'VALUE', Blockly.JavaScript.ORDER_ASSIGNMENT) || '0';
      var varName = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
      return 'programa.cambio_atributo("' + varName + '", function(){ return ' + argument0 + '; } );\n';
    }

  });

  /* ============================================== */

  var VariableLocalGet = CambioDeJSDeBlocky.extend({

    _categoria: _pilasEngineBloquesActividadesCategorias.Variables,

    init: function init() {
      this._super();
      this.set('id', 'local_var_get');
    },

    block_javascript: function block_javascript(block) {
      // Variable getter.
      var code = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
      return ['receptor.variable("' + code + '")', Blockly.JavaScript.ORDER_ATOMIC];
    }

  });

  /* ============================================== */

  var VariableLocalSet = CambioDeJSDeBlocky.extend({

    _categoria: _pilasEngineBloquesActividadesCategorias.Variables,

    init: function init() {
      this._super();
      this.set('id', 'local_var_set');
    },

    block_javascript: function block_javascript(block) {
      // Variable setter.
      var argument0 = Blockly.JavaScript.valueToCode(block, 'VALUE', Blockly.JavaScript.ORDER_ASSIGNMENT) || '0';
      var varName = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
      return 'programa.cambio_variable("' + varName + '", function(){ return ' + argument0 + '; } );\n';
    }

  });

  /* ============================================== */

  var Procedimiento = CambioDeJSDeBlocky.extend({

    _categoria: _pilasEngineBloquesActividadesCategorias.MisProcedimientos,

    init: function init() {
      this._super();
      this.set('id', 'procedures_defnoreturn');
    },

    block_javascript: function block_javascript(block) {
      // Define a procedure with a return value.
      var funcName = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('NAME'), Blockly.Procedures.NAME_TYPE);

      var branch = Blockly.JavaScript.statementToCode(block, 'STACK');

      if (Blockly.JavaScript.STATEMENT_PREFIX) {
        branch = Blockly.JavaScript.prefixLines(Blockly.JavaScript.STATEMENT_PREFIX.replace(/%1/g, '\'' + block.id + '\''), Blockly.JavaScript.INDENT) + branch;
      }

      if (Blockly.JavaScript.INFINITE_LOOP_TRAP) {
        branch = Blockly.JavaScript.INFINITE_LOOP_TRAP.replace(/%1/g, '\'' + block.id + '\'') + branch;
      }

      var args = [];
      for (var x = 0; x < block.arguments_.length; x++) {
        args[x] = Blockly.JavaScript.variableDB_.getName(block.arguments_[x], Blockly.Variables.NAME_TYPE);
      }

      //    var code = 'function ' + funcName + '(' + args.join(', ') + ') {\n' +
      //        branch + returnValue + '}';

      var args_string = args.map(function (i) {
        return '"' + i + '"';
      }).join(', ');

      var code = 'programa.empezar_secuencia(); \n' + branch + 'programa.def_proc("' + funcName + '", [' + args_string + ']);\n';

      code = Blockly.JavaScript.scrub_(block, code);
      Blockly.JavaScript.definitions_[funcName] = code;
      return null;
    }

  });

  /* ============================================== */

  var Funcion = CambioDeJSDeBlocky.extend({

    _categoria: _pilasEngineBloquesActividadesCategorias.MisFunciones,

    init: function init() {
      this._super();
      this.set('id', 'procedures_defreturn');
    },

    registrar_en_blockly: function registrar_en_blockly() {
      // pisado porque provisoriamente se
      // usa el que viene con blockly
    }

  });

  /* ============================================== */

  var CallNoReturn = CambioDeJSDeBlocky.extend({

    _categoria: _pilasEngineBloquesActividadesCategorias.MisProcedimientos,

    init: function init() {
      this._super();
      this.set('id', 'procedures_callnoreturn');
    },

    block_javascript: function block_javascript(block) {
      // Call a procedure with no return value.
      var funcName = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('NAME'), Blockly.Procedures.NAME_TYPE);
      var args = [];
      for (var x = 0; x < block.arguments_.length; x++) {
        args[x] = Blockly.JavaScript.valueToCode(block, 'ARG' + x, Blockly.JavaScript.ORDER_COMMA) || 'null';
        args[x] = 'function(){ return ' + args[x] + '; }';
      }
      function juntar_args() {
        if (args.length > 0) {
          return '[\n' + args.join(', \n') + '\n]';
        } else {
          return '[]';
        }
      }
      // var code = funcName + '(' + args.join(', ') + ');\n';
      var code = 'programa.llamada_proc("' + funcName + '", ' + juntar_args() + ');\n';
      return code;
    }

  });

  /* ============================================== */

  var CallReturn = CambioDeJSDeBlocky.extend({

    _categoria: _pilasEngineBloquesActividadesCategorias.MisFunciones,

    init: function init() {
      this._super();
      this.set('id', 'procedures_callreturn');
    },

    block_javascript: function block_javascript(block) {
      // Call a procedure with a return value.
      var funcName = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('NAME'), Blockly.Procedures.NAME_TYPE);
      var args = [];
      for (var x = 0; x < block.arguments_.length; x++) {
        args[x] = Blockly.JavaScript.valueToCode(block, 'ARG' + x, Blockly.JavaScript.ORDER_COMMA) || 'null';
        args[x] = 'function(){ return ' + args[x] + '; }';
      }
      var code = funcName + '(' + args.join(', ') + ')';
      return [code, Blockly.JavaScript.ORDER_FUNCTION_CALL];
    }

  });

  /* ============================================== */

  var ParamGet = CambioDeJSDeBlocky.extend({

    _categoria: _pilasEngineBloquesActividadesCategorias.MisProcedimientos,

    init: function init() {
      this._super();
      this.set('id', 'param_get');
    },

    block_javascript: function block_javascript(block) {
      // Variable getter.
      var code = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);

      // agrego parentesis para llamar al closure del parametro
      return ['receptor.parametro("' + code + '")', Blockly.JavaScript.ORDER_ATOMIC];
    }

  });

  /* ============================================== */

  var AlEmpezar = _pilasEngineBloquesActividadesBloque['default'].extend({

    init: function init() {
      this._super();
      this.set('id', 'al_empezar_a_ejecutar');
    },

    block_init: function block_init(block) {
      block.setColour(Blockly.Blocks.eventos.COLOUR);
      block.appendDummyInput().appendField('Al empezar a ejecutar');
      block.appendStatementInput('program');
      block.setDeletable(false);
      block.setEditable(false);
      block.setMovable(false);
    },

    block_javascript: function block_javascript(block) {
      var statements_program = Blockly.JavaScript.statementToCode(block, 'program');
      var r = 'programa.empezar_secuencia();\n';
      r += statements_program + '\n\n';

      r += "\n";
      r += "// CIERRE DEL PROGRAMA \n";
      r += "\n";

      r += 'var ComportamientoFinalizar = (function () { \n';
      r += "\n";
      r += '  function Comportamiento(argumentos) { \n';
      r += '    this.argumentos = argumentos; \n';
      r += '  } \n';
      r += "\n";
      r += '  Comportamiento.prototype.iniciar = function (receptor) { \n';
      r += '    this.receptor = receptor; \n';
      r += '  }; \n';
      r += "\n";
      r += '  Comportamiento.prototype.actualizar = function () { \n';
      r += '    var mensaje = { \n';
      r += '       tipo: "terminaEjecucion",\n';
      r += '       detalles: null\n';
      r += '    };\n';
      r += '    parent.postMessage(mensaje, window.location.origin); \n';
      r += '    return true; \n';
      r += '  }; \n';
      r += "\n";
      r += '  return Comportamiento; \n';
      r += "\n";
      r += '})(); \n';

      r += "\n";
      r += 'programa.hacer(ComportamientoFinalizar, {});\n';
      r += 'programa.ejecutar(receptor);\n';
      return r;
    }

  });

  var Accion = _pilasEngineBloquesActividadesBloque['default'].extend({

    block_init: function block_init(block) {
      this._super(block);
      block.setColour(Blockly.Blocks.primitivas.COLOUR);
      block.setPreviousStatement(true);
      block.setNextStatement(true);
    },

    block_javascript: function block_javascript(block) {
      var nombre = this.nombre_comportamiento();
      var argumentos = this.argumentos(block);

      return ['', '', '// BLOQUE: ' + nombre, 'programa.llamada_proc_primitivo(' + nombre + ', function() {', '  return ' + argumentos + ';', '});'].join("\n");

      /*
      return 'programa.llamada_proc_primitivo(' + this.nombre_comportamiento() +
      ', function(){\n return ' + this.argumentos(block) + ';\n})\n';
      */
    }

  });

  var Sensor = _pilasEngineBloquesActividadesBloque['default'].extend({

    _categoria: _pilasEngineBloquesActividadesCategorias.Sensores,

    block_init: function block_init(block) {
      this._super(block);
      block.setColour(Blockly.Blocks.sensores.COLOUR);
      block.setInputsInline(true);
      block.setOutput(true);
    },

    block_javascript: function block_javascript() /*block*/{
      return ['receptor.' + this.nombre_sensor() + '\n', Blockly.JavaScript.ORDER_ATOMIC];
    }
  });

  // Crea una accion a partir de una descripcion, un icono, comportamiento y argumentos
  // Como la mayoría de los bloques siempre son así, primero un ícono y luego una descripción,
  // Esto me permite rápidamente crear una accion, es casi como un DSL para hacerlo
  var AccionBuilder = {
    build: function build(opciones) {
      return Accion.extend({
        init: function init() {
          this._super();
          this.set('id', opciones.id || this.toID(opciones.descripcion));
        },

        block_init: function block_init(block) {
          this._super(block);
          block = block.appendDummyInput();
          if (opciones.icono !== undefined) {
            block = block.appendField(this.obtener_icono('../libs/data/' + opciones.icono));
          }
          block = block.appendField(opciones.descripcion);
        },

        nombre_comportamiento: function nombre_comportamiento() {
          return opciones.comportamiento;
        },

        argumentos: function argumentos(block) {
          //jshint unused:vars
          return opciones.argumentos;
        },

        toID: function toID(descripcion) {
          return descripcion.replace(/[^a-zA-z]/g, "");
        }

      });
    },

    // TODO: Quitar código repetido con build
    buildSensor: function buildSensor(opciones) {
      return Sensor.extend({
        init: function init() {
          this._super();
          this.set('id', opciones.id || this.toID(opciones.descripcion));
        },

        block_init: function block_init(block) {
          this._super(block);
          block.appendDummyInput().appendField('¿' + opciones.descripcion).appendField(this.obtener_icono('../libs/data/' + opciones.icono)).appendField('?');
        },

        nombre_sensor: function nombre_sensor() {
          return opciones.funcionSensor;
        },

        toID: function toID(descripcion) {
          return descripcion.replace(/[^a-zA-z]/g, "");
        }
      });
    },

    buildSensorNumerico: function buildSensorNumerico(opciones) {
      return Sensor.extend({
        init: function init() {
          this._super();
          this.set('id', opciones.id || this.toID(opciones.descripcion));
        },

        block_init: function block_init(block) {
          this._super(block);
          block.appendDummyInput().appendField(this.obtener_icono('../libs/data/' + opciones.icono)).appendField(opciones.descripcion);
        },

        nombre_sensor: function nombre_sensor() {
          return opciones.funcionSensor;
        },

        toID: function toID(descripcion) {
          return descripcion.replace(/[^a-zA-z]/g, "");
        }
      });
    },

    // TODO: Quitar código repetido con build
    buildValor: function buildValor(opciones) {
      return _pilasEngineBloquesActividadesBloque['default'].extend({
        _categoria: _pilasEngineBloquesActividadesCategorias.Valores,
        init: function init() {
          this._super();
          this.set('id', opciones.id);
        },

        block_init: function block_init(block) {
          this._super(block);

          block.setColour(Blockly.Blocks.sensores.COLOUR);
          block.setInputsInline(true);
          block.setOutput(true);

          block.appendDummyInput().appendField(this.obtener_icono('../libs/data/' + opciones.icono)).appendField(opciones.descripcion);
        },

        block_javascript: function block_javascript() {
          return [opciones.valor, Blockly.JavaScript.ORDER_ATOMIC];
        }
      });
    }
  };

  /*
   * Representa un valor mas complejo
   * de un campo de un bloque
   */
  var ParamValor = _ember['default'].Object.extend({
    build: function build() {
      var str_block = '';
      str_block += '<value name="NOMBRE">'.replace('NOMBRE', this.get('nombre_param'));

      str_block += '<block type="TIPO">'.replace('TIPO', this.get('tipo_bloque'));

      str_block += '<field name="TIPO">'.replace('TIPO', this.get('nombre_valor'));
      str_block += this.get('valor');
      str_block += '</field>';

      str_block += '</block>';

      str_block += '</value>';

      return str_block;
    }
  });

  var ParamCampo = _ember['default'].Object.extend({
    build: function build() {
      var str_block = '';
      str_block += '<field name="NOMBRE">'.replace('NOMBRE', this.get('nombre_valor'));
      str_block += this.get('valor');
      str_block += '</field>';
      return str_block;
    }
  });

  /* ============================================== */

  var EstructuraDeControl = _pilasEngineBloquesActividadesBloque['default'].extend({
    block_init: function block_init(block) {
      this._super(block);
      block.setColour(Blockly.Blocks.loops.COLOUR);
      block.setInputsInline(true);
      block.setPreviousStatement(true);
      block.setNextStatement(true);
    }

  });

  /* ============================================== */

  var Repetir = EstructuraDeControl.extend({

    _categoria: _pilasEngineBloquesActividadesCategorias.Repeticiones,

    init: function init() {
      this._super();
      this.set('id', 'repetir');
    },

    block_init: function block_init(block) {
      this._super(block);
      block.appendValueInput('count').setCheck('Number').appendField('Repetir');
      block.appendStatementInput('block');
    },

    block_javascript: function block_javascript(block) {
      var value_count = Blockly.JavaScript.valueToCode(block, 'count', Blockly.JavaScript.ORDER_ATOMIC) || '0';
      var statements_block = Blockly.JavaScript.statementToCode(block, 'block');
      var r = 'programa.empezar_secuencia();\n';
      r += statements_block;
      r += 'programa.repetirN(function(){\nreturn {{n}};\n});\n'.replace('{{n}}', value_count);
      return r;
    },

    get_parametros: function get_parametros() {
      return [ParamValor.create({
        nombre_param: 'count',
        tipo_bloque: 'math_number',
        nombre_valor: 'NUM',
        valor: '10'
      })];
    }

  });

  var RepetirVacio = Repetir.extend({
    get_parametros: function get_parametros() {
      return [];
    }
  });

  var Si = EstructuraDeControl.extend({

    _categoria: _pilasEngineBloquesActividadesCategorias.Alternativas,

    init: function init() {
      this._super();
      this.set('id', 'si');
    },

    block_init: function block_init(block) {
      this._super(block);
      block.appendValueInput('condition').setCheck('Boolean').appendField('Si');
      block.appendStatementInput('block');
    },

    block_javascript: function block_javascript(block) {
      var value_condition = Blockly.JavaScript.valueToCode(block, 'condition', Blockly.JavaScript.ORDER_ATOMIC) || 'false';
      var statements_block = Blockly.JavaScript.statementToCode(block, 'block');
      var r = 'programa.empezar_secuencia();\n';
      r += statements_block;
      r += 'programa.alternativa_si(function(){\nreturn {{condition}};\n});\n'.replace('{{condition}}', value_condition);
      return r;
    }

  });

  /* ============================================== */

  var Sino = EstructuraDeControl.extend({

    _categoria: _pilasEngineBloquesActividadesCategorias.Alternativas,

    init: function init() {
      this._super();
      this.set('id', 'sino');
    },

    block_init: function block_init(block) {
      this._super(block);
      block.appendValueInput('condition').setCheck('Boolean').appendField('Si');
      block.appendStatementInput('block1');
      block.appendDummyInput().appendField('si no');
      block.appendStatementInput('block2');
    },

    block_javascript: function block_javascript(block) {
      var value_condition = Blockly.JavaScript.valueToCode(block, 'condition', Blockly.JavaScript.ORDER_ATOMIC) || 'false';
      var statements_block1 = Blockly.JavaScript.statementToCode(block, 'block1');
      var statements_block2 = Blockly.JavaScript.statementToCode(block, 'block2');
      var r = 'programa.empezar_secuencia();\n';
      r += statements_block1;
      r += 'programa.empezar_secuencia();\n';
      r += statements_block2;
      r += 'programa.alternativa_sino(function(){\nreturn {{condition}};\n});\n'.replace('{{condition}}', value_condition);
      return r;
    }

  });

  var Hasta = EstructuraDeControl.extend({

    _categoria: _pilasEngineBloquesActividadesCategorias.Repeticiones,

    init: function init() {
      this._super();
      this.set('id', 'hasta');
    },

    block_init: function block_init(block) {
      this._super(block);
      block.appendValueInput('condition').setCheck('Boolean').appendField('Repetir hasta que');
      block.appendStatementInput('block');
    },

    block_javascript: function block_javascript(block) {
      var value_condition = Blockly.JavaScript.valueToCode(block, 'condition', Blockly.JavaScript.ORDER_ATOMIC) || 'true';
      var statements_block = Blockly.JavaScript.statementToCode(block, 'block');
      var r = 'programa.empezar_secuencia();\n';
      r += statements_block;
      r += 'programa.repetir_hasta(function(){\nreturn {{condition}};\n});\n'.replace('{{condition}}', value_condition);
      return r;
    }

  });

  exports.Bloque = _pilasEngineBloquesActividadesBloque['default'];
  exports.CambioDeJSDeBlocky = CambioDeJSDeBlocky;
  exports.VariableGet = VariableGet;
  exports.VariableSet = VariableSet;
  exports.VariableLocalGet = VariableLocalGet;
  exports.VariableLocalSet = VariableLocalSet;
  exports.Procedimiento = Procedimiento;
  exports.Funcion = Funcion;
  exports.CallNoReturn = CallNoReturn;
  exports.CallReturn = CallReturn;
  exports.ParamGet = ParamGet;
  exports.AlEmpezar = AlEmpezar;
  exports.Accion = Accion;
  exports.AccionBuilder = AccionBuilder;
  exports.Sensor = Sensor;
  exports.Repetir = Repetir;
  exports.RepetirVacio = RepetirVacio;
  exports.Si = Si;
  exports.Sino = Sino;
  exports.Hasta = Hasta;
  exports.ParamCampo = ParamCampo;
  exports.ParamValor = ParamValor;
});
define('pilas-engine-bloques/actividades/bloquesCompus', ['exports', 'pilas-engine-bloques/actividades/bloques'], function (exports, _pilasEngineBloquesActividadesBloques) {

  var PrenderCompu = _pilasEngineBloquesActividadesBloques.AccionBuilder.build({
    descripcion: 'Prender compu',
    icono: 'icono.computadora.png',
    comportamiento: 'DesencadenarAnimacionSiColisiona',
    argumentos: '{etiqueta:"CompuAnimada", animacionColisionado:"prendida", nombreAnimacion: "escribir" }'
  });

  var EstoyEnEsquina = _pilasEngineBloquesActividadesBloques.AccionBuilder.buildSensor({
    descripcion: 'Estoy en una esquina',
    icono: 'casilla.prendiendoLasCompus2.png',
    funcionSensor: 'casillaActual().esEsquina()'
  });

  exports.PrenderCompu = PrenderCompu;
  exports.EstoyEnEsquina = EstoyEnEsquina;
});
define('pilas-engine-bloques/actividades/bloquesMonoContando', ['exports', 'pilas-engine-bloques/actividades/bloques', 'pilas-engine-bloques/actividades/direccionesCuadricula', 'pilas-engine-bloques/actividades/tocando', 'pilas-engine-bloques/actividades/contando'], function (exports, _pilasEngineBloquesActividadesBloques, _pilasEngineBloquesActividadesDireccionesCuadricula, _pilasEngineBloquesActividadesTocando, _pilasEngineBloquesActividadesContando) {

  var LargoColumnaActual = _pilasEngineBloquesActividadesBloques.AccionBuilder.buildSensorNumerico({
    id: 'LargoColumnaActual',
    descripcion: 'Largo de la columna actual',
    icono: 'icono.largoCol.png',
    funcionSensor: 'largoColumnaActual()-1'
  });

  var EstoyAlInicio = _pilasEngineBloquesActividadesBloques.AccionBuilder.buildSensor({
    id: 'estoyInicio',
    descripcion: 'Estoy al inicio de la columna',
    icono: 'casillainiciomono.png',
    funcionSensor: 'casillaActual().esInicio()'
  });

  var EstoyAlFin = _pilasEngineBloquesActividadesBloques.AccionBuilder.buildSensor({
    id: 'estoyFinColumna',
    descripcion: 'Estoy al final de la columna',
    icono: 'casillafinalmono.png',
    funcionSensor: 'casillaActual().esFin()'
  });

  var comunes = [_pilasEngineBloquesActividadesBloques.Procedimiento, _pilasEngineBloquesActividadesDireccionesCuadricula.IrArriba, _pilasEngineBloquesActividadesDireccionesCuadricula.IrAbajo, _pilasEngineBloquesActividadesDireccionesCuadricula.SiguienteColumna, _pilasEngineBloquesActividadesContando.ContarBanana, _pilasEngineBloquesActividadesContando.ContarManzana, _pilasEngineBloquesActividadesTocando.TocandoBanana, _pilasEngineBloquesActividadesTocando.TocandoManzana, _pilasEngineBloquesActividadesBloques.Repetir, _pilasEngineBloquesActividadesBloques.Si, _pilasEngineBloquesActividadesBloques.Sino, _pilasEngineBloquesActividadesBloques.Hasta, EstoyAlInicio];

  exports.comunes = comunes;
  exports.EstoyAlFin = EstoyAlFin;
  exports.LargoColumnaActual = LargoColumnaActual;
});
define('pilas-engine-bloques/actividades/bloquesTito', ['exports', 'pilas-engine-bloques/actividades/bloques'], function (exports, _pilasEngineBloquesActividadesBloques) {
  var AccionBuilder = _pilasEngineBloquesActividadesBloques['default'].AccionBuilder;

  var EncenderLuz = AccionBuilder.build({
    descripcion: 'Prender la luz',
    id: 'EncenderLuz',
    icono: 'icono.Lamparita.png',
    comportamiento: 'EncenderPorEtiqueta',
    argumentos: "{'etiqueta':'Luz'}"
  });

  var TocandoLuz = AccionBuilder.buildSensor({
    descripcion: 'Hay lamparita acá',
    id: 'tocandoLuz',
    icono: 'icono.LamparitaApagada.png',
    funcionSensor: 'tocando("Lamparin")'
  });

  var TocandoFinal = AccionBuilder.buildSensor({
    descripcion: 'Llegué al final',
    id: 'tocandoFinal',
    icono: 'casilla.titoFinalizacion.png',
    funcionSensor: 'estoyUltimaFila()'
  });

  exports.EncenderLuz = EncenderLuz;
  exports.TocandoLuz = TocandoLuz;
  exports.TocandoFinal = TocandoFinal;
});
define('pilas-engine-bloques/actividades/categorias', ['exports'], function (exports) {
  var Categoria = function Categoria(nombre) {
    this.nombre = nombre;
  };
  Categoria.prototype = {
    generarXML: function generarXML(bloques) {
      var _this = this;

      var misBloques = bloques.filter(function (b) {
        return b.categoria() === _this;
      });
      if (misBloques.length > 0) {
        return this.doGenerarXML(misBloques);
      }

      return '';
    },

    doGenerarXML: function doGenerarXML(bloques) {
      //Template method
      var str_category = ('<category name="x" ' + this.atributosExtra() + '>\n').replace('x', this.nombre);
      bloques.forEach(function (b) {
        return str_category += b.build();
      });
      return str_category + '</category>\n';
    },

    atributosExtra: function atributosExtra() {
      return '';
    }
  };

  var Comandos = new Categoria('Primitivas');

  var MisProcedimientos = new Categoria('Mis procedimientos');
  MisProcedimientos.atributosExtra = function () {
    return 'custom="PROCEDURE"';
  };

  var Repeticiones = new Categoria('Repeticiones');

  var Alternativas = new Categoria('Alternativas');

  var Variables = new Categoria('Variables');
  /* TODO: Desactivado porque blockly trata diferente a estas cosas,
    y no puedo meter variables ya creadas, con sólo sus getters.
    Esto está en blockly/core/variables.js en Blockly.Variables.flyoutCategory
  Variables.atributosExtra = function(){
      return 'custom="VARIABLE"';
  };
  */
  var Sensores = new Categoria('Sensores');

  var Operadores = new Categoria('Operadores');

  var Valores = new Categoria('Valores');

  var MisFunciones = new Categoria('Mis funciones');

  var Separador = new Categoria('Separador');
  Separador.generarXML = function (bloques) {
    // jshint ignore: line
    return '<sep></sep>';
  };

  // TODO: repite código con Categoria
  var Titulo = function Titulo(titulo, categorias) {
    var cat = new Categoria(titulo);
    cat.generarXML = function (bloques) {
      // jshint ignore: line
      var str_category = '<category name="x" expanded="true">\n'.replace('x', this.nombre);
      var sinCategorias = str_category;
      categorias.forEach(function (c) {
        return str_category += c.generarXML(bloques);
      });
      // si no se agregaron categorías, no genero nada:
      return sinCategorias !== str_category ? str_category + '</category>\n' : '';
    };
    return cat;
  };

  exports.Comandos = Comandos;
  exports.MisProcedimientos = MisProcedimientos;
  exports.Repeticiones = Repeticiones;
  exports.Alternativas = Alternativas;
  exports.Separador = Separador;
  exports.Variables = Variables;
  exports.Valores = Valores;
  exports.Sensores = Sensores;
  exports.Operadores = Operadores;
  exports.MisFunciones = MisFunciones;
  exports.Titulo = Titulo;
});
define('pilas-engine-bloques/actividades/comer', ['exports', 'pilas-engine-bloques/actividades/bloques'], function (exports, _pilasEngineBloquesActividadesBloques) {
  var AccionBuilder = _pilasEngineBloquesActividadesBloques['default'].AccionBuilder;

  var ComerBanana = AccionBuilder.build({
    descripcion: 'Comer banana',
    id: 'ComerBanana',
    icono: 'iconos.banana.png',
    comportamiento: 'RecogerPorEtiqueta',
    argumentos: '{\'etiqueta\' : \'BananaAnimada\',  nombreAnimacion: "comerBanana"}'
  });

  var ComerManzana = AccionBuilder.build({
    descripcion: 'Comer manzana',
    id: 'ComerManzana',
    icono: 'iconos.manzana.png',
    comportamiento: 'RecogerPorEtiqueta',
    argumentos: '{\'etiqueta\' : \'ManzanaAnimada\',  nombreAnimacion: "comerManzana"}'
  });

  var ComerQueso = AccionBuilder.build({
    descripcion: 'Comer queso',
    id: 'ComerQueso',
    icono: 'queso.png',
    comportamiento: 'RecogerPorEtiqueta',
    argumentos: '{\'etiqueta\' : \'QuesoAnimado\'}'
  });

  var ComerNaranja = AccionBuilder.build({
    descripcion: 'Comer naranja',
    id: 'ComerNaranja',
    icono: 'naranja.png',
    comportamiento: 'RecogerPorEtiqueta',
    argumentos: '{\'etiqueta\' : \'NaranjaAnimada\',  nombreAnimacion: "comerNaranja"}'
  });

  exports.ComerBanana = ComerBanana;
  exports.ComerManzana = ComerManzana;
  exports.ComerQueso = ComerQueso;
  exports.ComerNaranja = ComerNaranja;
});
define('pilas-engine-bloques/actividades/contando', ['exports', 'pilas-engine-bloques/actividades/bloques'], function (exports, _pilasEngineBloquesActividadesBloques) {
  var AccionBuilder = _pilasEngineBloquesActividadesBloques['default'].AccionBuilder;

  var ContarBanana = AccionBuilder.build({
    id: 'Contarbanana',
    descripcion: 'Contar una banana',
    icono: 'iconos.banana.png',
    comportamiento: 'ContarPorEtiqueta',
    argumentos: '{etiqueta: "BananaAnimada", nombreAnimacion: "comerBanana"}'
  });

  var ContarManzana = AccionBuilder.build({
    id: 'Contarmanzana',
    descripcion: 'Contar una manzana',
    icono: 'iconos.manzana.png',
    comportamiento: 'ContarPorEtiqueta',
    argumentos: '{etiqueta: "ManzanaAnimada", nombreAnimacion: "comerManzana"}'
  });

  exports.ContarBanana = ContarBanana;
  exports.ContarManzana = ContarManzana;
});
define('pilas-engine-bloques/actividades/direccionesCuadricula', ['exports', 'pilas-engine-bloques/actividades/bloques'], function (exports, _pilasEngineBloquesActividadesBloques) {
  var Accion = _pilasEngineBloquesActividadesBloques['default'].Accion;
  var AccionBuilder = _pilasEngineBloquesActividadesBloques['default'].AccionBuilder;

  var IrDerecha = AccionBuilder.build({
    descripcion: 'Mover a la derecha',
    id: 'MoverACasillaDerecha',
    icono: '../../iconos/derecha.png',
    comportamiento: 'MoverACasillaDerecha',
    argumentos: '{}'
  });

  var IrIzquierda = AccionBuilder.build({
    descripcion: 'Mover a la izquierda',
    id: 'MoverACasillaIzquierda',
    icono: '../../iconos/izquierda.png',
    comportamiento: 'MoverACasillaIzquierda',
    argumentos: '{}'
  });

  var IrArriba = AccionBuilder.build({
    descripcion: 'Mover arriba',
    id: 'MoverACasillaArriba',
    icono: '../../iconos/arriba.png',
    comportamiento: 'MoverACasillaArriba',
    argumentos: '{}'
  });

  var IrAbajo = AccionBuilder.build({
    descripcion: 'Mover abajo',
    id: 'MoverACasillaAbajo',
    icono: '../../iconos/abajo.png',
    comportamiento: 'MoverACasillaAbajo',
    argumentos: '{}'
  });

  var SiguienteFila = AccionBuilder.build({
    id: 'SiguienteFila',
    descripcion: 'Pasar a la siguiente fila',
    icono: '../../iconos/abajo.png',
    comportamiento: 'SiguienteFila',
    argumentos: '{}'
  });

  var SiguienteFilaTotal = SiguienteFila.extend({
    nombre_comportamiento: function nombre_comportamiento() {
      return 'SecuenciaAnimada';
    },

    argumentos: function argumentos() {
      return '{secuencia: [new MoverTodoAIzquierda({}), new MoverACasillaAbajo({})]}';
    }
  });

  var SiguienteColumna = AccionBuilder.build({
    id: 'SiguienteColumna',
    descripcion: 'Pasar a la siguiente columna',
    icono: '../../iconos/derecha.png',
    comportamiento: 'SiguienteColumna',
    argumentos: '{}'
  });

  var SiguienteColumnaTotal = SiguienteColumna.extend({
    nombre_comportamiento: function nombre_comportamiento() {
      return 'SecuenciaAnimada';
    },

    argumentos: function argumentos() {
      return '{secuencia: [new MoverTodoArriba({}), new MoverACasillaDerecha({})]}';
    }
  });

  var MoverA = Accion.extend({

    init: function init() {
      this._super();
      this.set('id', 'MoverA');
    },

    block_init: function block_init(block) {
      this._super(block);
      block.appendValueInput('direccion').setCheck('Number').appendField('Mover a');
    },

    nombre_comportamiento: function nombre_comportamiento() {
      return 'MovimientoEnCuadricula';
    },

    argumentos: function argumentos(block) {
      return '{claseDirCasilla: ' + Blockly.JavaScript.valueToCode(block, 'direccion', Blockly.JavaScript.ORDER_ATOMIC) + '}';
    }

  });

  var ParaLaDerecha = AccionBuilder.buildValor({
    id: 'ParaLaDerecha',
    descripcion: 'la derecha',
    icono: '../../iconos/derecha.png',
    valor: 'DirCasillaDerecha'
  });

  var ParaLaIzquierda = AccionBuilder.buildValor({
    id: 'ParaLaIzquierda',
    descripcion: 'la izquierda',
    icono: '../../iconos/izquierda.png',
    valor: 'DirCasillaIzquierda'
  });

  var ParaArriba = AccionBuilder.buildValor({
    id: 'ParaArriba',
    descripcion: 'arriba',
    icono: '../../iconos/arriba.png',
    valor: 'DirCasillaArriba'
  });

  var ParaAbajo = AccionBuilder.buildValor({
    id: 'ParaAbajo',
    descripcion: 'abajo',
    icono: '../../iconos/abajo.png',
    valor: 'DirCasillaAbajo'
  });

  exports.IrDerecha = IrDerecha;
  exports.IrIzquierda = IrIzquierda;
  exports.IrArriba = IrArriba;
  exports.IrAbajo = IrAbajo;
  exports.SiguienteFila = SiguienteFila;
  exports.SiguienteColumna = SiguienteColumna;
  exports.SiguienteFilaTotal = SiguienteFilaTotal;
  exports.SiguienteColumnaTotal = SiguienteColumnaTotal;
  exports.ParaLaDerecha = ParaLaDerecha;
  exports.ParaLaIzquierda = ParaLaIzquierda;
  exports.ParaArriba = ParaArriba;
  exports.ParaAbajo = ParaAbajo;
  exports.MoverA = MoverA;
});
define('pilas-engine-bloques/actividades/estructurasDeControl', ['exports', 'pilas-engine-bloques/actividades/bloque', 'pilas-engine-bloques/actividades/bloques'], function (exports, _pilasEngineBloquesActividadesBloque, _pilasEngineBloquesActividadesBloques) {

  var EstructuraDeControl = _pilasEngineBloquesActividadesBloque['default'].extend({

    block_init: function block_init(block) {
      this._super(block);
      block.setColour(Blockly.Blocks.loops.COLOUR);
      block.setInputsInline(true);
      block.setPreviousStatement(true);
      block.setNextStatement(true);
    }

  });

  var Repetir = EstructuraDeControl.extend({

    init: function init() {
      this._super();
      this.set('id', 'repetir');
    },

    block_init: function block_init(block) {
      this._super(block);
      block.appendValueInput('count').setCheck('Number').appendField('Repetir');
      block.appendStatementInput('block');
    },

    block_javascript: function block_javascript(block) {
      var value_count = Blockly.JavaScript.valueToCode(block, 'count', Blockly.JavaScript.ORDER_ATOMIC) || '0';
      var statements_block = Blockly.JavaScript.statementToCode(block, 'block');
      var r = 'programa.empezar_secuencia();\n';
      r += statements_block;
      r += 'programa.repetirN(function(){\nreturn {{n}};\n});\n'.replace('{{n}}', value_count);
      return r;
    },

    get_parametros: function get_parametros() {
      return [_pilasEngineBloquesActividadesBloques.ParamValor.create({
        nombre_param: 'count',
        tipo_bloque: 'math_number',
        nombre_valor: 'NUM',
        valor: '10'
      })];
    }

  });

  /* ============================================== */

  var Si = EstructuraDeControl.extend({

    init: function init() {
      this._super();
      this.set('id', 'si');
    },

    block_init: function block_init(block) {
      this._super(block);
      block.appendValueInput('condition').setCheck('Boolean').appendField('Si');
      block.appendStatementInput('block');
    },

    block_javascript: function block_javascript(block) {
      var value_condition = Blockly.JavaScript.valueToCode(block, 'condition', Blockly.JavaScript.ORDER_ATOMIC) || 'false';
      var statements_block = Blockly.JavaScript.statementToCode(block, 'block');
      var r = 'programa.empezar_secuencia();\n';
      r += statements_block;
      r += 'programa.alternativa_si(function(){\nreturn {{condition}};\n});\n'.replace('{{condition}}', value_condition);
      return r;
    }

  });

  /* ============================================== */

  var Sino = EstructuraDeControl.extend({

    init: function init() {
      this._super();
      this.set('id', 'sino');
    },

    block_init: function block_init(block) {
      this._super(block);
      block.appendValueInput('condition').setCheck('Boolean').appendField('Si');
      block.appendStatementInput('block1');
      block.appendDummyInput().appendField('si no');
      block.appendStatementInput('block2');
    },

    block_javascript: function block_javascript(block) {
      var value_condition = Blockly.JavaScript.valueToCode(block, 'condition', Blockly.JavaScript.ORDER_ATOMIC) || 'false';
      var statements_block1 = Blockly.JavaScript.statementToCode(block, 'block1');
      var statements_block2 = Blockly.JavaScript.statementToCode(block, 'block2');
      var r = 'programa.empezar_secuencia();\n';
      r += statements_block1;
      r += 'programa.empezar_secuencia();\n';
      r += statements_block2;
      r += 'programa.alternativa_sino(function(){\nreturn {{condition}};\n});\n'.replace('{{condition}}', value_condition);
      return r;
    }

  });

  /* ============================================== */

  var Hasta = EstructuraDeControl.extend({

    init: function init() {
      this._super();
      this.set('id', 'hasta');
    },

    block_init: function block_init(block) {
      this._super(block);
      block.appendValueInput('condition').setCheck('Boolean').appendField('Repetir hasta que');
      block.appendStatementInput('block');
    },

    block_javascript: function block_javascript(block) {
      var value_condition = Blockly.JavaScript.valueToCode(block, 'condition', Blockly.JavaScript.ORDER_ATOMIC) || 'true';
      var statements_block = Blockly.JavaScript.statementToCode(block, 'block');
      var r = 'programa.empezar_secuencia();\n';
      r += statements_block;
      r += 'programa.repetir_hasta(function(){\nreturn {{condition}};\n});\n'.replace('{{condition}}', value_condition);
      return r;
    }

  });

  exports.EstructuraDeControl = EstructuraDeControl;
  exports.Repetir = Repetir;
  exports.Si = Si;
  exports.Sino = Sino;
  exports.Hasta = Hasta;
});
define('pilas-engine-bloques/actividades/expresiones', ['exports', 'pilas-engine-bloques/actividades/bloque', 'pilas-engine-bloques/actividades/categorias'], function (exports, _pilasEngineBloquesActividadesBloque, _pilasEngineBloquesActividadesCategorias) {

  var ExpresionDeBlockly = _pilasEngineBloquesActividadesBloque['default'].extend({

    _categoria: _pilasEngineBloquesActividadesCategorias.Operadores,

    registrar_en_blockly: function registrar_en_blockly() {
      // pisado porque ya viene con blockly
      // ni tampoco quiero modificar el javascript
    }

  });

  var Texto = ExpresionDeBlockly.extend({

    _categoria: _pilasEngineBloquesActividadesCategorias.Valores,

    init: function init() {
      this._super();
      this.set('id', 'text');
    }
  });

  var Numero = ExpresionDeBlockly.extend({

    _categoria: _pilasEngineBloquesActividadesCategorias.Valores,

    init: function init() {
      this._super();
      this.set('id', 'math_number');
    }
  });

  var OpAritmetica = ExpresionDeBlockly.extend({
    init: function init() {
      this._super();
      this.set('id', 'math_arithmetic');
    }
  });

  var Booleano = ExpresionDeBlockly.extend({
    _categoria: _pilasEngineBloquesActividadesCategorias.Valores,
    init: function init() {
      this._super();
      this.set('id', 'logic_boolean');
    }
  });

  var OpComparacion = ExpresionDeBlockly.extend({
    init: function init() {
      this._super();
      this.set('id', 'logic_compare');
    }
  });

  var OpLogica = ExpresionDeBlockly.extend({
    init: function init() {
      this._super();
      this.set('id', 'logic_operation');
    }
  });

  var OpNegacion = ExpresionDeBlockly.extend({
    init: function init() {
      this._super();
      this.set('id', 'logic_negate');
    }
  });

  exports.ExpresionDeBlockly = ExpresionDeBlockly;
  exports.Numero = Numero;
  exports.OpAritmetica = OpAritmetica;
  exports.Booleano = Booleano;
  exports.OpComparacion = OpComparacion;
  exports.OpLogica = OpLogica;
  exports.OpNegacion = OpNegacion;
  exports.Texto = Texto;
});
define('pilas-engine-bloques/actividades/lenguaje', ['exports', 'ember', 'pilas-engine-bloques/actividades/categorias'], function (exports, _ember, _pilasEngineBloquesActividadesCategorias) {

  /* ============================================== */

  /*
   * Representa el lenguaje que podra utilizarse
   * en una actividad
   */
  var Lenguaje = _ember['default'].Object.extend({

    init: function init() {
      this.set('bloques', []);
    },

    agregarBloque: function agregarBloque(claseBloque) {
      this.get('bloques').pushObject(this.definir_bloque(claseBloque));
    },

    definir_bloque: function definir_bloque(claseBloque) {
      var block = claseBloque.create();
      block.registrar_en_blockly();
      return block;
    },

    /*
    Ejemplo con subcategorias:
    ordenCategorias(){
      return [
        Titulo('Comandos',[
          Comandos,
          MisProcedimientos,
          Repeticiones, Alternativas,
        ]),
        Separador,
        Variables,
        Separador,
        Titulo('Expresiones',[
          Valores,
          Sensores,
          Operadores,
          MisFunciones,
        ]),
      ];
    },
    */

    ordenCategorias: function ordenCategorias() {
      return [_pilasEngineBloquesActividadesCategorias.Comandos, _pilasEngineBloquesActividadesCategorias.MisProcedimientos, _pilasEngineBloquesActividadesCategorias.Repeticiones, _pilasEngineBloquesActividadesCategorias.Alternativas, _pilasEngineBloquesActividadesCategorias.Separador, _pilasEngineBloquesActividadesCategorias.Variables, _pilasEngineBloquesActividadesCategorias.Separador, _pilasEngineBloquesActividadesCategorias.Valores, _pilasEngineBloquesActividadesCategorias.Sensores, _pilasEngineBloquesActividadesCategorias.Operadores, _pilasEngineBloquesActividadesCategorias.MisFunciones];
    },

    build: function build() {
      var _this = this;

      var str_toolbox = '<xml>';
      this.ordenCategorias().forEach(function (categoria) {
        return str_toolbox += _this.xmlCategoria(categoria);
      });
      return str_toolbox + '</xml>';
    },

    xmlCategoria: function xmlCategoria(categoria) {
      return categoria.generarXML(this.get('bloques'));
    }
  });

  exports['default'] = Lenguaje;
});
define('pilas-engine-bloques/actividades/tocando', ['exports', 'pilas-engine-bloques/actividades/bloques'], function (exports, _pilasEngineBloquesActividadesBloques) {
  var AccionBuilder = _pilasEngineBloquesActividadesBloques['default'].AccionBuilder;

  var TocandoManzana = AccionBuilder.buildSensor({
    descripcion: 'Hay una manzana acá',
    id: 'tocandoManzana',
    icono: 'iconos.manzana.png',
    funcionSensor: 'tocando("ManzanaAnimada")'
  });

  var TocandoBanana = AccionBuilder.buildSensor({
    descripcion: 'Hay una banana acá',
    id: 'tocandoBanana',
    icono: 'iconos.banana.png',
    funcionSensor: 'tocando("BananaAnimada")'
  });

  var TocandoNaranja = AccionBuilder.buildSensor({
    descripcion: 'Hay una naranja acá',
    id: 'TocandoNaranja',
    icono: 'naranja.png',
    funcionSensor: 'tocando("NaranjaAnimada")'
  });

  var TocandoQueso = AccionBuilder.buildSensor({
    descripcion: 'Hay queso acá',
    id: 'tocandoQueso',
    icono: 'queso.png',
    funcionSensor: 'tocando("QuesoAnimado")'
  });

  var TocandoAbajo = AccionBuilder.buildSensor({
    descripcion: 'Puedo mover abajo',
    id: 'TocandoAbajo',
    icono: '../../iconos/abajo.png',
    funcionSensor: 'tocandoFlechaAbajo()'
  });

  var TocandoDerecha = AccionBuilder.buildSensor({
    descripcion: 'Puedo mover a la derecha',
    id: 'TocandoDerecha',
    icono: '../../iconos/derecha.png',
    funcionSensor: 'tocandoFlechaDerecha()'
  });

  var TocandoFinCamino = AccionBuilder.buildSensor({
    descripcion: 'Llegó a la meta',
    id: 'TocandoFinCamino',
    icono: 'icono.finCamino.png',
    funcionSensor: 'alFinalDelCamino()'
  });

  exports.TocandoBanana = TocandoBanana;
  exports.TocandoManzana = TocandoManzana;
  exports.TocandoAbajo = TocandoAbajo;
  exports.TocandoDerecha = TocandoDerecha;
  exports.TocandoFinCamino = TocandoFinCamino;
  exports.TocandoQueso = TocandoQueso;
  exports.TocandoNaranja = TocandoNaranja;
});
define('pilas-engine-bloques/adapters/ls-adapter', ['exports', 'ember-localstorage-adapter/adapters/ls-adapter'], function (exports, _emberLocalstorageAdapterAdaptersLsAdapter) {
  exports['default'] = _emberLocalstorageAdapterAdaptersLsAdapter['default'];
});
define('pilas-engine-bloques/app', ['exports', 'ember', 'pilas-engine-bloques/resolver', 'ember-load-initializers', 'pilas-engine-bloques/config/environment'], function (exports, _ember, _pilasEngineBloquesResolver, _emberLoadInitializers, _pilasEngineBloquesConfigEnvironment) {

  var App = undefined;

  _ember['default'].MODEL_FACTORY_INJECTIONS = true;

  App = _ember['default'].Application.extend({
    modulePrefix: _pilasEngineBloquesConfigEnvironment['default'].modulePrefix,
    podModulePrefix: _pilasEngineBloquesConfigEnvironment['default'].podModulePrefix,
    Resolver: _pilasEngineBloquesResolver['default']
  });

  (0, _emberLoadInitializers['default'])(App, _pilasEngineBloquesConfigEnvironment['default'].modulePrefix);

  exports['default'] = App;
});
define('pilas-engine-bloques/blueprints/page-object-component', ['exports', 'ember-cli-page-object/blueprints/page-object-component'], function (exports, _emberCliPageObjectBlueprintsPageObjectComponent) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberCliPageObjectBlueprintsPageObjectComponent['default'];
    }
  });
});
define('pilas-engine-bloques/blueprints/page-object-helper', ['exports', 'ember-cli-page-object/blueprints/page-object-helper'], function (exports, _emberCliPageObjectBlueprintsPageObjectHelper) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberCliPageObjectBlueprintsPageObjectHelper['default'];
    }
  });
});
define('pilas-engine-bloques/blueprints/page-object', ['exports', 'ember-cli-page-object/blueprints/page-object'], function (exports, _emberCliPageObjectBlueprintsPageObject) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberCliPageObjectBlueprintsPageObject['default'];
    }
  });
});
define('pilas-engine-bloques/blueprints/surge', ['exports', 'ember-cli-surge/blueprints/surge'], function (exports, _emberCliSurgeBlueprintsSurge) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberCliSurgeBlueprintsSurge['default'];
    }
  });
});
define('pilas-engine-bloques/breakpoints', ['exports'], function (exports) {
  exports['default'] = {
    mobile: '(max-width: 768px)',
    tablet: '(min-width: 769px) and (max-width: 992px)',
    desktop: '(min-width: 993px) and (max-width: 1200px)',
    jumbo: '(min-width: 1201px)'
  };
});
define('pilas-engine-bloques/components/app-version', ['exports', 'ember-cli-app-version/components/app-version', 'pilas-engine-bloques/config/environment'], function (exports, _emberCliAppVersionComponentsAppVersion, _pilasEngineBloquesConfigEnvironment) {

  var name = _pilasEngineBloquesConfigEnvironment['default'].APP.name;
  var version = _pilasEngineBloquesConfigEnvironment['default'].APP.version;

  exports['default'] = _emberCliAppVersionComponentsAppVersion['default'].extend({
    version: version,
    name: name
  });
});
define('pilas-engine-bloques/components/ember-modal-dialog-positioned-container', ['exports', 'ember-modal-dialog/components/positioned-container'], function (exports, _emberModalDialogComponentsPositionedContainer) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberModalDialogComponentsPositionedContainer['default'];
    }
  });
});
define('pilas-engine-bloques/components/ember-wormhole', ['exports', 'ember-wormhole/components/ember-wormhole'], function (exports, _emberWormholeComponentsEmberWormhole) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberWormholeComponentsEmberWormhole['default'];
    }
  });
});
define('pilas-engine-bloques/components/fa-icon', ['exports', 'ember-font-awesome/components/fa-icon'], function (exports, _emberFontAwesomeComponentsFaIcon) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberFontAwesomeComponentsFaIcon['default'];
    }
  });
});
define('pilas-engine-bloques/components/fa-list', ['exports', 'ember-font-awesome/components/fa-list'], function (exports, _emberFontAwesomeComponentsFaList) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberFontAwesomeComponentsFaList['default'];
    }
  });
});
define('pilas-engine-bloques/components/fa-stack', ['exports', 'ember-font-awesome/components/fa-stack'], function (exports, _emberFontAwesomeComponentsFaStack) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberFontAwesomeComponentsFaStack['default'];
    }
  });
});
define("pilas-engine-bloques/components/listaImagenes", ["exports"], function (exports) {
    // Autogenerado por scripts/generarListaImagenes.py
    // Todo cambio se sobreescribira.
    exports["default"] = ["PlacaContarGris.png", "PlacaContarNegra.png", "aceituna.png", "aceituna_burla.png", "aceituna_grita.png", "aceituna_risa.png", "actor.BoyScout.png", "actor.Fogata.png", "alien.png", "alienAnimado.png", "alien_camina.png", "alien_marron.png", "alimento_pez.png", "balloon-tip-left.png", "balloon-tip-right.png", "balloon-tip-think-left.png", "balloon-tip-think-right.png", "balloon.png", "banana-1.png", "banana.nano.png", "banana.png", "bascket.png", "bloque.png", "bomba.png", "boton.boton_normal.png", "boton.boton_over.png", "boton.boton_press.png", "boton.pboton_press.png", "boton.tema.png", "botonAnimado.png", "bruja.png", "buzo.png", "caballero_oscuro.png", "caja.png", "camino-alien-boton.png", "cangrejo.png", "carbon_animado.png", "casilla.alienLevantaTuercas.png", "casilla.cangrejo_aguafiestas.png", "casilla.futbolRobots1.png", "casilla.futbolRobots2.png", "casilla.grisoscuro.png", "casilla.mariaSandia.png", "casilla.mono.contar.png", "casilla.prendiendoLasCompus.png", "casilla.prendiendoLasCompus2.png", "casilla.prendiendoLasFogatas.png", "casilla.prendiendoLasFogatas2.png", "casilla.recolector.png", "casilla.reparandoNave.png", "casilla.titoFinalizacion.png", "casilla.tresNaranjas.png", "casillaAbajo.png", "casillaArriba.png", "casillaDerecha.png", "casillaIzquierda.png", "casilla_base.png", "casillafinalmono.png", "casillainiciomono.png", "casillamediomono.png", "casillas.alien_inicial.png", "casillas.elPlanetaDeNano.png", "casillas.violeta.png", "cesto.png", "cofre.png", "cofreAnimado.png", "comedor_naranjas.png", "compu_animada.png", "computadoraAnimada2.png", "cooperativista.alerta.png", "cooperativista.camina.png", "cooperativista.camina_sujeta.png", "cooperativista.ok.png", "cooperativista.parado.png", "cooperativista.parado_sujeta.png", "cooperativista.sprites.png", "cooperativista.trabajando.png", "detective.png", "dibujante.png", "disparos.misil.png", "dracula.png", "ejes.png", "estrellaAnimada.png", "explosion.png", "finCamino.png", "flechaEscenarioAleatorio.png", "focos.color.png", "fondo.BosqueDeNoche.png", "fondo.alimentando_peces.png.png", "fondo.cangrejo_aguafiestas.png", "fondo.detective.png", "fondo.dibujando.figuras.png", "fondo.elMarcianoEnElDesierto.png", "fondo.elPlanetaDeNano.png", "fondo.elSuperviaje.png", "fondo.fiestadracula.png", "fondo.gatoEnLaCalle.png", "fondo.laberinto.corto.png", "fondo.laberinto.largo.png", "fondo.laberinto.queso.png", "fondo.marEncantado.png", "fondo.mariaSandia.png", "fondo.mono.contar.png", "fondo.monoCuentadeNuevo.png", "fondo.noMeCansoDeSaltar.png", "fondo.prendiendoLasCompus.png", "fondo.recolector.png", "fondo.salvandonavidad.png", "fondo.superTito1.png", "fondo.superTito2.png", "fondo.tito-cuadrado.png", "fondo.tresNaranjas.png", "fondos.alien-inicial.png", "fondos.alienLevantaTuercas.png", "fondos.biblioteca.png", "fondos.elPlanetaDeNano.png", "fondos.estrellas.png", "fondos.futbolRobots.png", "fondos.laberinto1.png", "fondos.mar.png", "fondos.navidad.png", "fondos.nubes.png", "fondos.obrero.png", "fondos.reparandoLaNave.png", "fondos.selva.png", "frank.png", "gatoAnimado.png", "globo.png", "globoAnimado.png", "heroe.png", "heroina.png", "hierro_animado.png", "hueso.png", "icono.ComputadoraPrendida.png", "icono.DibujarLinea.png", "icono.FogataApagada.png", "icono.Girar.png", "icono.Lamparita.png", "icono.LamparitaApagada.png", "icono.abrirOjos.png", "icono.acostarse.png", "icono.alimento_pez.png", "icono.cambiar.color.png", "icono.carbon.png", "icono.cerrarOjos.png", "icono.cofre.png", "icono.computadora.png", "icono.culpable.png", "icono.empezar.fiesta.png", "icono.espada.png", "icono.estrella.png", "icono.finCamino.png", "icono.globo.png", "icono.hierro.png", "icono.kms.png", "icono.largoCol.png", "icono.llave.png", "icono.naranja.png", "icono.pararse.png", "icono.pez.png", "icono.regalo.png", "icono.sacar.disfraz.png", "icono.saludar.png", "icono.sandia.png", "icono.sombrero.png", "icono.soniar.png", "icono.unicornio.png", "iconos.banana.png", "iconos.botonRojo.png", "iconos.futbolInicio.png", "iconos.lamparita.png", "iconos.manzana.png", "iconos.pelota.png", "instalador.png", "invisible.png", "lamparin.png", "llave.png", "llaveAnimada.png", "mago.png", "manzana.png", "manzanaConSombra.png", "manzanaSinSombra.png", "manzana_chica.png", "marcianoAnimado.png", "maria.png", "monkey_normal.png", "monkey_shout.png", "monkey_smile.png", "monoAnimado.png", "murcielago.png", "nano.png", "naranja.png", "nave.png", "naveAnimada.png", "nube1.png", "nube2.png", "papaNoel.png", "pasto.png", "pasto_cuadriculado.png", "pelota.png", "pelotaAnimada.png", "perro_cohete.png", "pez1.png", "pez2.png", "pez3.png", "piedra_chica.png", "piedra_grande.png", "piedra_media.png", "pingu.png", "placacontar.png", "plano.png", "portada.lightbot.png", "portada.nano.png", "princesa.png", "principe.png", "queso.png", "quesoAnimado.png", "raton.png", "ratonAnimado.png", "recolectorAnimado.png", "regalo.png", "robotAnimado.png", "rpg.maton.png", "sandia.png", "sin_imagen.png", "sombra.png", "sospechosos.png", "sprites.png", "superheroe.png", "tito.png", "tortuga.png", "tuerca.png", "unicornio.heroina.png", "unicornio.png", "vaca.png", "zanahoria_normal.png", "zanahoria_sonrie.png"];
});
define('pilas-engine-bloques/components/modal-ayuda', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Component.extend({
    tagName: '',

    actions: {
      close: function close() {
        this.set("mostrar", false);
      }
    }

  });
});
define('pilas-engine-bloques/components/modal-dialog-overlay', ['exports', 'ember-modal-dialog/components/modal-dialog-overlay'], function (exports, _emberModalDialogComponentsModalDialogOverlay) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberModalDialogComponentsModalDialogOverlay['default'];
    }
  });
});
define('pilas-engine-bloques/components/modal-dialog', ['exports', 'ember-modal-dialog/components/modal-dialog'], function (exports, _emberModalDialogComponentsModalDialog) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberModalDialogComponentsModalDialog['default'];
    }
  });
});
define('pilas-engine-bloques/components/modal-preferencias', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Component.extend({
    tagName: '',

    actions: {
      close: function close() {
        this.set("mostrar", false);
      }
    }
  });
});
define('pilas-engine-bloques/components/modal-title', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Component.extend({
    tagName: '',

    actions: {
      ocultar: function ocultar() {
        this.sendAction("close");
      }
    }
  });
});
define('pilas-engine-bloques/components/pilas-acerca-de', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Component.extend({});
});
define('pilas-engine-bloques/components/pilas-blockly', ['exports', 'ember'], function (exports, _ember) {

  var VERSION_DEL_FORMATO_DE_ARCHIVO = 1;

  exports['default'] = _ember['default'].Component.extend({
    classNames: 'desafio-panel-derecho',
    ejecutando: false,
    cola_deshacer: [],
    data_observar_blockly: false,
    actividad: null,
    environment: _ember['default'].inject.service(),
    abrirConsignaInicial: false,
    solucion: null,
    pilas: null, // Se espera que sea una referencia al servicio pilas.
    codigoJavascript: "", // Se carga como parametro
    persistirSolucionEnURL: false, // se le asigna una valor por parámetro.
    debeMostrarFinDeDesafio: false,

    twitter: _ember['default'].inject.service(),
    previewData: null, // representa la imagen previsualización del dialogo para twittear.
    mensajeCompartir: 'Comparto mi solución de Pilas Bloques',
    compartirEnCurso: false,
    //browser: Ember.inject.service(),

    anterior_ancho: -1,
    anterior_alto: -1,

    inyectarRedimensionado: _ember['default'].on('init', function () {
      var _this = this;

      // Muestra el dialogo inicial si está definida la consigna inicial.
      if (this.get('actividad.actividad.consignaInicial')) {
        _ember['default'].run.later(function () {
          _this.set('abrirConsignaInicial', true);
        });
      }
    }),

    didInsertElement: function didInsertElement() {
      var _this2 = this;

      if (!this.get('actividad')) {
        return null;
      }

      var contenedor = this.$().find('#contenedor-blockly')[0];
      this.get('actividad').iniciarBlockly(contenedor);

      if (this.get("codigo")) {
        this.restaurar_codigo(atob(this.get("codigo")));
      }

      if (this.get("persistirSolucionEnURL")) {
        Blockly.addChangeListener(function () {
          _ember['default'].run(_this2, function () {
            this.guardarEnURL();
            this.generarCodigoTemporal();
          });
        });
      }

      if (this.get("debeMostrarFinDeDesafio")) {
        this.get('pilas').on('terminaEjecucion', function () {
          _this2.cuandoTerminaEjecucion();
        });
      }

      // this.set('cola_deshacer', []);
      // this.cargar_codigo_desde_el_modelo();
      // this.observarCambiosEnBlocky();

      this.conectar_evento_para_ajustar_blocky();
      $(window).trigger('resize');
    },

    conectar_evento_para_ajustar_blocky: function conectar_evento_para_ajustar_blocky() {
      $(window).bind('resize.blockly', function () {

        var newWidth = window.innerWidth - $("#panel-izquierdo").width();
        $('.desafio-panel-derecho').width(newWidth - 35);

        var blocklyArea = document.getElementById('blocklyArea');
        var blocklyDiv = document.getElementById('contenedor-blockly');

        blocklyDiv.style.left = 0 + 'px';
        blocklyDiv.style.top = 0 + 'px';
        blocklyDiv.style.width = blocklyArea.offsetWidth + 'px';
        blocklyDiv.style.height = blocklyArea.offsetHeight + 'px';
      });
    },

    guardarEnURL: function guardarEnURL() {
      var codigo = this.obtener_codigo_en_texto();
      this.set("codigo", btoa(codigo));
    },

    generarCodigoTemporal: function generarCodigoTemporal() {
      var codigoJavascript = this.get('actividad').generarCodigo();
      this.set("codigoJavascript", codigoJavascript);
    },

    cuandoTerminaEjecucion: function cuandoTerminaEjecucion() {
      if (this.get('pilas').estaResueltoElProblema() && this.get('actividad').debeFelicitarse()) {
        this.send('abrirFinDesafio');
      }
    },

    willDestroyElement: function willDestroyElement() {
      window.removeEventListener('terminaCargaInicial', this.handlerCargaInicial, false);
      window.removeEventListener('terminaEjecucion', this.handlerTerminaEjecucion, false);
      $(window).unbind('resize.blockly');
    },

    /**
    * Se conecta a los eventos y cambios de estado de blockly para implementar
    * la funcionalidad de 'deshacer'.
    */
    /*
    observarCambiosEnBlocky() {
      var f = this.almacenar_cambio.bind(this);
      var d = Blockly.addChangeListener(f);
      this.set('data_observar_blockly', d);
    },
     noMirarCambiosEnBlockly() {
      if(this.get('data_observar_blockly')) {
        Blockly.removeChangeListener(this.get('data_observar_blockly'));
      }
    },
     almacenar_cambio() {
      this.get('cola_deshacer').pushObject(this.obtener_codigo_en_texto());
      console.log("guardar");
    },
    */

    restaurar_codigo: function restaurar_codigo(codigo) {
      var xml = Blockly.Xml.textToDom(codigo);
      Blockly.mainWorkspace.clear();
      Blockly.Xml.domToWorkspace(Blockly.getMainWorkspace(), xml);
    },

    obtener_codigo_en_texto: function obtener_codigo_en_texto() {
      var xml = Blockly.Xml.workspaceToDom(Blockly.getMainWorkspace());
      return Blockly.Xml.domToText(xml);
    },

    /*
    cargar_codigo_desde_el_modelo() {
      if (this.get('model')) {
        var modelo = this.get('model');
        var codigo = modelo.get('codigo');
        this.restaurar_codigo(codigo);
      }
      this.sendAction('registrarPrimerCodigo');
    },
    */

    actions: {
      ejecutar: function ejecutar() {
        window.LoopTrap = 1000;
        //this.sendAction('reiniciar');
        Blockly.JavaScript.INFINITE_LOOP_TRAP = 'if (--window.LoopTrap == 0) throw "Infinite loop.";\n';

        var code = this.get('actividad').generarCodigo();
        //console.log(code);

        Blockly.JavaScript.INFINITE_LOOP_TRAP = null;

        this.set('ejecutando', true);
        this.get('pilas').ejecutarCodigoSinReiniciar(code);

        /*
        Ember.run(() => {
          try {
            this.set('ejecutando', true);
            eval(code);
            this.sendAction('parar');
          } catch (e) {
            console.error(e.stack);
            alert(e);
          }
        });
        */
      },

      reiniciar: function reiniciar() {
        this.set('ejecutando', false);
        this.get('pilas').reiniciarEscenaCompleta();
      },

      guardar: function guardar() {
        this.sendAction('guardar');
      },

      guardar_solucion_en_el_backend: function guardar_solucion_en_el_backend() {
        var codigo_xml = this.get('actividad').generarCodigoXMLComoString();
        this.sendAction('guardar_solucion_en_el_backend', codigo_xml);
      },

      alternar: function alternar() {
        //this.sendAction('redimensionar');
        console.log(this.controllerFor('application'));
        //.sendAction('redimensionar');
      },

      ver_codigo: function ver_codigo() {
        var codigo_como_string = this.get('actividad').generarCodigoXMLComoString();
        alert(codigo_como_string);
      },

      ingresar_codigo: function ingresar_codigo() {
        var codigo = prompt("Ingrese el código");

        if (codigo) {
          this.get('actividad').cargarCodigoDesdeStringXML(codigo);
        }
      },

      /*
      deshacer_cambio() {
        this.noMirarCambiosEnBlockly();
        this.get('cola_deshacer').popObject();
        var c =  this.get('cola_deshacer').popObject();
        if (c) {
          console.log("deshacer");
          this.restaurar_codigo(c);
        }
        this.observarCambiosEnBlocky();
      },
      */

      compartir: function compartir() {
        this.set('abrirDialogoCompartir', true);
        var data = this.get("pilas").obtenerCapturaDePantalla();
        this.set('previewData', data);
      },

      ocultarModalTwitter: function ocultarModalTwitter() {
        this.set('abrirDialogoCompartir', false);
      },

      abrirFinDesafio: function abrirFinDesafio() {
        this.set('mostrarDialogoFinDesafio', true);
      },

      ocultarFinDesafio: function ocultarFinDesafio() {
        this.set('mostrarDialogoFinDesafio', false);
      },

      abrirMensajePublicado: function abrirMensajePublicado() {
        var url = this.get('mensajePublicadoURL');
        this.get('browser').openLink(url);
      },

      enviarMensaje: function enviarMensaje() {
        var _this3 = this;

        this.set('envioEnCurso', true);

        var mensaje = this.get('mensajeCompartir');
        var imagen = this.get('previewData');

        this.get('twitter').compartir(mensaje, imagen).then(function (data) {
          _this3.set('envioEnCurso', false);
          _this3.set('mensajePublicadoURL', data.url);
        })['catch'](function (err) {
          alert(err);
          _this3.set('envioEnCurso', false);
        });
      },

      cargarSolucion: function cargarSolucion(archivo, contenido) {
        var regex_file = /\.spbq$/;
        var regex_version = /^\d+$/;
        var data = null;
        var solucion = null;

        if (!regex_file.test(archivo.name)) {
          alert("Lo siento, solo se permiten cargar archivos .spbq");
          return;
        }

        try {
          data = JSON.parse(contenido);
          solucion = atob(data.solucion);
        } catch (e) {
          console.error(e);
          alert("Lo siento, el archivo está dañando.");
          return;
        }

        if (!regex_version.test(data.version)) {
          alert("Lo siento, la especificación de versión es incorrecta.");
          return;
        }

        if (parseInt(data.version) > VERSION_DEL_FORMATO_DE_ARCHIVO) {
          alert("Cuidado, el archivo corresponde a otra versión de la aplicación. Se cargará de todas formas, pero puede fallar.");
        }

        if (this.get("actividad").id !== data.actividad) {
          alert('Cuidado, el archivo indica que es para otra actividad (' + data.actividad + '). Se cargará de todas formas, pero puede fallar.');
        }

        this.get('actividad').cargarCodigoDesdeStringXML(solucion);
      },

      guardarSolucion: function guardarSolucion() {
        var nombre_de_la_actividad = this.get("actividad").id;
        var nombre_surgerido = nombre_de_la_actividad + '.spbq';
        var contenido = {
          version: VERSION_DEL_FORMATO_DE_ARCHIVO,
          actividad: nombre_de_la_actividad,
          solucion: btoa(this.get('actividad').generarCodigoXMLComoString())
        };
        var contenido_como_string = JSON.stringify(contenido);

        function descargar(text, name, type) {
          var a = document.getElementById("placeholder");
          var file = new Blob([text], { type: type });
          a.href = URL.createObjectURL(file);
          a.download = name;
          a.click();
        }

        descargar(contenido_como_string, nombre_surgerido, 'application/octet-stream');
      }

    }

  });
});
define('pilas-engine-bloques/components/pilas-boton-cargar', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Component.extend({
    tagName: 'span',
    cuandoSelecciona: null,

    didInsertElement: function didInsertElement() {
      var _this = this;

      this.$('#cargarActividadInput').change(function (event) {
        var archivo = event.target.files[0];

        if (archivo) {
          var reader = new FileReader();

          reader.onload = function (e) {
            var contenido = e.target.result;

            _this.sendAction('cuandoSelecciona', archivo, contenido);
          };

          reader.readAsText(archivo);
        }

        // Fuerza a que se pueda cargar dos o más veces el mismo archivo.
        _this.limpiarInput();
        return false;
      });
    },

    limpiarInput: function limpiarInput() {
      document.getElementById('cargarActividadInput').value = null;
    },

    actions: {
      alPulsar: function alPulsar() {
        this.$("#cargarActividadInput").click();
      }
    }
  });
});
define('pilas-engine-bloques/components/pilas-botones-zoom', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Component.extend({
    tagName: 'div',
    classNames: ['nw-zoom'],
    zoomValue: 100,
    zoom: _ember['default'].inject.service(),

    canZoomIn: _ember['default'].computed('zoomValue', function () {
      return this.get('zoomValue') < 120;
    }),

    canZoomOut: _ember['default'].computed('zoomValue', function () {
      return this.get('zoomValue') > 80;
    }),

    cambiarZoom: _ember['default'].observer('zoomValue', function () {
      this.get('zoom').setValue(this.get('zoomValue'));

      this.aplicarZoom((this.get('zoomValue') - 100) / 10);
    }),

    aplicarZoom: function aplicarZoom(zoomLevel) {
      document.body.style.zoom = 100 + zoomLevel * 10 + "%";
    },

    onStart: _ember['default'].on('init', function () {
      this.set('zoomValue', this.get('zoom').getValue());
      this.cambiarZoom();
    }),

    actions: {
      zoomIn: function zoomIn() {
        this.set('zoomValue', this.get('zoomValue') + 10);
      },
      zoomOut: function zoomOut() {
        this.set('zoomValue', this.get('zoomValue') - 10);
      },
      zoomRestore: function zoomRestore() {
        this.set('zoomValue', 100);
      }
    }

  });
});
define('pilas-engine-bloques/components/pilas-canvas', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Component.extend({
    classNames: ['pilas-canvas-container'],
    classNameBindings: ['media.isMobile:media-mobile'],
    iframeElement: null,
    escena: null,
    pilas: null, /* Se espera que este atributo se defina al
                  * llamar al componente y es obligatorio. */

    didInsertElement: function didInsertElement() {
      _ember['default'].run.scheduleOnce('afterRender', this, this.initElement);
    },

    willDestroyElement: function willDestroyElement() {
      this.get("pilas").liberarRecursos();
    },

    initElement: function initElement() {
      var _this = this;

      var iframeElement = this.$().find('#innerIframe')[0];

      this.set("iframeElement", iframeElement);

      this.get("iframeElement").onload = function () {

        if (_this.get('pilas')) {
          _this.get("pilas").inicializarPilas(iframeElement, { width: 420, height: 480 }).then(function (pilas) {

            if (_this.get('escena')) {
              _this.get("pilas").inicializarEscena(iframeElement, _this.get("escena"));
            } else {
              console.warn("No especificó una escena para cargar en pilas-canvas.");
            }

            /*
             * Invoca a la acción "onReady" que envía el objeto pilas listo
             * para ser utilizado.
             *
             */
            if (_this.get('onReady')) {
              _this.sendAction("onReady", pilas);
            } else {
              //console.warn("Se a iniciado el componente pilas-canvas sin referencia a la acción onLoad.");
            }
          });
        } else {
            console.warn("No has enviado el objeto pilas.");
          }

        // onLoad solo se utiliza dentro de la batería de tests. Este
        // componente se tendría que usar mediante el servicio "pilas"
        // en cualquier otro lugar.
        _this.sendAction('onLoad', { iframeElement: iframeElement });
      };
    },

    reloadIframe: function reloadIframe(onLoadFunction) {
      this.get("iframeElement").onload = onLoadFunction;
      this.get("iframeElement").contentWindow.location.reload(true);
    },

    actions: {
      execute: function execute(code) {
        var _this2 = this;

        this.reloadIframe(function () {
          alert("Ha cargado el código y está todo listo!");
          _this2.get("iframeElement").contentWindow.eval(code);
        });
      },
      clear: function clear() {
        this.reloadIframe();
      },
      quitFullscreen: function quitFullscreen() {
        this.set('inFullScreen', false);
      },
      enterFullscreen: function enterFullscreen() {
        this.set('inFullScreen', true);
      }
    }

  });
});
define('pilas-engine-bloques/components/pilas-cargando', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Component.extend({
    classNames: ['contenido-principal', 'pilas-cargando-container']
  });
});
define('pilas-engine-bloques/components/pilas-debug-bar', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Component.extend({
    classNames: 'pilas-debug-bar',
    panelCanvasVisible: true,

    layout: _ember['default'].computed('panelCanvasVisible', 'panelBlocklyVisible', 'panelCodigoVisible', function () {
      this.actualizar_layout();
      return false;
    }),

    actualizar_layout: function actualizar_layout() {
      _ember['default'].run.schedule("afterRender", this, function () {
        var evt = window.document.createEvent('UIEvents');
        evt.initUIEvent('resize', true, false, window, 0);

        window.dispatchEvent(evt);
        window.dispatchEvent(evt);
      });
    }
  });
});
define('pilas-engine-bloques/components/pilas-desafio', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Component.extend({
    classNames: ['desafio'],
    nombre: null,
    deshabilitada: false,

    actions: {
      abrir: function abrir() {
        this.sendAction('onSelect', this.get('nombre'));
      }
    }
  });
});
define('pilas-engine-bloques/components/pilas-editor', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Component.extend({
    classNames: ['contenedor-pilas-editor'],
    persistirSolucionEnURL: true,
    ningunPanelVisible: _ember['default'].computed.none('panelCanvasVisible', 'panelBlocklyVisible', 'panelCodigoVisible'),

    actions: {
      onReady: function onReady(pilas) {
        this.sendAction("onReady", pilas);
      },
      guardar_solucion_en_el_backend: function guardar_solucion_en_el_backend(codigo_xml) {
        var hash = this.get("hash");
        var idAlumno = this.get("idAlumno");
        var actividad = this.get("model.actividad").id;

        this.sendAction("guardar_solucion_en_el_backend", { hash: hash, idAlumno: idAlumno, actividad: actividad, codigo_xml: codigo_xml });
      }
    }
  });
});
define('pilas-engine-bloques/components/pilas-header', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Component.extend({
    tagName: 'nav',
    classNames: ['navbar', 'navbar-default'],
    mostrarDialogoOpciones: false,
    mostrarDialogoAyuda: false,

    actions: {
      abrirPreferencias: function abrirPreferencias() {
        this.set('mostrarDialogoOpciones', true);
      },

      abrirAyuda: function abrirAyuda() {
        this.set('mostrarDialogoAyuda', true);
      }
    }
  });
});
define('pilas-engine-bloques/components/pilas-link', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Component.extend({
    tagName: '',
    href: null,
    inElectron: false,

    didInsertElement: function didInsertElement() {
      this.set('inElectron', typeof process !== "undefined");
    },

    actions: {
      abrirConNavegadorExterno: function abrirConNavegadorExterno(url) {
        var _require = require('electron');

        var shell = _require.shell;

        shell.openExternal(url);
      }
    }
  });
});
define('pilas-engine-bloques/components/pilas-notificador', ['exports', 'ember', 'pilas-engine-bloques/config/environment'], function (exports, _ember, _pilasEngineBloquesConfigEnvironment) {
  exports['default'] = _ember['default'].Component.extend({
    servicioNotificador: null,
    hayActualizacion: false,
    tagName: '',
    linkDescarga: _pilasEngineBloquesConfigEnvironment['default'].linkDeDescarga,

    didInsertElement: function didInsertElement() {
      var inElectron = typeof process !== "undefined";

      if (this.get('servicioNotificador')) {
        if (inElectron) {
          /* Solo si está en la versión offline, sobre elecrton, espera 5 segundos
           * y consulta si existe una versión nueva para descargar. */
          _ember['default'].run.later(this, function () {
            this.consultarSiExisteVersionNueva();
          }, 5000);
        }
      }
    },

    consultarSiExisteVersionNueva: function consultarSiExisteVersionNueva() {
      var _this = this;

      this.get('servicioNotificador').consultar().then(function (data) {

        if (data.hayActualizacion) {
          _this.set('hayActualizacion', true);
          _this.set('versionMasReciente', data.version);
          console.log('Hay una actualización disponible. La versión ' + data.version + '.');
        } else {
          console.log('Se consultó buscando una nueva versión, pero el servidor informó la versión ' + data.version + ' así que no hace falta actualizar...');
        }
      }, function (error) {
        console.warn("Se quiso consultar una nueva versión pero falló el request", error);
      });
    },

    actions: {
      cerrar: function cerrar() {
        this.set('hayActualizacion', false);
      }
    }
  });
});
define('pilas-engine-bloques/components/pilas-spinner', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Component.extend({
    classNames: ['content-spinner'],
    centered: false
  });
});
define('pilas-engine-bloques/components/pilas-splitter', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Component.extend({
    classNames: ['pilas-splitter'],

    didInsertElement: function didInsertElement() {
      var _this = this;

      $(window).resize(function () {
        _this.fixLayout();
      });

      this.$('#splitter').on("mousedown", function (event) {
        event.preventDefault();

        $('#over-splitter').show();

        var initialX = event.pageX;
        var initialWidth = $(_this.get("panel")).width();

        $('#over-splitter').on("mousemove", function (event) {
          var dx = event.pageX - initialX;
          var newWidth = initialWidth + dx;

          // Aplica límites de tamaño, entre 200 y 800.
          newWidth = Math.max(newWidth, 200);
          newWidth = Math.min(newWidth, 800);

          $(_this.get("panel")).width(newWidth);

          $(window).trigger('resize');
          window.dispatchEvent(new Event('resize'));
        });

        $('.over-splitter').on("mouseup", function () {
          $('.over-splitter').off("mousemove");
          $('.over-splitter').hide();
        });
      });
    },

    willDestroyElement: function willDestroyElement() {
      $(window).off('resize');
    },

    fixLayout: function fixLayout() {
      var width = $(this.get("iframe")).width();
      var height = width * 1.1428;

      $(this.get('iframe')).height(height);
      $(this.get('ayuda')).css('top', height);
    }
  });
});
define('pilas-engine-bloques/components/tether-dialog', ['exports', 'ember-modal-dialog/components/tether-dialog'], function (exports, _emberModalDialogComponentsTetherDialog) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberModalDialogComponentsTetherDialog['default'];
    }
  });
});
define('pilas-engine-bloques/controllers/acercade', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Controller.extend({
    notificador: _ember['default'].inject.service(),
    hayActualizacion: _ember['default'].computed.alias('notificador.hayActualizacion'),
    versionMasReciente: _ember['default'].computed.alias('notificador.versionActual'),

    actions: {
      visitarWeb: function visitarWeb() {
        var url = "http://bloques.pilas-engine.com.ar";
        window.open(url);
      }
    }
  });
});
define('pilas-engine-bloques/controllers/application', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Controller.extend({
    layout: true,
    queryParams: ['layout'],
    notificador: _ember['default'].inject.service()
  });
});
define('pilas-engine-bloques/controllers/desafio', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Controller.extend({
    pilas: _ember['default'].inject.service(),
    queryParams: ['codigo', 'debug', 'panelCanvasVisible', 'panelBlocklyVisible', 'panelCodigoVisible'],
    codigo: "",
    debug: false,
    panelCanvasVisible: true,
    panelBlocklyVisible: true,
    panelCodigoVisible: false,
    codigoJavascript: '',

    actions: {
      cuandoCargaPilas: function cuandoCargaPilas() /*pilas*/{}
    }
  });
});
define('pilas-engine-bloques/controllers/desafios/curso-alumno', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Controller.extend({
    pilas: _ember['default'].inject.service(),
    queryParams: ['codigo', 'debug', 'panelCanvasVisible', 'panelBlocklyVisible', 'panelCodigoVisible'],
    codigo: null,
    debug: false,
    codigoJavascript: ''
  });
});
define('pilas-engine-bloques/controllers/desafios/curso-docente', ['exports', 'pilas-engine-bloques/controllers/desafios/curso-alumno'], function (exports, _pilasEngineBloquesControllersDesafiosCursoAlumno) {
  exports['default'] = _pilasEngineBloquesControllersDesafiosCursoAlumno['default'].extend({});
});
define("pilas-engine-bloques/controllers/test", ["exports", "ember"], function (exports, _ember) {
  exports["default"] = _ember["default"].Controller.extend({
    actividad: {
      iniciarEscena: function iniciarEscena() {
        var fondo = new pilas.fondos.Tarde(); // jshint ignore:line

        pilas.escena_actual().minZ = function () {
          return this.stage.children[this.stage.children.length - 1].z;
        };

        var p = new pilas.actores.Mono();
        p.transparencia = 50;

        var tablero = new Tablero(0, -40, { texto: "Hola?" }); // jshint ignore:line

        var tablero2 = new Tablero(100, -40, { texto: "Hola?" }); // jshint ignore:line

        var a = new pilas.actores.Aceituna();
        a.z = 10;
        a.x = [80];
        a.y = [20];
      },
      iniciarBlockly: function iniciarBlockly() {},
      finalizaCargarBlockly: function finalizaCargarBlockly() {}
    }
  });
});
define('pilas-engine-bloques/electron/browser-qunit-adapter', ['exports'], function (exports) {
    (function (window) {
        'use strict';

        // Exit immediately if we're not running in Electron
        if (!window.ELECTRON) {
            return;
        }

        function setQUnitAdapter(serverURL) {
            var socket = io(serverURL);

            socket.on('connect', function () {
                return socket.emit('browser-login', 'Electron', 1);
            });
            socket.on('start-tests', function () {
                socket.disconnect();
                window.location.reload();
            });

            qunitAdapter(socket);
        }

        // Adapted from Testem's default qunit-adapter.
        function qunitAdapter(socket) {
            var currentTest = undefined,
                currentModule = undefined;
            var id = 1;
            var results = {
                failed: 0,
                passed: 0,
                total: 0,
                skipped: 0,
                tests: []
            };

            QUnit.log(function (details) {
                var item = {
                    passed: details.result,
                    message: details.message
                };

                if (!details.result) {
                    item.actual = details.actual;
                    item.expected = details.expected;
                }

                currentTest.items.push(item);
            });

            QUnit.testStart(function (details) {
                currentTest = {
                    id: id++,
                    name: (currentModule ? currentModule + ': ' : '') + details.name,
                    items: []
                };
                socket.emit('tests-start');
            });

            QUnit.testDone(function (details) {
                currentTest.failed = details.failed;
                currentTest.passed = details.passed;
                currentTest.total = details.total;

                results.total++;

                if (currentTest.failed > 0) {
                    results.failed++;
                } else {
                    results.passed++;
                }

                results.tests.push(currentTest);
                socket.emit('test-result', currentTest);
            });

            QUnit.moduleStart(function (details) {
                currentModule = details.name;
            });

            QUnit.done(function (details) {
                results.runDuration = details.runtime;
                socket.emit('all-test-results', results);
            });
        }

        window.addEventListener('load', function () {
            setQUnitAdapter(process.env.ELECTRON_TESTEM_SERVER_URL);
        });
    })(this);
});
define('pilas-engine-bloques/electron/reload', ['exports'], function (exports) {
    /* jshint browser: true */
    (function () {
        'use strict';

        // Exit immediately if we're not running in Electron
        if (!window.ELECTRON) {
            return;
        }

        // Reload the page when anything in `dist` changes
        var fs = window.requireNode('fs');
        var path = window.requireNode('path');

        /**
         * Watch a given directory for changes and reload
         * on change
         * 
         * @param sub directory
         */
        var watch = function watch(sub) {
            var dirname = __dirname || path.resolve(path.dirname());
            var isInTest = !!window.QUnit;

            if (isInTest) {
                // In tests, __dirname is `<project>/tmp/<broccoli-dist-path>/tests`.
                // In normal `ember:electron` it's `<project>/dist`.
                // To achieve the regular behavior in testing, go to parent dir, which contains `tests` and `assets`
                dirname = path.join(dirname, '..');
            }

            if (sub) {
                dirname = path.join(dirname, sub);
            }

            fs.watch(dirname, { recursive: true }, function (e) {
                window.location.reload();
            });
        };

        /**
         * Install Devtron in the current window.
         */
        var installDevtron = function installDevtron() {
            var devtron = window.requireNode('devtron');

            if (devtron) {
                devtron.install();
            }
        };

        /**
         * Install Ember-Inspector in the current window.
         */
        var installEmberInspector = function installEmberInspector() {
            var location = path.join('node_modules', 'ember-inspector', 'dist', 'chrome');

            fs.lstat(location, function (err, results) {
                if (err) {
                    return;
                }

                if (results && results.isDirectory && results.isDirectory()) {
                    var BrowserWindow = window.requireNode('electron').remote.BrowserWindow;
                    try {
                        BrowserWindow.addDevToolsExtension(location);
                    } catch (err) {
                        // no-op
                    }
                }
            });
        };

        document.addEventListener('DOMContentLoaded', function (e) {
            var dirname = __dirname || path.resolve(path.dirname());

            fs.stat(dirname, function (err, stat) {
                if (!err) {
                    watch();

                    // On linux, the recursive `watch` command is not fully supported:
                    // https://nodejs.org/docs/latest/api/fs.html#fs_fs_watch_filename_options_listener
                    //
                    // However, the recursive option WILL watch direct children of the
                    // given directory.  So, this hack just manually sets up watches on
                    // the expected subdirs -- that is, `assets` and `tests`.
                    if (process.platform === 'linux') {
                        watch('/assets');
                        watch('/tests');
                    }
                }
            });

            installDevtron();
            installEmberInspector();
        });
    })();
});
define('pilas-engine-bloques/electron/tap-qunit-adapter', ['exports'], function (exports) {
    (function (window) {
        'use strict';

        // Exit immediately if we're not running in Electron
        if (!window.ELECTRON) {
            return;
        }

        // Log QUnit results to the console so they show up
        // in the `Electron` process output.
        function log(content) {
            console.log('[qunit-logger] ' + content);
            window.process.stdout.write('[qunit-logger] ' + content);
        }

        function setQUnitAdapter() {
            var testCount = 0;

            QUnit.begin(function (details) {
                if (details.totalTests >= 1) {
                    log('1..' + details.totalTests);
                }
            });

            QUnit.testDone(function (details) {
                testCount++;
                if (details.failed === 0) {
                    log('ok ' + testCount + ' - ' + details.module + ' # ' + details.name);
                }
            });

            QUnit.log(function (details) {
                if (details.result !== true) {
                    var actualTestCount = testCount + 1;
                    log('# ' + JSON.stringify(details));
                    log('not ok ' + actualTestCount + ' - ' + details.module + ' - ' + details.name);
                }
            });

            QUnit.done(function (details) {
                log('# done' + (details.failed === 0 ? '' : ' with errors'));
            });
        }

        window.addEventListener('load', setQUnitAdapter);
    })(this);
});
define('pilas-engine-bloques/helpers/append', ['exports', 'ember-composable-helpers/helpers/append'], function (exports, _emberComposableHelpersHelpersAppend) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersAppend['default'];
    }
  });
  Object.defineProperty(exports, 'append', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersAppend.append;
    }
  });
});
define('pilas-engine-bloques/helpers/array', ['exports', 'ember-composable-helpers/helpers/array'], function (exports, _emberComposableHelpersHelpersArray) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersArray['default'];
    }
  });
  Object.defineProperty(exports, 'array', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersArray.array;
    }
  });
});
define('pilas-engine-bloques/helpers/camelize', ['exports', 'ember-composable-helpers/helpers/camelize'], function (exports, _emberComposableHelpersHelpersCamelize) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersCamelize['default'];
    }
  });
  Object.defineProperty(exports, 'camelize', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersCamelize.camelize;
    }
  });
});
define('pilas-engine-bloques/helpers/capitalize', ['exports', 'ember-composable-helpers/helpers/capitalize'], function (exports, _emberComposableHelpersHelpersCapitalize) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersCapitalize['default'];
    }
  });
  Object.defineProperty(exports, 'capitalize', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersCapitalize.capitalize;
    }
  });
});
define('pilas-engine-bloques/helpers/chunk', ['exports', 'ember-composable-helpers/helpers/chunk'], function (exports, _emberComposableHelpersHelpersChunk) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersChunk['default'];
    }
  });
  Object.defineProperty(exports, 'chunk', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersChunk.chunk;
    }
  });
});
define('pilas-engine-bloques/helpers/classify', ['exports', 'ember-composable-helpers/helpers/classify'], function (exports, _emberComposableHelpersHelpersClassify) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersClassify['default'];
    }
  });
  Object.defineProperty(exports, 'classify', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersClassify.classify;
    }
  });
});
define('pilas-engine-bloques/helpers/compact', ['exports', 'ember-composable-helpers/helpers/compact'], function (exports, _emberComposableHelpersHelpersCompact) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersCompact['default'];
    }
  });
  Object.defineProperty(exports, 'compact', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersCompact.compact;
    }
  });
});
define('pilas-engine-bloques/helpers/compute', ['exports', 'ember-composable-helpers/helpers/compute'], function (exports, _emberComposableHelpersHelpersCompute) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersCompute['default'];
    }
  });
  Object.defineProperty(exports, 'compute', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersCompute.compute;
    }
  });
});
define('pilas-engine-bloques/helpers/contains', ['exports', 'ember-composable-helpers/helpers/contains'], function (exports, _emberComposableHelpersHelpersContains) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersContains['default'];
    }
  });
  Object.defineProperty(exports, 'contains', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersContains.contains;
    }
  });
});
define('pilas-engine-bloques/helpers/dasherize', ['exports', 'ember-composable-helpers/helpers/dasherize'], function (exports, _emberComposableHelpersHelpersDasherize) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersDasherize['default'];
    }
  });
  Object.defineProperty(exports, 'dasherize', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersDasherize.dasherize;
    }
  });
});
define('pilas-engine-bloques/helpers/dec', ['exports', 'ember-composable-helpers/helpers/dec'], function (exports, _emberComposableHelpersHelpersDec) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersDec['default'];
    }
  });
  Object.defineProperty(exports, 'dec', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersDec.dec;
    }
  });
});
define('pilas-engine-bloques/helpers/drop', ['exports', 'ember-composable-helpers/helpers/drop'], function (exports, _emberComposableHelpersHelpersDrop) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersDrop['default'];
    }
  });
  Object.defineProperty(exports, 'drop', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersDrop.drop;
    }
  });
});
define('pilas-engine-bloques/helpers/filter-by', ['exports', 'ember-composable-helpers/helpers/filter-by'], function (exports, _emberComposableHelpersHelpersFilterBy) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersFilterBy['default'];
    }
  });
  Object.defineProperty(exports, 'filterBy', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersFilterBy.filterBy;
    }
  });
});
define('pilas-engine-bloques/helpers/find-by', ['exports', 'ember-composable-helpers/helpers/find-by'], function (exports, _emberComposableHelpersHelpersFindBy) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersFindBy['default'];
    }
  });
  Object.defineProperty(exports, 'findBy', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersFindBy.findBy;
    }
  });
});
define('pilas-engine-bloques/helpers/flatten', ['exports', 'ember-composable-helpers/helpers/flatten'], function (exports, _emberComposableHelpersHelpersFlatten) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersFlatten['default'];
    }
  });
  Object.defineProperty(exports, 'flatten', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersFlatten.flatten;
    }
  });
});
define('pilas-engine-bloques/helpers/group-by', ['exports', 'ember-composable-helpers/helpers/group-by'], function (exports, _emberComposableHelpersHelpersGroupBy) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersGroupBy['default'];
    }
  });
  Object.defineProperty(exports, 'groupBy', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersGroupBy.groupBy;
    }
  });
});
define('pilas-engine-bloques/helpers/inc', ['exports', 'ember-composable-helpers/helpers/inc'], function (exports, _emberComposableHelpersHelpersInc) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersInc['default'];
    }
  });
  Object.defineProperty(exports, 'inc', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersInc.inc;
    }
  });
});
define('pilas-engine-bloques/helpers/intersect', ['exports', 'ember-composable-helpers/helpers/intersect'], function (exports, _emberComposableHelpersHelpersIntersect) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersIntersect['default'];
    }
  });
  Object.defineProperty(exports, 'intersect', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersIntersect.intersect;
    }
  });
});
define('pilas-engine-bloques/helpers/invoke', ['exports', 'ember-composable-helpers/helpers/invoke'], function (exports, _emberComposableHelpersHelpersInvoke) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersInvoke['default'];
    }
  });
  Object.defineProperty(exports, 'invoke', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersInvoke.invoke;
    }
  });
});
define('pilas-engine-bloques/helpers/join', ['exports', 'ember-composable-helpers/helpers/join'], function (exports, _emberComposableHelpersHelpersJoin) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersJoin['default'];
    }
  });
  Object.defineProperty(exports, 'join', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersJoin.join;
    }
  });
});
define('pilas-engine-bloques/helpers/map-by', ['exports', 'ember-composable-helpers/helpers/map-by'], function (exports, _emberComposableHelpersHelpersMapBy) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersMapBy['default'];
    }
  });
  Object.defineProperty(exports, 'mapBy', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersMapBy.mapBy;
    }
  });
});
define('pilas-engine-bloques/helpers/object-at', ['exports', 'ember-composable-helpers/helpers/object-at'], function (exports, _emberComposableHelpersHelpersObjectAt) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersObjectAt['default'];
    }
  });
  Object.defineProperty(exports, 'objectAt', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersObjectAt.objectAt;
    }
  });
});
define('pilas-engine-bloques/helpers/optional', ['exports', 'ember-composable-helpers/helpers/optional'], function (exports, _emberComposableHelpersHelpersOptional) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersOptional['default'];
    }
  });
  Object.defineProperty(exports, 'optional', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersOptional.optional;
    }
  });
});
define('pilas-engine-bloques/helpers/pipe-action', ['exports', 'ember-composable-helpers/helpers/pipe-action'], function (exports, _emberComposableHelpersHelpersPipeAction) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersPipeAction['default'];
    }
  });
});
define('pilas-engine-bloques/helpers/pipe', ['exports', 'ember-composable-helpers/helpers/pipe'], function (exports, _emberComposableHelpersHelpersPipe) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersPipe['default'];
    }
  });
  Object.defineProperty(exports, 'pipe', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersPipe.pipe;
    }
  });
});
define('pilas-engine-bloques/helpers/pluralize', ['exports', 'ember-inflector/lib/helpers/pluralize'], function (exports, _emberInflectorLibHelpersPluralize) {
  exports['default'] = _emberInflectorLibHelpersPluralize['default'];
});
define('pilas-engine-bloques/helpers/prism', ['exports', 'ember'], function (exports, _ember) {
  exports.prism = prism;

  function prism(params) {
    var html = Prism.highlight(params[0], Prism.languages.javascript);
    return _ember['default'].String.htmlSafe(html);
  }

  exports['default'] = _ember['default'].Helper.helper(prism);
});
define('pilas-engine-bloques/helpers/range', ['exports', 'ember-composable-helpers/helpers/range'], function (exports, _emberComposableHelpersHelpersRange) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersRange['default'];
    }
  });
  Object.defineProperty(exports, 'range', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersRange.range;
    }
  });
});
define('pilas-engine-bloques/helpers/reject-by', ['exports', 'ember-composable-helpers/helpers/reject-by'], function (exports, _emberComposableHelpersHelpersRejectBy) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersRejectBy['default'];
    }
  });
  Object.defineProperty(exports, 'rejectBy', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersRejectBy.rejectBy;
    }
  });
});
define('pilas-engine-bloques/helpers/repeat', ['exports', 'ember-composable-helpers/helpers/repeat'], function (exports, _emberComposableHelpersHelpersRepeat) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersRepeat['default'];
    }
  });
  Object.defineProperty(exports, 'repeat', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersRepeat.repeat;
    }
  });
});
define('pilas-engine-bloques/helpers/reverse', ['exports', 'ember-composable-helpers/helpers/reverse'], function (exports, _emberComposableHelpersHelpersReverse) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersReverse['default'];
    }
  });
  Object.defineProperty(exports, 'reverse', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersReverse.reverse;
    }
  });
});
define('pilas-engine-bloques/helpers/shuffle', ['exports', 'ember-composable-helpers/helpers/shuffle'], function (exports, _emberComposableHelpersHelpersShuffle) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersShuffle['default'];
    }
  });
  Object.defineProperty(exports, 'shuffle', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersShuffle.shuffle;
    }
  });
});
define('pilas-engine-bloques/helpers/singularize', ['exports', 'ember-inflector/lib/helpers/singularize'], function (exports, _emberInflectorLibHelpersSingularize) {
  exports['default'] = _emberInflectorLibHelpersSingularize['default'];
});
define('pilas-engine-bloques/helpers/sort-by', ['exports', 'ember-composable-helpers/helpers/sort-by'], function (exports, _emberComposableHelpersHelpersSortBy) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersSortBy['default'];
    }
  });
  Object.defineProperty(exports, 'sortBy', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersSortBy.sortBy;
    }
  });
});
define('pilas-engine-bloques/helpers/take', ['exports', 'ember-composable-helpers/helpers/take'], function (exports, _emberComposableHelpersHelpersTake) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersTake['default'];
    }
  });
  Object.defineProperty(exports, 'take', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersTake.take;
    }
  });
});
define('pilas-engine-bloques/helpers/toggle-action', ['exports', 'ember-composable-helpers/helpers/toggle-action'], function (exports, _emberComposableHelpersHelpersToggleAction) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersToggleAction['default'];
    }
  });
});
define('pilas-engine-bloques/helpers/toggle', ['exports', 'ember-composable-helpers/helpers/toggle'], function (exports, _emberComposableHelpersHelpersToggle) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersToggle['default'];
    }
  });
  Object.defineProperty(exports, 'toggle', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersToggle.toggle;
    }
  });
});
define('pilas-engine-bloques/helpers/truncate', ['exports', 'ember-composable-helpers/helpers/truncate'], function (exports, _emberComposableHelpersHelpersTruncate) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersTruncate['default'];
    }
  });
  Object.defineProperty(exports, 'truncate', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersTruncate.truncate;
    }
  });
});
define('pilas-engine-bloques/helpers/underscore', ['exports', 'ember-composable-helpers/helpers/underscore'], function (exports, _emberComposableHelpersHelpersUnderscore) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersUnderscore['default'];
    }
  });
  Object.defineProperty(exports, 'underscore', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersUnderscore.underscore;
    }
  });
});
define('pilas-engine-bloques/helpers/union', ['exports', 'ember-composable-helpers/helpers/union'], function (exports, _emberComposableHelpersHelpersUnion) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersUnion['default'];
    }
  });
  Object.defineProperty(exports, 'union', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersUnion.union;
    }
  });
});
define('pilas-engine-bloques/helpers/w', ['exports', 'ember-composable-helpers/helpers/w'], function (exports, _emberComposableHelpersHelpersW) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersW['default'];
    }
  });
  Object.defineProperty(exports, 'w', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersW.w;
    }
  });
});
define('pilas-engine-bloques/helpers/without', ['exports', 'ember-composable-helpers/helpers/without'], function (exports, _emberComposableHelpersHelpersWithout) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersWithout['default'];
    }
  });
  Object.defineProperty(exports, 'without', {
    enumerable: true,
    get: function get() {
      return _emberComposableHelpersHelpersWithout.without;
    }
  });
});
define('pilas-engine-bloques/initializers/add-modals-container', ['exports', 'ember-modal-dialog/initializers/add-modals-container'], function (exports, _emberModalDialogInitializersAddModalsContainer) {
  exports['default'] = {
    name: 'add-modals-container',
    initialize: _emberModalDialogInitializersAddModalsContainer['default']
  };
});
define('pilas-engine-bloques/initializers/app-version', ['exports', 'ember-cli-app-version/initializer-factory', 'pilas-engine-bloques/config/environment'], function (exports, _emberCliAppVersionInitializerFactory, _pilasEngineBloquesConfigEnvironment) {
  exports['default'] = {
    name: 'App Version',
    initialize: (0, _emberCliAppVersionInitializerFactory['default'])(_pilasEngineBloquesConfigEnvironment['default'].APP.name, _pilasEngineBloquesConfigEnvironment['default'].APP.version)
  };
});
define('pilas-engine-bloques/initializers/container-debug-adapter', ['exports', 'ember-resolver/container-debug-adapter'], function (exports, _emberResolverContainerDebugAdapter) {
  exports['default'] = {
    name: 'container-debug-adapter',

    initialize: function initialize() {
      var app = arguments[1] || arguments[0];

      app.register('container-debug-adapter:main', _emberResolverContainerDebugAdapter['default']);
      app.inject('container-debug-adapter:main', 'namespace', 'application:main');
    }
  };
});
define('pilas-engine-bloques/initializers/data-adapter', ['exports', 'ember'], function (exports, _ember) {

  /*
    This initializer is here to keep backwards compatibility with code depending
    on the `data-adapter` initializer (before Ember Data was an addon).
  
    Should be removed for Ember Data 3.x
  */

  exports['default'] = {
    name: 'data-adapter',
    before: 'store',
    initialize: function initialize() {}
  };
});
define('pilas-engine-bloques/initializers/ember-cli-mirage', ['exports', 'ember-cli-mirage/utils/read-modules', 'pilas-engine-bloques/config/environment', 'pilas-engine-bloques/mirage/config', 'ember-cli-mirage/server', 'lodash/object/assign'], function (exports, _emberCliMirageUtilsReadModules, _pilasEngineBloquesConfigEnvironment, _pilasEngineBloquesMirageConfig, _emberCliMirageServer, _lodashObjectAssign) {
  exports.startMirage = startMirage;
  exports['default'] = {
    name: 'ember-cli-mirage',
    initialize: function initialize(application) {
      if (arguments.length > 1) {
        // Ember < 2.1
        var container = arguments[0],
            application = arguments[1];
      }

      if (_shouldUseMirage(_pilasEngineBloquesConfigEnvironment['default'].environment, _pilasEngineBloquesConfigEnvironment['default']['ember-cli-mirage'])) {
        startMirage(_pilasEngineBloquesConfigEnvironment['default']);
      }
    }
  };

  function startMirage() {
    var env = arguments.length <= 0 || arguments[0] === undefined ? _pilasEngineBloquesConfigEnvironment['default'] : arguments[0];

    var environment = env.environment;
    var modules = (0, _emberCliMirageUtilsReadModules['default'])(env.modulePrefix);
    var options = (0, _lodashObjectAssign['default'])(modules, { environment: environment, baseConfig: _pilasEngineBloquesMirageConfig['default'], testConfig: _pilasEngineBloquesMirageConfig.testConfig });

    return new _emberCliMirageServer['default'](options);
  }

  function _shouldUseMirage(env, addonConfig) {
    var userDeclaredEnabled = typeof addonConfig.enabled !== 'undefined';
    var defaultEnabled = _defaultEnabled(env, addonConfig);

    return userDeclaredEnabled ? addonConfig.enabled : defaultEnabled;
  }

  /*
    Returns a boolean specifying the default behavior for whether
    to initialize Mirage.
  */
  function _defaultEnabled(env, addonConfig) {
    var usingInDev = env === 'development' && !addonConfig.usingProxy;
    var usingInTest = env === 'test';

    return usingInDev || usingInTest;
  }
});
define('pilas-engine-bloques/initializers/ember-data', ['exports', 'ember-data/setup-container', 'ember-data/-private/core'], function (exports, _emberDataSetupContainer, _emberDataPrivateCore) {

  /*
  
    This code initializes Ember-Data onto an Ember application.
  
    If an Ember.js developer defines a subclass of DS.Store on their application,
    as `App.StoreService` (or via a module system that resolves to `service:store`)
    this code will automatically instantiate it and make it available on the
    router.
  
    Additionally, after an application's controllers have been injected, they will
    each have the store made available to them.
  
    For example, imagine an Ember.js application with the following classes:
  
    App.StoreService = DS.Store.extend({
      adapter: 'custom'
    });
  
    App.PostsController = Ember.Controller.extend({
      // ...
    });
  
    When the application is initialized, `App.ApplicationStore` will automatically be
    instantiated, and the instance of `App.PostsController` will have its `store`
    property set to that instance.
  
    Note that this code will only be run if the `ember-application` package is
    loaded. If Ember Data is being used in an environment other than a
    typical application (e.g., node.js where only `ember-runtime` is available),
    this code will be ignored.
  */

  exports['default'] = {
    name: 'ember-data',
    initialize: _emberDataSetupContainer['default']
  };
});
define('pilas-engine-bloques/initializers/export-application-global', ['exports', 'ember', 'pilas-engine-bloques/config/environment'], function (exports, _ember, _pilasEngineBloquesConfigEnvironment) {
  exports.initialize = initialize;

  function initialize() {
    var application = arguments[1] || arguments[0];
    if (_pilasEngineBloquesConfigEnvironment['default'].exportApplicationGlobal !== false) {
      var theGlobal;
      if (typeof window !== 'undefined') {
        theGlobal = window;
      } else if (typeof global !== 'undefined') {
        theGlobal = global;
      } else if (typeof self !== 'undefined') {
        theGlobal = self;
      } else {
        // no reasonable global, just bail
        return;
      }

      var value = _pilasEngineBloquesConfigEnvironment['default'].exportApplicationGlobal;
      var globalName;

      if (typeof value === 'string') {
        globalName = value;
      } else {
        globalName = _ember['default'].String.classify(_pilasEngineBloquesConfigEnvironment['default'].modulePrefix);
      }

      if (!theGlobal[globalName]) {
        theGlobal[globalName] = application;

        application.reopen({
          willDestroy: function willDestroy() {
            this._super.apply(this, arguments);
            delete theGlobal[globalName];
          }
        });
      }
    }
  }

  exports['default'] = {
    name: 'export-application-global',

    initialize: initialize
  };
});
define('pilas-engine-bloques/initializers/injectStore', ['exports', 'ember'], function (exports, _ember) {

  /*
    This initializer is here to keep backwards compatibility with code depending
    on the `injectStore` initializer (before Ember Data was an addon).
  
    Should be removed for Ember Data 3.x
  */

  exports['default'] = {
    name: 'injectStore',
    before: 'store',
    initialize: function initialize() {}
  };
});
define('pilas-engine-bloques/initializers/responsive', ['exports', 'ember-responsive/initializers/responsive'], function (exports, _emberResponsiveInitializersResponsive) {
  exports['default'] = _emberResponsiveInitializersResponsive['default'];
});
define('pilas-engine-bloques/initializers/store', ['exports', 'ember'], function (exports, _ember) {

  /*
    This initializer is here to keep backwards compatibility with code depending
    on the `store` initializer (before Ember Data was an addon).
  
    Should be removed for Ember Data 3.x
  */

  exports['default'] = {
    name: 'store',
    after: 'ember-data',
    initialize: function initialize() {}
  };
});
define('pilas-engine-bloques/initializers/transforms', ['exports', 'ember'], function (exports, _ember) {

  /*
    This initializer is here to keep backwards compatibility with code depending
    on the `transforms` initializer (before Ember Data was an addon).
  
    Should be removed for Ember Data 3.x
  */

  exports['default'] = {
    name: 'transforms',
    before: 'store',
    initialize: function initialize() {}
  };
});
define("pilas-engine-bloques/instance-initializers/ember-data", ["exports", "ember-data/-private/instance-initializers/initialize-store-service"], function (exports, _emberDataPrivateInstanceInitializersInitializeStoreService) {
  exports["default"] = {
    name: "ember-data",
    initialize: _emberDataPrivateInstanceInitializersInitializeStoreService["default"]
  };
});
define('pilas-engine-bloques/mirage/config', ['exports'], function (exports) {
  exports['default'] = function () {

    this.get('/desafios');
    this.get('/desafios/:id');

    this.get('/grupos');
    this.get('/grupos/:id');

    // this.urlPrefix = '';    // make this `http://localhost:8080`, for example, if your API is on a different server
    // this.namespace = '';    // make this `api`, for example, if your API is namespaced
    this.timing = 500; // delay for each request, automatically set to 0 during testing

    this.passthrough('http://104.131.245.133:9914/**');
    this.passthrough('http://api.pilasbloques.program.ar/**');
    this.passthrough('https://api.github.com/**');
    this.passthrough('http://testing-pilas-bloques-api.enjambrelab.com.ar/**');

    /*
      Shorthand cheatsheet:
       this.get('/posts');
      this.post('/posts');
      this.get('/posts/:id');
      this.put('/posts/:id'); // or this.patch
      this.del('/posts/:id');
       http://www.ember-cli-mirage.com/docs/v0.2.0-beta.7/shorthands/
    */
  };
});
define('pilas-engine-bloques/mirage/fixtures/desafios', ['exports'], function (exports) {
  exports['default'] = [{
    id: 1,
    grupoId: 1,
    nombre: 'AlienTocaBoton',
    titulo: 'El alien toca el botón',
    enunciado: 'Ayudá a nuestro Alien a presionar el botón de su laboratorio. \n' + 'Pistas: mirá las acciones disponibles. ¡Vas a tener que avanzar varias veces!',
    consignaInicial: 'Los bloques te permiten formar secuencias de acciones para resolver los desafíos que te proponemos en Pilas Bloques.',
    escena: 'AlienInicial',
    actividad: null /* Se carga desde un hook en la ruta desafío. */
  }, {
    id: 2,
    grupoId: 1,
    nombre: 'ElGatoEnLaCalle', // sale de 'id' en 'app/actividades/actividadElGatoEnLaCalle.js'
    titulo: 'El gato en la calle', // sale de 'nombre' en 'app/actividades/actividadElGatoEnLaCalle.js'
    enunciado: 'Hacé que el gato avance un paso, se duerma, se despierte, salude y vuelva a su lugar.',
    consignaInicial: 'Se pueden crear nuevas acciones en Procedimientos definiendo nuevos bloques que incluyan otras acciones.',
    escena: 'ElGatoEnLaCalle',
    actividad: null
  }, {
    id: 3,
    grupoId: 1,
    nombre: 'NoMeCansoDeSaltar',
    titulo: 'No me canso de saltar',
    enunciado: 'Ayudá al gato a quitarse la pereza saltando 30 veces seguidas. Pista: se puede resolver con menos de 30 bloques.',
    consignaInicial: 'El bloque Repetir permite elegir la cantidad de veces que se desea repetir una secuencia de acciones. Esto se llama "Repetición simple".',
    escena: 'NoMeCansoDeSaltar',
    actividad: null
  }, {
    id: 4,
    grupoId: 1,
    nombre: 'ElMarcianoEnElDesierto',
    titulo: 'El marciano en el desierto',
    enunciado: 'El marciano está perdido en el desierto y necesita alimentarse de su comida favorita: ¡las manzanas! Ayudalo a comer las frutas. Pista: Crear un procedimiento (bloque) para cada conjunto de manzanas',
    consignaInicial: 'Hay muchas formas de comer las manzanas. Podés empezar por las de la derecha, ¡o podés empezar por arriba! ¿Se te ocurre otra estrategia? Pensala siempre antes de programar',
    escena: 'ElMarcianoEnElDesierto',
    actividad: null
  }, {
    id: 5,
    grupoId: 1,
    nombre: 'TitoEnciendeLuces',
    titulo: 'Tito enciende las luces',
    enunciado: 'Ayudá a Tito a encender todas las luces. \n' + 'Pista: creá un procedimiento para prender todas las luces de una diagonal.',
    consignaInicial: 'Se puede crear un procedimiento una vez y usarlo todas las veces que quieras dentro de un programa.',
    escena: 'TitoEnciendeLuces',
    actividad: null
  }, {
    id: 6,
    grupoId: 1,
    nombre: 'ElAlienYLasTuercas',
    titulo: 'El alien y las tuercas',
    enunciado: 'Definí un programa para que el alien junte todas las tuercas. Pista: ¿El alien no puede moverse en diagonal? Podés crear tu propio procedimiento para que lo haga',
    escena: 'AlienLevantaTuercas',
    actividad: null
  }, {
    id: 7,
    grupoId: 1,
    nombre: 'ElRecolectorDeEstrellas',
    titulo: 'El recolector de estrellas',
    enunciado: 'Ayudá a nuestro personaje a recolectar todas las estrellas. Pista: podés hacer un procedimiento que tome una fila de estrellas.',
    consignaInicial: 'Usar muchas veces un procedimiento te ahorra trabajo.',
    escena: 'ElRecolectorDeEstrellas',
    actividad: null
  }, {
    id: 8,
    grupoId: 1,
    nombre: 'MariaLaComeSandias',
    titulo: 'María y las sandías',
    enunciado: 'María necesita comer todas las sandías de la cuadrícula. Pensá de qué manera puede hacerlo creando los bloques necesarios. Pista: la forma en que las sandías están distribuidas en la cuadrícula, es clave para crear la menor cantidad de procedimientos.',
    escena: 'MariaLaComeSandias',
    actividad: null
  }, {
    id: 9,
    grupoId: 1,
    nombre: 'AlimentandoALosPeces',
    titulo: 'Alimentando a los peces',
    enunciado: 'Nuestro buzo debe alimentar con lombrices a los 7 peces que hay en esta escena. Buscá primero a las lombrices y luego pasá por cada pez alimentándolo. Pista: pensá en una estrategia de 3 partes.',
    consignaInicial: '',
    escena: 'AlimentandoALosPeces',
    actividad: null
  }, {
    id: 10,
    grupoId: 1,
    nombre: 'InstalandoJuegos',
    titulo: 'Instalando juegos',
    enunciado: 'Ramiro tiene que instalar un juego en 3 compus para divertirse con sus amigos. Los pasos para instalarlo en cada una son: encenderla, ingresar la contraseña ("ABC"), instalar el juego y apagar la máquina. Pista: aprovechá que en cada compu hay que hacer el mismo trabajo.',
    escena: 'InstalandoJuegos',
    actividad: null
  }, {
    id: 11,
    grupoId: 1,
    nombre: 'LaGranAventuraDelMarEncantado',
    titulo: 'La gran aventura del mar encantado',
    enunciado: 'Ayuda a la heroína a rescatar a su príncipe. Para ello debe superar en orden cada una de las siguientes pruebas:\n' + '1) Buscar la llave.\n' + '2) Abrir el cofre con la llave y tomar el sombrero mágico que está dentro.\n' + '3) Entregarle el sombrero al mago para recibir la espada a cambio.\n' + '4) Luchar con la espada contra el caballero oscuro.\n' + '5) Escapar en unicornio.',
    consignaInicial: '',
    escena: 'LaGranAventuraDelMarEncantado',
    actividad: null
  }, {
    id: 12,
    grupoId: 1,
    nombre: 'ReparandoLaNave',
    titulo: 'Reparando la nave',
    enunciado: 'El marciano debe arreglar su nave para poder volver a su hogar. Para lograrlo debe llevar 3 unidades de carbón y 3 de hierro a la nave, pero no puede cargar más de una unidad a la vez.',
    escena: 'ReparandoLaNave',
    actividad: null
  }, {
    id: 13,
    grupoId: 2,
    nombre: 'ElMonoYLasBananas',
    titulo: 'El mono y las bananas',
    enunciado: '¿Podés hacer que el mono avance al casillero de enfrente?' + ' Si hay una banana debe comérsela. Si no, es feliz con sólo llegar. \n ' + 'Ejecutá el programa varias veces para asegurarte que siempre funciona. \n' + 'Pista: mirá la categoría "Sensores" y la categoría "Alternativas".',
    consignaInicial: 'El bloque "Si... Entonces" ejecuta una secuencia de instrucciones solamente cuando la condición es verdadera. Esto se llama "alternativa condicional".',
    escena: 'ElMonoYLasBananas',
    actividad: null
  }, {
    id: 14,
    grupoId: 2,
    nombre: 'LaEleccionDelMono',
    titulo: 'La elección del mono',
    enunciado: '¿Podés ayudar nuevamente a nuestro mono? Esta vez tiene ' + 'que elegir qué fruta comer. \n' + 'Ejecutá el programa varias veces para asegurarte que siempre funciona. \n' + 'Pista: ésta vez no alcanza con el bloque "Si".',
    consignaInicial: 'Cuando sólo hay 2 opciones, alcanza con hacer una sola pregunta. En esos casos se puede usar el bloque "Si... si no".',
    escena: 'LaEleccionDelMono',
    actividad: null
  }, {
    id: 15,
    grupoId: 2,
    nombre: 'LaberintoCorto',
    titulo: 'Laberinto corto',
    enunciado: 'Guiá al ratón para llegar a la meta. Para lograrlo, debe avanzar una casilla en la dirección que indica la flecha. Pista: mirá en la categoría "Sensores" qué preguntas podés hacer.',
    escena: 'LaberintoCorto',
    actividad: null
  }, {
    id: 16,
    grupoId: 2,
    nombre: 'TresNaranjas',
    titulo: 'Tres naranjas',
    enunciado: 'El alien debe comer todos los gajos de naranja que aparezcan en las casillas violetas. ¡Pero no siempre aparecen en los mismos lugares ni la misma cantidad de naranjas! Pista: pensá primero cómo harías un procedimiento para comer una sola naranja si es que la hay.',
    escena: 'TresNaranjas',
    actividad: null
  }, {
    id: 17,
    grupoId: 2,
    nombre: 'TitoRecargado',
    titulo: 'Tito recargado',
    enunciado: 'Tito necesita encender las luces para poder conocer el camino... ¡Pero en cada ejecución cambian de lugar! Podés utlizar los procedimientos y bloques de control.',
    escena: 'TitoRecargado',
    actividad: null
  }, {
    id: 18,
    grupoId: 2,
    nombre: 'LaberintoLargo',
    titulo: 'Laberinto largo',
    enunciado: 'Ayudá al ratón a salir del laberinto. A diferencia del laberinto anterior, aquí la cantidad de casillas que debe avanzar son muchas. ¿Cuántas? ¿Es siempre la misma? Pista: pensá primero cómo avanzar una sola casilla.',
    escena: 'LaberintoLargo',
    actividad: null
  }, {
    id: 19,
    grupoId: 3,
    nombre: 'SuperTito1',
    titulo: 'Súper Tito 1 ',
    enunciado: ' Ayudá a Tito a encender las luces. \n ¡Ojo! En todas las celdas hay una luz, pero no sabés cuántas celdas hay en cada ejecución.',
    consignaInicial: 'Hay nuevos bloques que pueden ayudarte a resolver el desafío de manera muy sencilla. ¡Aprovechalos!',
    escena: 'SuperTito1',
    actividad: null
  }, {
    id: 20,
    grupoId: 3,
    nombre: 'SuperTito2',
    titulo: 'Súper Tito 2',
    enunciado: 'Súper Tito debe encender todas las luces, pero a diferencia del desafío anterior, hay celdas sin luz. ¿Podrás utilizar el mismo procedimiento que en Súper Tito 1? \n',
    consignaInicial: 'El bloque "repetir hasta que" repite una secuencia de acciones hasta que se cumple una condición. Esto se llama "repetición condicional".',
    escena: 'SuperTito2',
    actividad: null
  }, {
    id: 21,
    grupoId: 3,
    nombre: 'LaberintoConQueso',
    titulo: 'Laberinto con queso',
    enunciado: '¡El ratón está más hambriento que nunca! Guialo por el laberinto para que pueda comer todos los trozos de queso. Pista: antes de empezar, apretá varias veces el botón Ejecutar para conocer cómo varía el escenario.',
    consignaInicial: 'Es importante pensar si en algún momento se cumple la condición del bloque "Repetir hasta qué". Sino, ¡el programa podría no terminar nunca!',
    escena: 'LaberintoConQueso',
    actividad: null
  }, {
    id: 22,
    grupoId: 3,
    nombre: 'ElDetectiveChaparro',
    titulo: 'El detective Chaparro',
    enunciado: 'El detective debe descubrir al culpable de un crimen, quitándole el disfraz que lo camufla. Comenzando por el primero de la izquierda, ¡interrogá a cada uno de los sospechosos hasta encontrar al culpable!',
    consignaInicial: 'El bloque "Repetir hasta que" nos permite terminar el programa cuando encontramos al culpable sin tener que interrogar a todos los sospechosos de la fila.',
    escena: 'ElDetectiveChaparro',
    actividad: null
  }, {
    id: 23,
    grupoId: 3,
    nombre: 'FutbolRobots',
    titulo: 'Fútbol para robots',
    enunciado: 'Ayudá a nuestro robot futbolista a patear todas las pelotas. ' + 'Recordá siempre que una buena división en procedimientos puede ayudarte a encarar ' + 'mejor el problema.',
    consignaInicial: 'El procedimiento que se defina debe considerar el escenario variable y ofrecer una solución con poca cantidad de bloques. Es importante tener en cuenta que la acción se repite varias veces y que la longitud de las filas varía.',
    escena: 'FutbolRobots',
    actividad: null
  }, {
    id: 24,
    grupoId: 3,
    nombre: 'PrendiendoLasCompus',
    titulo: 'Prendiendo las compus',
    enunciado: 'Debemos prender todas las compus teniendo en cuenta que el ancho y el alto del escenario cambian en cada ejecución. Pista: pensá cómo harías para prender las compus de un solo lado del rectángulo y después repetilo para el resto de los lados.',
    escena: 'PrendiendoLasCompus',
    actividad: null
  }, {
    id: 25,
    grupoId: 3,
    nombre: 'ElMonoQueSabeContar',
    titulo: 'El mono que sabe contar',
    enunciado: 'El mono debe recorrer todas las casillas y contar cuántas bananas y manzanas hay en total. Pista: primero pensá cómo contarías si hay una manzana o una banana en una casilla determinada. Luego pensá cómo harías para contar todas las frutas de una sola columna.',
    consignaInicial: 'Subdividir un problema grande en problemas más pequeños ayuda a comprender mejor cada una de las partes que lo componen. Además nos permite concentrarnos en resolver cuestiones más sencillas al problema original.',
    escena: 'ElMonoQueSabeContar',
    actividad: null
  }, {
    id: 26,
    grupoId: 4,
    nombre: 'ElSuperviaje',
    titulo: 'El Superviaje',
    enunciado: 'Nuestro superhéroe debe realizar su súper paseo matutino que consiste en recorrer una cierta cantidad de kilómetros que varía día a día (entre 15 y 45 km). ¡Lográ que nuestro súper amigo llegue siempre a destino!',
    consignaInicial: 'Se puede usar un bloque "Repetir" con el valor de una variable. Esto permite repetir una secuencia de código la cantidad de veces que indique la variable.',
    escena: 'SuperViaje',
    actividad: null
  }, {
    id: 27,
    grupoId: 4,
    nombre: 'ElMonoCuentaDeNuevo',
    titulo: 'El mono cuenta de nuevo',
    enunciado: 'El mono tiene que contar otra vez las frutas, ¡pero ahora no puede verificar si ya llegó al final de una columna! Pista: mirá en la categoría "Variables" si hay algo que te pueda servir.',
    consignaInicial: 'Una variable nos permite guardar información que puede cambiar en cada ejecución del programa, incluso en una misma ejecución. Por ejemplo, el largo de cada columna varía dependiendo en qué columna esté parado el mono.',
    escena: 'ElMonoCuentaDeNuevo',
    actividad: null
  }, {
    id: 28,
    grupoId: 5,
    nombre: 'ElPlanetaDeNano',
    titulo: 'El planeta de Nano',
    escena: 'ElPlanetaDeNano',
    enunciado: 'Ayudá a Nano a recoger todas sus frutas. ¡Cuidado! No se puede bajar... \n ¡Tené en cuenta que el escenario no cambia, las bananas están siempre en las mismas casillas!',
    consignaInicial: 'A los procedimientos se les pueden agregar parámetros para que resulten más generales. Por ejemplo, si creamos los procedimientos "Avanzar 2 casillas", "Avanzar 3 casillas" y "Avanzar 4 casillas", podemos reemplazar a los 3 por un solo procedimiento que reciba como parámetro la cantidad de casillas que queremos avanzar: "Avanzar [cantidad] casillas".',
    actividad: null
  }, {
    id: 29,
    grupoId: 5,
    nombre: 'DibujandoAlCuadrado',
    titulo: 'Dibujando: Al cuadrado',
    enunciado: 'Dibujá un cuadrado que tenga 100 de lado.',
    consignaInicial: '',
    escena: 'DibujandoCuadrado',
    actividad: null
  }, {
    id: 30,
    grupoId: 5,
    nombre: 'DibujandoRayuelaRobotica',
    titulo: 'Dibujando: Rayuela robótica',
    enunciado: 'Dibujá 5 cuadrados en fila, cada uno de lado 50, como muestra la figura sombreada.',
    consignaInicial: '',
    escena: 'Dibujando5CuadradosHorizontal',
    actividad: null
  }, {
    id: 31,
    grupoId: 5,
    nombre: 'DibujandoCortoPorLaDiagonal',
    titulo: 'Dibujando: Corto por la diagonal',
    enunciado: 'Dibujá 5 cuadrados en diagonal, cada uno de lado 50, como muestra la figura sombreada.',
    consignaInicial: '',
    escena: 'Dibujando5CuadradosDiagonal',
    actividad: null
  }, {
    id: 32,
    grupoId: 5,
    nombre: 'DibujandoMamushkaCuadrada',
    titulo: 'Dibujando: Mamushka cuadrada',
    enunciado: 'Dibujá 4 cuadrados de lados 50, 100, 150 y 200, como muestra la figura sombreada. Pista: creá un procedimiento nuevo para dibujar cuadrados de cualquier longitud de lado.',
    consignaInicial: 'Incluir parámetros en los procedimientos permite generalizar un concepto. Por ejemplo, la longitud del lado de un cuadrado.',
    escena: 'Dibujando4CuadradosInteriores',
    actividad: null
  }, {
    id: 33,
    grupoId: 5,
    nombre: 'DibujandoEscaleraCuadrada',
    titulo: 'Dibujando: Escalera cuadrada',
    enunciado: 'Dibujá 5 cuadros de lado 50 y uno de 100, como muestra la figura sombreada.',
    consignaInicial: 'Al crear un procedimiento con parámetros, sus valores no están definidos (por ej. "longitud de lado"). Al usar los procedimientos hay que darles un valor concreto a esos parámetros (50, 100, etc.).',
    escena: 'DibujandoCabezaElefante',
    actividad: null
  }, {
    id: 34,
    grupoId: 5,
    nombre: 'DibujandoHexagono',
    titulo: 'Dibujando: Hexágono',
    enunciado: 'Dibujá un hexágono de lado 100, como muestra la figura sombreada. Pista: pensá cuántos grados debe girar el robot sabiendo cuánto miden los ángulos internos del hexágono.',
    consignaInicial: 'En los polígonos, el valor de un ángulo externo es igual a 180 menos el valor de un ángulo interno.',
    escena: 'DibujandoHexagono',
    actividad: null
  }, {
    id: 35,
    grupoId: 5,
    nombre: 'DibujandoPiramideInvertida',
    titulo: 'Dibujando: Pirámide invertida',
    enunciado: 'Dibujá un triángulo equilátero de lado 100, como muestra la figura sombreada. Pista: pensá si existe una relación entre los ángulos y la cantidad de lados.',
    consignaInicial: 'En los polígonos, la suma de todos los ángulos externos es 360',
    escena: 'DibujandoTrianguloEquilatero',
    actividad: null
  }, {
    id: 36,
    grupoId: 5,
    nombre: 'DibujandoFigurasDentroDeFiguras',
    titulo: 'Dibujando: Figuras dentro de figuras',
    enunciado: 'Dibujá un triángulo, un cuadrado y un hexágono de lados 100, como muestra la figura sombreada. Pista: creá un procedimiento con un parámetro para la cantidad de lados.',
    consignaInicial: 'Para agregar un parámetro a un procedimiento nuevo, hay que hacer clic en la estrella que aparece al lado de "Definir" y luego arrastrar el bloque "nombre de entrada" a "entradas".',
    escena: 'DibujandoPoligonosInteriores',
    actividad: null
  }, {
    id: 37,
    grupoId: 5,
    nombre: 'DibujandoLaCuevaDeEstalagtitas',
    titulo: 'Dibujando: La cueva de estalagtitas',
    enunciado: 'Dibujá 3 triángulos de lados 40, 60 y 100, y un cuadrado de lado 100, como muestra la figura sombreada. Pista: creá un procedimiento con 2 parámetros, uno para la cantidad de lados y otro para la longitud de los lados.',
    consignaInicial: 'Para poder usar los parámetros en un nuevo procedimiento, hay que hacer clic derecho en el bloque que define dicho procedimiento.',
    escena: 'DibujandoCuevaEstalagtitas',
    actividad: null
  }, {
    id: 130,
    grupoId: 5,
    nombre: 'LaFiestaDeDracula',
    titulo: 'La fiesta de Drácula',
    escena: 'LaFiestaDeDracula',
    enunciado: 'Para que la fiesta de Drácula comience debemos cambiar el color de las 3 lámparas una cierta cantidad de veces: 5 veces la primera, 8 la segunda y 12 la tercera.',
    actividad: null
  }, {
    id: 131,
    grupoId: 5,
    nombre: 'SalvandoLaNavidad',
    titulo: 'Salvando la Navidad',
    escena: 'SalvandoLaNavidad',
    enunciado: 'Ayudá a Papá Noel a dejar un regalo al final de cada fila. ¡Tené en cuenta que el escenario no cambia de una ejecución a la otra! Pista: si tuvieses que elegir un parámetro para tu procedimiento... ¿Cuál eligirías?',
    actividad: null
  }, {
    id: 132,
    grupoId: 5,
    nombre: 'PrendiendoLasCompusParametrizado',
    titulo: 'Prendiendo las compus parametrizado',
    escena: 'PrendiendoLasCompus',
    enunciado: 'Al igual que antes, debemos prender todas las compus. Pero esta vez tenés que definir un único procedimiento que prenda cualquiera de los lados.',
    consignaInicial: 'Los parámetros pueden ser de texto además de numéricos. Por ejemplo, un parámetro podría ser la dirección en que el autómata debe moverse.',
    actividad: null
  }, {
    id: 133,
    grupoId: 5,
    nombre: 'TitoCuadrado',
    titulo: 'Tito cuadrado',
    escena: 'TitoCuadrado',
    enunciado: 'Tito debe encender todas las luces del cuadrado pero en cada ejecución están distribuidas de una manera diferente. Tené en cuenta que las casillas de la esquina nunca se prenden y que el tamaño del cuadrado no varía de una ejecución a la otra.',
    actividad: null
  }, {
    id: 134,
    grupoId: 5,
    nombre: 'ElCangrejoAguafiestas',
    titulo: 'El cangrejo aguafiestas',
    escena: 'ElCangrejoAguafiestas',
    enunciado: 'El cangrejo quiere pinchar todos los globos de la fiesta. Tené en cuenta que estos no cambian de lugar. Pista: ¿la cantidad de globos y la dirección podrían ser parámetros?',
    consignaInicial: 'Se pueden combinar parámetros numéricos (cantidades, longitudes) con parámetros de texto (direcciones, nombres).',
    actividad: null
  }, {
    id: 135,
    grupoId: 5,
    nombre: 'PrendiendoLasFogatas',
    titulo: 'Prendiendo las fogatas',
    escena: 'PrendiendoLasFogatas',
    enunciado: 'En este caso debemos encender todas las fogatas del cuadrado pero en cada ejecución están distribuidas de una manera diferente. Tené en cuenta que las casillas de la esquina nunca se prenden y que el tamaño del cuadrado no varía de una ejecución a la otra.',
    actividad: null
  }, {
    id: 136,
    grupoId: 5,
    nombre: '',
    titulo: 'Próximamente: más actividades',
    deshabilitado: true,
    actividad: null
  }];
});
define('pilas-engine-bloques/mirage/fixtures/grupos', ['exports'], function (exports) {
  exports['default'] = [{
    id: 1,
    titulo: 'Autómatas, comandos, procedimientos y repetición'
  }, {
    id: 2,
    titulo: 'Alternativa condicional'
  }, {
    id: 3,
    titulo: 'Repetición condicional'
  }, {
    id: 4,
    titulo: 'Sensores Numéricos'
  }, {
    id: 5,
    titulo: 'Parametrización de soluciones'
  }];
});
define('pilas-engine-bloques/mirage/models/desafio', ['exports', 'ember-cli-mirage'], function (exports, _emberCliMirage) {
  exports['default'] = _emberCliMirage.Model.extend({});
});
define('pilas-engine-bloques/mirage/models/grupo', ['exports', 'ember-cli-mirage'], function (exports, _emberCliMirage) {
  exports['default'] = _emberCliMirage.Model.extend({
    desafios: (0, _emberCliMirage.hasMany)('desafio', { inverseOf: 'grupo' })
  });
});
define('pilas-engine-bloques/mirage/scenarios/default', ['exports'], function (exports) {
  exports['default'] = function (server) {
    server.loadFixtures('grupos');
    server.loadFixtures('desafios');
  };
});
define('pilas-engine-bloques/mirage/serializers/application', ['exports', 'ember-cli-mirage'], function (exports, _emberCliMirage) {
  exports['default'] = _emberCliMirage.JSONAPISerializer.extend({});
});
define('pilas-engine-bloques/models/desafio', ['exports', 'ember-data/model', 'ember-data/attr', 'ember-data/relationships'], function (exports, _emberDataModel, _emberDataAttr, _emberDataRelationships) {
  exports['default'] = _emberDataModel['default'].extend({
    nombre: (0, _emberDataAttr['default'])('string'),
    titulo: (0, _emberDataAttr['default'])('string'),
    deshabilitado: (0, _emberDataAttr['default'])('boolean'),
    enunciado: (0, _emberDataAttr['default'])('string'),
    consignaInicial: (0, _emberDataAttr['default'])('string'),
    escena: (0, _emberDataAttr['default'])('string'), // escena que se tiene que cargar, por ejemplo: 'AlienInicial'
    actividad: (0, _emberDataAttr['default'])(), // se completa desde el hook del desafío.
    grupo: (0, _emberDataRelationships.belongsTo)('grupo')
  });
});
define('pilas-engine-bloques/models/grupo', ['exports', 'ember-data/model', 'ember-data/attr', 'ember-data/relationships'], function (exports, _emberDataModel, _emberDataAttr, _emberDataRelationships) {
  exports['default'] = _emberDataModel['default'].extend({
    titulo: (0, _emberDataAttr['default'])('string'),
    desafios: (0, _emberDataRelationships.hasMany)('desafio') // , {inverseOf: 'grupo'})
  });
});
define('pilas-engine-bloques/resolver', ['exports', 'ember-resolver'], function (exports, _emberResolver) {
  exports['default'] = _emberResolver['default'];
});
define('pilas-engine-bloques/router', ['exports', 'ember', 'pilas-engine-bloques/config/environment'], function (exports, _ember, _pilasEngineBloquesConfigEnvironment) {

  var Router = _ember['default'].Router.extend({
    location: _pilasEngineBloquesConfigEnvironment['default'].locationType
  });

  Router.map(function () {
    this.route('acercade');
    this.route('desafio', { path: '/desafio/:desafio_id' });

    /* Rutas para el curso online 2016 (moodle) */
    this.route('desafios', function () {
      this.route('cursoAlumno', { path: "/cursoAlumno/:hash" });
      this.route('cursoDocente', { path: "/cursoDocente/:hash" });
      this.route('desafioPorNombre', { path: '/:nombreDelDesafio' });
      this.route('mensajeGuardado');
    });
  });

  Router.reopen({
    notifyGoogleAnalytics: _ember['default'].on("didTransition", function () {
      if (ga) {
        var url = this.get('url');
        ga('send', 'pageview', { page: url, title: url });
      }
    })
  });

  exports['default'] = Router;
});
define('pilas-engine-bloques/routes/acercade', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Route.extend({});
});
define('pilas-engine-bloques/routes/desafio', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Route.extend({
    pilas: _ember['default'].inject.service(),
    actividades: _ember['default'].inject.service(),

    // NOTA: el model hook está implícito, solo retornará el modelo por id.

    afterModel: function afterModel(model) {
      var actividad = this.get("actividades").obtenerPorNombre(model.get('nombre'));
      model.set('actividad', actividad);
    }
  });
});
define('pilas-engine-bloques/routes/desafios/curso-alumno', ['exports', 'ember'], function (exports, _ember) {

  /* Esta ruta es una especialización de la ruta Nombre,
   * ya que hace algo muy similar, pero esconde elementos
   * de la interfaz y permite guardar la solución en un
   * backend de datos.
   */
  exports['default'] = _ember['default'].Route.extend({
    cursoAPI: _ember['default'].inject.service(),
    actividades: _ember['default'].inject.service(),

    model: function model(params) {
      params.nombre = this.decodificarHash(params.hash).actividad;

      return this.store.findAll("desafio").then(function (data) {
        // TODO: reemplazar la linea anterior (findAll) y la siguiente
        //       por una consulta a ember-data más específica, como la que
        //       realiza findRecord, que solo debería traer un solo registro.
        //
        //       (esto está así ahora porque se debe corregir mirage antes).
        var model = data.findBy('nombre', params.nombre);

        if (!model) {
          throw new Error('No existe una actividad con el nombre ' + params.nombre);
        }

        return model;
      });
    },

    /* Agrega los parámetros decodificados del hash al modelo. */
    afterModel: function afterModel(model, transition) {
      var hash = this.obtener_hash_desde_transition(transition);
      var valores = this.decodificarHash(hash);

      var actividad = this.get("actividades").obtenerPorNombre(valores.actividad);
      model.set('actividad', actividad);

      model.idAlumno = valores.idAlumno;
      model.hash = valores.hashCompleto;

      return this.get("cursoAPI").obtener_solucion_xml_desde_hash(model.hash).then(function (solucion_xml) {
        model.set("solucion", btoa(solucion_xml));
      })['catch'](function () {
        console.warn("Ha fallado solicitar la solución al servidor, esto es porque el alumno no hay guardado nunca.");
        return null;
      });
    },

    obtener_hash_desde_transition: function obtener_hash_desde_transition(transition) {
      return transition.params[this.routeName].hash;
    },

    decodificarHash: function decodificarHash(hash) {
      var hashString = atob(hash);
      var valores = hashString.split("-");

      if (valores.length !== 3) {
        throw Error('Hash con formato de piezas incorrecto: ' + hashString);
      }

      return {
        actividad: valores[0],
        idAlumno: valores[1],
        hashMoodle: valores[2],
        hashCompleto: hash
      };
    },

    activate: function activate() {
      this.ocultarLayout();
    },

    ocultarLayout: function ocultarLayout() {
      this.controllerFor('application').set('layout', false);
    },

    actions: {
      guardar_solucion_en_el_backend: function guardar_solucion_en_el_backend(parametros) {
        var _this = this;

        this.get("cursoAPI").guardar(parametros).then(function () {
          _this.transitionTo("desafios.mensajeGuardado");
        })['catch'](function (reason) {
          console.error(reason);
          alert("Se a producido un error al guardar, por favor volvé a intentar.");
        });
      }
    }

  });
});
define("pilas-engine-bloques/routes/desafios/curso-docente", ["exports", "pilas-engine-bloques/routes/desafios/curso-alumno"], function (exports, _pilasEngineBloquesRoutesDesafiosCursoAlumno) {
  exports["default"] = _pilasEngineBloquesRoutesDesafiosCursoAlumno["default"].extend({

    afterModel: function afterModel(model, transition) {
      this._super(model, transition);

      return this.get("cursoAPI").obtener_solucion_xml_desde_hash(model.hash).then(function (solucion_xml) {
        model.set("solucion", btoa(solucion_xml));
      });
    }
  });
});
define('pilas-engine-bloques/routes/desafios/desafio-por-nombre', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Route.extend({

    model: function model(params) {
      var _this = this;

      return this.store.findAll("desafio").then(function (data) {
        // TODO: reemplazar la linea anterior (findAll) y la siguiente
        //       por una consulta a ember-data más específica, como la que
        //       realiza findRecord, que solo debería traer un solo registro.
        //
        //       (esto está así ahora porque se debe corregir mirage antes).
        var model = data.findBy('nombre', params.nombreDelDesafio);

        if (!model) {
          throw new Error('No existe una actividad con el nombre ' + params.nombreDelDesafio);
        }

        return _this.transitionTo("desafio", model);
      });
    }

  });
});
define('pilas-engine-bloques/routes/desafios/index', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Route.extend({
    model: function model() {
      return this.store.findAll('grupo');
    }
  });
});
define('pilas-engine-bloques/routes/desafios/mensaje-guardado', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Route.extend({});
});
define('pilas-engine-bloques/routes/index', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Route.extend({});
});
define('pilas-engine-bloques/serializers/ls-serializer', ['exports', 'ember-localstorage-adapter/serializers/ls-serializer'], function (exports, _emberLocalstorageAdapterSerializersLsSerializer) {
  exports['default'] = _emberLocalstorageAdapterSerializersLsSerializer['default'];
});
define('pilas-engine-bloques/services/actividades', ['exports', 'ember', 'pilas-engine-bloques/actividades/actividadAlien', 'pilas-engine-bloques/actividades/actividadLaEleccionDelMono', 'pilas-engine-bloques/actividades/actividadElMonoYLasBananas', 'pilas-engine-bloques/actividades/actividadTitoEnciendeLuces', 'pilas-engine-bloques/actividades/actividadFutbolRobots', 'pilas-engine-bloques/actividades/actividadElPlanetaDeNano', 'pilas-engine-bloques/actividades/actividadAlienTocaBoton', 'pilas-engine-bloques/actividades/actividadTitoRecargado', 'pilas-engine-bloques/actividades/actividadSuperTito1', 'pilas-engine-bloques/actividades/actividadSuperTito2', 'pilas-engine-bloques/actividades/actividadElRecolectorDeEstrellas', 'pilas-engine-bloques/actividades/actividadLaGranAventuraDelMarEncantado', 'pilas-engine-bloques/actividades/actividadMariaLaComeSandias', 'pilas-engine-bloques/actividades/actividadElMarcianoEnElDesierto', 'pilas-engine-bloques/actividades/actividadAlimentandoALosPeces', 'pilas-engine-bloques/actividades/actividadInstalandoJuegos', 'pilas-engine-bloques/actividades/actividadElGatoEnLaCalle', 'pilas-engine-bloques/actividades/actividadNoMeCansoDeSaltar', 'pilas-engine-bloques/actividades/actividadReparandoLaNave', 'pilas-engine-bloques/actividades/actividadElMonoQueSabeContar', 'pilas-engine-bloques/actividades/actividadTresNaranjas', 'pilas-engine-bloques/actividades/actividadLaberintoCorto', 'pilas-engine-bloques/actividades/actividadLaberintoLargo', 'pilas-engine-bloques/actividades/actividadLaberintoConQueso', 'pilas-engine-bloques/actividades/actividadElCangrejoAguafiestas', 'pilas-engine-bloques/actividades/actividadElDetectiveChaparro', 'pilas-engine-bloques/actividades/actividadPrendiendoLasCompus', 'pilas-engine-bloques/actividades/actividadPrendiendoLasCompus-conParametros', 'pilas-engine-bloques/actividades/actividadElMonoCuentaDeNuevo', 'pilas-engine-bloques/actividades/actividadElSuperviaje', 'pilas-engine-bloques/actividades/actividadesDibujandoFiguras', 'pilas-engine-bloques/actividades/actividadSalvandoLaNavidad', 'pilas-engine-bloques/actividades/actividadTitoCuadrado', 'pilas-engine-bloques/actividades/actividadLaFiestaDeDracula', 'pilas-engine-bloques/actividades/actividadPrendiendoLasFogatas', 'pilas-engine-bloques/actividades/actividad'], function (exports, _ember, _pilasEngineBloquesActividadesActividadAlien, _pilasEngineBloquesActividadesActividadLaEleccionDelMono, _pilasEngineBloquesActividadesActividadElMonoYLasBananas, _pilasEngineBloquesActividadesActividadTitoEnciendeLuces, _pilasEngineBloquesActividadesActividadFutbolRobots, _pilasEngineBloquesActividadesActividadElPlanetaDeNano, _pilasEngineBloquesActividadesActividadAlienTocaBoton, _pilasEngineBloquesActividadesActividadTitoRecargado, _pilasEngineBloquesActividadesActividadSuperTito1, _pilasEngineBloquesActividadesActividadSuperTito2, _pilasEngineBloquesActividadesActividadElRecolectorDeEstrellas, _pilasEngineBloquesActividadesActividadLaGranAventuraDelMarEncantado, _pilasEngineBloquesActividadesActividadMariaLaComeSandias, _pilasEngineBloquesActividadesActividadElMarcianoEnElDesierto, _pilasEngineBloquesActividadesActividadAlimentandoALosPeces, _pilasEngineBloquesActividadesActividadInstalandoJuegos, _pilasEngineBloquesActividadesActividadElGatoEnLaCalle, _pilasEngineBloquesActividadesActividadNoMeCansoDeSaltar, _pilasEngineBloquesActividadesActividadReparandoLaNave, _pilasEngineBloquesActividadesActividadElMonoQueSabeContar, _pilasEngineBloquesActividadesActividadTresNaranjas, _pilasEngineBloquesActividadesActividadLaberintoCorto, _pilasEngineBloquesActividadesActividadLaberintoLargo, _pilasEngineBloquesActividadesActividadLaberintoConQueso, _pilasEngineBloquesActividadesActividadElCangrejoAguafiestas, _pilasEngineBloquesActividadesActividadElDetectiveChaparro, _pilasEngineBloquesActividadesActividadPrendiendoLasCompus, _pilasEngineBloquesActividadesActividadPrendiendoLasCompusConParametros, _pilasEngineBloquesActividadesActividadElMonoCuentaDeNuevo, _pilasEngineBloquesActividadesActividadElSuperviaje, _pilasEngineBloquesActividadesActividadesDibujandoFiguras, _pilasEngineBloquesActividadesActividadSalvandoLaNavidad, _pilasEngineBloquesActividadesActividadTitoCuadrado, _pilasEngineBloquesActividadesActividadLaFiestaDeDracula, _pilasEngineBloquesActividadesActividadPrendiendoLasFogatas, _pilasEngineBloquesActividadesActividad) {

  /*
   * Representa un valor mas complejo
   * de un campo de un bloque
   */
  var ParamValor = _ember['default'].Object.extend({
    build: function build() {
      var str_block = '';
      str_block += '<value name="NOMBRE">'.replace('NOMBRE', this.get('nombre_param'));

      str_block += '<block type="TIPO">'.replace('TIPO', this.get('tipo_bloque'));

      str_block += '<field name="TIPO">'.replace('TIPO', this.get('nombre_valor'));
      str_block += this.get('valor');
      str_block += '</field>';

      str_block += '</block>';

      str_block += '</value>';

      return str_block;
    }
  });

  exports['default'] = _ember['default'].Service.extend({

    obtenerPorNombre: function obtenerPorNombre(nombre) {

      var actividades = [_pilasEngineBloquesActividadesActividadAlien['default'], _pilasEngineBloquesActividadesActividadAlienTocaBoton['default'], _pilasEngineBloquesActividadesActividadLaEleccionDelMono['default'], _pilasEngineBloquesActividadesActividadElMonoYLasBananas['default'], _pilasEngineBloquesActividadesActividadTitoEnciendeLuces['default'], _pilasEngineBloquesActividadesActividadFutbolRobots['default'], _pilasEngineBloquesActividadesActividadElPlanetaDeNano['default'], _pilasEngineBloquesActividadesActividadTitoRecargado['default'], _pilasEngineBloquesActividadesActividadSuperTito1['default'], _pilasEngineBloquesActividadesActividadSuperTito2['default'], _pilasEngineBloquesActividadesActividadElRecolectorDeEstrellas['default'], _pilasEngineBloquesActividadesActividadMariaLaComeSandias['default'], _pilasEngineBloquesActividadesActividadElMarcianoEnElDesierto['default'], _pilasEngineBloquesActividadesActividadAlimentandoALosPeces['default'], _pilasEngineBloquesActividadesActividadInstalandoJuegos['default'], _pilasEngineBloquesActividadesActividadNoMeCansoDeSaltar['default'], _pilasEngineBloquesActividadesActividadElGatoEnLaCalle['default'], _pilasEngineBloquesActividadesActividadElMonoQueSabeContar['default'], _pilasEngineBloquesActividadesActividadReparandoLaNave['default'], _pilasEngineBloquesActividadesActividadTresNaranjas['default'], _pilasEngineBloquesActividadesActividadLaberintoCorto['default'], _pilasEngineBloquesActividadesActividadLaberintoLargo['default'], _pilasEngineBloquesActividadesActividadLaberintoConQueso['default'], _pilasEngineBloquesActividadesActividadElCangrejoAguafiestas['default'], _pilasEngineBloquesActividadesActividadLaGranAventuraDelMarEncantado['default'], _pilasEngineBloquesActividadesActividadElDetectiveChaparro['default'], _pilasEngineBloquesActividadesActividadPrendiendoLasCompus['default'], _pilasEngineBloquesActividadesActividadElMonoCuentaDeNuevo['default'], _pilasEngineBloquesActividadesActividadElSuperviaje['default'], _pilasEngineBloquesActividadesActividadSalvandoLaNavidad['default'], _pilasEngineBloquesActividadesActividadTitoCuadrado['default'], _pilasEngineBloquesActividadesActividadLaFiestaDeDracula['default'], _pilasEngineBloquesActividadesActividadPrendiendoLasCompusConParametros['default'], _pilasEngineBloquesActividadesActividadPrendiendoLasFogatas['default']];

      actividades = actividades.concat(_pilasEngineBloquesActividadesActividadesDibujandoFiguras['default']);

      var actividad = actividades.findBy('id', nombre);

      if (!actividad) {
        throw new Error('No se encuentra la actividad de nombre ' + nombre);
      }

      return _pilasEngineBloquesActividadesActividad['default'].create({ actividad: actividad });
    }
  });
});
/* jshint unused:false */
define('pilas-engine-bloques/services/ajax', ['exports', 'ember-ajax/services/ajax'], function (exports, _emberAjaxServicesAjax) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberAjaxServicesAjax['default'];
    }
  });
});
define('pilas-engine-bloques/services/curso-api', ['exports', 'ember', 'pilas-engine-bloques/config/environment'], function (exports, _ember, _pilasEngineBloquesConfigEnvironment) {
  exports['default'] = _ember['default'].Service.extend({
    guardar: function guardar(parametros) {

      return new _ember['default'].RSVP.Promise(function (success, reject) {

        var data = {
          hash: parametros.hash,
          desafio: parametros.actividad,
          usuario: parametros.idAlumno,
          xml: parametros.codigo_xml
        };

        $.ajax({
          url: _pilasEngineBloquesConfigEnvironment['default'].cursoBackendURL + '/soluciones/',
          contentType: 'application/json',
          type: "post",
          data: JSON.stringify(data)
        }).done(success).fail(reject);
      });
    },

    obtener_solucion_xml_desde_hash: function obtener_solucion_xml_desde_hash(hash) {

      return new _ember['default'].RSVP.Promise(function (success, reject) {
        $.ajax({
          url: _pilasEngineBloquesConfigEnvironment['default'].cursoBackendURL + '/soluciones/' + hash,
          contentType: 'application/json',
          type: "get"
        }).done(function (result) {
          success(result.data[0].xml);
        }).fail(reject);
      });
    }
  });
});
define('pilas-engine-bloques/services/media', ['exports', 'ember-responsive/media'], function (exports, _emberResponsiveMedia) {
  exports['default'] = _emberResponsiveMedia['default'];
});
define('pilas-engine-bloques/services/modal-dialog', ['exports', 'ember-modal-dialog/services/modal-dialog'], function (exports, _emberModalDialogServicesModalDialog) {
  exports['default'] = _emberModalDialogServicesModalDialog['default'];
});
define('pilas-engine-bloques/services/notificador', ['exports', 'ember', 'pilas-engine-bloques/config/environment'], function (exports, _ember, _pilasEngineBloquesConfigEnvironment) {
  exports['default'] = _ember['default'].Service.extend({
    ajax: _ember['default'].inject.service(),
    hayActualizacion: false,
    versionActual: null,

    esVersionAnterior: function esVersionAnterior(stringV1, stringV2) {

      function parseVersionString(str) {
        if (typeof str !== 'string') {
          return false;
        }

        var x = str.split('+')[0].split('.');
        // parse from string or default to 0 if can't parse
        var maj = parseInt(x[0]) || 0;
        var min = parseInt(x[1]) || 0;
        var pat = parseInt(x[2]) || 0;

        return { major: maj, minor: min, patch: pat };
      }

      var v1 = parseVersionString(stringV1);
      var v2 = parseVersionString(stringV2);

      return v1.major < v2.major || v1.major === v2.major && v1.minor < v2.minor || v1.major === v2.major && v1.minor === v2.minor && v1.patch < v2.patch;
    },

    /**
     * Consulta contra la API de github si existe una versión nueva de la
     * aplicación para actualizar.
     */
    consultar: function consultar() {
      var _this = this;

      var versionActual = _pilasEngineBloquesConfigEnvironment['default'].APP.version;
      var url = _pilasEngineBloquesConfigEnvironment['default']['versionURL'];

      return this.get('ajax').request(url).then(function (data) {
        var versionDesdeElServidor = data.tag_name;

        if (_this.esVersionAnterior(versionActual, versionDesdeElServidor)) {
          _this.set('hayActualizacion', true);
          _this.set('versionActual', data.tag_name);
          return { hayActualizacion: true, version: data.tag_name };
        } else {
          return { hayActualizacion: false, version: data.tag_name };
        }
      });
    }
  });
});
define('pilas-engine-bloques/services/pilas', ['exports', 'ember', 'pilas-engine-bloques/components/listaImagenes'], function (exports, _ember, _pilasEngineBloquesComponentsListaImagenes) {

  /**
   * Provee acceso a pilasweb y sus eventos.
   *
   * @public
   * @module PilasService
   */

  /**
   * Un servicio que provee métodos y eventos para comunicarse
   * con pilasweb y el componente pilas-canvas.
   * DEMO.
   *
   * Estos son los eventos que puede reportar el servicio:
   *
   * - terminaEjecucion
   * - terminaCargaInicial
   * - errorDeActividad
   *
   * @public
   * @class PilasService
   */
  exports['default'] = _ember['default'].Service.extend(_ember['default'].Evented, {
    iframe: null,
    actorCounter: 0,
    pilas: null,
    loading: true,
    nombreDeLaEscenaActual: null,
    temporallyCallback: null, /* almacena el callback para avisar si pilas
                                 se reinició correctamente. */

    /**
     * Instancia pilas-engine con los atributos que le envíe
     * el componente x-canvas.
     *
     * Este método realiza una conexión con el servicio pilas, y
     * se llamará automáticamente ante dos eventos: se agrega el
     * componente x-canvas a un template o se ha llamado a `reload`
     * en el servicio pilas.
     *
     * @public
     */
    inicializarPilas: function inicializarPilas(iframeElement, options) {
      var _this = this;

      this.set("iframe", iframeElement);
      this.set("loading", true);

      return new _ember['default'].RSVP.Promise(function (success) {
        var width = options.width;
        var height = options.height;
        var listaImagenesSerializada = _pilasEngineBloquesComponentsListaImagenes['default'].join("|");

        var code = '\n        var canvasElement = document.getElementById(\'canvas\');\n        var listaImagenes = "' + listaImagenesSerializada + '".split("|");\n        var opciones = {ancho: ' + width + ',\n                        alto: ' + height + ',\n                        canvas: canvasElement,\n                        data_path: \'libs/data\',\n                        imagenesExtra: listaImagenes,\n                      };\n\n        var pilas = pilasengine.iniciar(opciones);\n\n        pilas;\n      ';

        var pilas = iframeElement.contentWindow.eval(code);

        _this.conectarEventos();

        pilas.onready = function () {

          //this.get('actividad').iniciarEscena();
          //var contenedor = document.getElementById('contenedor-blockly');
          //this.get('actividad').iniciarBlockly(contenedor);

          //if (this.get('actividad')['finalizaCargarBlockly']) {
          //  this.get('actividad').finalizaCargarBlockly();
          //}

          success(pilas);

          /*
           * Si el usuario llamó a "reload" desde este servicio, tendría
           * que existir una promesa en curso, así que estas lineas se
           * encargan de satisfacer esa promesa llamando al callback success.
           */
          if (_this.get("temporallyCallback")) {
            _this.get("temporallyCallback")(pilas);
            _this.set("temporallyCallback", null);
          }

          _this.set("loading", false);
        };

        pilas.ejecutar();
      });
    },

    /**
     * Libera los eventos y recursos instanciados por este servicio.
     *
     * @method liberarRecursos
     * @public
     */
    liberarRecursos: function liberarRecursos() {
      this.desconectarEventos();
    },

    /**
     * Captura cualquier mensaje desde el iframe y lo propaga
     * como un evento de ember evented.
     *
     * Los eventos que se originan en el iframe tienen la forma:
     *
     *     {
     *       tipo: "tipoDeMensaje"    # Cualquiera de los listados más arriba.
     *       detalle: [...]           # string con detalles para ese evento.
     *     }
     *
     * Sin embargo esta función separa esa estructura para que sea más
     * sencillo capturarla dentro de ember.
     *
     * Por ejemplo, si queremos capturar un error (como hace la batería de tests),
     * podemos escribir:
     *
     *     pilas.on('errorDeActividad', function(motivoDelError) {
     *       // etc...
     *     });
     *
     * @method contectarEventos
     * @private
     *
     */
    conectarEventos: function conectarEventos() {
      var _this2 = this;

      $(window).on("message.fromIframe", function (e) {
        var datos = e.originalEvent.data;
        _this2.trigger(datos.tipo, datos.detalle);
      });
    },

    /**
     * Se llama automáticamente para desconectar los eventos del servicio.
     *
     * @method desconectarEventos
     * @private
     */
    desconectarEventos: function desconectarEventos() {
      $(window).off("message.fromIframe");
    },

    inicializarEscena: function inicializarEscena(iframeElement, nombreDeLaEscena) {
      var codigo = '\n      var escena = new ' + nombreDeLaEscena + '();\n      pilas.mundo.gestor_escenas.cambiar_escena(escena);\n    ';

      this.evaluar(codigo);
      this.set("nombreDeLaEscenaActual", nombreDeLaEscena);
    },

    /**
     * Evalúa código reiniciando completamente la biblioteca.
     *
     * @method ejecutarCodigo
     * @public
     */
    ejecutarCodigo: function ejecutarCodigo(codigo) {
      var _this3 = this;

      this.reiniciar().then(function () {
        var iframeElement = _this3.get("iframe");
        iframeElement.contentWindow.eval(codigo);
      });
    },

    /**
     * Retorna true si el problema está resuelto.
     *
     * @method estaResueltoElProblema
     * @public
     */
    estaResueltoElProblema: function estaResueltoElProblema() {
      return this.evaluar('pilas.escena_actual().estaResueltoElProblema();');
    },

    /**
     * Ejecuta el código reiniciando la escena rápidamente.
     *
     * @method ejecutarCodigoSinReiniciar
     * @public
     *
     * @todo convertir en método privado.
     */
    ejecutarCodigoSinReiniciar: function ejecutarCodigoSinReiniciar(codigo) {

      if (this.get("loading")) {
        console.warn("Cuidado, no se puede ejecutar antes de que pilas cargue.");
        return;
      }

      var iframeElement = this.get("iframe");

      this.reiniciarEscenaCompleta();

      iframeElement.contentWindow.eval(codigo);
    },

    /**
     * Retorna una captura de pantalla de la escena en formato png/base64
     *
     * @method obtenerCapturaDePantalla
     * @public
     */
    obtenerCapturaDePantalla: function obtenerCapturaDePantalla() {
      var iframeElement = this.get("iframe");
      return iframeElement.contentWindow.document.getElementById('canvas').toDataURL('image/png');
    },

    /**
     * Realiza un reinicio rápido de la escena actual.
     *
     * @method reiniciarEscenaCompleta
     * @private
     */
    reiniciarEscenaCompleta: function reiniciarEscenaCompleta() {
      var iframeElement = this.get("iframe");
      iframeElement.contentWindow.eval("pilas.reiniciar();");
      this.inicializarEscena(iframeElement, this.get("nombreDeLaEscenaActual"));
    },

    /**
     * Modifica la velocidad de las animaciones y la simulación.
     *
     * Este método es particularmente útil para ejecutar los tests de integración
     * super rápido.
     *
     * Por omisión pilas utiliza un temporizador a 60 FPS.
     *
     * @method cambiarFPS
     * @public
     *
     */
    cambiarFPS: function cambiarFPS(fps) {
      this.evaluar('createjs.Ticker.setFPS(' + fps + ');');
    },

    /**
     * Permite reiniciar pilas por completo.
     *
     * La acción de reinicio se realiza re-cargando el iframe
     * que contiene a pilas, así que se va a volver a llamar al
     * método `instanciarPilas` automáticamente.
     *
     * Este método retorna una promesa, que se cumple cuando pilas se
     * halla cargado completamente.
     *
     * @method reiniciar
     * @private
     */
    reiniciar: function reiniciar() {
      var _this4 = this;

      return new _ember['default'].RSVP.Promise(function (success) {
        if (_this4.get("loading")) {
          console.warn("Cuidado, se está reiniciando en medio de la carga.");
        }

        _this4.set("loading", true);
        _this4.get("iframe").contentWindow.location.reload(true);

        /* Guarda el callback  para que se llame luego de la carga de pilas. */
        _this4.set("temporallyCallback", success);
      });
    },

    /**
     * Retorna la cantidad de actores en la escena con la etiqueta solicitada.
     *
     * @method contarActoresConEtiqueta
     * @public
     */
    contarActoresConEtiqueta: function contarActoresConEtiqueta(etiqueta) {
      var codigo = '\n      var actoresEnLaEscena = pilas.escena_actual().actores;\n\n      var actoresConLaEtiqueta = actoresEnLaEscena.filter(function(actor) {\n        return actor.tiene_etiqueta("' + etiqueta + '");\n      });\n\n      actoresConLaEtiqueta.length;\n    ';

      return this.evaluar(codigo);
    },

    /**
     * Evalúa código directamente, sin reiniciar de ninguna forma.
     *
     * @method evaluar
     * @public
     */
    evaluar: function evaluar(codigo) {
      var iframeElement = this.get("iframe");
      return iframeElement.contentWindow.eval(codigo);
    }

  });
});
define('pilas-engine-bloques/services/twitter', ['exports', 'ember'], function (exports, _ember) {

  //const URL = "http://localhost:3000/sendMessage";
  var URL_SEND_MESSAGE = "http://104.131.245.133:9914/sendMessage";

  exports['default'] = _ember['default'].Service.extend({
    compartir: function compartir(mensaje, imagen) {
      return new _ember['default'].RSVP.Promise(function (resolve, reject) {
        $.ajax({
          url: URL_SEND_MESSAGE,
          type: 'POST',
          dataType: 'json',
          contentType: "application/json",
          data: JSON.stringify({
            message: mensaje,
            media: imagen
          }),
          success: function success(res) {
            resolve(res);
          },
          error: function error(xhr) {
            console.error(xhr.responseText);
            reject(xhr.responseText);
          }
        });
      });
    }
  });
});
define('pilas-engine-bloques/services/zoom', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = _ember['default'].Service.extend({
    zoom: 100,

    getValue: function getValue() {
      return this.get('zoom');
    },

    setValue: function setValue(zoomValue) {
      this.set('zoom', zoomValue);
    }
  });
});
define("pilas-engine-bloques/templates/acercade", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    var child0 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 7,
              "column": 3
            },
            "end": {
              "line": 9,
              "column": 3
            }
          },
          "moduleName": "pilas-engine-bloques/templates/acercade.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("			 	(y se puede actualizar a la versión ");
          dom.appendChild(el0, el1);
          var el1 = dom.createComment("");
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode(")\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 1, 1, contextualElement);
          return morphs;
        },
        statements: [["content", "versionMasReciente", ["loc", [null, [8, 41], [8, 63]]]]],
        locals: [],
        templates: []
      };
    })();
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type", "multiple-nodes"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 18,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/acercade.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("div");
        dom.setAttribute(el1, "class", "contenido-principal");
        var el2 = dom.createTextNode("\n	");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("div");
        dom.setAttribute(el2, "class", "contenedor-acercade");
        var el3 = dom.createTextNode("\n		");
        dom.appendChild(el2, el3);
        var el3 = dom.createComment("");
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n\n		");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("p");
        var el4 = dom.createTextNode("Actualmente estás usando la versión ");
        dom.appendChild(el3, el4);
        var el4 = dom.createElement("code");
        var el5 = dom.createComment("");
        dom.appendChild(el4, el5);
        dom.appendChild(el3, el4);
        var el4 = dom.createTextNode("\n");
        dom.appendChild(el3, el4);
        var el4 = dom.createComment("");
        dom.appendChild(el3, el4);
        var el4 = dom.createTextNode("			");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n\n		");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("p");
        var el4 = dom.createTextNode("\n		  ");
        dom.appendChild(el3, el4);
        var el4 = dom.createElement("button");
        dom.setAttribute(el4, "class", "btn btn-warning");
        var el5 = dom.createComment("");
        dom.appendChild(el4, el5);
        var el5 = dom.createTextNode(" Visitar la web del proyecto");
        dom.appendChild(el4, el5);
        dom.appendChild(el3, el4);
        var el4 = dom.createTextNode("\n		  ");
        dom.appendChild(el3, el4);
        var el4 = dom.createComment("");
        dom.appendChild(el3, el4);
        var el4 = dom.createTextNode("\n		");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n	");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var element0 = dom.childAt(fragment, [2, 1]);
        var element1 = dom.childAt(element0, [3]);
        var element2 = dom.childAt(element0, [5]);
        var element3 = dom.childAt(element2, [1]);
        var morphs = new Array(7);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        morphs[1] = dom.createMorphAt(element0, 1, 1);
        morphs[2] = dom.createMorphAt(dom.childAt(element1, [1]), 0, 0);
        morphs[3] = dom.createMorphAt(element1, 3, 3);
        morphs[4] = dom.createElementMorph(element3);
        morphs[5] = dom.createMorphAt(element3, 0, 0);
        morphs[6] = dom.createMorphAt(element2, 3, 3);
        dom.insertBoundary(fragment, 0);
        return morphs;
      },
      statements: [["content", "outlet", ["loc", [null, [1, 0], [1, 10]]]], ["content", "pilas-acerca-de", ["loc", [null, [4, 2], [4, 21]]]], ["content", "app-version", ["loc", [null, [6, 47], [6, 62]]]], ["block", "if", [["get", "hayActualizacion", ["loc", [null, [7, 9], [7, 25]]]]], [], 0, null, ["loc", [null, [7, 3], [9, 10]]]], ["element", "action", ["visitarWeb"], [], ["loc", [null, [13, 36], [13, 59]]]], ["inline", "fa-icon", ["globe"], [], ["loc", [null, [13, 60], [13, 79]]]], ["content", "pilas-update", ["loc", [null, [14, 4], [14, 20]]]]],
      locals: [],
      templates: [child0]
    };
  })());
});
define("pilas-engine-bloques/templates/application-loading", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type", "multiple-nodes"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 3,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/application-loading.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var morphs = new Array(2);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        morphs[1] = dom.createMorphAt(fragment, 2, 2, contextualElement);
        dom.insertBoundary(fragment, 0);
        return morphs;
      },
      statements: [["content", "outlet", ["loc", [null, [1, 0], [1, 10]]]], ["content", "pilas-cargando", ["loc", [null, [2, 0], [2, 18]]]]],
      locals: [],
      templates: []
    };
  })());
});
define("pilas-engine-bloques/templates/application", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    var child0 = (function () {
      return {
        meta: {
          "fragmentReason": {
            "name": "missing-wrapper",
            "problems": ["wrong-type", "multiple-nodes"]
          },
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 1,
              "column": 0
            },
            "end": {
              "line": 4,
              "column": 0
            }
          },
          "moduleName": "pilas-engine-bloques/templates/application.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("  ");
          dom.appendChild(el0, el1);
          var el1 = dom.createComment("");
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n  ");
          dom.appendChild(el0, el1);
          var el1 = dom.createComment("");
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(2);
          morphs[0] = dom.createMorphAt(fragment, 1, 1, contextualElement);
          morphs[1] = dom.createMorphAt(fragment, 3, 3, contextualElement);
          return morphs;
        },
        statements: [["content", "pilas-header", ["loc", [null, [2, 2], [2, 18]]]], ["inline", "pilas-notificador", [], ["servicioNotificador", ["subexpr", "@mut", [["get", "notificador", ["loc", [null, [3, 42], [3, 53]]]]], [], []]], ["loc", [null, [3, 2], [3, 55]]]]],
        locals: [],
        templates: []
      };
    })();
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type", "multiple-nodes"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 9,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/application.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("div");
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var element0 = dom.childAt(fragment, [2]);
        var morphs = new Array(3);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        morphs[1] = dom.createAttrMorph(element0, 'class');
        morphs[2] = dom.createMorphAt(element0, 1, 1);
        dom.insertBoundary(fragment, 0);
        return morphs;
      },
      statements: [["block", "if", [["get", "layout", ["loc", [null, [1, 6], [1, 12]]]]], [], 0, null, ["loc", [null, [1, 0], [4, 7]]]], ["attribute", "class", ["subexpr", "if", [["get", "layout", ["loc", [null, [6, 16], [6, 22]]]], "contenedor-padding-superior", "contenedor-sin-padding"], [], ["loc", [null, [6, 11], [6, 79]]]]], ["content", "outlet", ["loc", [null, [7, 0], [7, 10]]]]],
      locals: [],
      templates: [child0]
    };
  })());
});
define("pilas-engine-bloques/templates/components/modal-ayuda", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    var child0 = (function () {
      var child0 = (function () {
        return {
          meta: {
            "fragmentReason": false,
            "revision": "Ember@2.6.2",
            "loc": {
              "source": null,
              "start": {
                "line": 2,
                "column": 2
              },
              "end": {
                "line": 38,
                "column": 2
              }
            },
            "moduleName": "pilas-engine-bloques/templates/components/modal-ayuda.hbs"
          },
          isEmpty: false,
          arity: 0,
          cachedFragment: null,
          hasRendered: false,
          buildFragment: function buildFragment(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createTextNode("\n  ");
            dom.appendChild(el0, el1);
            var el1 = dom.createComment("");
            dom.appendChild(el0, el1);
            var el1 = dom.createTextNode("\n\n  ");
            dom.appendChild(el0, el1);
            var el1 = dom.createElement("div");
            dom.setAttribute(el1, "class", "modal-body");
            var el2 = dom.createTextNode("\n    ");
            dom.appendChild(el1, el2);
            var el2 = dom.createComment("");
            dom.appendChild(el1, el2);
            var el2 = dom.createTextNode("\n\n    ");
            dom.appendChild(el1, el2);
            var el2 = dom.createElement("p");
            var el3 = dom.createTextNode("Esta aplicación te presentará varios desafíos que se pueden\n      resolver conectando bloques.");
            dom.appendChild(el2, el3);
            dom.appendChild(el1, el2);
            var el2 = dom.createTextNode("\n\n    ");
            dom.appendChild(el1, el2);
            var el2 = dom.createElement("p");
            var el3 = dom.createTextNode("El primer paso es abrir la sección de Desafíos:");
            dom.appendChild(el2, el3);
            dom.appendChild(el1, el2);
            var el2 = dom.createTextNode("\n\n    ");
            dom.appendChild(el1, el2);
            var el2 = dom.createElement("img");
            dom.setAttribute(el2, "src", "imagenes/ayuda/seleccionar.gif");
            dom.setAttribute(el2, "class", "img-border");
            dom.appendChild(el1, el2);
            var el2 = dom.createTextNode("\n\n    ");
            dom.appendChild(el1, el2);
            var el2 = dom.createElement("p");
            var el3 = dom.createTextNode("Los bloques están agrupados en categorías, usá la barra lateral\n      para desplegar los bloques.");
            dom.appendChild(el2, el3);
            dom.appendChild(el1, el2);
            var el2 = dom.createTextNode("\n\n    ");
            dom.appendChild(el1, el2);
            var el2 = dom.createElement("p");
            var el3 = dom.createTextNode("Luego podés arrastrar y soltar los bloques sobre el área\n      de trabajo.");
            dom.appendChild(el2, el3);
            dom.appendChild(el1, el2);
            var el2 = dom.createTextNode("\n\n    ");
            dom.appendChild(el1, el2);
            var el2 = dom.createElement("img");
            dom.setAttribute(el2, "src", "imagenes/ayuda/arrastrar.gif");
            dom.setAttribute(el2, "class", "img-border");
            dom.appendChild(el1, el2);
            var el2 = dom.createTextNode("\n\n    ");
            dom.appendChild(el1, el2);
            var el2 = dom.createElement("p");
            var el3 = dom.createTextNode("Una vez que tengas tu programa listo pulsá el botón ejecutar\n      continuar.");
            dom.appendChild(el2, el3);
            dom.appendChild(el1, el2);
            var el2 = dom.createTextNode("\n\n    ");
            dom.appendChild(el1, el2);
            var el2 = dom.createElement("img");
            dom.setAttribute(el2, "src", "imagenes/ayuda/ejecutar.gif");
            dom.setAttribute(el2, "class", "img-border");
            dom.appendChild(el1, el2);
            var el2 = dom.createTextNode("\n\n    ");
            dom.appendChild(el1, el2);
            var el2 = dom.createElement("p");
            var el3 = dom.createTextNode("Ah, y los bloques se pueden borrar arrastrándolos a la papelera.");
            dom.appendChild(el2, el3);
            dom.appendChild(el1, el2);
            var el2 = dom.createTextNode("\n\n    ");
            dom.appendChild(el1, el2);
            var el2 = dom.createElement("img");
            dom.setAttribute(el2, "src", "imagenes/ayuda/borrar.gif");
            dom.setAttribute(el2, "class", "img-border");
            dom.appendChild(el1, el2);
            var el2 = dom.createTextNode("\n\n\n  ");
            dom.appendChild(el1, el2);
            dom.appendChild(el0, el1);
            var el1 = dom.createTextNode("\n\n");
            dom.appendChild(el0, el1);
            return el0;
          },
          buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
            var morphs = new Array(2);
            morphs[0] = dom.createMorphAt(fragment, 1, 1, contextualElement);
            morphs[1] = dom.createMorphAt(dom.childAt(fragment, [3]), 1, 1);
            return morphs;
          },
          statements: [["inline", "modal-title", [], ["title", "Ayuda", "close", "close"], ["loc", [null, [6, 2], [6, 45]]]], ["content", "yield", ["loc", [null, [9, 4], [9, 13]]]]],
          locals: [],
          templates: []
        };
      })();
      return {
        meta: {
          "fragmentReason": {
            "name": "missing-wrapper",
            "problems": ["wrong-type"]
          },
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 1,
              "column": 0
            },
            "end": {
              "line": 40,
              "column": 0
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/modal-ayuda.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createComment("");
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
          dom.insertBoundary(fragment, 0);
          return morphs;
        },
        statements: [["block", "modal-dialog", [], ["close", "close", "targetAttachment", "center", "translucentOverlay", true], 0, null, ["loc", [null, [2, 2], [38, 19]]]]],
        locals: [],
        templates: [child0]
      };
    })();
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 41,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/components/modal-ayuda.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var morphs = new Array(1);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        dom.insertBoundary(fragment, 0);
        dom.insertBoundary(fragment, null);
        return morphs;
      },
      statements: [["block", "if", [["get", "mostrar", ["loc", [null, [1, 6], [1, 13]]]]], [], 0, null, ["loc", [null, [1, 0], [40, 7]]]]],
      locals: [],
      templates: [child0]
    };
  })());
});
define('pilas-engine-bloques/templates/components/modal-dialog', ['exports', 'ember-modal-dialog/templates/components/modal-dialog'], function (exports, _emberModalDialogTemplatesComponentsModalDialog) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberModalDialogTemplatesComponentsModalDialog['default'];
    }
  });
});
define("pilas-engine-bloques/templates/components/modal-preferencias", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    var child0 = (function () {
      var child0 = (function () {
        return {
          meta: {
            "fragmentReason": false,
            "revision": "Ember@2.6.2",
            "loc": {
              "source": null,
              "start": {
                "line": 2,
                "column": 2
              },
              "end": {
                "line": 20,
                "column": 2
              }
            },
            "moduleName": "pilas-engine-bloques/templates/components/modal-preferencias.hbs"
          },
          isEmpty: false,
          arity: 0,
          cachedFragment: null,
          hasRendered: false,
          buildFragment: function buildFragment(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createTextNode("\n  ");
            dom.appendChild(el0, el1);
            var el1 = dom.createComment("");
            dom.appendChild(el0, el1);
            var el1 = dom.createTextNode("\n  ");
            dom.appendChild(el0, el1);
            var el1 = dom.createElement("div");
            dom.setAttribute(el1, "class", "modal-body");
            var el2 = dom.createTextNode("\n    ");
            dom.appendChild(el1, el2);
            var el2 = dom.createComment("");
            dom.appendChild(el1, el2);
            var el2 = dom.createTextNode("\n\n    ");
            dom.appendChild(el1, el2);
            var el2 = dom.createElement("div");
            dom.setAttribute(el2, "class", "modal-body");
            var el3 = dom.createTextNode("\n\n        ");
            dom.appendChild(el2, el3);
            var el3 = dom.createElement("div");
            dom.setAttribute(el3, "class", "fila-opcion");
            var el4 = dom.createTextNode("\n          ");
            dom.appendChild(el3, el4);
            var el4 = dom.createElement("p");
            var el5 = dom.createTextNode("Tamaño de la interfaz: ");
            dom.appendChild(el4, el5);
            var el5 = dom.createComment("");
            dom.appendChild(el4, el5);
            dom.appendChild(el3, el4);
            var el4 = dom.createTextNode("\n        ");
            dom.appendChild(el3, el4);
            dom.appendChild(el2, el3);
            var el3 = dom.createTextNode("\n\n      ");
            dom.appendChild(el2, el3);
            dom.appendChild(el1, el2);
            var el2 = dom.createTextNode("\n\n\n  ");
            dom.appendChild(el1, el2);
            dom.appendChild(el0, el1);
            var el1 = dom.createTextNode("\n");
            dom.appendChild(el0, el1);
            return el0;
          },
          buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
            var element0 = dom.childAt(fragment, [3]);
            var morphs = new Array(3);
            morphs[0] = dom.createMorphAt(fragment, 1, 1, contextualElement);
            morphs[1] = dom.createMorphAt(element0, 1, 1);
            morphs[2] = dom.createMorphAt(dom.childAt(element0, [3, 1, 1]), 1, 1);
            return morphs;
          },
          statements: [["inline", "modal-title", [], ["title", "Opciones", "close", "close"], ["loc", [null, [6, 2], [6, 48]]]], ["content", "yield", ["loc", [null, [8, 4], [8, 13]]]], ["content", "pilas-botones-zoom", ["loc", [null, [13, 36], [13, 58]]]]],
          locals: [],
          templates: []
        };
      })();
      return {
        meta: {
          "fragmentReason": {
            "name": "missing-wrapper",
            "problems": ["wrong-type"]
          },
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 1,
              "column": 0
            },
            "end": {
              "line": 22,
              "column": 0
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/modal-preferencias.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createComment("");
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
          dom.insertBoundary(fragment, 0);
          return morphs;
        },
        statements: [["block", "modal-dialog", [], ["close", "close", "targetAttachment", "center", "translucentOverlay", true], 0, null, ["loc", [null, [2, 2], [20, 19]]]]],
        locals: [],
        templates: [child0]
      };
    })();
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 23,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/components/modal-preferencias.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var morphs = new Array(1);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        dom.insertBoundary(fragment, 0);
        dom.insertBoundary(fragment, null);
        return morphs;
      },
      statements: [["block", "if", [["get", "mostrar", ["loc", [null, [1, 6], [1, 13]]]]], [], 0, null, ["loc", [null, [1, 0], [22, 7]]]]],
      locals: [],
      templates: [child0]
    };
  })());
});
define("pilas-engine-bloques/templates/components/modal-title", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["multiple-nodes", "wrong-type"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 4,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/components/modal-title.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createElement("h4");
        dom.setAttribute(el1, "class", "modal-title");
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode(" ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("button");
        dom.setAttribute(el2, "id", "cerrar-modal");
        dom.setAttribute(el2, "class", "pull-right btn btn-xs btn-default");
        var el3 = dom.createComment("");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var element0 = dom.childAt(fragment, [0]);
        var element1 = dom.childAt(element0, [2]);
        var morphs = new Array(4);
        morphs[0] = dom.createMorphAt(element0, 0, 0);
        morphs[1] = dom.createElementMorph(element1);
        morphs[2] = dom.createMorphAt(element1, 0, 0);
        morphs[3] = dom.createMorphAt(fragment, 2, 2, contextualElement);
        return morphs;
      },
      statements: [["content", "title", ["loc", [null, [1, 24], [1, 33]]]], ["element", "action", ["ocultar"], [], ["loc", [null, [1, 60], [1, 80]]]], ["inline", "fa-icon", [], ["icon", "close fa-2x"], ["loc", [null, [1, 123], [1, 153]]]], ["content", "yield", ["loc", [null, [3, 0], [3, 9]]]]],
      locals: [],
      templates: []
    };
  })());
});
define("pilas-engine-bloques/templates/components/pilas-acerca-de", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    var child0 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 46,
              "column": 282
            },
            "end": {
              "line": 46,
              "column": 371
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-acerca-de.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("Comunidad de conocimiento");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes() {
          return [];
        },
        statements: [],
        locals: [],
        templates: []
      };
    })();
    var child1 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 77,
              "column": 37
            },
            "end": {
              "line": 77,
              "column": 88
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-acerca-de.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("Program.AR");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes() {
          return [];
        },
        statements: [],
        locals: [],
        templates: []
      };
    })();
    var child2 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 77,
              "column": 106
            },
            "end": {
              "line": 77,
              "column": 181
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-acerca-de.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("Fundación Sadosky");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes() {
          return [];
        },
        statements: [],
        locals: [],
        templates: []
      };
    })();
    var child3 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 77,
              "column": 220
            },
            "end": {
              "line": 77,
              "column": 287
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-acerca-de.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("Huayra");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes() {
          return [];
        },
        statements: [],
        locals: [],
        templates: []
      };
    })();
    var child4 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 77,
              "column": 347
            },
            "end": {
              "line": 77,
              "column": 409
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-acerca-de.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("Pilas Engine");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes() {
          return [];
        },
        statements: [],
        locals: [],
        templates: []
      };
    })();
    var child5 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 77,
              "column": 428
            },
            "end": {
              "line": 77,
              "column": 495
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-acerca-de.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("Hugo Ruscitti");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes() {
          return [];
        },
        statements: [],
        locals: [],
        templates: []
      };
    })();
    var child6 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 80,
              "column": 67
            },
            "end": {
              "line": 80,
              "column": 118
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-acerca-de.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("Program.AR");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes() {
          return [];
        },
        statements: [],
        locals: [],
        templates: []
      };
    })();
    var child7 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 83,
              "column": 161
            },
            "end": {
              "line": 83,
              "column": 290
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-acerca-de.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("http://program.ar/por-que-ciencias-de-la-computacion/");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes() {
          return [];
        },
        statements: [],
        locals: [],
        templates: []
      };
    })();
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type", "multiple-nodes"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 85,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/components/pilas-acerca-de.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("h1");
        var el2 = dom.createTextNode("Acerca de Pilas Bloques");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("p");
        var el2 = dom.createTextNode("\n  Pilas Bloques es una aplicación para aprender a programar.\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("p");
        var el2 = dom.createTextNode("\n  Se proponen desafíos con diversos niveles de dificultad para acercar a los alumnos al mundo de la programación por medio de bloques.\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("h2");
        var el2 = dom.createTextNode("\n  ¿Qué es programar por medio de bloques?\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("p");
        var el2 = dom.createTextNode("\n  Es desarrollar programas con acciones e instrucciones incorporadas en bloques o piezas prediseñadas. El resultado de encastrar los bloques entre sí es el programa que resuelve el problema ó desafío planteado.\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("h2");
        var el2 = dom.createTextNode("\n  ¿Por qué es positiva esta modalidad de aprendizaje?\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("ul");
        var el2 = dom.createTextNode("\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("li");
        var el3 = dom.createTextNode("\n    Porque cada ");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("b");
        var el4 = dom.createTextNode("concepto");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode(" abstracto asociado a la programación tiene su representación ");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("b");
        var el4 = dom.createTextNode("visual");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode(".\n  ");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("li");
        var el3 = dom.createTextNode("\n    Porque ahorra las ");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("b");
        var el4 = dom.createTextNode("dificultades");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode(" que genera la sintaxis formal de un lenguaje ");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("b");
        var el4 = dom.createTextNode("escrito");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode(" (¡y la frustración cuando cometemos un error al escribir!). Los bloques se seleccionan, arrastran, encastran y listo.\n  ");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("h2");
        var el2 = dom.createTextNode("\n  ¿En qué se diferencia Pilas Bloques de otras herramientas?\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("p");
        var el2 = dom.createTextNode("\n  La principal diferencia es que esta plataforma fue pensada para ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("b");
        var el3 = dom.createTextNode("acompañar una secuencia didáctica");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode(" para el aprendizaje de la programación en la escuela.\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("h2");
        var el2 = dom.createTextNode("\n  ¿Qué es una secuencia didáctica?\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("p");
        var el2 = dom.createTextNode("\n  Es el plan mediante el cual se propone aprender un tema. La secuencia didáctica de Pilas Bloques fue ideada y probada por docentes e investigadores argentinos. Hoy en día, esta propuesta se está profundizando y ampliando. Conocé más sobre las iniciativas que estamos abordando en ");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode(".\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("h2");
        var el2 = dom.createTextNode("\n  ¿Quién puede hacer los desafíos de Pilas Bloques?\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("p");
        var el2 = dom.createTextNode("\n  Los desafíos pueden ser realizados por niños de 3 a 99 años. Sin embargo, ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("b");
        var el3 = dom.createTextNode("a partir de los 10 u 11 años");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode(" los contenidos se podrán aprovechar por completo.\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("h2");
        var el2 = dom.createTextNode("\n  ¿Y cualquiera puede hacer los desafíos por su cuenta?\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("p");
        var el2 = dom.createTextNode("\n  La herramienta está pensada como ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("b");
        var el3 = dom.createTextNode("ayuda al docente y al alumno");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode(" en el proceso de aprendizaje de la programación en un entorno escolar. En la secuencia didáctica que se plantea, la ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("b");
        var el3 = dom.createTextNode("indagación");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode(" autodidacta es fundamental. Nuestra recomendación, no obstante, es que el docente sea el que ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("b");
        var el3 = dom.createTextNode("guíe");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode(" y asista el proceso de aprendizaje del alumno.\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("h2");
        var el2 = dom.createTextNode("\n  Contacto\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("p");
        var el2 = dom.createTextNode("\n  Por cualquier duda nos pueden contactar a: ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("a");
        dom.setAttribute(el2, "href", "mailto:pilasbloques@program.ar");
        var el3 = dom.createTextNode("pilasbloques@program.ar");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("h2");
        var el2 = dom.createTextNode("\n  Sobre los autores y Program.AR\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("p");
        var el2 = dom.createTextNode("\n  Pilas Bloques fue desarrollada por ");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode(" - ");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode(" con la colaboración de ");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode(". Esta aplicación hace uso de la herramienta ");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode(" de ");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode(".\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("p");
        var el2 = dom.createTextNode("\n  La secuencia didáctica que guía la herramienta fue elaborada por ");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode(", y puede encontrarse junto con otros materiales en la página web. Contó con el apoyo y la colaboración de la Universidad Nacional de Quilmes y otras universidades nacionales de Argentina.\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("p");
        var el2 = dom.createTextNode("\n  Program.AR es una iniciativa que trabaja para que el aprendizaje significativo de Computación esté presente en todas las escuelas argentinas. Más información: ");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var element0 = dom.childAt(fragment, [38]);
        var morphs = new Array(9);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        morphs[1] = dom.createMorphAt(dom.childAt(fragment, [22]), 1, 1);
        morphs[2] = dom.createMorphAt(element0, 1, 1);
        morphs[3] = dom.createMorphAt(element0, 3, 3);
        morphs[4] = dom.createMorphAt(element0, 5, 5);
        morphs[5] = dom.createMorphAt(element0, 7, 7);
        morphs[6] = dom.createMorphAt(element0, 9, 9);
        morphs[7] = dom.createMorphAt(dom.childAt(fragment, [40]), 1, 1);
        morphs[8] = dom.createMorphAt(dom.childAt(fragment, [42]), 1, 1);
        dom.insertBoundary(fragment, 0);
        return morphs;
      },
      statements: [["content", "yield", ["loc", [null, [1, 0], [1, 9]]]], ["block", "pilas-link", [], ["href", "http://program.ar/comunidad-conocimiento/"], 0, null, ["loc", [null, [46, 282], [46, 386]]]], ["block", "pilas-link", [], ["href", "http://program.ar/"], 1, null, ["loc", [null, [77, 37], [77, 103]]]], ["block", "pilas-link", [], ["href", "http://www.fundacionsadosky.org.ar/"], 2, null, ["loc", [null, [77, 106], [77, 196]]]], ["block", "pilas-link", [], ["href", "http://huayra.conectarigualdad.gob.ar/"], 3, null, ["loc", [null, [77, 220], [77, 302]]]], ["block", "pilas-link", [], ["href", "http://pilas-engine.com.ar/"], 4, null, ["loc", [null, [77, 347], [77, 424]]]], ["block", "pilas-link", [], ["href", "https://github.com/hugoruscitti"], 5, null, ["loc", [null, [77, 428], [77, 510]]]], ["block", "pilas-link", [], ["href", "http://program.ar/"], 6, null, ["loc", [null, [80, 67], [80, 133]]]], ["block", "pilas-link", [], ["href", "http://program.ar/por-que-ciencias-de-la-computacion/"], 7, null, ["loc", [null, [83, 161], [83, 305]]]]],
      locals: [],
      templates: [child0, child1, child2, child3, child4, child5, child6, child7]
    };
  })());
});
define("pilas-engine-bloques/templates/components/pilas-blockly", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    var child0 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 11,
              "column": 12
            },
            "end": {
              "line": 13,
              "column": 12
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("              ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("button");
          dom.setAttribute(el1, "disabled", "");
          dom.setAttribute(el1, "class", "btn btn-info");
          var el2 = dom.createElement("i");
          dom.setAttribute(el2, "class", "fa fa-arrows-h");
          dom.appendChild(el1, el2);
          var el2 = dom.createTextNode(" Alterar");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var element14 = dom.childAt(fragment, [1]);
          var morphs = new Array(1);
          morphs[0] = dom.createElementMorph(element14);
          return morphs;
        },
        statements: [["element", "action", ["alternar"], [], ["loc", [null, [12, 52], [12, 73]]]]],
        locals: [],
        templates: []
      };
    })();
    var child1 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 15,
              "column": 12
            },
            "end": {
              "line": 17,
              "column": 12
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("                ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("button");
          dom.setAttribute(el1, "class", "btn btn-warning");
          var el2 = dom.createElement("i");
          dom.setAttribute(el2, "class", "fa fa-refresh");
          dom.appendChild(el1, el2);
          var el2 = dom.createTextNode(" Reiniciar");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var element13 = dom.childAt(fragment, [1]);
          var morphs = new Array(1);
          morphs[0] = dom.createElementMorph(element13);
          return morphs;
        },
        statements: [["element", "action", ["reiniciar"], [], ["loc", [null, [16, 48], [16, 70]]]]],
        locals: [],
        templates: []
      };
    })();
    var child2 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 17,
              "column": 12
            },
            "end": {
              "line": 19,
              "column": 12
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("                ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("button");
          dom.setAttribute(el1, "class", "btn btn-success");
          var el2 = dom.createElement("i");
          dom.setAttribute(el2, "class", "fa fa-play");
          dom.appendChild(el1, el2);
          var el2 = dom.createTextNode(" Ejecutar");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var element12 = dom.childAt(fragment, [1]);
          var morphs = new Array(1);
          morphs[0] = dom.createElementMorph(element12);
          return morphs;
        },
        statements: [["element", "action", ["ejecutar"], [], ["loc", [null, [18, 48], [18, 69]]]]],
        locals: [],
        templates: []
      };
    })();
    var child3 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 21,
              "column": 12
            },
            "end": {
              "line": 23,
              "column": 12
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("              ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("button");
          dom.setAttribute(el1, "class", "btn btn-info pull-right");
          var el2 = dom.createTextNode("Guardar mi solución");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var element11 = dom.childAt(fragment, [1]);
          var morphs = new Array(1);
          morphs[0] = dom.createElementMorph(element11);
          return morphs;
        },
        statements: [["element", "action", ["guardar_solucion_en_el_backend"], [], ["loc", [null, [22, 54], [22, 97]]]]],
        locals: [],
        templates: []
      };
    })();
    var child4 = (function () {
      var child0 = (function () {
        return {
          meta: {
            "fragmentReason": false,
            "revision": "Ember@2.6.2",
            "loc": {
              "source": null,
              "start": {
                "line": 23,
                "column": 12
              },
              "end": {
                "line": 25,
                "column": 12
              }
            },
            "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
          },
          isEmpty: false,
          arity: 0,
          cachedFragment: null,
          hasRendered: false,
          buildFragment: function buildFragment(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createTextNode("\n");
            dom.appendChild(el0, el1);
            return el0;
          },
          buildRenderNodes: function buildRenderNodes() {
            return [];
          },
          statements: [],
          locals: [],
          templates: []
        };
      })();
      var child1 = (function () {
        var child0 = (function () {
          return {
            meta: {
              "fragmentReason": false,
              "revision": "Ember@2.6.2",
              "loc": {
                "source": null,
                "start": {
                  "line": 27,
                  "column": 14
                },
                "end": {
                  "line": 30,
                  "column": 14
                }
              },
              "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
            },
            isEmpty: false,
            arity: 0,
            cachedFragment: null,
            hasRendered: false,
            buildFragment: function buildFragment(dom) {
              var el0 = dom.createDocumentFragment();
              var el1 = dom.createTextNode("                ");
              dom.appendChild(el0, el1);
              var el1 = dom.createElement("button");
              dom.setAttribute(el1, "class", "btn btn-warning");
              var el2 = dom.createTextNode("Ver código XML");
              dom.appendChild(el1, el2);
              dom.appendChild(el0, el1);
              var el1 = dom.createTextNode("\n                ");
              dom.appendChild(el0, el1);
              var el1 = dom.createElement("button");
              dom.setAttribute(el1, "class", "btn btn-warning");
              var el2 = dom.createTextNode("Ingresar código XML");
              dom.appendChild(el1, el2);
              dom.appendChild(el0, el1);
              var el1 = dom.createTextNode("\n");
              dom.appendChild(el0, el1);
              return el0;
            },
            buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
              var element8 = dom.childAt(fragment, [1]);
              var element9 = dom.childAt(fragment, [3]);
              var morphs = new Array(2);
              morphs[0] = dom.createElementMorph(element8);
              morphs[1] = dom.createElementMorph(element9);
              return morphs;
            },
            statements: [["element", "action", ["ver_codigo"], [], ["loc", [null, [28, 48], [28, 71]]]], ["element", "action", ["ingresar_codigo"], [], ["loc", [null, [29, 48], [29, 76]]]]],
            locals: [],
            templates: []
          };
        })();
        var child1 = (function () {
          var child0 = (function () {
            return {
              meta: {
                "fragmentReason": false,
                "revision": "Ember@2.6.2",
                "loc": {
                  "source": null,
                  "start": {
                    "line": 33,
                    "column": 16
                  },
                  "end": {
                    "line": 35,
                    "column": 16
                  }
                },
                "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
              },
              isEmpty: false,
              arity: 0,
              cachedFragment: null,
              hasRendered: false,
              buildFragment: function buildFragment(dom) {
                var el0 = dom.createDocumentFragment();
                var el1 = dom.createTextNode("                  ");
                dom.appendChild(el0, el1);
                var el1 = dom.createElement("button");
                dom.setAttribute(el1, "class", "btn btn-success");
                var el2 = dom.createTextNode("Guardar");
                dom.appendChild(el1, el2);
                dom.appendChild(el0, el1);
                var el1 = dom.createTextNode("\n");
                dom.appendChild(el0, el1);
                return el0;
              },
              buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
                var element7 = dom.childAt(fragment, [1]);
                var morphs = new Array(1);
                morphs[0] = dom.createElementMorph(element7);
                return morphs;
              },
              statements: [["element", "action", ["guardar"], [], ["loc", [null, [34, 50], [34, 70]]]]],
              locals: [],
              templates: []
            };
          })();
          var child1 = (function () {
            return {
              meta: {
                "fragmentReason": false,
                "revision": "Ember@2.6.2",
                "loc": {
                  "source": null,
                  "start": {
                    "line": 35,
                    "column": 16
                  },
                  "end": {
                    "line": 37,
                    "column": 16
                  }
                },
                "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
              },
              isEmpty: false,
              arity: 0,
              cachedFragment: null,
              hasRendered: false,
              buildFragment: function buildFragment(dom) {
                var el0 = dom.createDocumentFragment();
                var el1 = dom.createTextNode("                  ");
                dom.appendChild(el0, el1);
                var el1 = dom.createElement("button");
                dom.setAttribute(el1, "class", "btn btn-success");
                var el2 = dom.createTextNode("Crear y Guardar");
                dom.appendChild(el1, el2);
                dom.appendChild(el0, el1);
                var el1 = dom.createTextNode("\n");
                dom.appendChild(el0, el1);
                return el0;
              },
              buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
                var element6 = dom.childAt(fragment, [1]);
                var morphs = new Array(1);
                morphs[0] = dom.createElementMorph(element6);
                return morphs;
              },
              statements: [["element", "action", ["guardar"], [], ["loc", [null, [36, 50], [36, 70]]]]],
              locals: [],
              templates: []
            };
          })();
          return {
            meta: {
              "fragmentReason": false,
              "revision": "Ember@2.6.2",
              "loc": {
                "source": null,
                "start": {
                  "line": 32,
                  "column": 14
                },
                "end": {
                  "line": 38,
                  "column": 14
                }
              },
              "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
            },
            isEmpty: false,
            arity: 0,
            cachedFragment: null,
            hasRendered: false,
            buildFragment: function buildFragment(dom) {
              var el0 = dom.createDocumentFragment();
              var el1 = dom.createComment("");
              dom.appendChild(el0, el1);
              return el0;
            },
            buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
              var morphs = new Array(1);
              morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
              dom.insertBoundary(fragment, 0);
              dom.insertBoundary(fragment, null);
              return morphs;
            },
            statements: [["block", "if", [["get", "model", ["loc", [null, [33, 22], [33, 27]]]]], [], 0, 1, ["loc", [null, [33, 16], [37, 23]]]]],
            locals: [],
            templates: [child0, child1]
          };
        })();
        var child2 = (function () {
          return {
            meta: {
              "fragmentReason": false,
              "revision": "Ember@2.6.2",
              "loc": {
                "source": null,
                "start": {
                  "line": 46,
                  "column": 14
                },
                "end": {
                  "line": 48,
                  "column": 14
                }
              },
              "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
            },
            isEmpty: false,
            arity: 0,
            cachedFragment: null,
            hasRendered: false,
            buildFragment: function buildFragment(dom) {
              var el0 = dom.createDocumentFragment();
              var el1 = dom.createTextNode("                ");
              dom.appendChild(el0, el1);
              var el1 = dom.createElement("button");
              dom.setAttribute(el1, "class", "btn btn-info border-right right");
              var el2 = dom.createElement("i");
              dom.setAttribute(el2, "class", "fa fa-twitter");
              dom.appendChild(el1, el2);
              var el2 = dom.createTextNode(" Compartir");
              dom.appendChild(el1, el2);
              dom.appendChild(el0, el1);
              var el1 = dom.createTextNode("\n");
              dom.appendChild(el0, el1);
              return el0;
            },
            buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
              var element5 = dom.childAt(fragment, [1]);
              var morphs = new Array(1);
              morphs[0] = dom.createElementMorph(element5);
              return morphs;
            },
            statements: [["element", "action", ["compartir"], [], ["loc", [null, [47, 64], [47, 86]]]]],
            locals: [],
            templates: []
          };
        })();
        return {
          meta: {
            "fragmentReason": false,
            "revision": "Ember@2.6.2",
            "loc": {
              "source": null,
              "start": {
                "line": 25,
                "column": 12
              },
              "end": {
                "line": 50,
                "column": 12
              }
            },
            "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
          },
          isEmpty: false,
          arity: 0,
          cachedFragment: null,
          hasRendered: false,
          buildFragment: function buildFragment(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createTextNode("\n");
            dom.appendChild(el0, el1);
            var el1 = dom.createComment("");
            dom.appendChild(el0, el1);
            var el1 = dom.createTextNode("\n");
            dom.appendChild(el0, el1);
            var el1 = dom.createComment("");
            dom.appendChild(el0, el1);
            var el1 = dom.createTextNode("\n\n              ");
            dom.appendChild(el0, el1);
            var el1 = dom.createComment("");
            dom.appendChild(el0, el1);
            var el1 = dom.createTextNode("\n\n              ");
            dom.appendChild(el0, el1);
            var el1 = dom.createElement("button");
            dom.setAttribute(el1, "class", "btn btn-default");
            var el2 = dom.createElement("i");
            dom.setAttribute(el2, "class", "fa fa-download");
            dom.appendChild(el1, el2);
            var el2 = dom.createTextNode(" Guardar");
            dom.appendChild(el1, el2);
            dom.appendChild(el0, el1);
            var el1 = dom.createTextNode("\n\n\n");
            dom.appendChild(el0, el1);
            var el1 = dom.createComment("");
            dom.appendChild(el0, el1);
            var el1 = dom.createTextNode("\n            ");
            dom.appendChild(el0, el1);
            return el0;
          },
          buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
            var element10 = dom.childAt(fragment, [7]);
            var morphs = new Array(5);
            morphs[0] = dom.createMorphAt(fragment, 1, 1, contextualElement);
            morphs[1] = dom.createMorphAt(fragment, 3, 3, contextualElement);
            morphs[2] = dom.createMorphAt(fragment, 5, 5, contextualElement);
            morphs[3] = dom.createElementMorph(element10);
            morphs[4] = dom.createMorphAt(fragment, 9, 9, contextualElement);
            return morphs;
          },
          statements: [["block", "if", [["get", "environment.debeMostrarBotonCodigoXML", ["loc", [null, [27, 20], [27, 57]]]]], [], 0, null, ["loc", [null, [27, 14], [30, 21]]]], ["block", "if", [["get", "mostrarGuardar", ["loc", [null, [32, 20], [32, 34]]]]], [], 1, null, ["loc", [null, [32, 14], [38, 21]]]], ["inline", "pilas-boton-cargar", [], ["cuandoSelecciona", "cargarSolucion"], ["loc", [null, [41, 14], [41, 70]]]], ["element", "action", ["guardarSolucion"], [], ["loc", [null, [43, 46], [43, 74]]]], ["block", "if", [["get", "mostrarCompartir", ["loc", [null, [46, 20], [46, 36]]]]], [], 2, null, ["loc", [null, [46, 14], [48, 21]]]]],
          locals: [],
          templates: [child0, child1, child2]
        };
      })();
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 23,
              "column": 12
            },
            "end": {
              "line": 50,
              "column": 12
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createComment("");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
          dom.insertBoundary(fragment, 0);
          dom.insertBoundary(fragment, null);
          return morphs;
        },
        statements: [["block", "if", [["get", "modoDocente", ["loc", [null, [23, 22], [23, 33]]]]], [], 0, 1, ["loc", [null, [23, 12], [50, 12]]]]],
        locals: [],
        templates: [child0, child1]
      };
    })();
    var child5 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 71,
              "column": 0
            },
            "end": {
              "line": 73,
              "column": 0
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes() {
          return [];
        },
        statements: [],
        locals: [],
        templates: []
      };
    })();
    var child6 = (function () {
      var child0 = (function () {
        var child0 = (function () {
          return {
            meta: {
              "fragmentReason": false,
              "revision": "Ember@2.6.2",
              "loc": {
                "source": null,
                "start": {
                  "line": 77,
                  "column": 2
                },
                "end": {
                  "line": 89,
                  "column": 2
                }
              },
              "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
            },
            isEmpty: false,
            arity: 0,
            cachedFragment: null,
            hasRendered: false,
            buildFragment: function buildFragment(dom) {
              var el0 = dom.createDocumentFragment();
              var el1 = dom.createTextNode("\n  ");
              dom.appendChild(el0, el1);
              var el1 = dom.createComment("");
              dom.appendChild(el0, el1);
              var el1 = dom.createTextNode("\n\n    ");
              dom.appendChild(el0, el1);
              var el1 = dom.createElement("p");
              var el2 = dom.createTextNode("El autómata cumplió el objetivo.");
              dom.appendChild(el1, el2);
              dom.appendChild(el0, el1);
              var el1 = dom.createTextNode("\n\n    ");
              dom.appendChild(el0, el1);
              var el1 = dom.createElement("p");
              var el2 = dom.createElement("strong");
              var el3 = dom.createTextNode("Ojo.");
              dom.appendChild(el2, el3);
              dom.appendChild(el1, el2);
              var el2 = dom.createTextNode(" Tu programa puede ser excelente o no estar bien. Discutilo con amigos o docentes para saber si realmente encontraste una idea que también te sirva en otros desafíos.");
              dom.appendChild(el1, el2);
              dom.appendChild(el0, el1);
              var el1 = dom.createTextNode("\n\n");
              dom.appendChild(el0, el1);
              return el0;
            },
            buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
              var morphs = new Array(1);
              morphs[0] = dom.createMorphAt(fragment, 1, 1, contextualElement);
              return morphs;
            },
            statements: [["inline", "modal-title", [], ["title", "Objetivo cumplido", "close", "ocultarFinDesafio"], ["loc", [null, [83, 2], [83, 69]]]]],
            locals: [],
            templates: []
          };
        })();
        return {
          meta: {
            "fragmentReason": false,
            "revision": "Ember@2.6.2",
            "loc": {
              "source": null,
              "start": {
                "line": 76,
                "column": 0
              },
              "end": {
                "line": 90,
                "column": 0
              }
            },
            "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
          },
          isEmpty: false,
          arity: 0,
          cachedFragment: null,
          hasRendered: false,
          buildFragment: function buildFragment(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createComment("");
            dom.appendChild(el0, el1);
            return el0;
          },
          buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
            var morphs = new Array(1);
            morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
            dom.insertBoundary(fragment, 0);
            dom.insertBoundary(fragment, null);
            return morphs;
          },
          statements: [["block", "modal-dialog", [], ["close", "ocultarFinDesafio", "target", "panel-pilas", "attatchment", "middle center", "translucentOverlay", true, "container-class", "dialogoFinDesafio"], 0, null, ["loc", [null, [77, 2], [89, 19]]]]],
          locals: [],
          templates: [child0]
        };
      })();
      var child1 = (function () {
        var child0 = (function () {
          var child0 = (function () {
            return {
              meta: {
                "fragmentReason": false,
                "revision": "Ember@2.6.2",
                "loc": {
                  "source": null,
                  "start": {
                    "line": 112,
                    "column": 10
                  },
                  "end": {
                    "line": 114,
                    "column": 10
                  }
                },
                "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
              },
              isEmpty: false,
              arity: 0,
              cachedFragment: null,
              hasRendered: false,
              buildFragment: function buildFragment(dom) {
                var el0 = dom.createDocumentFragment();
                var el1 = dom.createTextNode("            ");
                dom.appendChild(el0, el1);
                var el1 = dom.createElement("button");
                dom.setAttribute(el1, "class", "btn btn-info");
                dom.setAttribute(el1, "disabled", "");
                var el2 = dom.createElement("i");
                dom.setAttribute(el2, "class", "fa fa-twitter");
                dom.appendChild(el1, el2);
                var el2 = dom.createTextNode(" Compartiendo ...");
                dom.appendChild(el1, el2);
                dom.appendChild(el0, el1);
                var el1 = dom.createTextNode("\n");
                dom.appendChild(el0, el1);
                return el0;
              },
              buildRenderNodes: function buildRenderNodes() {
                return [];
              },
              statements: [],
              locals: [],
              templates: []
            };
          })();
          var child1 = (function () {
            return {
              meta: {
                "fragmentReason": false,
                "revision": "Ember@2.6.2",
                "loc": {
                  "source": null,
                  "start": {
                    "line": 114,
                    "column": 10
                  },
                  "end": {
                    "line": 116,
                    "column": 10
                  }
                },
                "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
              },
              isEmpty: false,
              arity: 0,
              cachedFragment: null,
              hasRendered: false,
              buildFragment: function buildFragment(dom) {
                var el0 = dom.createDocumentFragment();
                var el1 = dom.createTextNode("            ");
                dom.appendChild(el0, el1);
                var el1 = dom.createElement("button");
                dom.setAttribute(el1, "class", "btn btn-info");
                var el2 = dom.createElement("i");
                dom.setAttribute(el2, "class", "fa fa-twitter");
                dom.appendChild(el1, el2);
                var el2 = dom.createTextNode(" Compartir");
                dom.appendChild(el1, el2);
                dom.appendChild(el0, el1);
                var el1 = dom.createTextNode("\n");
                dom.appendChild(el0, el1);
                return el0;
              },
              buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
                var element1 = dom.childAt(fragment, [1]);
                var morphs = new Array(1);
                morphs[0] = dom.createElementMorph(element1);
                return morphs;
              },
              statements: [["element", "action", ["enviarMensaje"], [], ["loc", [null, [115, 41], [115, 67]]]]],
              locals: [],
              templates: []
            };
          })();
          var child2 = (function () {
            return {
              meta: {
                "fragmentReason": false,
                "revision": "Ember@2.6.2",
                "loc": {
                  "source": null,
                  "start": {
                    "line": 119,
                    "column": 8
                  },
                  "end": {
                    "line": 124,
                    "column": 8
                  }
                },
                "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
              },
              isEmpty: false,
              arity: 0,
              cachedFragment: null,
              hasRendered: false,
              buildFragment: function buildFragment(dom) {
                var el0 = dom.createDocumentFragment();
                var el1 = dom.createTextNode("          ");
                dom.appendChild(el0, el1);
                var el1 = dom.createElement("div");
                dom.setAttribute(el1, "class", "compartir-mensaje");
                var el2 = dom.createTextNode("\n            Listo, tu mensaje fué publicado en twitter,\n            ");
                dom.appendChild(el1, el2);
                var el2 = dom.createElement("a");
                dom.setAttribute(el2, "href", "");
                var el3 = dom.createTextNode("¿querés abrirlo?");
                dom.appendChild(el2, el3);
                dom.appendChild(el1, el2);
                var el2 = dom.createTextNode(".\n          ");
                dom.appendChild(el1, el2);
                dom.appendChild(el0, el1);
                var el1 = dom.createTextNode("\n");
                dom.appendChild(el0, el1);
                return el0;
              },
              buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
                var element0 = dom.childAt(fragment, [1, 1]);
                var morphs = new Array(1);
                morphs[0] = dom.createElementMorph(element0);
                return morphs;
              },
              statements: [["element", "action", ["abrirMensajePublicado"], [], ["loc", [null, [122, 23], [122, 57]]]]],
              locals: [],
              templates: []
            };
          })();
          return {
            meta: {
              "fragmentReason": false,
              "revision": "Ember@2.6.2",
              "loc": {
                "source": null,
                "start": {
                  "line": 94,
                  "column": 4
                },
                "end": {
                  "line": 130,
                  "column": 4
                }
              },
              "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
            },
            isEmpty: false,
            arity: 0,
            cachedFragment: null,
            hasRendered: false,
            buildFragment: function buildFragment(dom) {
              var el0 = dom.createDocumentFragment();
              var el1 = dom.createTextNode("\n    ");
              dom.appendChild(el0, el1);
              var el1 = dom.createComment("");
              dom.appendChild(el0, el1);
              var el1 = dom.createTextNode("\n\n    ");
              dom.appendChild(el0, el1);
              var el1 = dom.createElement("div");
              dom.setAttribute(el1, "class", "modal-body");
              var el2 = dom.createTextNode("\n      ");
              dom.appendChild(el1, el2);
              var el2 = dom.createElement("div");
              dom.setAttribute(el2, "class", "modal-inline-block  float-left");
              var el3 = dom.createTextNode("\n        ");
              dom.appendChild(el2, el3);
              var el3 = dom.createElement("img");
              dom.setAttribute(el3, "id", "preview");
              dom.setAttribute(el3, "width", "210");
              dom.setAttribute(el3, "height", "240");
              dom.appendChild(el2, el3);
              var el3 = dom.createTextNode("\n      ");
              dom.appendChild(el2, el3);
              dom.appendChild(el1, el2);
              var el2 = dom.createTextNode("\n\n      ");
              dom.appendChild(el1, el2);
              var el2 = dom.createElement("div");
              dom.setAttribute(el2, "class", "modal-inline-block");
              var el3 = dom.createTextNode("\n\n        ");
              dom.appendChild(el2, el3);
              var el3 = dom.createElement("div");
              dom.setAttribute(el3, "class", "fila-opcion");
              var el4 = dom.createTextNode("\n          Mensaje: ");
              dom.appendChild(el3, el4);
              var el4 = dom.createComment("");
              dom.appendChild(el3, el4);
              var el4 = dom.createTextNode("\n        ");
              dom.appendChild(el3, el4);
              dom.appendChild(el2, el3);
              var el3 = dom.createTextNode("\n\n        ");
              dom.appendChild(el2, el3);
              var el3 = dom.createElement("div");
              dom.setAttribute(el3, "class", "fila-opcion");
              var el4 = dom.createTextNode("\n");
              dom.appendChild(el3, el4);
              var el4 = dom.createComment("");
              dom.appendChild(el3, el4);
              var el4 = dom.createTextNode("        ");
              dom.appendChild(el3, el4);
              dom.appendChild(el2, el3);
              var el3 = dom.createTextNode("\n\n");
              dom.appendChild(el2, el3);
              var el3 = dom.createComment("");
              dom.appendChild(el2, el3);
              var el3 = dom.createTextNode("\n      ");
              dom.appendChild(el2, el3);
              dom.appendChild(el1, el2);
              var el2 = dom.createTextNode("\n    ");
              dom.appendChild(el1, el2);
              dom.appendChild(el0, el1);
              var el1 = dom.createTextNode("\n\n\n");
              dom.appendChild(el0, el1);
              return el0;
            },
            buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
              var element2 = dom.childAt(fragment, [3]);
              var element3 = dom.childAt(element2, [1, 1]);
              var element4 = dom.childAt(element2, [3]);
              var morphs = new Array(5);
              morphs[0] = dom.createMorphAt(fragment, 1, 1, contextualElement);
              morphs[1] = dom.createAttrMorph(element3, 'src');
              morphs[2] = dom.createMorphAt(dom.childAt(element4, [1]), 1, 1);
              morphs[3] = dom.createMorphAt(dom.childAt(element4, [3]), 1, 1);
              morphs[4] = dom.createMorphAt(element4, 5, 5);
              return morphs;
            },
            statements: [["inline", "modal-title", [], ["title", "Compartir en twitter", "close", "ocultarModalTwitter"], ["loc", [null, [98, 4], [98, 76]]]], ["attribute", "src", ["get", "previewData", ["loc", [null, [102, 32], [102, 43]]]]], ["inline", "textarea", [], ["class", "modal-mensaje-compartir", "rows", 3, "value", ["subexpr", "@mut", [["get", "mensajeCompartir", ["loc", [null, [108, 75], [108, 91]]]]], [], []]], ["loc", [null, [108, 19], [108, 93]]]], ["block", "if", [["get", "envioEnCurso", ["loc", [null, [112, 16], [112, 28]]]]], [], 0, 1, ["loc", [null, [112, 10], [116, 17]]]], ["block", "if", [["get", "mensajePublicadoURL", ["loc", [null, [119, 14], [119, 33]]]]], [], 2, null, ["loc", [null, [119, 8], [124, 15]]]]],
            locals: [],
            templates: [child0, child1, child2]
          };
        })();
        return {
          meta: {
            "fragmentReason": false,
            "revision": "Ember@2.6.2",
            "loc": {
              "source": null,
              "start": {
                "line": 93,
                "column": 2
              },
              "end": {
                "line": 131,
                "column": 2
              }
            },
            "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
          },
          isEmpty: false,
          arity: 0,
          cachedFragment: null,
          hasRendered: false,
          buildFragment: function buildFragment(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createComment("");
            dom.appendChild(el0, el1);
            return el0;
          },
          buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
            var morphs = new Array(1);
            morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
            dom.insertBoundary(fragment, 0);
            dom.insertBoundary(fragment, null);
            return morphs;
          },
          statements: [["block", "modal-dialog", [], ["close", "ocultarModalTwitter", "targetAttachment", "center", "translucentOverlay", true], 0, null, ["loc", [null, [94, 4], [130, 21]]]]],
          locals: [],
          templates: [child0]
        };
      })();
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 73,
              "column": 0
            },
            "end": {
              "line": 133,
              "column": 0
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("\n\n");
          dom.appendChild(el0, el1);
          var el1 = dom.createComment("");
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n\n");
          dom.appendChild(el0, el1);
          var el1 = dom.createComment("");
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(2);
          morphs[0] = dom.createMorphAt(fragment, 1, 1, contextualElement);
          morphs[1] = dom.createMorphAt(fragment, 3, 3, contextualElement);
          return morphs;
        },
        statements: [["block", "if", [["get", "mostrarDialogoFinDesafio", ["loc", [null, [76, 6], [76, 30]]]]], [], 0, null, ["loc", [null, [76, 0], [90, 7]]]], ["block", "if", [["get", "abrirDialogoCompartir", ["loc", [null, [93, 8], [93, 29]]]]], [], 1, null, ["loc", [null, [93, 2], [131, 9]]]]],
        locals: [],
        templates: [child0, child1]
      };
    })();
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type", "multiple-nodes"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 134,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/components/pilas-blockly.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("table");
        var el2 = dom.createTextNode("\n\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("tbody");
        var el3 = dom.createTextNode("\n    ");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("tr");
        var el4 = dom.createTextNode("\n      ");
        dom.appendChild(el3, el4);
        var el4 = dom.createElement("td");
        var el5 = dom.createTextNode("\n          ");
        dom.appendChild(el4, el5);
        var el5 = dom.createElement("div");
        dom.setAttribute(el5, "class", "pilas-blockly-botones");
        var el6 = dom.createTextNode("\n\n");
        dom.appendChild(el5, el6);
        var el6 = dom.createComment("");
        dom.appendChild(el5, el6);
        var el6 = dom.createTextNode("\n");
        dom.appendChild(el5, el6);
        var el6 = dom.createComment("");
        dom.appendChild(el5, el6);
        var el6 = dom.createTextNode("\n");
        dom.appendChild(el5, el6);
        var el6 = dom.createComment("");
        dom.appendChild(el5, el6);
        var el6 = dom.createTextNode("\n          ");
        dom.appendChild(el5, el6);
        dom.appendChild(el4, el5);
        var el5 = dom.createTextNode("\n\n      ");
        dom.appendChild(el4, el5);
        dom.appendChild(el3, el4);
        var el4 = dom.createTextNode("\n    ");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n\n    ");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("tr");
        var el4 = dom.createTextNode("\n      ");
        dom.appendChild(el3, el4);
        var el4 = dom.createElement("td");
        dom.setAttribute(el4, "id", "blocklyArea");
        var el5 = dom.createTextNode("\n\n        ");
        dom.appendChild(el4, el5);
        var el5 = dom.createElement("div");
        dom.setAttribute(el5, "id", "contenedor-blockly");
        dom.setAttribute(el5, "style", "position: absolute;");
        var el6 = dom.createTextNode(" ");
        dom.appendChild(el5, el6);
        dom.appendChild(el4, el5);
        var el5 = dom.createTextNode("\n\n      ");
        dom.appendChild(el4, el5);
        dom.appendChild(el3, el4);
        var el4 = dom.createTextNode("\n    ");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n  ");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n\n\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var element15 = dom.childAt(fragment, [2, 1, 1, 1, 1]);
        var morphs = new Array(5);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        morphs[1] = dom.createMorphAt(element15, 1, 1);
        morphs[2] = dom.createMorphAt(element15, 3, 3);
        morphs[3] = dom.createMorphAt(element15, 5, 5);
        morphs[4] = dom.createMorphAt(fragment, 4, 4, contextualElement);
        dom.insertBoundary(fragment, 0);
        dom.insertBoundary(fragment, null);
        return morphs;
      },
      statements: [["content", "yield", ["loc", [null, [1, 0], [1, 9]]]], ["block", "if", [["get", "mostrarAlternar", ["loc", [null, [11, 18], [11, 33]]]]], [], 0, null, ["loc", [null, [11, 12], [13, 19]]]], ["block", "if", [["get", "ejecutando", ["loc", [null, [15, 18], [15, 28]]]]], [], 1, 2, ["loc", [null, [15, 12], [19, 19]]]], ["block", "if", [["get", "modoAlumno", ["loc", [null, [21, 18], [21, 28]]]]], [], 3, 4, ["loc", [null, [21, 12], [50, 19]]]], ["block", "if", [["get", "ocultarModal", ["loc", [null, [71, 6], [71, 18]]]]], [], 5, 6, ["loc", [null, [71, 0], [133, 7]]]]],
      locals: [],
      templates: [child0, child1, child2, child3, child4, child5, child6]
    };
  })());
});
define("pilas-engine-bloques/templates/components/pilas-boton-cargar", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type", "multiple-nodes"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 7,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/components/pilas-boton-cargar.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("input");
        dom.setAttribute(el1, "type", "file");
        dom.setAttribute(el1, "id", "cargarActividadInput");
        dom.setAttribute(el1, "accept", ".spbq");
        dom.setAttribute(el1, "class", "hidden");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("a");
        dom.setAttribute(el1, "id", "placeholder");
        dom.setAttribute(el1, "class", "hidden");
        var el2 = dom.createTextNode("..");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("button");
        dom.setAttribute(el1, "class", "btn btn-default");
        var el2 = dom.createElement("i");
        dom.setAttribute(el2, "class", "fa fa-folder-open-o");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode(" Abrir");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var element0 = dom.childAt(fragment, [6]);
        var morphs = new Array(2);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        morphs[1] = dom.createElementMorph(element0);
        dom.insertBoundary(fragment, 0);
        return morphs;
      },
      statements: [["content", "yield", ["loc", [null, [1, 0], [1, 9]]]], ["element", "action", ["alPulsar"], [], ["loc", [null, [6, 32], [6, 53]]]]],
      locals: [],
      templates: []
    };
  })());
});
define("pilas-engine-bloques/templates/components/pilas-botones-zoom", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    var child0 = (function () {
      return {
        meta: {
          "fragmentReason": {
            "name": "modifiers",
            "modifiers": ["action"]
          },
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 1,
              "column": 0
            },
            "end": {
              "line": 3,
              "column": 0
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-botones-zoom.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("  ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("button");
          dom.setAttribute(el1, "class", "btn btn-success btn-rect");
          var el2 = dom.createElement("i");
          dom.setAttribute(el2, "class", "fa fa-minus");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var element1 = dom.childAt(fragment, [1]);
          var morphs = new Array(1);
          morphs[0] = dom.createElementMorph(element1);
          return morphs;
        },
        statements: [["element", "action", ["zoomOut"], [], ["loc", [null, [2, 10], [2, 30]]]]],
        locals: [],
        templates: []
      };
    })();
    var child1 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 3,
              "column": 0
            },
            "end": {
              "line": 5,
              "column": 0
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-botones-zoom.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("  ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("button");
          dom.setAttribute(el1, "disabled", "");
          dom.setAttribute(el1, "class", "btn btn-success btn-rect");
          var el2 = dom.createElement("i");
          dom.setAttribute(el2, "class", "fa fa-minus");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes() {
          return [];
        },
        statements: [],
        locals: [],
        templates: []
      };
    })();
    var child2 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 9,
              "column": 0
            },
            "end": {
              "line": 11,
              "column": 0
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-botones-zoom.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("  ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("button");
          dom.setAttribute(el1, "class", "btn btn-success btn-rect");
          var el2 = dom.createElement("i");
          dom.setAttribute(el2, "class", "fa fa-plus");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var element0 = dom.childAt(fragment, [1]);
          var morphs = new Array(1);
          morphs[0] = dom.createElementMorph(element0);
          return morphs;
        },
        statements: [["element", "action", ["zoomIn"], [], ["loc", [null, [10, 10], [10, 29]]]]],
        locals: [],
        templates: []
      };
    })();
    var child3 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 11,
              "column": 0
            },
            "end": {
              "line": 13,
              "column": 0
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-botones-zoom.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("  ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("button");
          dom.setAttribute(el1, "disabled", "");
          dom.setAttribute(el1, "class", "btn btn-success btn-rect");
          var el2 = dom.createElement("i");
          dom.setAttribute(el2, "class", "fa fa-plus");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes() {
          return [];
        },
        statements: [],
        locals: [],
        templates: []
      };
    })();
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type", "multiple-nodes"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 17,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/components/pilas-botones-zoom.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n  ");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("span");
        dom.setAttribute(el1, "class", "zoom-label");
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("%");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var element2 = dom.childAt(fragment, [2]);
        var morphs = new Array(5);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        morphs[1] = dom.createElementMorph(element2);
        morphs[2] = dom.createMorphAt(element2, 0, 0);
        morphs[3] = dom.createMorphAt(fragment, 4, 4, contextualElement);
        morphs[4] = dom.createMorphAt(fragment, 6, 6, contextualElement);
        dom.insertBoundary(fragment, 0);
        return morphs;
      },
      statements: [["block", "if", [["get", "canZoomOut", ["loc", [null, [1, 6], [1, 16]]]]], [], 0, 1, ["loc", [null, [1, 0], [5, 7]]]], ["element", "action", ["zoomRestore"], [], ["loc", [null, [7, 8], [7, 32]]]], ["content", "zoomValue", ["loc", [null, [7, 52], [7, 65]]]], ["block", "if", [["get", "canZoomIn", ["loc", [null, [9, 6], [9, 15]]]]], [], 2, 3, ["loc", [null, [9, 0], [13, 7]]]], ["content", "yield", ["loc", [null, [16, 0], [16, 9]]]]],
      locals: [],
      templates: [child0, child1, child2, child3]
    };
  })());
});
define("pilas-engine-bloques/templates/components/pilas-canvas", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type", "multiple-nodes"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 6,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/components/pilas-canvas.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("iframe");
        dom.setAttribute(el1, "src", "pilas.html");
        dom.setAttribute(el1, "width", "100%");
        dom.setAttribute(el1, "height", "100%");
        dom.setAttribute(el1, "class", "iframe-pilas-canvas");
        dom.setAttribute(el1, "id", "innerIframe");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var morphs = new Array(2);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        morphs[1] = dom.createMorphAt(fragment, 2, 2, contextualElement);
        dom.insertBoundary(fragment, 0);
        return morphs;
      },
      statements: [["content", "yield", ["loc", [null, [1, 0], [1, 9]]]], ["inline", "pilas-spinner", [], ["centered", true], ["loc", [null, [3, 0], [3, 31]]]]],
      locals: [],
      templates: []
    };
  })());
});
define("pilas-engine-bloques/templates/components/pilas-cargando", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 2,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/components/pilas-cargando.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var morphs = new Array(1);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        dom.insertBoundary(fragment, 0);
        return morphs;
      },
      statements: [["content", "pilas-spinner", ["loc", [null, [1, 0], [1, 17]]]]],
      locals: [],
      templates: []
    };
  })());
});
define("pilas-engine-bloques/templates/components/pilas-debug-bar", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["multiple-nodes"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 6,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/components/pilas-debug-bar.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createElement("button");
        var el2 = dom.createTextNode("1");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("button");
        var el2 = dom.createTextNode("2");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("button");
        var el2 = dom.createTextNode("3");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("span");
        dom.setAttribute(el1, "class", "hidden");
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var element0 = dom.childAt(fragment, [0]);
        var element1 = dom.childAt(fragment, [2]);
        var element2 = dom.childAt(fragment, [4]);
        var morphs = new Array(7);
        morphs[0] = dom.createAttrMorph(element0, 'class');
        morphs[1] = dom.createElementMorph(element0);
        morphs[2] = dom.createAttrMorph(element1, 'class');
        morphs[3] = dom.createElementMorph(element1);
        morphs[4] = dom.createAttrMorph(element2, 'class');
        morphs[5] = dom.createElementMorph(element2);
        morphs[6] = dom.createMorphAt(dom.childAt(fragment, [6]), 0, 0);
        return morphs;
      },
      statements: [["attribute", "class", ["concat", ["btn btn-default ", ["subexpr", "if", [["get", "panelCanvasVisible", ["loc", [null, [1, 82], [1, 100]]]], "active"], [], ["loc", [null, [1, 77], [1, 111]]]]]]], ["element", "action", [["subexpr", "toggle", ["panelCanvasVisible", ["get", "this", ["loc", [null, [1, 46], [1, 50]]]]], [], ["loc", [null, [1, 17], [1, 51]]]]], [], ["loc", [null, [1, 8], [1, 53]]]], ["attribute", "class", ["concat", ["btn btn-default ", ["subexpr", "if", [["get", "panelBlocklyVisible", ["loc", [null, [2, 83], [2, 102]]]], "active"], [], ["loc", [null, [2, 78], [2, 113]]]]]]], ["element", "action", [["subexpr", "toggle", ["panelBlocklyVisible", ["get", "this", ["loc", [null, [2, 47], [2, 51]]]]], [], ["loc", [null, [2, 17], [2, 52]]]]], [], ["loc", [null, [2, 8], [2, 54]]]], ["attribute", "class", ["concat", ["btn btn-default ", ["subexpr", "if", [["get", "panelCodigoVisible", ["loc", [null, [3, 82], [3, 100]]]], "active"], [], ["loc", [null, [3, 77], [3, 111]]]]]]], ["element", "action", [["subexpr", "toggle", ["panelCodigoVisible", ["get", "this", ["loc", [null, [3, 46], [3, 50]]]]], [], ["loc", [null, [3, 17], [3, 51]]]]], [], ["loc", [null, [3, 8], [3, 53]]]], ["content", "layout", ["loc", [null, [5, 21], [5, 31]]]]],
      locals: [],
      templates: []
    };
  })());
});
define("pilas-engine-bloques/templates/components/pilas-desafio", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    var child0 = (function () {
      var child0 = (function () {
        return {
          meta: {
            "fragmentReason": false,
            "revision": "Ember@2.6.2",
            "loc": {
              "source": null,
              "start": {
                "line": 3,
                "column": 2
              },
              "end": {
                "line": 5,
                "column": 2
              }
            },
            "moduleName": "pilas-engine-bloques/templates/components/pilas-desafio.hbs"
          },
          isEmpty: false,
          arity: 0,
          cachedFragment: null,
          hasRendered: false,
          buildFragment: function buildFragment(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createTextNode("    ");
            dom.appendChild(el0, el1);
            var el1 = dom.createElement("img");
            dom.setAttribute(el1, "class", "grayscale semi-transparente");
            dom.appendChild(el0, el1);
            var el1 = dom.createTextNode("\n");
            dom.appendChild(el0, el1);
            return el0;
          },
          buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
            var element1 = dom.childAt(fragment, [1]);
            var morphs = new Array(1);
            morphs[0] = dom.createAttrMorph(element1, 'src');
            return morphs;
          },
          statements: [["attribute", "src", ["concat", ["images/desafios/", ["get", "model.nombre", ["loc", [null, [4, 68], [4, 80]]]], ".png"]]]],
          locals: [],
          templates: []
        };
      })();
      var child1 = (function () {
        return {
          meta: {
            "fragmentReason": false,
            "revision": "Ember@2.6.2",
            "loc": {
              "source": null,
              "start": {
                "line": 5,
                "column": 2
              },
              "end": {
                "line": 7,
                "column": 2
              }
            },
            "moduleName": "pilas-engine-bloques/templates/components/pilas-desafio.hbs"
          },
          isEmpty: false,
          arity: 0,
          cachedFragment: null,
          hasRendered: false,
          buildFragment: function buildFragment(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createTextNode("    ");
            dom.appendChild(el0, el1);
            var el1 = dom.createElement("img");
            dom.setAttribute(el1, "class", "grayscale semi-transparente");
            dom.setAttribute(el1, "src", "images/desafios/proximamente.png");
            dom.appendChild(el0, el1);
            var el1 = dom.createTextNode("\n");
            dom.appendChild(el0, el1);
            return el0;
          },
          buildRenderNodes: function buildRenderNodes() {
            return [];
          },
          statements: [],
          locals: [],
          templates: []
        };
      })();
      return {
        meta: {
          "fragmentReason": {
            "name": "missing-wrapper",
            "problems": ["wrong-type", "multiple-nodes"]
          },
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 1,
              "column": 0
            },
            "end": {
              "line": 15,
              "column": 0
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-desafio.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          var el1 = dom.createComment("");
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n  ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("div");
          dom.setAttribute(el1, "class", "ribbon right gray semi-transparente");
          var el2 = dom.createTextNode("\n    ");
          dom.appendChild(el1, el2);
          var el2 = dom.createElement("a");
          var el3 = dom.createTextNode("Muy pronto");
          dom.appendChild(el2, el3);
          dom.appendChild(el1, el2);
          var el2 = dom.createTextNode("\n  ");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n\n  ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("div");
          dom.setAttribute(el1, "class", "pilas-desafio-titulo");
          var el2 = dom.createComment("");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(2);
          morphs[0] = dom.createMorphAt(fragment, 1, 1, contextualElement);
          morphs[1] = dom.createMorphAt(dom.childAt(fragment, [5]), 0, 0);
          return morphs;
        },
        statements: [["block", "if", [["get", "model.nombre", ["loc", [null, [3, 8], [3, 20]]]]], [], 0, 1, ["loc", [null, [3, 2], [7, 9]]]], ["content", "model.titulo", ["loc", [null, [13, 36], [13, 52]]]]],
        locals: [],
        templates: [child0, child1]
      };
    })();
    var child1 = (function () {
      var child0 = (function () {
        var child0 = (function () {
          return {
            meta: {
              "fragmentReason": false,
              "revision": "Ember@2.6.2",
              "loc": {
                "source": null,
                "start": {
                  "line": 19,
                  "column": 4
                },
                "end": {
                  "line": 21,
                  "column": 4
                }
              },
              "moduleName": "pilas-engine-bloques/templates/components/pilas-desafio.hbs"
            },
            isEmpty: false,
            arity: 0,
            cachedFragment: null,
            hasRendered: false,
            buildFragment: function buildFragment(dom) {
              var el0 = dom.createDocumentFragment();
              var el1 = dom.createTextNode("      ");
              dom.appendChild(el0, el1);
              var el1 = dom.createElement("img");
              dom.setAttribute(el1, "class", "desafio-img");
              dom.appendChild(el0, el1);
              var el1 = dom.createTextNode("\n");
              dom.appendChild(el0, el1);
              return el0;
            },
            buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
              var element0 = dom.childAt(fragment, [1]);
              var morphs = new Array(1);
              morphs[0] = dom.createAttrMorph(element0, 'src');
              return morphs;
            },
            statements: [["attribute", "src", ["concat", ["images/desafios/", ["get", "model.nombre", ["loc", [null, [20, 54], [20, 66]]]], ".png"]]]],
            locals: [],
            templates: []
          };
        })();
        return {
          meta: {
            "fragmentReason": false,
            "revision": "Ember@2.6.2",
            "loc": {
              "source": null,
              "start": {
                "line": 17,
                "column": 2
              },
              "end": {
                "line": 24,
                "column": 2
              }
            },
            "moduleName": "pilas-engine-bloques/templates/components/pilas-desafio.hbs"
          },
          isEmpty: false,
          arity: 0,
          cachedFragment: null,
          hasRendered: false,
          buildFragment: function buildFragment(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createTextNode("\n");
            dom.appendChild(el0, el1);
            var el1 = dom.createComment("");
            dom.appendChild(el0, el1);
            var el1 = dom.createTextNode("\n    ");
            dom.appendChild(el0, el1);
            var el1 = dom.createElement("div");
            dom.setAttribute(el1, "class", "pilas-desafio-titulo");
            var el2 = dom.createComment("");
            dom.appendChild(el1, el2);
            dom.appendChild(el0, el1);
            var el1 = dom.createTextNode("\n");
            dom.appendChild(el0, el1);
            return el0;
          },
          buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
            var morphs = new Array(2);
            morphs[0] = dom.createMorphAt(fragment, 1, 1, contextualElement);
            morphs[1] = dom.createMorphAt(dom.childAt(fragment, [3]), 0, 0);
            return morphs;
          },
          statements: [["block", "if", [["get", "model.nombre", ["loc", [null, [19, 10], [19, 22]]]]], [], 0, null, ["loc", [null, [19, 4], [21, 11]]]], ["content", "model.titulo", ["loc", [null, [23, 38], [23, 54]]]]],
          locals: [],
          templates: [child0]
        };
      })();
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 15,
              "column": 0
            },
            "end": {
              "line": 26,
              "column": 0
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-desafio.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          var el1 = dom.createComment("");
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 1, 1, contextualElement);
          return morphs;
        },
        statements: [["block", "link-to", ["desafio", ["get", "model", ["loc", [null, [17, 23], [17, 28]]]], ["subexpr", "query-params", [], ["codigo", ""], ["loc", [null, [17, 29], [17, 53]]]]], [], 0, null, ["loc", [null, [17, 2], [24, 14]]]]],
        locals: [],
        templates: [child0]
      };
    })();
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 27,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/components/pilas-desafio.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var morphs = new Array(1);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        dom.insertBoundary(fragment, 0);
        dom.insertBoundary(fragment, null);
        return morphs;
      },
      statements: [["block", "if", [["get", "model.deshabilitado", ["loc", [null, [1, 6], [1, 25]]]]], [], 0, 1, ["loc", [null, [1, 0], [26, 7]]]]],
      locals: [],
      templates: [child0, child1]
    };
  })());
});
define("pilas-engine-bloques/templates/components/pilas-editor", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    var child0 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 3,
              "column": 2
            },
            "end": {
              "line": 11,
              "column": 2
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-editor.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("\n    ");
          dom.appendChild(el0, el1);
          var el1 = dom.createComment("");
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 1, 1, contextualElement);
          return morphs;
        },
        statements: [["inline", "pilas-debug-bar", [], ["panelCanvasVisible", ["subexpr", "@mut", [["get", "panelCanvasVisible", ["loc", [null, [6, 29], [6, 47]]]]], [], []], "panelBlocklyVisible", ["subexpr", "@mut", [["get", "panelBlocklyVisible", ["loc", [null, [7, 30], [7, 49]]]]], [], []], "panelCodigoVisible", ["subexpr", "@mut", [["get", "panelCodigoVisible", ["loc", [null, [8, 29], [8, 47]]]]], [], []]], ["loc", [null, [5, 4], [9, 6]]]]],
        locals: [],
        templates: []
      };
    })();
    var child1 = (function () {
      var child0 = (function () {
        return {
          meta: {
            "fragmentReason": false,
            "revision": "Ember@2.6.2",
            "loc": {
              "source": null,
              "start": {
                "line": 27,
                "column": 8
              },
              "end": {
                "line": 33,
                "column": 8
              }
            },
            "moduleName": "pilas-engine-bloques/templates/components/pilas-editor.hbs"
          },
          isEmpty: false,
          arity: 0,
          cachedFragment: null,
          hasRendered: false,
          buildFragment: function buildFragment(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createTextNode("          ");
            dom.appendChild(el0, el1);
            var el1 = dom.createElement("div");
            dom.setAttribute(el1, "class", "tip-block");
            var el2 = dom.createTextNode("\n            ");
            dom.appendChild(el1, el2);
            var el2 = dom.createElement("p");
            var el3 = dom.createElement("em");
            var el4 = dom.createTextNode("¿Sabías qué...?");
            dom.appendChild(el3, el4);
            dom.appendChild(el2, el3);
            dom.appendChild(el1, el2);
            var el2 = dom.createTextNode("\n\n            ");
            dom.appendChild(el1, el2);
            var el2 = dom.createElement("p");
            var el3 = dom.createComment("");
            dom.appendChild(el2, el3);
            dom.appendChild(el1, el2);
            var el2 = dom.createTextNode("\n          ");
            dom.appendChild(el1, el2);
            dom.appendChild(el0, el1);
            var el1 = dom.createTextNode("\n");
            dom.appendChild(el0, el1);
            return el0;
          },
          buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
            var morphs = new Array(1);
            morphs[0] = dom.createMorphAt(dom.childAt(fragment, [1, 3]), 0, 0);
            return morphs;
          },
          statements: [["content", "model.consignaInicial", ["loc", [null, [31, 15], [31, 40]]]]],
          locals: [],
          templates: []
        };
      })();
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 15,
              "column": 0
            },
            "end": {
              "line": 39,
              "column": 0
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-editor.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("  ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("div");
          dom.setAttribute(el1, "class", "desafio-panel-izquierdo");
          dom.setAttribute(el1, "id", "panel-izquierdo");
          var el2 = dom.createTextNode("\n\n    ");
          dom.appendChild(el1, el2);
          var el2 = dom.createComment("");
          dom.appendChild(el1, el2);
          var el2 = dom.createTextNode("\n\n    ");
          dom.appendChild(el1, el2);
          var el2 = dom.createElement("div");
          dom.setAttribute(el2, "class", "contenedor-panel-ayuda");
          dom.setAttribute(el2, "id", "panel-ayuda");
          var el3 = dom.createTextNode("\n      ");
          dom.appendChild(el2, el3);
          var el3 = dom.createElement("div");
          dom.setAttribute(el3, "class", "panel-ayuda puede-seleccionar");
          var el4 = dom.createTextNode("\n\n        ");
          dom.appendChild(el3, el4);
          var el4 = dom.createElement("h4");
          var el5 = dom.createComment("");
          dom.appendChild(el4, el5);
          dom.appendChild(el3, el4);
          var el4 = dom.createTextNode("\n\n        ");
          dom.appendChild(el3, el4);
          var el4 = dom.createElement("p");
          var el5 = dom.createComment("");
          dom.appendChild(el4, el5);
          dom.appendChild(el3, el4);
          var el4 = dom.createTextNode("\n\n");
          dom.appendChild(el3, el4);
          var el4 = dom.createComment("");
          dom.appendChild(el3, el4);
          var el4 = dom.createTextNode("\n      ");
          dom.appendChild(el3, el4);
          dom.appendChild(el2, el3);
          var el3 = dom.createTextNode("\n    ");
          dom.appendChild(el2, el3);
          dom.appendChild(el1, el2);
          var el2 = dom.createTextNode("\n\n  ");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var element0 = dom.childAt(fragment, [1]);
          var element1 = dom.childAt(element0, [3, 1]);
          var morphs = new Array(4);
          morphs[0] = dom.createMorphAt(element0, 1, 1);
          morphs[1] = dom.createMorphAt(dom.childAt(element1, [1]), 0, 0);
          morphs[2] = dom.createMorphAt(dom.childAt(element1, [3]), 0, 0);
          morphs[3] = dom.createMorphAt(element1, 5, 5);
          return morphs;
        },
        statements: [["inline", "pilas-canvas", [], ["pilas", ["subexpr", "@mut", [["get", "pilas", ["loc", [null, [18, 25], [18, 30]]]]], [], []], "onReady", "onReady", "escena", ["subexpr", "@mut", [["get", "model.escena", ["loc", [null, [18, 56], [18, 68]]]]], [], []]], ["loc", [null, [18, 4], [18, 70]]]], ["content", "model.titulo", ["loc", [null, [23, 12], [23, 28]]]], ["content", "model.enunciado", ["loc", [null, [25, 11], [25, 30]]]], ["block", "if", [["get", "model.consignaInicial", ["loc", [null, [27, 14], [27, 35]]]]], [], 0, null, ["loc", [null, [27, 8], [33, 15]]]]],
        locals: [],
        templates: [child0]
      };
    })();
    var child2 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 43,
              "column": 0
            },
            "end": {
              "line": 57,
              "column": 0
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-editor.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("    ");
          dom.appendChild(el0, el1);
          var el1 = dom.createComment("");
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 1, 1, contextualElement);
          return morphs;
        },
        statements: [["inline", "pilas-blockly", [], ["guardar", "guardar", "registrarPrimerCodigo", "registrarPrimerCodigo", "codigo", ["subexpr", "@mut", [["get", "codigo", ["loc", [null, [46, 27], [46, 33]]]]], [], []], "modoDocente", ["subexpr", "@mut", [["get", "modoDocente", ["loc", [null, [48, 32], [48, 43]]]]], [], []], "modoAlumno", ["subexpr", "@mut", [["get", "modoAlumno", ["loc", [null, [48, 55], [48, 65]]]]], [], []], "hash", ["subexpr", "@mut", [["get", "hash", ["loc", [null, [49, 25], [49, 29]]]]], [], []], "idAlumno", ["subexpr", "@mut", [["get", "idAlumno", ["loc", [null, [49, 39], [49, 47]]]]], [], []], "guardar_solucion_en_el_backend", "guardar_solucion_en_el_backend", "persistirSolucionEnURL", ["subexpr", "@mut", [["get", "persistirSolucionEnURL", ["loc", [null, [52, 43], [52, 65]]]]], [], []], "debeMostrarFinDeDesafio", ["subexpr", "@mut", [["get", "debeMostrarFinDeDesafio", ["loc", [null, [53, 44], [53, 67]]]]], [], []], "pilas", ["subexpr", "@mut", [["get", "pilas", ["loc", [null, [54, 26], [54, 31]]]]], [], []], "codigoJavascript", ["subexpr", "@mut", [["get", "codigoJavascript", ["loc", [null, [55, 37], [55, 53]]]]], [], []], "actividad", ["subexpr", "@mut", [["get", "model.actividad", ["loc", [null, [56, 30], [56, 45]]]]], [], []]], ["loc", [null, [44, 4], [56, 47]]]]],
        locals: [],
        templates: []
      };
    })();
    var child3 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 59,
              "column": 0
            },
            "end": {
              "line": 63,
              "column": 0
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-editor.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("  ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("div");
          dom.setAttribute(el1, "class", "desafio-panel-codigo");
          var el2 = dom.createTextNode("\n    ");
          dom.appendChild(el1, el2);
          var el2 = dom.createElement("pre");
          var el3 = dom.createComment("");
          dom.appendChild(el2, el3);
          dom.appendChild(el1, el2);
          var el2 = dom.createTextNode("\n  ");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(dom.childAt(fragment, [1, 1]), 0, 0);
          return morphs;
        },
        statements: [["inline", "prism", [["get", "codigoJavascript", ["loc", [null, [61, 17], [61, 33]]]]], [], ["loc", [null, [61, 9], [61, 35]]]]],
        locals: [],
        templates: []
      };
    })();
    var child4 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 66,
              "column": 0
            },
            "end": {
              "line": 68,
              "column": 0
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-editor.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("  ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("p");
          var el2 = dom.createTextNode("Hey, ningún panel está visible");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes() {
          return [];
        },
        statements: [],
        locals: [],
        templates: []
      };
    })();
    return {
      meta: {
        "fragmentReason": {
          "name": "triple-curlies"
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 71,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/components/pilas-editor.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createElement("div");
        dom.setAttribute(el1, "class", "contenido-principal desafio-contenedor");
        var el2 = dom.createTextNode("\n\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var element2 = dom.childAt(fragment, [0]);
        var morphs = new Array(7);
        morphs[0] = dom.createMorphAt(element2, 1, 1);
        morphs[1] = dom.createMorphAt(element2, 3, 3);
        morphs[2] = dom.createMorphAt(element2, 5, 5);
        morphs[3] = dom.createMorphAt(element2, 7, 7);
        morphs[4] = dom.createMorphAt(element2, 9, 9);
        morphs[5] = dom.createMorphAt(element2, 11, 11);
        morphs[6] = dom.createMorphAt(element2, 13, 13);
        return morphs;
      },
      statements: [["block", "if", [["get", "debug", ["loc", [null, [3, 8], [3, 13]]]]], [], 0, null, ["loc", [null, [3, 2], [11, 9]]]], ["content", "outlet", ["loc", [null, [13, 2], [13, 12]]]], ["block", "if", [["get", "panelCanvasVisible", ["loc", [null, [15, 6], [15, 24]]]]], [], 1, null, ["loc", [null, [15, 0], [39, 7]]]], ["inline", "pilas-splitter", [], ["panel", "#panel-izquierdo", "iframe", "iframe", "ayuda", "#panel-ayuda"], ["loc", [null, [41, 0], [41, 80]]]], ["block", "if", [["get", "panelBlocklyVisible", ["loc", [null, [43, 6], [43, 25]]]]], [], 2, null, ["loc", [null, [43, 0], [57, 7]]]], ["block", "if", [["get", "panelCodigoVisible", ["loc", [null, [59, 6], [59, 24]]]]], [], 3, null, ["loc", [null, [59, 0], [63, 7]]]], ["block", "if", [["get", "ningunPanelVisible", ["loc", [null, [66, 6], [66, 24]]]]], [], 4, null, ["loc", [null, [66, 0], [68, 7]]]]],
      locals: [],
      templates: [child0, child1, child2, child3, child4]
    };
  })());
});
define("pilas-engine-bloques/templates/components/pilas-header", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    var child0 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 13,
              "column": 8
            },
            "end": {
              "line": 13,
              "column": 64
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-header.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createElement("a");
          dom.setAttribute(el1, "href", "#");
          var el2 = dom.createTextNode("Principal");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes() {
          return [];
        },
        statements: [],
        locals: [],
        templates: []
      };
    })();
    var child1 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 14,
              "column": 8
            },
            "end": {
              "line": 14,
              "column": 66
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-header.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createElement("a");
          dom.setAttribute(el1, "href", "#");
          var el2 = dom.createTextNode("Desafíos");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes() {
          return [];
        },
        statements: [],
        locals: [],
        templates: []
      };
    })();
    var child2 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 15,
              "column": 8
            },
            "end": {
              "line": 15,
              "column": 67
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-header.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createElement("a");
          dom.setAttribute(el1, "href", "#");
          var el2 = dom.createTextNode("Acerca de");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes() {
          return [];
        },
        statements: [],
        locals: [],
        templates: []
      };
    })();
    var child3 = (function () {
      var child0 = (function () {
        return {
          meta: {
            "fragmentReason": false,
            "revision": "Ember@2.6.2",
            "loc": {
              "source": null,
              "start": {
                "line": 23,
                "column": 12
              },
              "end": {
                "line": 23,
                "column": 93
              }
            },
            "moduleName": "pilas-engine-bloques/templates/components/pilas-header.hbs"
          },
          isEmpty: false,
          arity: 0,
          cachedFragment: null,
          hasRendered: false,
          buildFragment: function buildFragment(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createElement("img");
            dom.setAttribute(el1, "src", "imagenes/programar-short.png");
            dom.appendChild(el0, el1);
            return el0;
          },
          buildRenderNodes: function buildRenderNodes() {
            return [];
          },
          statements: [],
          locals: [],
          templates: []
        };
      })();
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 22,
              "column": 10
            },
            "end": {
              "line": 24,
              "column": 10
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-header.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("            ");
          dom.appendChild(el0, el1);
          var el1 = dom.createComment("");
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 1, 1, contextualElement);
          return morphs;
        },
        statements: [["block", "pilas-link", [], ["href", "http://program.ar"], 0, null, ["loc", [null, [23, 12], [23, 108]]]]],
        locals: [],
        templates: [child0]
      };
    })();
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type", "multiple-nodes"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 40,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/components/pilas-header.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("nav");
        dom.setAttribute(el1, "class", "navbar navbar-default");
        dom.setAttribute(el1, "role", "navigation");
        var el2 = dom.createTextNode("\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("div");
        dom.setAttribute(el2, "class", "container-fluid");
        var el3 = dom.createTextNode("\n    ");
        dom.appendChild(el2, el3);
        var el3 = dom.createComment(" Brand and toggle get grouped for better mobile display ");
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n    ");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("div");
        dom.setAttribute(el3, "class", "navbar-header navbar-collapse");
        var el4 = dom.createTextNode("\n      ");
        dom.appendChild(el3, el4);
        var el4 = dom.createElement("a");
        dom.setAttribute(el4, "class", "navbar-brand");
        dom.setAttribute(el4, "href", "#");
        var el5 = dom.createElement("img");
        dom.setAttribute(el5, "src", "imagenes/logo.png");
        dom.appendChild(el4, el5);
        dom.appendChild(el3, el4);
        var el4 = dom.createTextNode("\n    ");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n\n    ");
        dom.appendChild(el2, el3);
        var el3 = dom.createComment(" Collect the nav links, forms, and other content for toggling ");
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n    ");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("div");
        dom.setAttribute(el3, "id", "bs-example-navbar-collapse-1");
        var el4 = dom.createTextNode("\n      ");
        dom.appendChild(el3, el4);
        var el4 = dom.createElement("ul");
        dom.setAttribute(el4, "class", "nav navbar-nav");
        var el5 = dom.createTextNode("\n        ");
        dom.appendChild(el4, el5);
        var el5 = dom.createComment("");
        dom.appendChild(el4, el5);
        var el5 = dom.createTextNode("\n        ");
        dom.appendChild(el4, el5);
        var el5 = dom.createComment("");
        dom.appendChild(el4, el5);
        var el5 = dom.createTextNode("\n        ");
        dom.appendChild(el4, el5);
        var el5 = dom.createComment("");
        dom.appendChild(el4, el5);
        var el5 = dom.createTextNode("\n      ");
        dom.appendChild(el4, el5);
        dom.appendChild(el3, el4);
        var el4 = dom.createTextNode("\n\n      ");
        dom.appendChild(el3, el4);
        var el4 = dom.createElement("div");
        dom.setAttribute(el4, "class", "header-right");
        var el5 = dom.createTextNode("\n\n        ");
        dom.appendChild(el4, el5);
        var el5 = dom.createElement("div");
        dom.setAttribute(el5, "class", "navbar-header navbar-collapse");
        var el6 = dom.createTextNode("\n          ");
        dom.appendChild(el5, el6);
        var el6 = dom.createComment(" Haciendo que el logo de programar no se colapse, y desaparezca en mobile. ");
        dom.appendChild(el5, el6);
        var el6 = dom.createTextNode("\n");
        dom.appendChild(el5, el6);
        var el6 = dom.createComment("");
        dom.appendChild(el5, el6);
        var el6 = dom.createTextNode("        ");
        dom.appendChild(el5, el6);
        dom.appendChild(el4, el5);
        var el5 = dom.createTextNode("\n\n        ");
        dom.appendChild(el4, el5);
        var el5 = dom.createComment("");
        dom.appendChild(el4, el5);
        var el5 = dom.createTextNode("\n\n        ");
        dom.appendChild(el4, el5);
        var el5 = dom.createElement("button");
        dom.setAttribute(el5, "class", "header-button");
        dom.setAttribute(el5, "id", "abrir-ayuda");
        var el6 = dom.createComment("");
        dom.appendChild(el5, el6);
        dom.appendChild(el4, el5);
        var el5 = dom.createTextNode("\n        ");
        dom.appendChild(el4, el5);
        var el5 = dom.createElement("button");
        dom.setAttribute(el5, "class", "header-button");
        dom.setAttribute(el5, "id", "abrir-opciones");
        var el6 = dom.createComment("");
        dom.appendChild(el5, el6);
        dom.appendChild(el4, el5);
        var el5 = dom.createTextNode("\n      ");
        dom.appendChild(el4, el5);
        dom.appendChild(el3, el4);
        var el4 = dom.createTextNode("\n\n    ");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n  ");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var element0 = dom.childAt(fragment, [2, 1, 7]);
        var element1 = dom.childAt(element0, [1]);
        var element2 = dom.childAt(element0, [3]);
        var element3 = dom.childAt(element2, [5]);
        var element4 = dom.childAt(element2, [7]);
        var morphs = new Array(12);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        morphs[1] = dom.createMorphAt(element1, 1, 1);
        morphs[2] = dom.createMorphAt(element1, 3, 3);
        morphs[3] = dom.createMorphAt(element1, 5, 5);
        morphs[4] = dom.createMorphAt(dom.childAt(element2, [1]), 3, 3);
        morphs[5] = dom.createMorphAt(element2, 3, 3);
        morphs[6] = dom.createElementMorph(element3);
        morphs[7] = dom.createMorphAt(element3, 0, 0);
        morphs[8] = dom.createElementMorph(element4);
        morphs[9] = dom.createMorphAt(element4, 0, 0);
        morphs[10] = dom.createMorphAt(fragment, 4, 4, contextualElement);
        morphs[11] = dom.createMorphAt(fragment, 6, 6, contextualElement);
        dom.insertBoundary(fragment, 0);
        return morphs;
      },
      statements: [["content", "yield", ["loc", [null, [1, 0], [1, 9]]]], ["block", "link-to", ["index"], ["tagName", "li"], 0, null, ["loc", [null, [13, 8], [13, 76]]]], ["block", "link-to", ["desafios"], ["tagName", "li"], 1, null, ["loc", [null, [14, 8], [14, 78]]]], ["block", "link-to", ["acercade"], ["tagName", "li"], 2, null, ["loc", [null, [15, 8], [15, 79]]]], ["block", "unless", [["get", "media.isMobile", ["loc", [null, [22, 20], [22, 34]]]]], [], 3, null, ["loc", [null, [22, 10], [24, 21]]]], ["content", "pilas-automatic-update", ["loc", [null, [27, 8], [27, 34]]]], ["element", "action", ["abrirAyuda"], [], ["loc", [null, [29, 55], [29, 78]]]], ["inline", "fa-icon", ["question"], [], ["loc", [null, [29, 79], [29, 101]]]], ["element", "action", ["abrirPreferencias"], [], ["loc", [null, [30, 58], [30, 88]]]], ["inline", "fa-icon", ["gear"], [], ["loc", [null, [30, 89], [30, 107]]]], ["inline", "modal-ayuda", [], ["mostrar", ["subexpr", "@mut", [["get", "mostrarDialogoAyuda", ["loc", [null, [38, 22], [38, 41]]]]], [], []]], ["loc", [null, [38, 0], [38, 43]]]], ["inline", "modal-preferencias", [], ["mostrar", ["subexpr", "@mut", [["get", "mostrarDialogoOpciones", ["loc", [null, [39, 29], [39, 51]]]]], [], []]], ["loc", [null, [39, 0], [39, 53]]]]],
      locals: [],
      templates: [child0, child1, child2, child3]
    };
  })());
});
define("pilas-engine-bloques/templates/components/pilas-link", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    var child0 = (function () {
      return {
        meta: {
          "fragmentReason": {
            "name": "modifiers",
            "modifiers": ["action"]
          },
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 1,
              "column": 0
            },
            "end": {
              "line": 3,
              "column": 0
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-link.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("  ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("a");
          dom.setAttribute(el1, "href", "");
          var el2 = dom.createComment("");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var element1 = dom.childAt(fragment, [1]);
          var morphs = new Array(2);
          morphs[0] = dom.createElementMorph(element1);
          morphs[1] = dom.createMorphAt(element1, 0, 0);
          return morphs;
        },
        statements: [["element", "action", ["abrirConNavegadorExterno", ["get", "href", ["loc", [null, [2, 49], [2, 53]]]]], [], ["loc", [null, [2, 13], [2, 55]]]], ["content", "yield", ["loc", [null, [2, 56], [2, 65]]]]],
        locals: [],
        templates: []
      };
    })();
    var child1 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 3,
              "column": 0
            },
            "end": {
              "line": 5,
              "column": 0
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-link.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("  ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("a");
          dom.setAttribute(el1, "target", "_blank");
          var el2 = dom.createComment("");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var element0 = dom.childAt(fragment, [1]);
          var morphs = new Array(2);
          morphs[0] = dom.createAttrMorph(element0, 'href');
          morphs[1] = dom.createMorphAt(element0, 0, 0);
          return morphs;
        },
        statements: [["attribute", "href", ["get", "href", ["loc", [null, [4, 12], [4, 16]]]]], ["content", "yield", ["loc", [null, [4, 35], [4, 44]]]]],
        locals: [],
        templates: []
      };
    })();
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 6,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/components/pilas-link.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var morphs = new Array(1);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        dom.insertBoundary(fragment, 0);
        dom.insertBoundary(fragment, null);
        return morphs;
      },
      statements: [["block", "if", [["get", "inElectron", ["loc", [null, [1, 6], [1, 16]]]]], [], 0, 1, ["loc", [null, [1, 0], [5, 7]]]]],
      locals: [],
      templates: [child0, child1]
    };
  })());
});
define("pilas-engine-bloques/templates/components/pilas-notificador", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    var child0 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 5,
              "column": 12
            },
            "end": {
              "line": 5,
              "column": 78
            }
          },
          "moduleName": "pilas-engine-bloques/templates/components/pilas-notificador.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("nuestra web para más información.");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes() {
          return [];
        },
        statements: [],
        locals: [],
        templates: []
      };
    })();
    return {
      meta: {
        "fragmentReason": {
          "name": "triple-curlies"
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 9,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/components/pilas-notificador.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createElement("div");
        var el2 = dom.createTextNode("\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("div");
        dom.setAttribute(el2, "class", "pilas-notificador-cerrar");
        var el3 = dom.createElement("i");
        dom.setAttribute(el3, "class", "fa fa-close");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("p");
        var el3 = dom.createTextNode("Hay una nueva versión disponible para descargar.");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("p");
        var el3 = dom.createTextNode("Visitá ");
        dom.appendChild(el2, el3);
        var el3 = dom.createComment("");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var element0 = dom.childAt(fragment, [0]);
        var element1 = dom.childAt(element0, [1]);
        var morphs = new Array(4);
        morphs[0] = dom.createAttrMorph(element0, 'class');
        morphs[1] = dom.createElementMorph(element1);
        morphs[2] = dom.createMorphAt(dom.childAt(element0, [5]), 1, 1);
        morphs[3] = dom.createMorphAt(element0, 7, 7);
        return morphs;
      },
      statements: [["attribute", "class", ["concat", ["pilas-notificador ", ["subexpr", "if", [["get", "hayActualizacion", ["loc", [null, [1, 35], [1, 51]]]], "pilas-notificador-visible", "pilas-notificador-oculto"], [], ["loc", [null, [1, 30], [1, 108]]]]]]], ["element", "action", ["cerrar"], [], ["loc", [null, [2, 40], [2, 59]]]], ["block", "pilas-link", [], ["href", ["subexpr", "@mut", [["get", "linkDescarga", ["loc", [null, [5, 31], [5, 43]]]]], [], []]], 0, null, ["loc", [null, [5, 12], [5, 93]]]], ["content", "yield", ["loc", [null, [7, 2], [7, 11]]]]],
      locals: [],
      templates: [child0]
    };
  })());
});
define("pilas-engine-bloques/templates/components/pilas-spinner", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type", "multiple-nodes"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 4,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/components/pilas-spinner.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("div");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var element0 = dom.childAt(fragment, [2]);
        var morphs = new Array(2);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        morphs[1] = dom.createAttrMorph(element0, 'class');
        dom.insertBoundary(fragment, 0);
        return morphs;
      },
      statements: [["content", "yield", ["loc", [null, [1, 0], [1, 9]]]], ["attribute", "class", ["concat", ["spinner ", ["subexpr", "if", [["get", "centered", ["loc", [null, [3, 25], [3, 33]]]], "spinner-centered"], [], ["loc", [null, [3, 20], [3, 54]]]]]]]],
      locals: [],
      templates: []
    };
  })());
});
define("pilas-engine-bloques/templates/components/pilas-splitter", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["multiple-nodes"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 3,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/components/pilas-splitter.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createElement("div");
        dom.setAttribute(el1, "class", "splitter");
        dom.setAttribute(el1, "id", "splitter");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("div");
        dom.setAttribute(el1, "id", "over-splitter");
        dom.setAttribute(el1, "class", "over-splitter");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes() {
        return [];
      },
      statements: [],
      locals: [],
      templates: []
    };
  })());
});
define('pilas-engine-bloques/templates/components/tether-dialog', ['exports', 'ember-modal-dialog/templates/components/tether-dialog'], function (exports, _emberModalDialogTemplatesComponentsTetherDialog) {
  Object.defineProperty(exports, 'default', {
    enumerable: true,
    get: function get() {
      return _emberModalDialogTemplatesComponentsTetherDialog['default'];
    }
  });
});
define("pilas-engine-bloques/templates/desafio-loading", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type", "multiple-nodes"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 3,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/desafio-loading.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var morphs = new Array(2);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        morphs[1] = dom.createMorphAt(fragment, 2, 2, contextualElement);
        dom.insertBoundary(fragment, 0);
        return morphs;
      },
      statements: [["content", "outlet", ["loc", [null, [1, 0], [1, 10]]]], ["content", "pilas-cargando", ["loc", [null, [2, 0], [2, 18]]]]],
      locals: [],
      templates: []
    };
  })());
});
define("pilas-engine-bloques/templates/desafio", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 15,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/desafio.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var morphs = new Array(1);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        dom.insertBoundary(fragment, 0);
        return morphs;
      },
      statements: [["inline", "pilas-editor", [], ["pilas", ["subexpr", "@mut", [["get", "pilas", ["loc", [null, [2, 8], [2, 13]]]]], [], []], "debug", ["subexpr", "@mut", [["get", "debug", ["loc", [null, [3, 8], [3, 13]]]]], [], []], "model", ["subexpr", "@mut", [["get", "model", ["loc", [null, [4, 8], [4, 13]]]]], [], []], "onReady", "cuandoCargaPilas", "persistirSolucionEnURL", false, "codigo", ["subexpr", "@mut", [["get", "codigo", ["loc", [null, [7, 9], [7, 15]]]]], [], []], "codigoJavascript", ["subexpr", "@mut", [["get", "codigoJavascript", ["loc", [null, [8, 19], [8, 35]]]]], [], []], "debeMostrarFinDeDesafio", true, "panelCanvasVisible", ["subexpr", "@mut", [["get", "panelCanvasVisible", ["loc", [null, [11, 21], [11, 39]]]]], [], []], "panelBlocklyVisible", ["subexpr", "@mut", [["get", "panelBlocklyVisible", ["loc", [null, [12, 22], [12, 41]]]]], [], []], "panelCodigoVisible", ["subexpr", "@mut", [["get", "panelCodigoVisible", ["loc", [null, [13, 21], [13, 39]]]]], [], []]], ["loc", [null, [1, 0], [14, 2]]]]],
      locals: [],
      templates: []
    };
  })());
});
define("pilas-engine-bloques/templates/desafios-loading", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type", "multiple-nodes"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 4,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/desafios-loading.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var morphs = new Array(2);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        morphs[1] = dom.createMorphAt(fragment, 2, 2, contextualElement);
        dom.insertBoundary(fragment, 0);
        return morphs;
      },
      statements: [["content", "outlet", ["loc", [null, [1, 0], [1, 10]]]], ["content", "pilas-cargando", ["loc", [null, [3, 0], [3, 18]]]]],
      locals: [],
      templates: []
    };
  })());
});
define("pilas-engine-bloques/templates/desafios", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 2,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/desafios.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var morphs = new Array(1);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        dom.insertBoundary(fragment, 0);
        return morphs;
      },
      statements: [["content", "outlet", ["loc", [null, [1, 0], [1, 10]]]]],
      locals: [],
      templates: []
    };
  })());
});
define("pilas-engine-bloques/templates/desafios/curso-alumno-error", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    return {
      meta: {
        "fragmentReason": {
          "name": "triple-curlies"
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 13,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/desafios/curso-alumno-error.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createElement("div");
        dom.setAttribute(el1, "class", "contenido-principal");
        var el2 = dom.createTextNode("\n\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("h1");
        var el3 = dom.createTextNode(":(");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("p");
        var el3 = dom.createTextNode("Lo siento, la dirección URL no se puede decodificar,\n  posiblemente el parámetro ");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("code");
        var el4 = dom.createTextNode("hash");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode(" tenga un error\n  de formato.");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("p");
        var el3 = dom.createTextNode("Por favor contacte al docente del curso para informar\n  este error.");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes() {
        return [];
      },
      statements: [],
      locals: [],
      templates: []
    };
  })());
});
define("pilas-engine-bloques/templates/desafios/curso-alumno", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 11,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/desafios/curso-alumno.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var morphs = new Array(1);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        dom.insertBoundary(fragment, 0);
        return morphs;
      },
      statements: [["inline", "pilas-editor", [], ["pilas", ["subexpr", "@mut", [["get", "pilas", ["loc", [null, [2, 8], [2, 13]]]]], [], []], "model", ["subexpr", "@mut", [["get", "model", ["loc", [null, [3, 8], [3, 13]]]]], [], []], "persistirSolucionEnURL", true, "codigo", ["subexpr", "@mut", [["get", "model.solucion", ["loc", [null, [5, 9], [5, 23]]]]], [], []], "modoAlumno", true, "hash", ["subexpr", "@mut", [["get", "model.hash", ["loc", [null, [6, 23], [6, 33]]]]], [], []], "idAlumno", ["subexpr", "@mut", [["get", "model.idAlumno", ["loc", [null, [6, 43], [6, 57]]]]], [], []], "guardar_solucion_en_el_backend", "guardar_solucion_en_el_backend", "debeMostrarFinDeDesafio", true, "panelCanvasVisible", true, "panelBlocklyVisible", true], ["loc", [null, [1, 0], [10, 28]]]]],
      locals: [],
      templates: []
    };
  })());
});
define("pilas-engine-bloques/templates/desafios/curso-docente", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 10,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/desafios/curso-docente.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var morphs = new Array(1);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        dom.insertBoundary(fragment, 0);
        return morphs;
      },
      statements: [["inline", "pilas-editor", [], ["pilas", ["subexpr", "@mut", [["get", "pilas", ["loc", [null, [2, 8], [2, 13]]]]], [], []], "model", ["subexpr", "@mut", [["get", "model", ["loc", [null, [3, 8], [3, 13]]]]], [], []], "modoDocente", true, "persistirSolucionEnURL", true, "codigo", ["subexpr", "@mut", [["get", "model.solucion", ["loc", [null, [6, 9], [6, 23]]]]], [], []], "debeMostrarFinDeDesafio", true, "panelCanvasVisible", true, "panelBlocklyVisible", true], ["loc", [null, [1, 0], [9, 28]]]]],
      locals: [],
      templates: []
    };
  })());
});
define("pilas-engine-bloques/templates/desafios/desafio-por-nombre-error", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    return {
      meta: {
        "fragmentReason": {
          "name": "missing-wrapper",
          "problems": ["wrong-type", "multiple-nodes"]
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 11,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/desafios/desafio-por-nombre-error.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("div");
        dom.setAttribute(el1, "class", "contenido-principal");
        var el2 = dom.createTextNode("\n\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("h2");
        var el3 = dom.createTextNode("Lo siento, algo salió mal...");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("p");
        var el3 = dom.createTextNode("No existe un desafío con el nombre indicado en la URL. ¿Podrías\n    corroborar la correctitud de la dirección a este desafío?.");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var morphs = new Array(1);
        morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
        dom.insertBoundary(fragment, 0);
        return morphs;
      },
      statements: [["content", "outlet", ["loc", [null, [1, 0], [1, 10]]]]],
      locals: [],
      templates: []
    };
  })());
});
define("pilas-engine-bloques/templates/desafios/index", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    var child0 = (function () {
      var child0 = (function () {
        return {
          meta: {
            "fragmentReason": false,
            "revision": "Ember@2.6.2",
            "loc": {
              "source": null,
              "start": {
                "line": 9,
                "column": 4
              },
              "end": {
                "line": 11,
                "column": 4
              }
            },
            "moduleName": "pilas-engine-bloques/templates/desafios/index.hbs"
          },
          isEmpty: false,
          arity: 1,
          cachedFragment: null,
          hasRendered: false,
          buildFragment: function buildFragment(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createTextNode("      ");
            dom.appendChild(el0, el1);
            var el1 = dom.createComment("");
            dom.appendChild(el0, el1);
            var el1 = dom.createTextNode("\n");
            dom.appendChild(el0, el1);
            return el0;
          },
          buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
            var morphs = new Array(1);
            morphs[0] = dom.createMorphAt(fragment, 1, 1, contextualElement);
            return morphs;
          },
          statements: [["inline", "pilas-desafio", [], ["model", ["subexpr", "@mut", [["get", "desafio", ["loc", [null, [10, 28], [10, 35]]]]], [], []]], ["loc", [null, [10, 6], [10, 37]]]]],
          locals: ["desafio"],
          templates: []
        };
      })();
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 5,
              "column": 2
            },
            "end": {
              "line": 13,
              "column": 2
            }
          },
          "moduleName": "pilas-engine-bloques/templates/desafios/index.hbs"
        },
        isEmpty: false,
        arity: 1,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode("\n    ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("h2");
          var el2 = dom.createComment("");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n\n");
          dom.appendChild(el0, el1);
          var el1 = dom.createComment("");
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode("\n");
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(2);
          morphs[0] = dom.createMorphAt(dom.childAt(fragment, [1]), 0, 0);
          morphs[1] = dom.createMorphAt(fragment, 3, 3, contextualElement);
          return morphs;
        },
        statements: [["content", "grupo.titulo", ["loc", [null, [7, 8], [7, 24]]]], ["block", "each", [["get", "grupo.desafios", ["loc", [null, [9, 12], [9, 26]]]]], [], 0, null, ["loc", [null, [9, 4], [11, 13]]]]],
        locals: ["grupo"],
        templates: [child0]
      };
    })();
    return {
      meta: {
        "fragmentReason": {
          "name": "triple-curlies"
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 16,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/desafios/index.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createElement("div");
        dom.setAttribute(el1, "class", "contenido-principal");
        var el2 = dom.createTextNode("\n\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("h1");
        var el3 = dom.createTextNode("Desafíos");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n\n");
        dom.appendChild(el1, el2);
        var el2 = dom.createComment("");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var morphs = new Array(1);
        morphs[0] = dom.createMorphAt(dom.childAt(fragment, [0]), 3, 3);
        return morphs;
      },
      statements: [["block", "each", [["get", "model", ["loc", [null, [5, 10], [5, 15]]]]], [], 0, null, ["loc", [null, [5, 2], [13, 11]]]]],
      locals: [],
      templates: [child0]
    };
  })());
});
define("pilas-engine-bloques/templates/desafios/mensaje-guardado", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    return {
      meta: {
        "fragmentReason": {
          "name": "triple-curlies"
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 13,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/desafios/mensaje-guardado.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createElement("div");
        dom.setAttribute(el1, "class", "contenido-principal");
        var el2 = dom.createTextNode("\n\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("h1");
        var el3 = dom.createTextNode("¡Ya casi estás!");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("p");
        var el3 = dom.createTextNode("Tu solución al desafío se terminará de guardar cuando\n    aprietes el botón \"Enviar al tutor\" en la parte de\n    abajo de la página.");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("p");
        var el3 = dom.createTextNode("Recordá: para guardar bien tu solución ¡tenés\n    que apretar siempre ambos botones!");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes() {
        return [];
      },
      statements: [],
      locals: [],
      templates: []
    };
  })());
});
define("pilas-engine-bloques/templates/index", ["exports"], function (exports) {
  exports["default"] = Ember.HTMLBars.template((function () {
    var child0 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 16,
              "column": 28
            },
            "end": {
              "line": 16,
              "column": 77
            }
          },
          "moduleName": "pilas-engine-bloques/templates/index.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode(" ");
          dom.appendChild(el0, el1);
          var el1 = dom.createElement("strong");
          var el2 = dom.createTextNode("Desafíos");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes() {
          return [];
        },
        statements: [],
        locals: [],
        templates: []
      };
    })();
    var child1 = (function () {
      return {
        meta: {
          "fragmentReason": false,
          "revision": "Ember@2.6.2",
          "loc": {
            "source": null,
            "start": {
              "line": 21,
              "column": 24
            },
            "end": {
              "line": 21,
              "column": 73
            }
          },
          "moduleName": "pilas-engine-bloques/templates/index.hbs"
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createElement("strong");
          var el2 = dom.createTextNode("Acerca de");
          dom.appendChild(el1, el2);
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes() {
          return [];
        },
        statements: [],
        locals: [],
        templates: []
      };
    })();
    return {
      meta: {
        "fragmentReason": {
          "name": "triple-curlies"
        },
        "revision": "Ember@2.6.2",
        "loc": {
          "source": null,
          "start": {
            "line": 1,
            "column": 0
          },
          "end": {
            "line": 34,
            "column": 0
          }
        },
        "moduleName": "pilas-engine-bloques/templates/index.hbs"
      },
      isEmpty: false,
      arity: 0,
      cachedFragment: null,
      hasRendered: false,
      buildFragment: function buildFragment(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createElement("div");
        dom.setAttribute(el1, "class", "contenido-principal");
        var el2 = dom.createTextNode("\n\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("div");
        dom.setAttribute(el2, "class", "box");
        var el3 = dom.createTextNode("\n\n\n    ");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("p");
        var el4 = dom.createElement("img");
        dom.setAttribute(el4, "class", "main-logo");
        dom.setAttribute(el4, "src", "images/main-logo.png");
        dom.setAttribute(el4, "width", "468");
        dom.setAttribute(el4, "height", "262");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n\n    ");
        dom.appendChild(el2, el3);
        var el3 = dom.createComment("");
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n\n    ");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("p");
        var el4 = dom.createTextNode("\n      ¡Hola! Te damos la bienvenida a ");
        dom.appendChild(el3, el4);
        var el4 = dom.createElement("strong");
        var el5 = dom.createTextNode("Pilas Bloques");
        dom.appendChild(el4, el5);
        dom.appendChild(el3, el4);
        var el4 = dom.createTextNode(",\n      una herramienta para aprender a programar.\n    ");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n\n    ");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("p");
        var el4 = dom.createTextNode("\n      Ingresá en la sección ");
        dom.appendChild(el3, el4);
        var el4 = dom.createComment("");
        dom.appendChild(el3, el4);
        var el4 = dom.createTextNode("\n      para comenzar a resolver los retos disponibles.\n    ");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n\n    ");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("p");
        var el4 = dom.createTextNode("\n      Visitá la sección ");
        dom.appendChild(el3, el4);
        var el4 = dom.createComment("");
        dom.appendChild(el3, el4);
        var el4 = dom.createTextNode("\n      para conocer más en detalle de qué se trata esta herramienta y quién la desarrolló.\n    ");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n\n    ");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("p");
        var el4 = dom.createTextNode("\n      Si necesitás ayuda, presioná (");
        dom.appendChild(el3, el4);
        var el4 = dom.createComment("");
        dom.appendChild(el3, el4);
        var el4 = dom.createTextNode(") ubicado en la parte superior derecha\n      de la pantalla.\n    ");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n\n\n  ");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
        var element0 = dom.childAt(fragment, [0, 1]);
        var morphs = new Array(4);
        morphs[0] = dom.createMorphAt(element0, 3, 3);
        morphs[1] = dom.createMorphAt(dom.childAt(element0, [7]), 1, 1);
        morphs[2] = dom.createMorphAt(dom.childAt(element0, [9]), 1, 1);
        morphs[3] = dom.createMorphAt(dom.childAt(element0, [11]), 1, 1);
        return morphs;
      },
      statements: [["content", "outlet", ["loc", [null, [8, 4], [8, 14]]]], ["block", "link-to", ["desafios"], [], 0, null, ["loc", [null, [16, 28], [16, 89]]]], ["block", "link-to", ["acercade"], [], 1, null, ["loc", [null, [21, 24], [21, 85]]]], ["inline", "fa-icon", ["question"], [], ["loc", [null, [26, 36], [26, 58]]]]],
      locals: [],
      templates: [child0, child1]
    };
  })());
});
/* jshint ignore:start */



/* jshint ignore:end */

/* jshint ignore:start */

define('pilas-engine-bloques/config/environment', ['ember'], function(Ember) {
  var prefix = 'pilas-engine-bloques';
/* jshint ignore:start */

try {
  var metaName = prefix + '/config/environment';
  var rawConfig = Ember['default'].$('meta[name="' + metaName + '"]').attr('content');
  var config = JSON.parse(unescape(rawConfig));

  return { 'default': config };
}
catch(err) {
  throw new Error('Could not read config from meta tag with name "' + metaName + '".');
}

/* jshint ignore:end */

});

/* jshint ignore:end */

/* jshint ignore:start */

if (!runningTests) {
  require("pilas-engine-bloques/app")["default"].create({"name":"pilas-engine-bloques","version":"1.1.2+"});
}

/* jshint ignore:end */
//# sourceMappingURL=pilas-engine-bloques.map
