define('pilas-engine-bloques/tests/acceptance/acercade-test', ['exports', 'qunit', 'pilas-engine-bloques/tests/helpers/module-for-acceptance', 'pilas-engine-bloques/tests/pages/acerca-de'], function (exports, _qunit, _pilasEngineBloquesTestsHelpersModuleForAcceptance, _pilasEngineBloquesTestsPagesAcercaDe) {

  (0, _pilasEngineBloquesTestsHelpersModuleForAcceptance['default'])('Acceptance | acercade');

  (0, _qunit.test)('visiting /acercade', function (assert) {

    _pilasEngineBloquesTestsPagesAcercaDe['default'].visit();

    andThen(function () {
      assert.ok(_pilasEngineBloquesTestsPagesAcercaDe['default'].titulo(), "Tiene título");
      assert.equal(_pilasEngineBloquesTestsPagesAcercaDe['default'].titulo(), "Acerca de Pilas Bloques", "Aparece el título de la aplicación.");
      assert.equal(_pilasEngineBloquesTestsPagesAcercaDe['default'].cantidadDeBotones(), 1, "Existe un solo botón");
    });
  });
});
define('pilas-engine-bloques/tests/acceptance/acercade-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | acceptance/acercade-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'acceptance/acercade-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/acceptance/desafios-test', ['exports', 'qunit', 'pilas-engine-bloques/tests/helpers/module-for-acceptance', 'pilas-engine-bloques/tests/pages/desafios'], function (exports, _qunit, _pilasEngineBloquesTestsHelpersModuleForAcceptance, _pilasEngineBloquesTestsPagesDesafios) {

  (0, _pilasEngineBloquesTestsHelpersModuleForAcceptance['default'])('Acceptance | desafios');

  (0, _qunit.test)('visiting /desafios', function (assert) {
    var cantidadDesafiosEsperada = 44;

    _pilasEngineBloquesTestsPagesDesafios['default'].visit();

    andThen(function () {
      assert.equal(_pilasEngineBloquesTestsPagesDesafios['default'].cantidadDeDesafiosDisponibles(), cantidadDesafiosEsperada, 'Hay exactamente ' + cantidadDesafiosEsperada + ' desafios habilitados para utilizar.');
    });
  });
});
define('pilas-engine-bloques/tests/acceptance/desafios-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | acceptance/desafios-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'acceptance/desafios-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/acceptance/principal-test', ['exports', 'qunit', 'pilas-engine-bloques/tests/helpers/module-for-acceptance', 'pilas-engine-bloques/tests/pages/principal'], function (exports, _qunit, _pilasEngineBloquesTestsHelpersModuleForAcceptance, _pilasEngineBloquesTestsPagesPrincipal) {

  (0, _pilasEngineBloquesTestsHelpersModuleForAcceptance['default'])('Acceptance | principal');

  (0, _qunit.test)('visiting /', function (assert) {
    _pilasEngineBloquesTestsPagesPrincipal['default'].visit();

    andThen(function () {
      assert.equal(_pilasEngineBloquesTestsPagesPrincipal['default'].cantidadDeImagenes(), 1, "Tiene solo una imagen, la del logotipo.");
      assert.equal(_pilasEngineBloquesTestsPagesPrincipal['default'].cantidadDeLinks(), 2, "Hay dos links en pantalla.");
    });

    _pilasEngineBloquesTestsPagesPrincipal['default'].abrirAyuda();

    andThen(function () {
      assert.equal(_pilasEngineBloquesTestsPagesPrincipal['default'].tituloModal(), "Ayuda", "El modal de ayuda está visible.");
    });

    _pilasEngineBloquesTestsPagesPrincipal['default'].cerrarDialogo().abrirOpciones();

    andThen(function () {
      assert.equal(_pilasEngineBloquesTestsPagesPrincipal['default'].tituloModal(), "Opciones", "El modal de opciones está visible");
    });
  });
});
define('pilas-engine-bloques/tests/acceptance/principal-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | acceptance/principal-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'acceptance/principal-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/acceptance/puede-ingresar-en-actividades-test', ['exports', 'qunit', 'pilas-engine-bloques/tests/helpers/module-for-acceptance'], function (exports, _qunit, _pilasEngineBloquesTestsHelpersModuleForAcceptance) {

  (0, _pilasEngineBloquesTestsHelpersModuleForAcceptance['default'])('Acceptance | puede ingresar en actividades');

  /*
   * Realiza una validación luego de que se detengan todas las promesas pendientes.
   *
   * La validación consiste en asegurarse de que el título que se muestra en el
   * panel de consigna sea exacamente el título el esperado.
   */
  function validar_que_se_muestra_el_titulo(assert, tituloEsperado) {
    andThen(function () {
      var tituloVisibleEnPantalla = $(".contenedor-panel-ayuda h4").text();
      assert.equal(tituloVisibleEnPantalla, tituloEsperado, "La actividad se llama efectivamente " + tituloEsperado);
    });
  }

  (0, _qunit.test)('Nombres de actividades en la URL', function (assert) {

    visit('/desafios/DibujandoAlCuadrado');
    validar_que_se_muestra_el_titulo(assert, "Dibujando: Al cuadrado");

    visit('/desafios/DibujandoRayuelaRobotica');
    validar_que_se_muestra_el_titulo(assert, "Dibujando: Rayuela robótica");

    visit('/desafios/DibujandoCortoPorLaDiagonal');
    validar_que_se_muestra_el_titulo(assert, "Dibujando: Corto por la diagonal");

    visit('/desafios/DibujandoMamushkaCuadrada');
    validar_que_se_muestra_el_titulo(assert, "Dibujando: Mamushka cuadrada");

    visit('/desafios/DibujandoEscaleraCuadrada');
    validar_que_se_muestra_el_titulo(assert, "Dibujando: Escalera cuadrada");

    visit('/desafios/DibujandoHexagono');
    validar_que_se_muestra_el_titulo(assert, "Dibujando: Hexágono");

    visit('/desafios/DibujandoPiramideInvertida');
    validar_que_se_muestra_el_titulo(assert, "Dibujando: Pirámide invertida");

    visit('/desafios/DibujandoFigurasDentroDeFiguras');
    validar_que_se_muestra_el_titulo(assert, "Dibujando: Figuras dentro de figuras");

    visit('/desafios/DibujandoLaCuevaDeEstalagtitas');
    validar_que_se_muestra_el_titulo(assert, "Dibujando: La cueva de estalagtitas");
  });
});
define('pilas-engine-bloques/tests/acceptance/puede-ingresar-en-actividades-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | acceptance/puede-ingresar-en-actividades-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'acceptance/puede-ingresar-en-actividades-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/LaberintoConQueso.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/LaberintoConQueso.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/LaberintoConQueso.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividad.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividad.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividad.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadAlien.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadAlien.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadAlien.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadAlienTocaBoton.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadAlienTocaBoton.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadAlienTocaBoton.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadAlimentandoALosPeces.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadAlimentandoALosPeces.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadAlimentandoALosPeces.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadElCangrejoAguafiestas.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadElCangrejoAguafiestas.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadElCangrejoAguafiestas.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadElDetectiveChaparro.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadElDetectiveChaparro.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadElDetectiveChaparro.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadElGatoEnLaCalle.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadElGatoEnLaCalle.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadElGatoEnLaCalle.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadElMarcianoEnElDesierto.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadElMarcianoEnElDesierto.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadElMarcianoEnElDesierto.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadElMonoCuentaDeNuevo.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadElMonoCuentaDeNuevo.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadElMonoCuentaDeNuevo.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadElMonoQueSabeContar.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadElMonoQueSabeContar.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadElMonoQueSabeContar.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadElMonoYLasBananas.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadElMonoYLasBananas.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadElMonoYLasBananas.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadElObreroCopado.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadElObreroCopado.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadElObreroCopado.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadElPlanetaDeNano.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadElPlanetaDeNano.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadElPlanetaDeNano.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadElRecolectorDeEstrellas.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadElRecolectorDeEstrellas.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadElRecolectorDeEstrellas.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadElSuperviaje.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadElSuperviaje.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadElSuperviaje.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadFutbolRobots.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadFutbolRobots.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadFutbolRobots.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadInstalandoJuegos.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadInstalandoJuegos.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadInstalandoJuegos.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadLaEleccionDelMono.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadLaEleccionDelMono.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadLaEleccionDelMono.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadLaFiestaDeDracula.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadLaFiestaDeDracula.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadLaFiestaDeDracula.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadLaGranAventuraDelMarEncantado.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadLaGranAventuraDelMarEncantado.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadLaGranAventuraDelMarEncantado.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadLaberintoConQueso.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadLaberintoConQueso.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadLaberintoConQueso.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadLaberintoCorto.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadLaberintoCorto.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadLaberintoCorto.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadLaberintoLargo.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadLaberintoLargo.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadLaberintoLargo.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadMariaLaComeSandias.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadMariaLaComeSandias.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadMariaLaComeSandias.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadNoMeCansoDeSaltar.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadNoMeCansoDeSaltar.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadNoMeCansoDeSaltar.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadPrendiendoLasCompus-conParametros.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadPrendiendoLasCompus-conParametros.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadPrendiendoLasCompus-conParametros.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadPrendiendoLasCompus.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadPrendiendoLasCompus.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadPrendiendoLasCompus.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadPrendiendoLasFogatas.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadPrendiendoLasFogatas.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadPrendiendoLasFogatas.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadReparandoLaNave.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadReparandoLaNave.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadReparandoLaNave.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadSalvandoLaNavidad.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadSalvandoLaNavidad.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadSalvandoLaNavidad.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadSuperTito1.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadSuperTito1.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadSuperTito1.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadSuperTito2.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadSuperTito2.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadSuperTito2.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadTitoCuadrado.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadTitoCuadrado.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadTitoCuadrado.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadTitoEnciendeLuces.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadTitoEnciendeLuces.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadTitoEnciendeLuces.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadTitoRecargado.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadTitoRecargado.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadTitoRecargado.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadTresNaranjas.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadTresNaranjas.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadTresNaranjas.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/actividadesDibujandoFiguras.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/actividadesDibujandoFiguras.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/actividadesDibujandoFiguras.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/bloque.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/bloque.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/bloque.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/bloques.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/bloques.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/bloques.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/bloquesCompus.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/bloquesCompus.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/bloquesCompus.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/bloquesMonoContando.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/bloquesMonoContando.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/bloquesMonoContando.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/bloquesTito.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/bloquesTito.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/bloquesTito.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/categorias.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/categorias.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/categorias.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/comer.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/comer.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/comer.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/contando.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/contando.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/contando.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/direccionesCuadricula.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/direccionesCuadricula.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/direccionesCuadricula.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/estructurasDeControl.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/estructurasDeControl.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/estructurasDeControl.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/expresiones.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/expresiones.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/expresiones.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/lenguaje.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/lenguaje.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/lenguaje.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/actividades/tocando.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | actividades/tocando.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'actividades/tocando.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/app.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | app.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'app.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/breakpoints.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | breakpoints.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'breakpoints.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/components/listaImagenes.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | components/listaImagenes.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'components/listaImagenes.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/components/modal-ayuda.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | components/modal-ayuda.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'components/modal-ayuda.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/components/modal-preferencias.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | components/modal-preferencias.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'components/modal-preferencias.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/components/modal-title.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | components/modal-title.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'components/modal-title.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/components/pilas-acerca-de.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | components/pilas-acerca-de.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'components/pilas-acerca-de.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/components/pilas-blockly.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | components/pilas-blockly.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'components/pilas-blockly.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/components/pilas-boton-cargar.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | components/pilas-boton-cargar.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'components/pilas-boton-cargar.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/components/pilas-botones-zoom.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | components/pilas-botones-zoom.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'components/pilas-botones-zoom.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/components/pilas-canvas.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | components/pilas-canvas.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'components/pilas-canvas.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/components/pilas-cargando.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | components/pilas-cargando.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'components/pilas-cargando.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/components/pilas-debug-bar.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | components/pilas-debug-bar.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'components/pilas-debug-bar.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/components/pilas-desafio.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | components/pilas-desafio.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'components/pilas-desafio.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/components/pilas-editor.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | components/pilas-editor.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'components/pilas-editor.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/components/pilas-header.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | components/pilas-header.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'components/pilas-header.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/components/pilas-link.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | components/pilas-link.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'components/pilas-link.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/components/pilas-notificador.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | components/pilas-notificador.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'components/pilas-notificador.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/components/pilas-spinner.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | components/pilas-spinner.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'components/pilas-spinner.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/components/pilas-splitter.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | components/pilas-splitter.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'components/pilas-splitter.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/controllers/acercade.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | controllers/acercade.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'controllers/acercade.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/controllers/application.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | controllers/application.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'controllers/application.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/controllers/desafio.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | controllers/desafio.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'controllers/desafio.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/controllers/desafios/curso-alumno.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | controllers/desafios/curso-alumno.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'controllers/desafios/curso-alumno.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/controllers/desafios/curso-docente.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | controllers/desafios/curso-docente.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'controllers/desafios/curso-docente.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/controllers/test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | controllers/test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'controllers/test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/helpers/actividadTest', ['exports', 'ember-qunit', 'ember', 'pilas-engine-bloques/tests/helpers/start-mirage'], function (exports, _emberQunit, _ember, _pilasEngineBloquesTestsHelpersStartMirage) {
  exports.moduloActividad = moduloActividad;
  exports.actividadTest = actividadTest;

  /**
   * Inicia los tests de la actividad definiendo un grupo para qunit.
   */

  function moduloActividad(nombre) {
    var titulo = 'Integration | Actividad | ' + nombre;

    var opciones = {
      integration: true,

      setup: function setup() {
        (0, _pilasEngineBloquesTestsHelpersStartMirage['default'])(this.container);
      }
    };

    (0, _emberQunit.moduleForComponent)('pilas-editor', titulo, opciones);
  }

  /**
   * Realiza una validación en la cantidad de actores, este función se utiliza
   * como helper para aquellos tests que intentan contar actores antes y
   * después de realizar una actividad.
   */
  function validarCantidadDeActores(actoresEsperadosPorEtiqueta, assert, pilas) {
    $.each(actoresEsperadosPorEtiqueta, function (etiqueta, cantidadEsperada) {
      var mensaje = 'Hay ' + cantidadEsperada + ' actores con la etiqueta ' + etiqueta + '.';
      assert.equal(pilas.contarActoresConEtiqueta(etiqueta), cantidadEsperada, mensaje);
    });
  }

  /**
   * Valida las opciones enviadas al test de la actividad para detectar
   * errores o inconsistencias en las opciones antes de iniciar cualquier
   * test.
   *
   * Retorna True si alguna de las opciones enviadas es incorrecta.
   */
  function validarOpciones(opciones) {
    var listaDeOpciones = Object.keys(opciones);
    var opcionesValidas = ['solucion', 'descripcionAdicional', 'errorEsperado', 'resuelveDesafio', 'cantidadDeActoresAlComenzar', 'cantidadDeActoresAlTerminar', 'fps'];

    function esOpcionInvalida(opcion) {
      return opcionesValidas.indexOf(opcion) === -1;
    }

    var opcionesInvalidas = $.grep(listaDeOpciones, esOpcionInvalida);

    $.map(opcionesInvalidas, function (opcionInvalida) {
      var error = 'La opcion enviada al test (' + opcionInvalida + ') es inválida.';
      throw new Error(error);
    });

    if (opciones.errorEsperado && opciones.cantidadDeActoresAlTerminar) {
      var error = 'Es inválido escribir un test que incluya un errorEsperado y conteo de actores al terminar.';
      throw new Error(error);
    }

    return opcionesInvalidas.length > 0;
  }

  /**
   * Permite realizar una prueba sobre una actividad y su comportamiento.
   *
   * Argumentos:
   *
   *  - nombre: El identificador de la actividad, por ejemplo "AlienTocaBoton".
   *  - opciones: Un diccionario de opciones, con las siguientes claves:
   *
   *        - solucion (obligatorio): El código xml de la solución en base64.
   *        - descripcionAdicional: Un string con un detalle del objetivo del test.
   *        - errorEsperado: El string que debería llevar una excepción esperada.
   *        - cantidadDeActoresAlComenzar: Un diccionario para validar la cantidad de actores en la escena.
   *        - cantidadDeActoresAlTerminar: Un diccionario para validar la cantidad de actores en la escena.
   *        - fps: Los cuadros por segundo esperados (por omisión 200 en los test y 60 normalmente).
   *
   * Para ejemplos de invocación podés ver: actividadElAlienYLasTuercas-test.js
   */

  function actividadTest(nombre, opciones) {

    if (validarOpciones(opciones)) {
      throw new Error('Se ha iniciado el tests ' + nombre + ' con opciones inválidas.');
    }

    var descripcion = opciones.descripcionAdicional || 'Se puede resolver';

    (0, _emberQunit.test)(descripcion, function (assert) {
      var _this = this;

      var store = this.container.lookup('service:store');
      var pilas = this.container.lookup('service:pilas');
      var actividades = this.container.lookup('service:actividades');

      return new _ember['default'].RSVP.Promise(function (success) {

        _ember['default'].run(function () {

          // Simula el model hook del router desafío.
          store.findAll("desafio").then(function (data) {
            // TODO: reemplazar la linea anterior (findAll) y la siguiente
            //       por una consulta a ember-data más específica, como la que
            //       realiza findRecord, que solo debería traer un solo registro.
            //
            //       (esto está así ahora porque se debe corregir mirage antes).
            var model = data.findBy('nombre', nombre);

            if (!model) {
              throw new Error('No existe una actividad con el nombre ' + nombre);
            }

            _this.set('model', model);
            _this.set('pilas', pilas);

            // TODO:
            // Simula el método afterModel del router. Este código se quitará
            // cuando migremos completamente a ember-data.
            var actividad = actividades.obtenerPorNombre(model.get("nombre"));
            _this.set('model.actividad', actividad);

            // Carga la solución en base64, el formato que espera el componente.
            _this.set('solucion', window.btoa(opciones.solucion));

            // Captura el evento de inicialización de pilas:
            _this.on('onReady', function () /*instanciaPilas*/{
              var code = actividad.generarCodigo();
              pilas.ejecutarCodigoSinReiniciar(code);

              // Intenta usar la velocidad de ejecución indicada por
              // las opciones del test.
              // Por omisión los tests se ejecutarán muy rápido.
              if (opciones.fps) {
                pilas.cambiarFPS(opciones.fps);
              } else {
                pilas.cambiarFPS(200);
              }

              if (opciones.cantidadDeActoresAlComenzar) {
                validarCantidadDeActores(opciones.cantidadDeActoresAlComenzar, assert, pilas);
              }
            });

            /**
             * Si hay un error en la actividad intenta determinar
             * si es un error esperado o no. Y en cualquiera de los
             * dos casos finaliza el test.
             */
            pilas.on("errorDeActividad", function (motivoDelError) {
              var errorEsperado = opciones.errorEsperado;

              if (errorEsperado) {
                assert.equal(motivoDelError, errorEsperado, 'Ocurrió el error esperado: \'' + errorEsperado + '\'. Bien!');
              } else {
                assert.notOk('Ocurrió un error inesperado: \'' + motivoDelError + '\'');
              }

              success();
            });

            pilas.on("terminaEjecucion", function () /*data*/{

              if (opciones.cantidadDeActoresAlTerminar) {
                validarCantidadDeActores(opciones.cantidadDeActoresAlTerminar, assert, pilas);
              }

              // Los errores esperados no deberían llegar a este punto, así
              // que se emite un error.
              var errorEsperado = opciones.errorEsperado;

              if (errorEsperado) {
                assert.notOk('No ocurrió el error esperado: \'' + errorEsperado + '\'');
              } else if (opciones.resuelveDesafio === false) {
                assert.ok(!pilas.estaResueltoElProblema(), "Se esperaba que la solución no resuelva el problema");
              } else {
                assert.ok(pilas.estaResueltoElProblema(), "Se puede resolver el problema");
              }

              success();
            });

            /**
             * Se instancia el componente pilas-editor con los paneles que
             * observará el usuario y una solución pre-cargada, tal y como se
             * hace dentro de la aplicación.
             */
            _this.render(_ember['default'].HTMLBars.template((function () {
              return {
                meta: {
                  'fragmentReason': {
                    'name': 'missing-wrapper',
                    'problems': ['wrong-type']
                  },
                  'revision': 'Ember@2.6.2',
                  'loc': {
                    'source': null,
                    'start': {
                      'line': 1,
                      'column': 0
                    },
                    'end': {
                      'line': 16,
                      'column': 10
                    }
                  }
                },
                isEmpty: false,
                arity: 0,
                cachedFragment: null,
                hasRendered: false,
                buildFragment: function buildFragment(dom) {
                  var el0 = dom.createDocumentFragment();
                  var el1 = dom.createTextNode('\n            ');
                  dom.appendChild(el0, el1);
                  var el1 = dom.createComment('');
                  dom.appendChild(el0, el1);
                  var el1 = dom.createTextNode('\n          ');
                  dom.appendChild(el0, el1);
                  return el0;
                },
                buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
                  var morphs = new Array(1);
                  morphs[0] = dom.createMorphAt(fragment, 1, 1, contextualElement);
                  return morphs;
                },
                statements: [['inline', 'pilas-editor', [], ['debug', false, 'pilas', ['subexpr', '@mut', [['get', 'pilas', ['loc', [null, [4, 20], [4, 25]]]]], [], []], 'model', ['subexpr', '@mut', [['get', 'model', ['loc', [null, [5, 20], [5, 25]]]]], [], []], 'onReady', 'onReady', 'codigo', ['subexpr', '@mut', [['get', 'solucion', ['loc', [null, [7, 21], [7, 29]]]]], [], []], 'codigoJavascript', '', 'persistirSolucionEnURL', false, 'panelCanvasVisible', true, 'panelBlocklyVisible', true, 'panelCodigoVisible', false], ['loc', [null, [2, 12], [15, 14]]]]],
                locals: [],
                templates: []
              };
            })()));
          });
        });
      });
    });
  }
});
define('pilas-engine-bloques/tests/helpers/actividadTest.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | helpers/actividadTest.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'helpers/actividadTest.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/helpers/createPilasTest', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = createPilasTest;

  function createPilasTest(context, escena, callback) {
    // context en este caso es el test en si mismo (this).

    return new _ember['default'].RSVP.Promise(function (resolve) {

      context.inject.service('pilas');
      context.set("escena", escena);

      context.on('onReady', function (pilas) {
        callback(pilas, resolve, context.get('pilas'));
      });

      context.render(_ember['default'].HTMLBars.template((function () {
        return {
          meta: {
            'fragmentReason': {
              'name': 'missing-wrapper',
              'problems': ['wrong-type']
            },
            'revision': 'Ember@2.6.2',
            'loc': {
              'source': null,
              'start': {
                'line': 1,
                'column': 0
              },
              'end': {
                'line': 1,
                'column': 60
              }
            }
          },
          isEmpty: false,
          arity: 0,
          cachedFragment: null,
          hasRendered: false,
          buildFragment: function buildFragment(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createComment('');
            dom.appendChild(el0, el1);
            return el0;
          },
          buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
            var morphs = new Array(1);
            morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
            dom.insertBoundary(fragment, 0);
            dom.insertBoundary(fragment, null);
            return morphs;
          },
          statements: [['inline', 'pilas-canvas', [], ['pilas', ['subexpr', '@mut', [['get', 'pilas', ['loc', [null, [1, 21], [1, 26]]]]], [], []], 'onReady', 'onReady', 'escena', ['subexpr', '@mut', [['get', 'escena', ['loc', [null, [1, 52], [1, 58]]]]], [], []]], ['loc', [null, [1, 0], [1, 60]]]]],
          locals: [],
          templates: []
        };
      })()));
    });
  }
});
define('pilas-engine-bloques/tests/helpers/createPilasTest.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | helpers/createPilasTest.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'helpers/createPilasTest.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/helpers/destroy-app', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = destroyApp;

  function destroyApp(application) {
    _ember['default'].run(application, 'destroy');
    server.shutdown();
  }
});
define('pilas-engine-bloques/tests/helpers/destroy-app.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | helpers/destroy-app.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'helpers/destroy-app.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/helpers/ejerciciosPilasTest', ['exports', 'ember-qunit'], function (exports, _emberQunit) {
  exports.moduloEjerciciosPilas = moduloEjerciciosPilas;
  exports.hacerLuegoConCallback = hacerLuegoConCallback;

  function moduloEjerciciosPilas(nombre) {
    var titulo = 'Integration | EjerciciosPilas | ' + nombre;

    (0, _emberQunit.moduleForComponent)('pilas-canvas', titulo, {
      integration: true
    });
  }

  /**
   * Decora un comportamiento, permitiendo llamar un callback cuando finaliza.
   */
  function ComportamDecorator(argumentos) {
    this.argumentos = argumentos;
  }

  ComportamDecorator.prototype = {
    iniciar: function iniciar(receptor) {
      this.comportamiento = new this.argumentos.comportamiento(this.argumentos.argumentos);
      this.comportamiento.iniciar(receptor);
    },

    actualizar: function actualizar() {
      var termino = this.comportamiento.actualizar();
      if (termino) {
        this.argumentos.callback();
      }
      return termino;
    }
  };

  /**
   * Llama un callback luego que el actor finaliza un comportamiento.
   */

  function hacerLuegoConCallback(actor, claseComport, argumentos, callback) {
    actor.hacer_luego(ComportamDecorator, { comportamiento: claseComport, callback: callback, argumentos: argumentos });
  }
});
define('pilas-engine-bloques/tests/helpers/ejerciciosPilasTest.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | helpers/ejerciciosPilasTest.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'helpers/ejerciciosPilasTest.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/helpers/module-for-acceptance', ['exports', 'qunit', 'ember', 'pilas-engine-bloques/tests/helpers/start-app', 'pilas-engine-bloques/tests/helpers/destroy-app'], function (exports, _qunit, _ember, _pilasEngineBloquesTestsHelpersStartApp, _pilasEngineBloquesTestsHelpersDestroyApp) {
  var Promise = _ember['default'].RSVP.Promise;

  exports['default'] = function (name) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    (0, _qunit.module)(name, {
      beforeEach: function beforeEach() {
        this.application = (0, _pilasEngineBloquesTestsHelpersStartApp['default'])();

        if (options.beforeEach) {
          return options.beforeEach.apply(this, arguments);
        }
      },

      afterEach: function afterEach() {
        var _this = this;

        var afterEach = options.afterEach && options.afterEach.apply(this, arguments);
        return Promise.resolve(afterEach).then(function () {
          return (0, _pilasEngineBloquesTestsHelpersDestroyApp['default'])(_this.application);
        });
      }
    });
  };
});
define('pilas-engine-bloques/tests/helpers/module-for-acceptance.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | helpers/module-for-acceptance.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'helpers/module-for-acceptance.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/helpers/prism.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | helpers/prism.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'helpers/prism.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/helpers/resolver', ['exports', 'pilas-engine-bloques/resolver', 'pilas-engine-bloques/config/environment'], function (exports, _pilasEngineBloquesResolver, _pilasEngineBloquesConfigEnvironment) {

  var resolver = _pilasEngineBloquesResolver['default'].create();

  resolver.namespace = {
    modulePrefix: _pilasEngineBloquesConfigEnvironment['default'].modulePrefix,
    podModulePrefix: _pilasEngineBloquesConfigEnvironment['default'].podModulePrefix
  };

  exports['default'] = resolver;
});
define('pilas-engine-bloques/tests/helpers/resolver.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | helpers/resolver.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'helpers/resolver.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/helpers/responsive', ['exports', 'ember', 'ember-responsive/media'], function (exports, _ember, _emberResponsiveMedia) {
  exports.setBreakpointForIntegrationTest = setBreakpointForIntegrationTest;
  var K = _ember['default'].K;
  var getOwner = _ember['default'].getOwner;
  var classify = _ember['default'].String.classify;

  _emberResponsiveMedia['default'].reopen({
    // Change this if you want a different default breakpoint in tests.
    _defaultBreakpoint: 'desktop',

    _breakpointArr: _ember['default'].computed('breakpoints', function () {
      return Object.keys(this.get('breakpoints')) || _ember['default'].A([]);
    }),

    _forceSetBreakpoint: function _forceSetBreakpoint(breakpoint) {
      var found = false;

      var props = {};
      this.get('_breakpointArr').forEach(function (bp) {
        var val = bp === breakpoint;
        if (val) {
          found = true;
        }

        props['is' + classify(bp)] = val;
      });

      if (found) {
        this.setProperties(props);
      } else {
        throw new Error('You tried to set the breakpoint to ' + breakpoint + ', which is not in your app/breakpoint.js file.');
      }
    },

    match: K, // do not set up listeners in test

    init: function init() {
      this._super.apply(this, arguments);

      this._forceSetBreakpoint(this.get('_defaultBreakpoint'));
    }
  });

  exports['default'] = _ember['default'].Test.registerAsyncHelper('setBreakpoint', function (app, breakpoint) {
    // this should use getOwner once that's supported
    var mediaService = app.__deprecatedInstance__.lookup('service:media');
    mediaService._forceSetBreakpoint(breakpoint);
  });

  function setBreakpointForIntegrationTest(container, breakpoint) {
    var mediaService = getOwner(container).lookup('service:media');
    mediaService._forceSetBreakpoint(breakpoint);
    container.set('media', mediaService);

    return mediaService;
  }
});
define('pilas-engine-bloques/tests/helpers/responsive.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | helpers/responsive.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'helpers/responsive.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/helpers/start-app', ['exports', 'ember', 'pilas-engine-bloques/app', 'pilas-engine-bloques/config/environment'], function (exports, _ember, _pilasEngineBloquesApp, _pilasEngineBloquesConfigEnvironment) {
  exports['default'] = startApp;

  function startApp(attrs) {
    var application = undefined;

    var attributes = _ember['default'].merge({}, _pilasEngineBloquesConfigEnvironment['default'].APP);
    attributes = _ember['default'].merge(attributes, attrs); // use defaults, but you can override;

    _ember['default'].run(function () {
      application = _pilasEngineBloquesApp['default'].create(attributes);
      application.setupForTesting();
      application.injectTestHelpers();
    });

    return application;
  }
});
define('pilas-engine-bloques/tests/helpers/start-app.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | helpers/start-app.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'helpers/start-app.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/helpers/start-mirage', ['exports', 'pilas-engine-bloques/initializers/ember-cli-mirage'], function (exports, _pilasEngineBloquesInitializersEmberCliMirage) {
  exports['default'] = startMirage;

  function startMirage(container) {
    _pilasEngineBloquesInitializersEmberCliMirage['default'].initialize(container);
  }
});
define('pilas-engine-bloques/tests/helpers/start-mirage.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | helpers/start-mirage.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'helpers/start-mirage.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/components/modal-ayuda-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleForComponent)('modal-ayuda', 'Integration | Component | modal ayuda', {
    integration: true
  });

  (0, _emberQunit.test)('it renders', function (assert) {
    this.render(Ember.HTMLBars.template((function () {
      return {
        meta: {
          'fragmentReason': {
            'name': 'missing-wrapper',
            'problems': ['wrong-type']
          },
          'revision': 'Ember@2.6.2',
          'loc': {
            'source': null,
            'start': {
              'line': 1,
              'column': 0
            },
            'end': {
              'line': 1,
              'column': 15
            }
          }
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createComment('');
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
          dom.insertBoundary(fragment, 0);
          dom.insertBoundary(fragment, null);
          return morphs;
        },
        statements: [['content', 'modal-ayuda', ['loc', [null, [1, 0], [1, 15]]]]],
        locals: [],
        templates: []
      };
    })()));
    assert.equal(this.$().text().trim(), '', "No imprime texto si está oculto.");
  });
});
define('pilas-engine-bloques/tests/integration/components/modal-ayuda-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/components/modal-ayuda-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/components/modal-ayuda-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/components/modal-preferencias-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleForComponent)('modal-preferencias', 'Integration | Component | modal preferencias', {
    integration: true
  });

  (0, _emberQunit.test)('it renders', function (assert) {
    this.render(Ember.HTMLBars.template((function () {
      return {
        meta: {
          'fragmentReason': {
            'name': 'missing-wrapper',
            'problems': ['wrong-type']
          },
          'revision': 'Ember@2.6.2',
          'loc': {
            'source': null,
            'start': {
              'line': 1,
              'column': 0
            },
            'end': {
              'line': 1,
              'column': 22
            }
          }
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createComment('');
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
          dom.insertBoundary(fragment, 0);
          dom.insertBoundary(fragment, null);
          return morphs;
        },
        statements: [['content', 'modal-preferencias', ['loc', [null, [1, 0], [1, 22]]]]],
        locals: [],
        templates: []
      };
    })()));
    assert.equal(this.$().text().trim(), '', "No imprime texto si está oculto");
  });
});
define('pilas-engine-bloques/tests/integration/components/modal-preferencias-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/components/modal-preferencias-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/components/modal-preferencias-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/components/modal-title-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleForComponent)('modal-title', 'Integration | Component | modal title', {
    integration: true
  });

  (0, _emberQunit.test)('it renders', function (assert) {
    // Set any properties with this.set('myProperty', 'value');
    // Handle any actions with this.on('myAction', function(val) { ... });

    this.render(Ember.HTMLBars.template((function () {
      return {
        meta: {
          'fragmentReason': {
            'name': 'missing-wrapper',
            'problems': ['wrong-type']
          },
          'revision': 'Ember@2.6.2',
          'loc': {
            'source': null,
            'start': {
              'line': 1,
              'column': 0
            },
            'end': {
              'line': 1,
              'column': 15
            }
          }
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createComment('');
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
          dom.insertBoundary(fragment, 0);
          dom.insertBoundary(fragment, null);
          return morphs;
        },
        statements: [['content', 'modal-title', ['loc', [null, [1, 0], [1, 15]]]]],
        locals: [],
        templates: []
      };
    })()));

    assert.equal(this.$().text().trim(), '');

    // Template block usage:
    this.render(Ember.HTMLBars.template((function () {
      var child0 = (function () {
        return {
          meta: {
            'fragmentReason': false,
            'revision': 'Ember@2.6.2',
            'loc': {
              'source': null,
              'start': {
                'line': 2,
                'column': 4
              },
              'end': {
                'line': 4,
                'column': 4
              }
            }
          },
          isEmpty: false,
          arity: 0,
          cachedFragment: null,
          hasRendered: false,
          buildFragment: function buildFragment(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createTextNode('      template block text\n');
            dom.appendChild(el0, el1);
            return el0;
          },
          buildRenderNodes: function buildRenderNodes() {
            return [];
          },
          statements: [],
          locals: [],
          templates: []
        };
      })();

      return {
        meta: {
          'fragmentReason': {
            'name': 'missing-wrapper',
            'problems': ['wrong-type']
          },
          'revision': 'Ember@2.6.2',
          'loc': {
            'source': null,
            'start': {
              'line': 1,
              'column': 0
            },
            'end': {
              'line': 5,
              'column': 2
            }
          }
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode('\n');
          dom.appendChild(el0, el1);
          var el1 = dom.createComment('');
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode('  ');
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 1, 1, contextualElement);
          return morphs;
        },
        statements: [['block', 'modal-title', [], [], 0, null, ['loc', [null, [2, 4], [4, 20]]]]],
        locals: [],
        templates: [child0]
      };
    })()));

    assert.equal(this.$().text().trim(), 'template block text');
  });
});
define('pilas-engine-bloques/tests/integration/components/modal-title-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/components/modal-title-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/components/modal-title-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-acerca-de-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleForComponent)('pilas-acerca-de', 'Integration | Component | pilas acerca de', {
    integration: true
  });

  (0, _emberQunit.test)('it renders', function (assert) {
    // Set any properties with this.set('myProperty', 'value');
    // Handle any actions with this.on('myAction', function(val) { ... });

    this.render(Ember.HTMLBars.template((function () {
      return {
        meta: {
          'fragmentReason': {
            'name': 'missing-wrapper',
            'problems': ['wrong-type']
          },
          'revision': 'Ember@2.6.2',
          'loc': {
            'source': null,
            'start': {
              'line': 1,
              'column': 0
            },
            'end': {
              'line': 1,
              'column': 19
            }
          }
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createComment('');
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
          dom.insertBoundary(fragment, 0);
          dom.insertBoundary(fragment, null);
          return morphs;
        },
        statements: [['content', 'pilas-acerca-de', ['loc', [null, [1, 0], [1, 19]]]]],
        locals: [],
        templates: []
      };
    })()));

    assert.ok(this.$().text(), "Incluye texto");
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-acerca-de-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/components/pilas-acerca-de-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/components/pilas-acerca-de-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-blockly-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleForComponent)('pilas-blockly', 'Integration | Component | pilas blockly', {
    integration: true
  });

  (0, _emberQunit.test)('it renders', function (assert) {
    this.render(Ember.HTMLBars.template((function () {
      return {
        meta: {
          'fragmentReason': {
            'name': 'missing-wrapper',
            'problems': ['wrong-type']
          },
          'revision': 'Ember@2.6.2',
          'loc': {
            'source': null,
            'start': {
              'line': 1,
              'column': 0
            },
            'end': {
              'line': 1,
              'column': 17
            }
          }
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createComment('');
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
          dom.insertBoundary(fragment, 0);
          dom.insertBoundary(fragment, null);
          return morphs;
        },
        statements: [['content', 'pilas-blockly', ['loc', [null, [1, 0], [1, 17]]]]],
        locals: [],
        templates: []
      };
    })()));
    assert.ok(this.$().text().indexOf("Ejecutar") > -1, "Tiene el botón ejecutar visible");
    assert.ok(this.$().text().indexOf("Compartir") === -1, 'Ya no existe un botón para compartir por twitter por omisión');

    assert.ok(this.$().text().indexOf("Abrir") > -1, 'Existe un botón para cargar una solución');
    assert.ok(this.$().text().indexOf("Guardar") > -1, 'Existe un botón para guardar una solución');
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-blockly-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/components/pilas-blockly-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/components/pilas-blockly-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-botones-zoom-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleForComponent)('pilas-botones-zoom', 'Integration | Component | pilas botones zoom', {
    integration: true
  });

  (0, _emberQunit.test)('it renders', function (assert) {
    this.render(Ember.HTMLBars.template((function () {
      return {
        meta: {
          'fragmentReason': {
            'name': 'missing-wrapper',
            'problems': ['wrong-type']
          },
          'revision': 'Ember@2.6.2',
          'loc': {
            'source': null,
            'start': {
              'line': 1,
              'column': 0
            },
            'end': {
              'line': 1,
              'column': 22
            }
          }
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createComment('');
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
          dom.insertBoundary(fragment, 0);
          dom.insertBoundary(fragment, null);
          return morphs;
        },
        statements: [['content', 'pilas-botones-zoom', ['loc', [null, [1, 0], [1, 22]]]]],
        locals: [],
        templates: []
      };
    })()));
    assert.equal(this.$().text().trim(), '100%');
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-botones-zoom-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/components/pilas-botones-zoom-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/components/pilas-botones-zoom-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-canvas-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleForComponent)('pilas-canvas', 'Integration | Component | pilas canvas', {
    integration: true
  });

  (0, _emberQunit.test)('it renders', function (assert) {
    // Set any properties with this.set('myProperty', 'value');
    // Handle any actions with this.on('myAction', function(val) { ... });

    this.inject.service('pilas');

    this.render(Ember.HTMLBars.template((function () {
      return {
        meta: {
          'fragmentReason': {
            'name': 'missing-wrapper',
            'problems': ['wrong-type']
          },
          'revision': 'Ember@2.6.2',
          'loc': {
            'source': null,
            'start': {
              'line': 1,
              'column': 0
            },
            'end': {
              'line': 1,
              'column': 28
            }
          }
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createComment('');
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
          dom.insertBoundary(fragment, 0);
          dom.insertBoundary(fragment, null);
          return morphs;
        },
        statements: [['inline', 'pilas-canvas', [], ['pilas', ['subexpr', '@mut', [['get', 'pilas', ['loc', [null, [1, 21], [1, 26]]]]], [], []]], ['loc', [null, [1, 0], [1, 28]]]]],
        locals: [],
        templates: []
      };
    })()));

    assert.equal(this.$().text().trim(), '');

    // Template block usage:
    this.render(Ember.HTMLBars.template((function () {
      var child0 = (function () {
        return {
          meta: {
            'fragmentReason': false,
            'revision': 'Ember@2.6.2',
            'loc': {
              'source': null,
              'start': {
                'line': 2,
                'column': 4
              },
              'end': {
                'line': 4,
                'column': 4
              }
            }
          },
          isEmpty: false,
          arity: 0,
          cachedFragment: null,
          hasRendered: false,
          buildFragment: function buildFragment(dom) {
            var el0 = dom.createDocumentFragment();
            var el1 = dom.createTextNode('      template block text\n');
            dom.appendChild(el0, el1);
            return el0;
          },
          buildRenderNodes: function buildRenderNodes() {
            return [];
          },
          statements: [],
          locals: [],
          templates: []
        };
      })();

      return {
        meta: {
          'fragmentReason': {
            'name': 'missing-wrapper',
            'problems': ['wrong-type']
          },
          'revision': 'Ember@2.6.2',
          'loc': {
            'source': null,
            'start': {
              'line': 1,
              'column': 0
            },
            'end': {
              'line': 5,
              'column': 2
            }
          }
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createTextNode('\n');
          dom.appendChild(el0, el1);
          var el1 = dom.createComment('');
          dom.appendChild(el0, el1);
          var el1 = dom.createTextNode('  ');
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 1, 1, contextualElement);
          return morphs;
        },
        statements: [['block', 'pilas-canvas', [], ['pilas', ['subexpr', '@mut', [['get', 'pilas', ['loc', [null, [2, 26], [2, 31]]]]], [], []]], 0, null, ['loc', [null, [2, 4], [4, 21]]]]],
        locals: [],
        templates: [child0]
      };
    })()));

    assert.equal(this.$().text().trim(), 'template block text');
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-canvas-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/components/pilas-canvas-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/components/pilas-canvas-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-cargando-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleForComponent)('pilas-cargando', 'Integration | Component | pilas cargando', {
    integration: true
  });

  (0, _emberQunit.test)('it renders', function (assert) {
    this.render(Ember.HTMLBars.template((function () {
      return {
        meta: {
          'fragmentReason': {
            'name': 'missing-wrapper',
            'problems': ['wrong-type']
          },
          'revision': 'Ember@2.6.2',
          'loc': {
            'source': null,
            'start': {
              'line': 1,
              'column': 0
            },
            'end': {
              'line': 1,
              'column': 18
            }
          }
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createComment('');
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
          dom.insertBoundary(fragment, 0);
          dom.insertBoundary(fragment, null);
          return morphs;
        },
        statements: [['content', 'pilas-cargando', ['loc', [null, [1, 0], [1, 18]]]]],
        locals: [],
        templates: []
      };
    })()));
    assert.equal(this.$().text().trim(), '', "No debe tener texto alguno.");
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-cargando-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/components/pilas-cargando-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/components/pilas-cargando-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-debug-bar-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleForComponent)('pilas-debug-bar', 'Integration | Component | pilas debug bar', {
    integration: true
  });

  (0, _emberQunit.test)('it renders', function (assert) {
    // Set any properties with this.set('myProperty', 'value');
    // Handle any actions with this.on('myAction', function(val) { ... });

    this.render(Ember.HTMLBars.template((function () {
      return {
        meta: {
          'fragmentReason': {
            'name': 'missing-wrapper',
            'problems': ['wrong-type']
          },
          'revision': 'Ember@2.6.2',
          'loc': {
            'source': null,
            'start': {
              'line': 1,
              'column': 0
            },
            'end': {
              'line': 1,
              'column': 19
            }
          }
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createComment('');
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
          dom.insertBoundary(fragment, 0);
          dom.insertBoundary(fragment, null);
          return morphs;
        },
        statements: [['content', 'pilas-debug-bar', ['loc', [null, [1, 0], [1, 19]]]]],
        locals: [],
        templates: []
      };
    })()));

    assert.ok(this.$().text().trim(), 'Contiene algo de texto visible');
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-debug-bar-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/components/pilas-debug-bar-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/components/pilas-debug-bar-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-desafio-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleForComponent)('pilas-desafio', 'Integration | Component | pilas desafio', {
    integration: true
  });

  (0, _emberQunit.test)('it renders', function (assert) {
    this.set("model", { id: 1, titulo: 'demo', nombre: "AlienTocaBoton", escena: "AlienTocaBoton" });
    this.set("modelDeshabilitado", { id: 1, titulo: 'demo', nombre: "AlienTocaBoton", escena: "AlienTocaBoton", deshabilitado: true });

    this.render(Ember.HTMLBars.template((function () {
      return {
        meta: {
          'fragmentReason': {
            'name': 'missing-wrapper',
            'problems': ['wrong-type']
          },
          'revision': 'Ember@2.6.2',
          'loc': {
            'source': null,
            'start': {
              'line': 1,
              'column': 0
            },
            'end': {
              'line': 1,
              'column': 29
            }
          }
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createComment('');
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
          dom.insertBoundary(fragment, 0);
          dom.insertBoundary(fragment, null);
          return morphs;
        },
        statements: [['inline', 'pilas-desafio', [], ['model', ['subexpr', '@mut', [['get', 'model', ['loc', [null, [1, 22], [1, 27]]]]], [], []]], ['loc', [null, [1, 0], [1, 29]]]]],
        locals: [],
        templates: []
      };
    })()));
    assert.equal(this.$().text().trim(), 'demo', "Muestra el Título del desafio.");

    this.render(Ember.HTMLBars.template((function () {
      return {
        meta: {
          'fragmentReason': {
            'name': 'missing-wrapper',
            'problems': ['wrong-type']
          },
          'revision': 'Ember@2.6.2',
          'loc': {
            'source': null,
            'start': {
              'line': 1,
              'column': 0
            },
            'end': {
              'line': 1,
              'column': 42
            }
          }
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createComment('');
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
          dom.insertBoundary(fragment, 0);
          dom.insertBoundary(fragment, null);
          return morphs;
        },
        statements: [['inline', 'pilas-desafio', [], ['model', ['subexpr', '@mut', [['get', 'modelDeshabilitado', ['loc', [null, [1, 22], [1, 40]]]]], [], []]], ['loc', [null, [1, 0], [1, 42]]]]],
        locals: [],
        templates: []
      };
    })()));
    assert.ok(this.$().text().trim().indexOf("Muy pronto") > -1, "Tiene el texto Muy pronto");
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-desafio-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/components/pilas-desafio-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/components/pilas-desafio-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-editor-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleForComponent)('pilas-editor', 'Integration | Component | pilas editor', {
    integration: true
  });

  (0, _emberQunit.test)('it renders', function (assert) {
    // Set any properties with this.set('myProperty', 'value');
    // Handle any actions with this.on('myAction', function(val) { ... });

    this.render(Ember.HTMLBars.template((function () {
      return {
        meta: {
          'fragmentReason': {
            'name': 'missing-wrapper',
            'problems': ['wrong-type']
          },
          'revision': 'Ember@2.6.2',
          'loc': {
            'source': null,
            'start': {
              'line': 1,
              'column': 0
            },
            'end': {
              'line': 1,
              'column': 16
            }
          }
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createComment('');
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
          dom.insertBoundary(fragment, 0);
          dom.insertBoundary(fragment, null);
          return morphs;
        },
        statements: [['content', 'pilas-editor', ['loc', [null, [1, 0], [1, 16]]]]],
        locals: [],
        templates: []
      };
    })()));

    assert.equal(this.$().text().trim(), 'Hey, ningún panel está visible');
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-editor-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/components/pilas-editor-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/components/pilas-editor-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-header-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleForComponent)('pilas-header', 'Integration | Component | pilas header', {
    integration: true
  });

  (0, _emberQunit.test)('it renders', function (assert) {
    // Set any properties with this.set('myProperty', 'value');
    // Handle any actions with this.on('myAction', function(val) { ... });

    this.render(Ember.HTMLBars.template((function () {
      return {
        meta: {
          'fragmentReason': {
            'name': 'missing-wrapper',
            'problems': ['wrong-type']
          },
          'revision': 'Ember@2.6.2',
          'loc': {
            'source': null,
            'start': {
              'line': 1,
              'column': 0
            },
            'end': {
              'line': 1,
              'column': 16
            }
          }
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createComment('');
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
          dom.insertBoundary(fragment, 0);
          dom.insertBoundary(fragment, null);
          return morphs;
        },
        statements: [['content', 'pilas-header', ['loc', [null, [1, 0], [1, 16]]]]],
        locals: [],
        templates: []
      };
    })()));

    assert.ok(this.$().text(), 'Contiene texto');
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-header-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/components/pilas-header-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/components/pilas-header-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-notificador-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleForComponent)('pilas-notificador', 'Integration | Component | pilas notificador', {
    integration: true
  });

  (0, _emberQunit.test)('it renders', function (assert) {
    this.render(Ember.HTMLBars.template((function () {
      return {
        meta: {
          'fragmentReason': {
            'name': 'missing-wrapper',
            'problems': ['wrong-type']
          },
          'revision': 'Ember@2.6.2',
          'loc': {
            'source': null,
            'start': {
              'line': 1,
              'column': 0
            },
            'end': {
              'line': 1,
              'column': 21
            }
          }
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createComment('');
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
          dom.insertBoundary(fragment, 0);
          dom.insertBoundary(fragment, null);
          return morphs;
        },
        statements: [['content', 'pilas-notificador', ['loc', [null, [1, 0], [1, 21]]]]],
        locals: [],
        templates: []
      };
    })()));
    assert.ok(this.$().text().trim(), 'Hay algo de texto');
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-notificador-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/components/pilas-notificador-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/components/pilas-notificador-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-spinner-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleForComponent)('pilas-spinner', 'Integration | Component | pilas spinner', {
    integration: true
  });

  (0, _emberQunit.test)('it renders', function (assert) {
    // Set any properties with this.set('myProperty', 'value');
    // Handle any actions with this.on('myAction', function(val) { ... });

    this.render(Ember.HTMLBars.template((function () {
      return {
        meta: {
          'fragmentReason': {
            'name': 'missing-wrapper',
            'problems': ['wrong-type']
          },
          'revision': 'Ember@2.6.2',
          'loc': {
            'source': null,
            'start': {
              'line': 1,
              'column': 0
            },
            'end': {
              'line': 1,
              'column': 17
            }
          }
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createComment('');
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
          dom.insertBoundary(fragment, 0);
          dom.insertBoundary(fragment, null);
          return morphs;
        },
        statements: [['content', 'pilas-spinner', ['loc', [null, [1, 0], [1, 17]]]]],
        locals: [],
        templates: []
      };
    })()));
    assert.equal(this.$(".spinner")[0].className, 'spinner ', "Deaabe tener las clases normales del spinner");

    this.render(Ember.HTMLBars.template((function () {
      return {
        meta: {
          'fragmentReason': {
            'name': 'missing-wrapper',
            'problems': ['wrong-type']
          },
          'revision': 'Ember@2.6.2',
          'loc': {
            'source': null,
            'start': {
              'line': 1,
              'column': 0
            },
            'end': {
              'line': 1,
              'column': 31
            }
          }
        },
        isEmpty: false,
        arity: 0,
        cachedFragment: null,
        hasRendered: false,
        buildFragment: function buildFragment(dom) {
          var el0 = dom.createDocumentFragment();
          var el1 = dom.createComment('');
          dom.appendChild(el0, el1);
          return el0;
        },
        buildRenderNodes: function buildRenderNodes(dom, fragment, contextualElement) {
          var morphs = new Array(1);
          morphs[0] = dom.createMorphAt(fragment, 0, 0, contextualElement);
          dom.insertBoundary(fragment, 0);
          dom.insertBoundary(fragment, null);
          return morphs;
        },
        statements: [['inline', 'pilas-spinner', [], ['centered', true], ['loc', [null, [1, 0], [1, 31]]]]],
        locals: [],
        templates: []
      };
    })()));
    assert.equal(this.$(".spinner")[0].className, 'spinner spinner-centered', "Deaabe tener las clases normales del spinner");
  });
});
define('pilas-engine-bloques/tests/integration/components/pilas-spinner-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/components/pilas-spinner-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/components/pilas-spinner-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/components/pilasweb-actores-test', ['exports', 'ember-qunit', 'pilas-engine-bloques/tests/helpers/createPilasTest'], function (exports, _emberQunit, _pilasEngineBloquesTestsHelpersCreatePilasTest) {

  (0, _emberQunit.moduleForComponent)('pilas-canvas-actores', 'Integration | Component | pilasweb actores', {
    integration: true
  });

  (0, _emberQunit.test)('Puede crear un actor y actualizar algunos atributos', function (assert) {

    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'AlienInicial', function (pilas, resolve) {
      /* CREACION DE ACTORES */
      var actor = new pilas.actores.Mono();

      assert.equal(actor.x, 0, "El actor está en la posición inicial X=0.");
      assert.equal(actor.y, 0, "El actor está en la posición inicial Y=0.");

      /* POSICIONES */
      actor.x = 100;
      assert.equal(actor.x, 100, "El actor puede cambiar de posición.");

      /* ESCALA */
      actor.escala_x = 2;
      actor.escala_y = 3;

      assert.equal(actor.escala_x, 2, "El actor puede cambiar de escala x.");
      assert.equal(actor.escala_y, 3, "El actor puede cambiar de escala y.");

      actor.escala = 1;

      assert.equal(actor.escala, 1, "La escala se guarda correctamente.");
      assert.equal(actor.escala_x, 1, "El atributo escala impacta en la escala_x.");
      assert.equal(actor.escala_y, 1, "El atributo escala impacta en la escala_y.");

      /* ROTACION */
      actor.rotacion = 180;
      assert.equal(actor.rotacion, 180, "El actor puede cambiar de posición.");

      actor.rotacion = 180 + 181; // 361 grados son equivalentes a 1 grado
      assert.equal(actor.rotacion, 1, "Los angulos se simplifican.");

      actor.decir("chau!");

      resolve();
    });
  });
});
define('pilas-engine-bloques/tests/integration/components/pilasweb-actores-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/components/pilasweb-actores-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/components/pilasweb-actores-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/AlienTocaBoton-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = 'AlienTocaBoton';

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="1" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="MoverACasillaDerecha" id="4"><next><block type="MoverACasillaDerecha" id="7"><next><block type="MoverACasillaDerecha" id="10"><next><block type="ApretarBoton" id="13"></block></next></block></next></block></next></block></statement></block></xml>'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'Da error al querer apretar botón cuando no hay',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="21" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="ApretarBoton" id="24"></block></statement></block></xml>',
		errorEsperado: 'No hay un botón aquí'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'Da error al querer avanzar hacia la derecha cuando ya no hay camino',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="21" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="MoverACasillaDerecha" id="39"><next><block type="MoverACasillaDerecha" id="36"><next><block type="MoverACasillaDerecha" id="27"><next><block type="MoverACasillaDerecha" id="33"></block></next></block></next></block></next></block></statement></block></xml>',
		errorEsperado: 'No puedo ir para la derecha'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/AlienTocaBoton-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/AlienTocaBoton-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/AlienTocaBoton-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/AlimentandoALosPeces-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = "AlimentandoALosPeces";

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="141" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="142"><mutation name="Buscar alimento"></mutation><next><block type="procedures_callnoreturn" id="143"><mutation name="Alimentar peces de arriba"></mutation><next><block type="procedures_callnoreturn" id="144"><mutation name="Alimentar peces de abajo"></mutation></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="145" x="477" y="34"><mutation></mutation><field name="NAME">Alimentar peces de arriba</field><statement name="STACK"><block type="MoverACasillaArriba" id="146"><next><block type="repetir" id="147" inline="true"><value name="count"><block type="math_number" id="148"><field name="NUM">4</field></block></value><statement name="block"><block type="MoverACasillaIzquierda" id="149"><next><block type="AlimentarPez" id="150"></block></next></block></statement></block></next></block></statement></block><block type="procedures_defnoreturn" id="151" x="20" y="219"><mutation></mutation><field name="NAME">Buscar alimento</field><statement name="STACK"><block type="repetir" id="152" inline="true"><value name="count"><block type="math_number" id="153"><field name="NUM">2</field></block></value><statement name="block"><block type="MoverACasillaArriba" id="154"></block></statement><next><block type="repetir" id="155" inline="true"><value name="count"><block type="math_number" id="156"><field name="NUM">4</field></block></value><statement name="block"><block type="MoverACasillaDerecha" id="157"></block></statement><next><block type="AgarrarComida" id="158"></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="159" x="473" y="345"><mutation></mutation><field name="NAME">Alimentar peces de abajo</field><statement name="STACK"><block type="repetir" id="160" inline="true"><value name="count"><block type="math_number" id="161"><field name="NUM">3</field></block></value><statement name="block"><block type="MoverACasillaAbajo" id="162"></block></statement><next><block type="repetir" id="163" inline="true"><value name="count"><block type="math_number" id="164"><field name="NUM">3</field></block></value><statement name="block"><block type="MoverACasillaDerecha" id="165"><next><block type="AlimentarPez" id="166"></block></next></block></statement></block></next></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/AlimentandoALosPeces-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/AlimentandoALosPeces-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/AlimentandoALosPeces-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/DibujandoFiguras-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)('DibujandoAlCuadrado');

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)('DibujandoAlCuadrado', {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="18" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="21"><mutation name="Dibujar cuadrado de 100"></mutation></block></statement></block><block type="procedures_defnoreturn" id="24" x="20" y="180"><mutation></mutation><field name="NAME">Dibujar cuadrado de 100</field><statement name="STACK"><block type="repetir" id="25" inline="true"><value name="count"><block type="math_number" id="26"><field name="NUM">4</field></block></value><statement name="block"><block type="DibujarLado" id="27" inline="true"><value name="longitud"><block type="math_number" id="28"><field name="NUM">100</field></block></value><next><block type="GirarGrados" id="29" inline="true"><value name="grados"><block type="math_number" id="30"><field name="NUM">90</field></block></value></block></next></block></statement></block></statement></block></xml>'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)('DibujandoRayuelaRobotica');

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)('DibujandoRayuelaRobotica', {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="2" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="38" inline="true"><value name="count"><block type="math_number" id="39"><field name="NUM">5</field></block></value><statement name="block"><block type="procedures_callnoreturn" id="3"><mutation name="Dibujar cuadrado de 50"></mutation><next><block type="DibujarLado" id="28" inline="true"><value name="longitud"><block type="math_number" id="29"><field name="NUM">50</field></block></value></block></next></block></statement></block></statement></block><block type="procedures_defnoreturn" id="4" x="20" y="180"><mutation></mutation><field name="NAME">Dibujar cuadrado de 50</field><statement name="STACK"><block type="repetir" id="5" inline="true"><value name="count"><block type="math_number" id="6"><field name="NUM">4</field></block></value><statement name="block"><block type="DibujarLado" id="7" inline="true"><value name="longitud"><block type="math_number" id="8"><field name="NUM">50</field></block></value><next><block type="GirarGrados" id="9" inline="true"><value name="grados"><block type="math_number" id="10"><field name="NUM">90</field></block></value></block></next></block></statement></block></statement></block></xml>'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)('DibujandoCortoPorLaDiagonal');

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)('DibujandoCortoPorLaDiagonal', {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="2" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="3" inline="true"><value name="count"><block type="math_number" id="4"><field name="NUM">5</field></block></value><statement name="block"><block type="procedures_callnoreturn" id="5"><mutation name="Dibujar cuadrado de 50"></mutation><next><block type="DibujarLado" id="6" inline="true"><value name="longitud"><block type="math_number" id="7"><field name="NUM">50</field></block></value><next><block type="GirarGrados" id="50" inline="true"><value name="grados"><block type="math_number" id="51"><field name="NUM">90</field></block></value><next><block type="DibujarLado" id="28" inline="true"><value name="longitud"><block type="math_number" id="29"><field name="NUM">50</field></block></value><next><block type="GirarGrados" id="58" inline="true"><value name="grados"><block type="math_number" id="59"><field name="NUM">270</field></block></value></block></next></block></next></block></next></block></next></block></statement></block></statement></block><block type="procedures_defnoreturn" id="8" x="348" y="-9"><mutation></mutation><field name="NAME">Dibujar cuadrado de 50</field><statement name="STACK"><block type="repetir" id="9" inline="true"><value name="count"><block type="math_number" id="10"><field name="NUM">4</field></block></value><statement name="block"><block type="DibujarLado" id="11" inline="true"><value name="longitud"><block type="math_number" id="12"><field name="NUM">50</field></block></value><next><block type="GirarGrados" id="13" inline="true"><value name="grados"><block type="math_number" id="14"><field name="NUM">90</field></block></value></block></next></block></statement></block></statement></block></xml>'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)('DibujandoMamushkaCuadrada');

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)('DibujandoMamushkaCuadrada', {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="2" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="5" inline="true"><mutation name="Dibujar cuadrado de 50"><arg name="largo lado"></arg></mutation><value name="ARG0"><block type="math_number" id="30"><field name="NUM">50</field></block></value><next><block type="procedures_callnoreturn" id="36" inline="true"><mutation name="Dibujar cuadrado de 50"><arg name="largo lado"></arg></mutation><value name="ARG0"><block type="math_number" id="33"><field name="NUM">100</field></block></value><next><block type="procedures_callnoreturn" id="39" inline="true"><mutation name="Dibujar cuadrado de 50"><arg name="largo lado"></arg></mutation><value name="ARG0"><block type="math_number" id="43"><field name="NUM">150</field></block></value><next><block type="procedures_callnoreturn" id="46" inline="true"><mutation name="Dibujar cuadrado de 50"><arg name="largo lado"></arg></mutation><value name="ARG0"><block type="math_number" id="48"><field name="NUM">200</field></block></value></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="14" x="4" y="290"><mutation><arg name="largo lado"></arg></mutation><field name="NAME">Dibujar cuadrado de 50</field><statement name="STACK"><block type="repetir" id="15" inline="true"><value name="count"><block type="math_number" id="16"><field name="NUM">4</field></block></value><statement name="block"><block type="DibujarLado" id="17" inline="true"><value name="longitud"><block type="param_get" id="27"><field name="VAR">largo lado</field></block></value><next><block type="GirarGrados" id="19" inline="true"><value name="grados"><block type="math_number" id="20"><field name="NUM">90</field></block></value></block></next></block></statement></block></statement></block></xml>'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)('DibujandoEscaleraCuadrada');

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)('DibujandoEscaleraCuadrada', {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="19" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="20" inline="true"><mutation name="Dibujar cuadrado"><arg name="largo lado"></arg></mutation><value name="ARG0"><block type="math_number" id="21"><field name="NUM">100</field></block></value><next><block type="procedures_callnoreturn" id="72"><mutation name="Ir Siguiente grande"></mutation><next><block type="repetir" id="104" inline="true"><value name="count"><block type="math_number" id="105"><field name="NUM">4</field></block></value><statement name="block"><block type="procedures_callnoreturn" id="22" inline="true"><mutation name="Dibujar cuadrado"><arg name="largo lado"></arg></mutation><value name="ARG0"><block type="math_number" id="23"><field name="NUM">50</field></block></value><next><block type="DibujarLado" id="86" inline="true"><value name="longitud"><block type="math_number" id="87"><field name="NUM">50</field></block></value></block></next></block></statement></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="47" x="413" y="200"><mutation></mutation><field name="NAME">Ir Siguiente grande</field><statement name="STACK"><block type="DibujarLado" id="56" inline="true"><value name="longitud"><block type="math_number" id="57"><field name="NUM">100</field></block></value><next><block type="GirarGrados" id="39" inline="true"><value name="grados"><block type="math_number" id="40"><field name="NUM">90</field></block></value><next><block type="DibujarLado" id="62" inline="true"><value name="longitud"><block type="math_number" id="63"><field name="NUM">100</field></block></value></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="28" x="40" y="301"><mutation><arg name="largo lado"></arg></mutation><field name="NAME">Dibujar cuadrado</field><statement name="STACK"><block type="repetir" id="29" inline="true"><value name="count"><block type="math_number" id="30"><field name="NUM">4</field></block></value><statement name="block"><block type="DibujarLado" id="31" inline="true"><value name="longitud"><block type="param_get" id="32"><field name="VAR">largo lado</field></block></value><next><block type="GirarGrados" id="33" inline="true"><value name="grados"><block type="math_number" id="34"><field name="NUM">90</field></block></value></block></next></block></statement></block></statement></block></xml>'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)('DibujandoHexagono');

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)('DibujandoHexagono', {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="19" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="29" inline="true"><value name="count"><block type="math_number" id="30"><field name="NUM">6</field></block></value><statement name="block"><block type="DibujarLado" id="31" inline="true"><value name="longitud"><block type="math_number" id="128"><field name="NUM">100</field></block></value><next><block type="GirarGrados" id="33" inline="true"><value name="grados"><block type="math_number" id="34"><field name="NUM">60</field></block></value></block></next></block></statement></block></statement></block></xml>'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)('DibujandoPiramideInvertida');

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)('DibujandoPiramideInvertida', {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="19" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="29" inline="true"><value name="count"><block type="math_number" id="30"><field name="NUM">3</field></block></value><statement name="block"><block type="DibujarLado" id="31" inline="true"><value name="longitud"><block type="math_number" id="128"><field name="NUM">100</field></block></value><next><block type="GirarGrados" id="33" inline="true"><value name="grados"><block type="math_number" id="34"><field name="NUM">120</field></block></value></block></next></block></statement></block></statement></block></xml>'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)('DibujandoFigurasDentroDeFiguras');

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)('DibujandoFigurasDentroDeFiguras', {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="19" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="177" inline="true"><mutation name="Dibujar poligono de lados"><arg name="cantidad"></arg></mutation><value name="ARG0"><block type="math_number" id="179"><field name="NUM">3</field></block></value><next><block type="procedures_callnoreturn" id="191" inline="true"><mutation name="Dibujar poligono de lados"><arg name="cantidad"></arg></mutation><value name="ARG0"><block type="math_number" id="196"><field name="NUM">4</field></block></value><next><block type="procedures_callnoreturn" id="194" inline="true"><mutation name="Dibujar poligono de lados"><arg name="cantidad"></arg></mutation><value name="ARG0"><block type="math_number" id="198"><field name="NUM">5</field></block></value></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="130" x="47" y="191"><mutation><arg name="cantidad"></arg></mutation><field name="NAME">Dibujar poligono de lados</field><statement name="STACK"><block type="repetir" id="29" inline="true"><value name="count"><block type="param_get" id="149"><field name="VAR">cantidad</field></block></value><statement name="block"><block type="DibujarLado" id="31" inline="true"><value name="longitud"><block type="math_number" id="128"><field name="NUM">100</field></block></value><next><block type="GirarGrados" id="33" inline="true"><value name="grados"><block type="math_arithmetic" id="139" inline="true"><field name="OP">DIVIDE</field><value name="A"><block type="math_number" id="34"><field name="NUM">360</field></block></value><value name="B"><block type="param_get" id="137"><field name="VAR">cantidad</field></block></value></block></value></block></next></block></statement></block></statement></block></xml>'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)('DibujandoLaCuevaDeEstalagtitas');

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)('DibujandoLaCuevaDeEstalagtitas', {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="19" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="352" inline="true"><mutation name="Dibujar poligono"><arg name="cantidad"></arg><arg name="largo lado"></arg></mutation><value name="ARG0"><block type="math_number" id="366"><field name="NUM">4</field></block></value><value name="ARG1"><block type="math_number" id="368"><field name="NUM">200</field></block></value><next><block type="procedures_callnoreturn" id="343" inline="true"><mutation name="Dibujar poligono"><arg name="cantidad"></arg><arg name="largo lado"></arg></mutation><value name="ARG0"><block type="math_number" id="354"><field name="NUM">3</field></block></value><value name="ARG1"><block type="math_number" id="356"><field name="NUM">40</field></block></value><next><block type="DibujarLado" id="317" inline="true"><value name="longitud"><block type="math_number" id="318"><field name="NUM">40</field></block></value><next><block type="procedures_callnoreturn" id="346" inline="true"><mutation name="Dibujar poligono"><arg name="cantidad"></arg><arg name="largo lado"></arg></mutation><value name="ARG0"><block type="math_number" id="358"><field name="NUM">3</field></block></value><value name="ARG1"><block type="math_number" id="360"><field name="NUM">60</field></block></value><next><block type="DibujarLado" id="333" inline="true"><value name="longitud"><block type="math_number" id="334"><field name="NUM">60</field></block></value><next><block type="procedures_callnoreturn" id="349" inline="true"><mutation name="Dibujar poligono"><arg name="cantidad"></arg><arg name="largo lado"></arg></mutation><value name="ARG0"><block type="math_number" id="362"><field name="NUM">3</field></block></value><value name="ARG1"><block type="math_number" id="364"><field name="NUM">100</field></block></value></block></next></block></next></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="130" x="59" y="315"><mutation><arg name="cantidad"></arg><arg name="largo lado"></arg></mutation><field name="NAME">Dibujar poligono</field><statement name="STACK"><block type="repetir" id="29" inline="true"><value name="count"><block type="param_get" id="149"><field name="VAR">cantidad</field></block></value><statement name="block"><block type="DibujarLado" id="31" inline="true"><value name="longitud"><block type="param_get" id="210"><field name="VAR">largo lado</field></block></value><next><block type="GirarGrados" id="33" inline="true"><value name="grados"><block type="math_arithmetic" id="139" inline="true"><field name="OP">DIVIDE</field><value name="A"><block type="math_number" id="34"><field name="NUM">360</field></block></value><value name="B"><block type="param_get" id="137"><field name="VAR">cantidad</field></block></value></block></value></block></next></block></statement></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/DibujandoFiguras-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/DibujandoFiguras-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/DibujandoFiguras-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/ElAlienYLasTuercas-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

  var nombre = 'ElAlienYLasTuercas';

  (0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

  (0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
    solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="7" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="16" inline="true"><value name="count"><block type="math_number" id="17"><field name="NUM">4</field></block></value><statement name="block"><block type="MoverACasillaArriba" id="23"></block></statement><next><block type="repetir" id="45" inline="true"><value name="count"><block type="math_number" id="46"><field name="NUM">4</field></block></value><statement name="block"><block type="LevantaTuerca" id="29"><next><block type="MoverACasillaAbajo" id="35"><next><block type="MoverACasillaDerecha" id="41"></block></next></block></next></block></statement><next><block type="LevantaTuerca" id="53"></block></next></block></next></block></statement></block></xml>',
    cantidadDeActoresAlComenzar: {
      TuercaAnimada: 5,
      AlienAnimado: 1
    },
    cantidadDeActoresAlTerminar: {
      TuercaAnimada: 0,
      AlienAnimado: 1
    }
  });
});
define('pilas-engine-bloques/tests/integration/desafios/ElAlienYLasTuercas-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/ElAlienYLasTuercas-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/ElAlienYLasTuercas-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/ElCangrejoAguafiestas-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = "ElCangrejoAguafiestas";

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="115" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="308" inline="true"><mutation name="Explotar globos hacia"><arg name="cantidad"></arg><arg name="direccion"></arg></mutation><value name="ARG0"><block type="math_number" id="320"><field name="NUM">4</field></block></value><value name="ARG1"><block type="ParaLaDerecha" id="314"></block></value><next><block type="procedures_callnoreturn" id="180" inline="true"><mutation name="Explotar globos hacia"><arg name="cantidad"></arg><arg name="direccion"></arg></mutation><value name="ARG0"><block type="math_number" id="192"><field name="NUM">3</field></block></value><value name="ARG1"><block type="ParaAbajo" id="275"></block></value><next><block type="procedures_callnoreturn" id="186" inline="true"><mutation name="Explotar globos hacia"><arg name="cantidad"></arg><arg name="direccion"></arg></mutation><value name="ARG0"><block type="math_number" id="198"><field name="NUM">4</field></block></value><value name="ARG1"><block type="ParaLaIzquierda" id="284"></block></value><next><block type="procedures_callnoreturn" id="183" inline="true"><mutation name="Explotar globos hacia"><arg name="cantidad"></arg><arg name="direccion"></arg></mutation><value name="ARG0"><block type="math_number" id="205"><field name="NUM">3</field></block></value><value name="ARG1"><block type="ParaArriba" id="290"></block></value><next><block type="procedures_callnoreturn" id="299"><mutation name="Explotar globos centro"></mutation></block></next></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="126" x="20" y="230"><mutation><arg name="cantidad"></arg><arg name="direccion"></arg></mutation><field name="NAME">Explotar globos hacia</field><statement name="STACK"><block type="MoverA" id="323" inline="true"><value name="direccion"><block type="param_get" id="328"><field name="VAR">direccion</field></block></value><next><block type="repetir" id="141" inline="true"><value name="count"><block type="param_get" id="147"><field name="VAR">cantidad</field></block></value><statement name="block"><block type="ExplotarGlobo" id="160"><next><block type="MoverA" id="157" inline="true"><value name="direccion"><block type="param_get" id="152"><field name="VAR">direccion</field></block></value></block></next></block></statement></block></next></block></statement></block><block type="procedures_defnoreturn" id="221" x="40" y="399"><mutation></mutation><field name="NAME">Explotar globos centro</field><statement name="STACK"><block type="repetir" id="234" inline="true"><value name="count"><block type="math_number" id="235"><field name="NUM">2</field></block></value><statement name="block"><block type="MoverA" id="210" inline="true"><value name="direccion"><block type="ParaAbajo" id="241"></block></value></block></statement><next><block type="procedures_callnoreturn" id="257" inline="true"><mutation name="Explotar globos hacia"><arg name="cantidad"></arg><arg name="direccion"></arg></mutation><value name="ARG0"><block type="math_number" id="269"><field name="NUM">4</field></block></value><value name="ARG1"><block type="ParaLaDerecha" id="263"></block></value></block></next></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/ElCangrejoAguafiestas-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/ElCangrejoAguafiestas-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/ElCangrejoAguafiestas-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/ElDetectiveChaparro-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = "ElDetectiveChaparro";

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="2" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="Primersospechoso" id="3"><next><block type="Sacardisfraz" id="8"><next><block type="hasta" id="4" inline="true"><value name="condition"><block type="Descubralculpable" id="5"></block></value><statement name="block"><block type="Siguientesospechoso" id="7"><next><block type="Sacardisfraz" id="6"></block></next></block></statement></block></next></block></next></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/ElDetectiveChaparro-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/ElDetectiveChaparro-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/ElDetectiveChaparro-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/ElGatoEnLaCalle-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = "ElGatoEnLaCalle";

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="1" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="Avanzar" id="33"><next><block type="procedures_callnoreturn" id="53"><mutation name="dormirse"></mutation><next><block type="procedures_callnoreturn" id="99"><mutation name="despertarse"></mutation><next><block type="Saludar" id="117"><next><block type="Volver" id="126"></block></next></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="74" x="476" y="134"><mutation></mutation><field name="NAME">despertarse</field><statement name="STACK"><block type="Abrirojos" id="83"><next><block type="Pararse" id="108"></block></next></block></statement></block><block type="procedures_defnoreturn" id="3" x="209" y="190"><mutation></mutation><field name="NAME">dormirse</field><statement name="STACK"><block type="Acostarse" id="42"><next><block type="Cerrarojos" id="62"><next><block type="Soar" id="71"></block></next></block></next></block></statement></block></xml>'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'Invirtiendo acciones sigue funcionando la solución',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="16" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="Avanzar" id="17"><next><block type="procedures_callnoreturn" id="18"><mutation name="dormirse"></mutation><next><block type="procedures_callnoreturn" id="19"><mutation name="despertarse"></mutation><next><block type="Saludar" id="20"><next><block type="Volver" id="21"></block></next></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="22" x="476" y="134"><mutation></mutation><field name="NAME">despertarse</field><statement name="STACK"><block type="Pararse" id="24"><next><block type="Abrirojos" id="23"></block></next></block></statement></block><block type="procedures_defnoreturn" id="25" x="209" y="190"><mutation></mutation><field name="NAME">dormirse</field><statement name="STACK"><block type="Cerrarojos" id="27"><next><block type="Acostarse" id="26"><next><block type="Soar" id="28"></block></next></block></next></block></statement></block></xml>'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'Puedo acostarme y pararme varias veces idem ojos',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="105" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="Cerrarojos" id="155"><next><block type="Abrirojos" id="164"><next><block type="Cerrarojos" id="173"><next><block type="Abrirojos" id="182"><next><block type="Acostarse" id="191"><next><block type="Pararse" id="200"><next><block type="Acostarse" id="209"></block></next></block></next></block></next></block></next></block></next></block></next></block></statement></block></xml>',
		resuelveDesafio: false
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'da error al intentar cerrar ojos dos veces',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="39" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="Cerrarojos" id="40"><next><block type="Cerrarojos" id="41"></block></next></block></statement></block></xml>',
		errorEsperado: 'No puedo, ya estoy con los ojos cerrados'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'da error al intentar abrir ojos dos veces',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="19" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="Cerrarojos" id="38"><next><block type="Abrirojos" id="20"><next><block type="Abrirojos" id="21"></block></next></block></next></block></statement></block></xml>',
		errorEsperado: 'No puedo, ya estoy con los ojos abiertos'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'da error al intentar pararse dos veces',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="57" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="Acostarse" id="75"><next><block type="Pararse" id="58"><next><block type="Pararse" id="59"></block></next></block></next></block></statement></block></xml>',
		errorEsperado: 'No puedo, ya estoy parado'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'da error al intentar acostarse dos veces',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="76" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="Acostarse" id="77"><next><block type="Acostarse" id="78"></block></next></block></statement></block></xml>',
		errorEsperado: 'No puedo, ya estoy acostado'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'da error al intentar pararse al principio',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="105" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="Pararse" id="244"></block></statement></block></xml>',
		errorEsperado: 'No puedo, ya estoy parado'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/ElGatoEnLaCalle-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/ElGatoEnLaCalle-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/ElGatoEnLaCalle-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/ElMarcianoEnElDesierto-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = "ElMarcianoEnElDesierto";

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	// Solución esperada. Va en sentido antihorario
	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="2" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="3"><mutation name="Comer 2 derecha"></mutation><next><block type="procedures_callnoreturn" id="4"><mutation name="Mover 2 derecha"></mutation><next><block type="procedures_callnoreturn" id="5"><mutation name="Comer 3 arriba"></mutation><next><block type="procedures_callnoreturn" id="6"><mutation name="Comer 2 izquierda"></mutation></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="8" x="10" y="207"><mutation></mutation><field name="NAME">Comer 2 derecha</field><statement name="STACK"><block type="repetir" id="9" inline="true"><value name="count"><block type="math_number" id="10"><field name="NUM">2</field></block></value><statement name="block"><block type="MoverACasillaDerecha" id="11"><next><block type="ComerManzana" id="12"></block></next></block></statement></block></statement></block><block type="procedures_defnoreturn" id="13" x="449" y="201"><mutation></mutation><field name="NAME">Mover 2 derecha</field><statement name="STACK"><block type="repetir" id="14" inline="true"><value name="count"><block type="math_number" id="15"><field name="NUM">2</field></block></value><statement name="block"><block type="MoverACasillaDerecha" id="16"></block></statement></block></statement></block><block type="procedures_defnoreturn" id="17" x="8" y="387"><mutation></mutation><field name="NAME">Comer 3 arriba</field><statement name="STACK"><block type="repetir" id="18" inline="true"><value name="count"><block type="math_number" id="19"><field name="NUM">3</field></block></value><statement name="block"><block type="MoverACasillaArriba" id="20"><next><block type="ComerManzana" id="21"></block></next></block></statement></block></statement></block><block type="procedures_defnoreturn" id="7" x="445" y="400"><mutation></mutation><field name="NAME">Comer 2 izquierda</field><statement name="STACK"><block type="repetir" id="33" inline="true"><value name="count"><block type="math_number" id="34"><field name="NUM">2</field></block></value><statement name="block"><block type="MoverACasillaIzquierda" id="46"><next><block type="MoverACasillaIzquierda" id="40"><next><block type="ComerManzana" id="52"></block></next></block></next></block></statement></block></statement></block></xml>'
	});

	// Solución alternativa. Va en sentido horario
	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="50" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="115"><mutation name="Mover 3 arriba"></mutation><next><block type="ComerManzana" id="121"><next><block type="procedures_callnoreturn" id="103"><mutation name="Comer 2 arriba"></mutation><next><block type="procedures_callnoreturn" id="144"><mutation name="Comer 2 derecha"></mutation><next><block type="procedures_callnoreturn" id="175"><mutation name="Mover 2 izquierda"></mutation><next><block type="procedures_callnoreturn" id="208"><mutation name="Comer 2 abajo"></mutation></block></next></block></next></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="60" x="3" y="207"><mutation></mutation><field name="NAME">Mover 3 arriba</field><statement name="STACK"><block type="repetir" id="61" inline="true"><value name="count"><block type="math_number" id="62"><field name="NUM">3</field></block></value><statement name="block"><block type="MoverACasillaArriba" id="109"></block></statement></block></statement></block><block type="procedures_defnoreturn" id="69" x="384" y="204"><mutation></mutation><field name="NAME">Comer 2 arriba</field><statement name="STACK"><block type="repetir" id="70" inline="true"><value name="count"><block type="math_number" id="71"><field name="NUM">2</field></block></value><statement name="block"><block type="MoverACasillaDerecha" id="86"><next><block type="MoverACasillaDerecha" id="80"><next><block type="ComerManzana" id="74"></block></next></block></next></block></statement></block></statement></block><block type="procedures_defnoreturn" id="55" x="15" y="403"><mutation></mutation><field name="NAME">Comer 2 derecha</field><statement name="STACK"><block type="repetir" id="56" inline="true"><value name="count"><block type="math_number" id="57"><field name="NUM">2</field></block></value><statement name="block"><block type="MoverACasillaAbajo" id="127"><next><block type="ComerManzana" id="59"></block></next></block></statement><next><block type="MoverACasillaAbajo" id="133"></block></next></block></statement></block><block type="procedures_defnoreturn" id="154" x="379" y="413"><mutation></mutation><field name="NAME">Mover 2 izquierda</field><statement name="STACK"><block type="repetir" id="147" inline="true"><value name="count"><block type="math_number" id="148"><field name="NUM">2</field></block></value><statement name="block"><block type="MoverACasillaIzquierda" id="214"></block></statement></block></statement></block><block type="procedures_defnoreturn" id="64" x="667" y="409"><mutation></mutation><field name="NAME">Comer 2 abajo</field><statement name="STACK"><block type="ComerManzana" id="201"><next><block type="MoverACasillaIzquierda" id="220"><next><block type="ComerManzana" id="68"></block></next></block></next></block></statement></block></xml>'
	});

	// Solución alternativa. Va de arriba para abajo
	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="252" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="310"><mutation name="Ir arriba y comer"></mutation><next><block type="MoverACasillaDerecha" id="322"><next><block type="procedures_callnoreturn" id="332"><mutation name="Ir abajo y comer"></mutation><next><block type="MoverACasillaDerecha" id="338"><next><block type="ComerManzana" id="344"><next><block type="procedures_callnoreturn" id="354"><mutation name="Ir arriba y comer"></mutation><next><block type="MoverACasillaDerecha" id="360"><next><block type="MoverACasillaDerecha" id="366"><next><block type="procedures_callnoreturn" id="371"><mutation name="Comer 3 abajo"></mutation></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="259" x="319" y="11"><mutation></mutation><field name="NAME">Ir arriba y comer</field><statement name="STACK"><block type="repetir" id="260" inline="true"><value name="count"><block type="math_number" id="261"><field name="NUM">3</field></block></value><statement name="block"><block type="MoverACasillaArriba" id="262"></block></statement><next><block type="ComerManzana" id="293"></block></next></block></statement></block><block type="procedures_defnoreturn" id="269" x="626" y="8"><mutation></mutation><field name="NAME">Comer 3 abajo</field><statement name="STACK"><block type="repetir" id="270" inline="true"><value name="count"><block type="math_number" id="271"><field name="NUM">2</field></block></value><statement name="block"><block type="ComerManzana" id="273"><next><block type="MoverACasillaAbajo" id="272"></block></next></block></statement><next><block type="ComerManzana" id="377"></block></next></block></statement></block><block type="procedures_defnoreturn" id="275" x="319" y="209"><mutation></mutation><field name="NAME">Ir abajo y comer</field><statement name="STACK"><block type="repetir" id="276" inline="true"><value name="count"><block type="math_number" id="277"><field name="NUM">3</field></block></value><statement name="block"><block type="MoverACasillaAbajo" id="299"></block></statement><next><block type="ComerManzana" id="305"></block></next></block></statement></block></xml>'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'Da error al querer tomar manzana cuando no hay',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="378" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="ComerManzana" id="409"></block></statement></block></xml>',
		errorEsperado: '¡Acá no hay manzana!'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'Da error al querer ir hacia arriba más allá del tablero',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="410" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="MoverACasillaArriba" id="431"><next><block type="MoverACasillaArriba" id="425"><next><block type="MoverACasillaArriba" id="437"><next><block type="MoverACasillaArriba" id="419"></block></next></block></next></block></next></block></statement></block></xml>',
		errorEsperado: 'No puedo ir para arriba'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'Da error al querer ir hacia la izquierda más allá del tablero',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="438" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="MoverACasillaIzquierda" id="454"></block></statement></block></xml>',
		errorEsperado: 'No puedo ir para la izquierda'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'Da error al querer ir hacia abajo más allá del tablero',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="460" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="MoverACasillaAbajo" id="467"></block></statement></block></xml>',
		errorEsperado: 'No puedo ir para abajo'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/ElMarcianoEnElDesierto-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/ElMarcianoEnElDesierto-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/ElMarcianoEnElDesierto-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/ElMonoCuentaDeNuevo-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = "ElMonoCuentaDeNuevo";

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="3" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="4" inline="true"><value name="count"><block type="math_number" id="5"><field name="NUM">4</field></block></value><statement name="block"><block type="procedures_callnoreturn" id="6"><mutation name="Contar frutas de columna"></mutation><next><block type="procedures_callnoreturn" id="7"><mutation name="Volver al inicio"></mutation><next><block type="SiguienteColumna" id="8"></block></next></block></next></block></statement><next><block type="procedures_callnoreturn" id="37"><mutation name="Contar frutas de columna"></mutation></block></next></block></statement></block><block type="procedures_defnoreturn" id="9" x="280" y="35"><mutation></mutation><field name="NAME">Volver al inicio</field><statement name="STACK"><block type="hasta" id="10" inline="true"><value name="condition"><block type="estoyInicio" id="11"></block></value><statement name="block"><block type="MoverACasillaArriba" id="12"></block></statement></block></statement></block><block type="procedures_defnoreturn" id="13" x="11" y="201"><mutation></mutation><field name="NAME">Contar frutas de columna</field><statement name="STACK"><block type="repetir" id="14" inline="true"><value name="count"><block type="LargoColumnaActual" id="15"></block></value><statement name="block"><block type="MoverACasillaAbajo" id="16"><next><block type="procedures_callnoreturn" id="17"><mutation name="Contar banana si hay"></mutation><next><block type="procedures_callnoreturn" id="18"><mutation name="Contar manzana si hay"></mutation></block></next></block></next></block></statement></block></statement></block><block type="procedures_defnoreturn" id="19" x="319" y="281"><mutation></mutation><field name="NAME">Contar manzana si hay</field><statement name="STACK"><block type="si" id="20" inline="true"><value name="condition"><block type="tocandoBanana" id="21"></block></value><statement name="block"><block type="Contarbanana" id="22"></block></statement></block></statement></block><block type="procedures_defnoreturn" id="23" x="47" y="393"><mutation></mutation><field name="NAME">Contar banana si hay</field><statement name="STACK"><block type="si" id="24" inline="true"><value name="condition"><block type="tocandoManzana" id="25"></block></value><statement name="block"><block type="Contarmanzana" id="26"></block></statement></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/ElMonoCuentaDeNuevo-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/ElMonoCuentaDeNuevo-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/ElMonoCuentaDeNuevo-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/ElMonoQueSabeContar-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = 'ElMonoQueSabeContar';

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="1" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="68" inline="true"><value name="count"><block type="math_number" id="69"><field name="NUM">4</field></block></value><statement name="block"><block type="procedures_callnoreturn" id="81"><mutation name="Contar frutas de columna"></mutation><next><block type="procedures_callnoreturn" id="87"><mutation name="Volver al inicio"></mutation><next><block type="SiguienteColumna" id="93"></block></next></block></next></block></statement><next><block type="procedures_callnoreturn" id="108"><mutation name="Contar frutas de columna"></mutation></block></next></block></statement></block><block type="procedures_defnoreturn" id="53" x="277" y="15"><mutation></mutation><field name="NAME">Contar frutas de columna</field><statement name="STACK"><block type="hasta" id="114" inline="true"><value name="condition"><block type="estoyFinColumna" id="129"></block></value><statement name="block"><block type="MoverACasillaAbajo" id="146"><next><block type="procedures_callnoreturn" id="163"><mutation name="Contar banana si hay"></mutation><next><block type="procedures_callnoreturn" id="157"><mutation name="Contar manzana si hay"></mutation></block></next></block></next></block></statement></block></statement></block><block type="procedures_defnoreturn" id="49" x="13" y="211"><mutation></mutation><field name="NAME">Contar banana si hay</field><statement name="STACK"><block type="si" id="202" inline="true"><value name="condition"><block type="tocandoBanana" id="217"></block></value><statement name="block"><block type="Contarbanana" id="228"></block></statement></block></statement></block><block type="procedures_defnoreturn" id="46" x="411" y="227"><mutation></mutation><field name="NAME">Contar manzana si hay</field><statement name="STACK"><block type="si" id="240" inline="true"><value name="condition"><block type="tocandoManzana" id="222"></block></value><statement name="block"><block type="Contarmanzana" id="234"></block></statement></block></statement></block><block type="procedures_defnoreturn" id="58" x="154" y="312"><mutation></mutation><field name="NAME">Volver al inicio</field><statement name="STACK"><block type="hasta" id="251" inline="true"><value name="condition"><block type="estoyInicio" id="256"></block></value><statement name="block"><block type="MoverACasillaArriba" id="262"></block></statement></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/ElMonoQueSabeContar-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/ElMonoQueSabeContar-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/ElMonoQueSabeContar-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/ElMonoYLasBananas-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = "ElMonoYLasBananas";

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="25" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="Avanzar" id="26"><next><block type="procedures_callnoreturn" id="40"><mutation name="Comer banana si hay"></mutation></block></next></block></statement></block><block type="procedures_defnoreturn" id="32" x="-11" y="110"><mutation></mutation><field name="NAME">Comer banana si hay</field><statement name="STACK"><block type="si" id="27" inline="true"><value name="condition"><block type="Tocandobanana" id="28"></block></value><statement name="block"><block type="Comerbanana" id="29"></block></statement></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/ElMonoYLasBananas-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/ElMonoYLasBananas-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/ElMonoYLasBananas-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/ElPlanetaDeNano-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = "ElPlanetaDeNano";

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="2" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="3" inline="true"><mutation name="comer"><arg name="cant"></arg></mutation><value name="ARG0"><block type="math_number" id="4"><field name="NUM">3</field></block></value><next><block type="MoverACasillaArriba" id="5"><next><block type="procedures_callnoreturn" id="6" inline="true"><mutation name="comer"><arg name="cant"></arg></mutation><value name="ARG0"><block type="math_number" id="7"><field name="NUM">1</field></block></value><next><block type="MoverACasillaArriba" id="8"><next><block type="procedures_callnoreturn" id="9" inline="true"><mutation name="comer"><arg name="cant"></arg></mutation><value name="ARG0"><block type="math_number" id="10"><field name="NUM">4</field></block></value><next><block type="MoverACasillaArriba" id="11"><next><block type="procedures_callnoreturn" id="12" inline="true"><mutation name="comer"><arg name="cant"></arg></mutation><value name="ARG0"><block type="math_number" id="13"><field name="NUM">2</field></block></value></block></next></block></next></block></next></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="14" x="282" y="33"><mutation><arg name="cant"></arg></mutation><field name="NAME">comer</field><statement name="STACK"><block type="repetir" id="15" inline="true"><value name="count"><block type="param_get" id="16"><field name="VAR">cant</field></block></value><statement name="block"><block type="MoverACasillaDerecha" id="17"><next><block type="ComerBanana" id="18"></block></next></block></statement><next><block type="Volveralbordeizquierdo" id="19"></block></next></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/ElPlanetaDeNano-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/ElPlanetaDeNano-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/ElPlanetaDeNano-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/ElRecolectorDeEstrellas-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

  var nombre = 'ElRecolectorDeEstrellas';

  (0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

  (0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
    solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="1" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="115" inline="true"><value name="count"><block type="math_number" id="116"><field name="NUM">3</field></block></value><statement name="block"><block type="procedures_callnoreturn" id="107"><mutation name="tomar estellas de la fila completa"></mutation><next><block type="VolverABordeIzquierdo" id="121"><next><block type="MoverACasillaArriba" id="126"></block></next></block></next></block></statement><next><block type="procedures_callnoreturn" id="129"><mutation name="tomar estellas de la fila completa"></mutation></block></next></block></statement></block><block type="procedures_defnoreturn" id="92" x="14" y="268"><mutation></mutation><field name="NAME">tomar estellas de la fila completa</field><statement name="STACK"><block type="repetir" id="89" inline="true"><value name="count"><block type="math_number" id="90"><field name="NUM">4</field></block></value><statement name="block"><block type="MoverACasillaDerecha" id="97"><next><block type="TomarEstrella" id="102"></block></next></block></statement></block></statement></block></xml>',
    cantidadDeActoresAlComenzar: {
      "EstrellaAnimada": 4 * 4
    },
    cantidadDeActoresAlTerminar: {
      "EstrellaAnimada": 0
    }
  });
});
define('pilas-engine-bloques/tests/integration/desafios/ElRecolectorDeEstrellas-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/ElRecolectorDeEstrellas-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/ElRecolectorDeEstrellas-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/ElSuperviaje-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = 'ElSuperviaje';

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="1" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="26" inline="true"><value name="count"><block type="KmsTotales" id="29"></block></value><statement name="block"><block type="AvanzarKm" id="12"></block></statement></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/ElSuperviaje-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/ElSuperviaje-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/ElSuperviaje-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/FutbolDeRobots-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = 'FutbolRobots';

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="1" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="14" inline="true"><value name="count"><block type="math_number" id="15"><field name="NUM">7</field></block></value><statement name="block"><block type="procedures_callnoreturn" id="95"><mutation name="Hacer gol"></mutation><next><block type="procedures_callnoreturn" id="99"><mutation name="Volver al inicio"></mutation><next><block type="SiguienteFila" id="87"></block></next></block></next></block></statement><next><block type="procedures_callnoreturn" id="107"><mutation name="Hacer gol"></mutation></block></next></block></statement></block><block type="procedures_defnoreturn" id="21" x="217" y="61"><mutation></mutation><field name="NAME">Hacer gol</field><statement name="STACK"><block type="hasta" id="33" inline="true"><value name="condition"><block type="tocandoPelota" id="70"></block></value><statement name="block"><block type="MoverACasillaDerecha" id="54"></block></statement><next><block type="PatearPelota" id="75"></block></next></block></statement></block><block type="procedures_defnoreturn" id="24" x="6" y="235"><mutation></mutation><field name="NAME">Volver al inicio</field><statement name="STACK"><block type="hasta" id="42" inline="true"><value name="condition"><block type="tocandoInicio" id="62"></block></value><statement name="block"><block type="MoverACasillaIzquierda" id="59"></block></statement></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/FutbolDeRobots-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/FutbolDeRobots-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/FutbolDeRobots-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/InstalandoJuegos-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = 'InstalandoJuegos';

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="193" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="212" inline="true"><value name="count"><block type="math_number" id="213"><field name="NUM">3</field></block></value><statement name="block"><block type="SiguienteCompu" id="221"><next><block type="procedures_callnoreturn" id="209"><mutation name="Procesar compu"></mutation></block></next></block></statement></block></statement></block><block type="procedures_defnoreturn" id="195" x="23" y="215"><mutation></mutation><field name="NAME">Procesar compu</field><statement name="STACK"><block type="PrenderCompu" id="229"><next><block type="procedures_callnoreturn" id="233"><mutation name="Ingresar password"></mutation><next><block type="InstalarJuego" id="241"><next><block type="ApagarCompu" id="249"></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="198" x="487" y="218"><mutation></mutation><field name="NAME">Ingresar password</field><statement name="STACK"><block type="EscribirA" id="257"><next><block type="EscribirB" id="265"><next><block type="EscribirC" id="273"></block></next></block></next></block></statement></block></xml>'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'No debe poderse resolver la actividad si no están las tres máquinas instaladas',
		solucion: '<xml><block y="0" x="0" editable="false" movable="false" deletable="false" id="32" type="al_empezar_a_ejecutar"><statement name="program"><block id="35" type="SiguienteCompu"><next><block inline="true" id="33" type="repetir"><value name="count"><block id="34" type="math_number"><field name="NUM">3</field></block></value><statement name="block"><block id="36" type="procedures_callnoreturn"><mutation name="Procesar compu"></mutation></block></statement></block></next></block></statement></block><block y="215" x="23" id="37" type="procedures_defnoreturn"><mutation></mutation><field name="NAME">Procesar compu</field><statement name="STACK"><block id="38" type="PrenderCompu"><next><block id="39" type="procedures_callnoreturn"><mutation name="Ingresar password"></mutation><next><block id="40" type="InstalarJuego"><next><block id="41" type="ApagarCompu"></block></next></block></next></block></next></block></statement></block><block y="218" x="487" id="42" type="procedures_defnoreturn"><mutation></mutation><field name="NAME">Ingresar password</field><statement name="STACK"><block id="43" type="EscribirA"><next><block id="44" type="EscribirB"><next><block id="45" type="EscribirC"></block></next></block></next></block></statement></block></xml>',
		errorEsperado: 'Esta compu ya la prendiste antes'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/InstalandoJuegos-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/InstalandoJuegos-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/InstalandoJuegos-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/LaEleccionDelMono-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

  var nombre = 'LaEleccionDelMono';

  (0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

  (0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
    solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="16" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="Avanzar" id="20"><next><block type="sino" id="22" inline="true"><value name="condition"><block type="tocandoManzana" id="30"></block></value><statement name="block1"><block type="ComerManzana" id="26"></block></statement><statement name="block2"><block type="ComerBanana" id="34"></block></statement></block></next></block></statement></block></xml>',
    descripcionAdicional: 'por Banana',
    cantidadDeActoresAlTerminar: {
      "MonoAnimado": 1
    }
  });
});
define('pilas-engine-bloques/tests/integration/desafios/LaEleccionDelMono-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/LaEleccionDelMono-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/LaEleccionDelMono-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/LaFiestaDeDracula-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = "LaFiestaDeDracula";

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="2" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="3" inline="true"><mutation name="Cambiar foco veces"><arg name="veces"></arg></mutation><value name="ARG0"><block type="math_number" id="4"><field name="NUM">5</field></block></value><next><block type="siguienteFoco" id="5"><next><block type="procedures_callnoreturn" id="6" inline="true"><mutation name="Cambiar foco veces"><arg name="veces"></arg></mutation><value name="ARG0"><block type="math_number" id="7"><field name="NUM">8</field></block></value><next><block type="siguienteFoco" id="8"><next><block type="procedures_callnoreturn" id="9" inline="true"><mutation name="Cambiar foco veces"><arg name="veces"></arg></mutation><value name="ARG0"><block type="math_number" id="10"><field name="NUM">12</field></block></value><next><block type="empezarFiesta" id="11"></block></next></block></next></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="12" x="23" y="254"><mutation><arg name="veces"></arg></mutation><field name="NAME">Cambiar foco veces</field><statement name="STACK"><block type="repetir" id="13" inline="true"><value name="count"><block type="param_get" id="14"><field name="VAR">veces</field></block></value><statement name="block"><block type="cambiarColor" id="15"></block></statement></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/LaFiestaDeDracula-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/LaFiestaDeDracula-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/LaFiestaDeDracula-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/LaGranAventuraDelMarEncantado-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = 'LaGranAventuraDelMarEncantado';

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'Da error al dar sombrero sin tenerlo',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="1" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="MoverACasillaDerecha" id="11"><next><block type="Darsombrero" id="24"></block></next></block></statement></block></xml>',
		errorEsperado: 'Para darle el sombrero al mago necesitás sacarlo del cofre.'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="2" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="3"><mutation name="Buscar llave"></mutation><next><block type="procedures_callnoreturn" id="4"><mutation name="Buscar Sombrero"></mutation><next><block type="procedures_callnoreturn" id="5"><mutation name="Buscar espada"></mutation><next><block type="procedures_callnoreturn" id="6"><mutation name="Luchar con el caballero"></mutation><next><block type="procedures_callnoreturn" id="7"><mutation name="Rescatar princesa"></mutation></block></next></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="8" x="500" y="-5"><mutation></mutation><field name="NAME">Buscar Sombrero</field>' + '<statement name="STACK"><block type="MoverACasillaArriba" id="9"><next><block type="repetir" id="10" inline="true"><value name="count"><block type="math_number" id="11"><field name="NUM">4</field></block></value><statement name="block"><block type="MoverACasillaIzquierda" id="12"></block></statement><next><block type="Abrircofre" id="49"></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="13" x="249" y="14"><mutation></mutation><field name="NAME">Rescatar princesa</field><statement name="STACK"><block type="repetir" id="14" inline="true"><value name="count"><block type="math_number" id="15"><field name="NUM">2</field></block></value><statement name="block"><block type="MoverACasillaAbajo" id="16"><next><block type="MoverACasillaDerecha" id="17"></block></next></block></statement><next><block type="Escaparenunicornio" id="18">' + '</block></next></block></statement></block><block type="procedures_defnoreturn" id="19" x="552" y="138"><mutation></mutation><field name="NAME">Luchar con el caballero</field><statement name="STACK"><block type="repetir" id="20" inline="true"><value name="count"><block type="math_number" id="21"><field name="NUM">2</field></block></value><statement name="block"><block type="MoverACasillaArriba" id="22"></block></statement><next><block type="MoverACasillaDerecha" id="23"><next><block type="Atacarconespada" id="24"></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="25" x="10" y="274"><mutation></mutation><field name="NAME">Buscar llave</field><statement name="STACK"><block type="repetir" id="26" inline="true"><value name="count"><block type="math_number" id="27"><field name="NUM">2</field></block></value><statement name="block">' + '<block type="MoverACasillaArriba" id="28"></block></statement><next><block type="repetir" id="29" inline="true"><value name="count"><block type="math_number" id="30"><field name="NUM">4</field></block></value><statement name="block"><block type="MoverACasillaDerecha" id="31"></block></statement><next><block type="Agarrarllave" id="73"></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="32" x="309" y="270"><mutation></mutation><field name="NAME">Buscar espada</field><statement name="STACK"><block type="repetir" id="33" inline="true"><value name="count"><block type="math_number" id="34"><field name="NUM">3</field></block></value><statement name="block"><block type="MoverACasillaAbajo" id="35"></block></statement><next><block type="MoverACasillaDerecha" id="36"><next><block type="Darsombrero" id="37"></block></next></block></next></block></statement></block></xml>'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'Solo puede escapar sobre el unicornio',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="1" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="58"><mutation name="Ir a buscar la llave"></mutation><next><block type="procedures_callnoreturn" id="306"><mutation name="Ir al Cofre"></mutation><next><block type="procedures_callnoreturn" id="328"><mutation name="Ir al mago"></mutation><next><block type="procedures_callnoreturn" id="299"><mutation name="Ir a pelear"></mutation><next><block type="procedures_callnoreturn" id="292"><mutation name="Ir a Escapar"></mutation></block></next></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="78" x="233" y="26"><mutation></mutation><field name="NAME">Ir al Cofre</field><statement name="STACK"><block type="repetir" id="120" inline="true"><value name="count"><block type="math_number" id="121"><field name="NUM">4</field></block></value><statement name="block"><block type="MoverACasillaIzquierda" id="137"></block></statement><next><block type="MoverACasillaArriba" id="147"><next><block type="Abrircofre" id="267"></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="3" x="-30" y="191"><mutation></mutation><field name="NAME">Ir a buscar la llave</field><statement name="STACK"><block type="repetir" id="17" inline="true"><value name="count"><block type="math_number" id="18"><field name="NUM">4</field></block></value><statement name="block"><block type="MoverACasillaDerecha" id="34"></block></statement><next><block type="repetir" id="23" inline="true"><value name="count"><block type="math_number" id="24"><field name="NUM">2</field></block></value><statement name="block"><block type="MoverACasillaArriba" id="46"></block></statement><next><block type="Agarrarllave" id="257"></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="96" x="252" y="216"><mutation></mutation><field name="NAME">Ir a pelear</field><statement name="STACK"><block type="MoverACasillaArriba" id="422"><next><block type="MoverACasillaArriba" id="392"><next><block type="MoverACasillaDerecha" id="402"><next><block type="Atacarconespada" id="237"></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="102" x="223" y="404"><mutation></mutation><field name="NAME">Ir a Escapar</field><statement name="STACK"><block type="repetir" id="444" inline="true"><value name="count"><block type="math_number" id="445"><field name="NUM">2</field></block></value><statement name="block"><block type="MoverACasillaAbajo" id="465"></block></statement><next><block type="Escaparenunicornio" id="163"></block></next></block></statement></block><block type="procedures_defnoreturn" id="82" x="-29" y="448"><mutation></mutation><field name="NAME">Ir al mago</field><statement name="STACK"><block type="repetir" id="340" inline="true"><value name="count"><block type="math_number" id="341"><field name="NUM">3</field></block></value><statement name="block"><block type="MoverACasillaAbajo" id="357"></block></statement><next><block type="MoverACasillaDerecha" id="367"><next><block type="Darsombrero" id="217"></block></next></block></next></block></statement></block></xml>',
		errorEsperado: 'Para escapar hace falta un transporte'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/LaGranAventuraDelMarEncantado-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/LaGranAventuraDelMarEncantado-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/LaGranAventuraDelMarEncantado-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/LaberintoConQueso-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = 'LaberintoConQueso';

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="1" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="hasta" id="51" inline="true"><value name="condition"><block type="TocandoFinCamino" id="61"></block></value><statement name="block"><block type="si" id="74" inline="true"><value name="condition"><block type="tocandoQueso" id="79"></block></value><statement name="block"><block type="ComerQueso" id="92"></block></statement><next><block type="sino" id="14" inline="true"><value name="condition"><block type="TocandoAbajo" id="26"></block></value><statement name="block1"><block type="MoverACasillaAbajo" id="30"></block></statement><statement name="block2"><block type="MoverACasillaDerecha" id="38"></block></statement></block></next></block></statement></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/LaberintoConQueso-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/LaberintoConQueso-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/LaberintoConQueso-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/LaberintoCorto-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = 'LaberintoCorto';

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="23" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="sino" id="24" inline="true"><value name="condition"><block type="TocandoAbajo" id="25"></block></value><statement name="block1"><block type="MoverACasillaAbajo" id="26"></block></statement><statement name="block2"><block type="MoverACasillaDerecha" id="27"></block></statement></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/LaberintoCorto-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/LaberintoCorto-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/LaberintoCorto-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/LaberintoLargo-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = 'LaberintoLargo';

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="1" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="88" inline="true"><value name="count"><block type="math_number" id="89"><field name="NUM">14</field></block></value><statement name="block"><block type="sino" id="10" inline="true"><value name="condition"><block type="TocandoAbajo" id="24"></block></value><statement name="block1"><block type="MoverACasillaAbajo" id="27"></block></statement><statement name="block2"><block type="MoverACasillaDerecha" id="55"></block></statement></block></statement></block></statement></block></xml>'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'Da error al querer avanzar hacia la derecha cuando ya no hay camino',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="2" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="3" inline="true"><value name="count"><block type="math_number" id="4"><field name="NUM">14</field></block></value><statement name="block"><block type="sino" id="5" inline="true"><value name="condition"><block type="TocandoAbajo" id="6"></block></value><statement name="block1"><block type="MoverACasillaAbajo" id="7"></block></statement><statement name="block2"><block type="MoverACasillaDerecha" id="8"></block></statement></block></statement><next><block type="MoverACasillaDerecha" id="11"></block></next></block></statement></block></xml>',
		errorEsperado: 'No puedo ir para la derecha'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'Debe dar error si se intenta preguntar en la meta final',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="11" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="12" inline="true"><value name="count"><block type="math_number" id="13"><field name="NUM">14</field></block></value><statement name="block"><block type="si" id="20" inline="true"><value name="condition"><block type="TocandoAbajo" id="15"></block></value><statement name="block"><block type="MoverACasillaAbajo" id="16"></block></statement><next><block type="si" id="23" inline="true"><value name="condition"><block type="TocandoDerecha" id="34"></block></value><statement name="block"><block type="MoverACasillaDerecha" id="17"></block></statement></block></next></block></statement></block></statement></block></xml>',
		errorEsperado: 'No se puede preguntar más, ya estoy al final del camino'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/LaberintoLargo-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/LaberintoLargo-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/LaberintoLargo-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/MariaLaComeSandias-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = 'MariaLaComeSandias';

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="78" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="87"><mutation name="Morder todas las filas"></mutation><next><block type="procedures_callnoreturn" id="91"><mutation name="Morder columna final"></mutation></block></next></block></statement></block><block type="procedures_defnoreturn" id="95" x="8" y="176"><mutation></mutation><field name="NAME">Morder fila de sandias</field><statement name="STACK"><block type="repetir" id="115" inline="true"><value name="count"><block type="math_number" id="116"><field name="NUM">5</field></block></value><statement name="block"><block type="MoverACasillaDerecha" id="134"><next><block type="MorderSandia" id="140"></block></next></block></statement></block></statement></block><block type="procedures_defnoreturn" id="100" x="382" y="175"><mutation></mutation><field name="NAME">Volver al borde izquierdo</field><statement name="STACK"><block type="repetir" id="119" inline="true"><value name="count"><block type="math_number" id="120"><field name="NUM">5</field></block></value><statement name="block"><block type="MoverACasillaIzquierda" id="146"></block></statement></block></statement></block><block type="procedures_defnoreturn" id="106" x="739" y="171"><mutation></mutation><field name="NAME">Siguiente fila</field><statement name="STACK"><block type="procedures_callnoreturn" id="153"><mutation name="Volver al borde izquierdo"></mutation><next><block type="MoverACasillaArriba" id="159"><next><block type="MoverACasillaArriba" id="165"></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="80" x="10" y="345"><mutation></mutation><field name="NAME">Morder todas las filas</field><statement name="STACK"><block type="repetir" id="123" inline="true"><value name="count"><block type="math_number" id="124"><field name="NUM">2</field></block></value><statement name="block"><block type="procedures_callnoreturn" id="172"><mutation name="Morder fila de sandias"></mutation><next><block type="procedures_callnoreturn" id="179"><mutation name="Siguiente fila"></mutation></block></next></block></statement><next><block type="procedures_callnoreturn" id="186"><mutation name="Morder fila de sandias"></mutation><next><block type="procedures_callnoreturn" id="193"><mutation name="Volver al borde izquierdo"></mutation></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="83" x="386" y="349"><mutation></mutation><field name="NAME">Morder columna final</field><statement name="STACK"><block type="repetir" id="127" inline="true"><value name="count"><block type="math_number" id="128"><field name="NUM">4</field></block></value><statement name="block"><block type="MorderSandia" id="199"><next><block type="MoverACasillaAbajo" id="210"></block></next></block></statement><next><block type="MorderSandia" id="216"></block></next></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/MariaLaComeSandias-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/MariaLaComeSandias-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/MariaLaComeSandias-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/NoMeCansoDeSaltar-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = 'NoMeCansoDeSaltar';

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	// Solución esperada. Usa el bloque Repetir
	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="13" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="14" inline="true"><value name="count"><block type="math_number" id="15"><field name="NUM">30</field></block></value><statement name="block"><block type="saltar1" id="16"></block></statement></block></statement></block></xml>'
	});

	// Solución alternativa donde no usa el bloque Repetir y ejecuta 30 bloques saltar seguidos.
	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="46" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="saltar1" id="109"><next><block type="saltar1" id="107"><next><block type="saltar1" id="105"><next><block type="saltar1" id="103"><next><block type="saltar1" id="101"><next><block type="saltar1" id="99"><next><block type="saltar1" id="97"><next><block type="saltar1" id="95"><next><block type="saltar1" id="93"><next><block type="saltar1" id="91"><next><block type="saltar1" id="89"><next><block type="saltar1" id="87"><next><block type="saltar1" id="85"><next><block type="saltar1" id="83"><next><block type="saltar1" id="81"><next><block type="saltar1" id="79"><next><block type="saltar1" id="77"><next><block type="saltar1" id="75"><next><block type="saltar1" id="73"><next><block type="saltar1" id="71"><next><block type="saltar1" id="69"><next><block type="saltar1" id="67"><next><block type="saltar1" id="65"><next><block type="saltar1" id="63"><next><block type="saltar1" id="61"><next><block type="saltar1" id="59"><next><block type="saltar1" id="57"><next><block type="saltar1" id="55"><next><block type="saltar1" id="51"><next><block type="saltar1" id="53"></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></statement></block></xml>'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'Da error al querer saltar más de 30 veces',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="1" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="4" inline="true"><value name="count"><block type="math_number" id="5"><field name="NUM">31</field></block></value><statement name="block"><block type="saltar1" id="7"></block></statement></block></statement></block></xml>',
		errorEsperado: '¡Uy! Salté mucho... ¡Me pasé!'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/NoMeCansoDeSaltar-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/NoMeCansoDeSaltar-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/NoMeCansoDeSaltar-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/PrendiendoLasCompus-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = 'PrendiendoLasCompus';

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="1" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="114"><mutation name="Prender hacia derecha"></mutation><next><block type="procedures_callnoreturn" id="120"><mutation name="Prender hacia abajo"></mutation><next><block type="procedures_callnoreturn" id="132"><mutation name="prender hacia izquierda"></mutation><next><block type="procedures_callnoreturn" id="126"><mutation name="prender hacia arriba"></mutation></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="32" x="263" y="32"><mutation></mutation><field name="NAME">Prender hacia derecha</field><statement name="STACK"><block type="MoverACasillaDerecha" id="202"><next><block type="hasta" id="60" inline="true"><value name="condition"><block type="Estoyenunaesquina" id="62"></block></value><statement name="block"><block type="Prendercompu" id="68"><next><block type="MoverACasillaDerecha" id="79"></block></next></block></statement></block></next></block></statement></block><block type="procedures_defnoreturn" id="44" x="10" y="172"><mutation></mutation><field name="NAME">prender hacia arriba</field><statement name="STACK"><block type="MoverACasillaArriba" id="208"><next><block type="hasta" id="147" inline="true"><value name="condition"><block type="Estoyenunaesquina" id="149"></block></value><statement name="block"><block type="Prendercompu" id="178"><next><block type="MoverACasillaArriba" id="172"></block></next></block></statement></block></next></block></statement></block><block type="procedures_defnoreturn" id="35" x="260" y="265"><mutation></mutation><field name="NAME">Prender hacia abajo</field><statement name="STACK"><block type="MoverACasillaAbajo" id="214"><next><block type="hasta" id="85" inline="true"><value name="condition"><block type="Estoyenunaesquina" id="91"></block></value><statement name="block"><block type="Prendercompu" id="108"><next><block type="MoverACasillaAbajo" id="97"></block></next></block></statement></block></next></block></statement></block><block type="procedures_defnoreturn" id="39" x="128" y="355"><mutation></mutation><field name="NAME">prender hacia izquierda</field><statement name="STACK"><block type="MoverACasillaIzquierda" id="221"><next><block type="hasta" id="154" inline="true"><value name="condition"><block type="Estoyenunaesquina" id="156"></block></value><statement name="block"><block type="Prendercompu" id="184"><next><block type="MoverACasillaIzquierda" id="195"></block></next></block></statement></block></next></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/PrendiendoLasCompus-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/PrendiendoLasCompus-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/PrendiendoLasCompus-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/PrendiendoLasCompusParametrizado-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = 'PrendiendoLasCompusParametrizado';

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="1" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="46" inline="true"><mutation name="Prender compus hacia"><arg name="direccion"></arg></mutation><value name="ARG0"><block type="ParaLaDerecha" id="61"></block></value><next><block type="procedures_callnoreturn" id="64" inline="true"><mutation name="Prender compus hacia"><arg name="direccion"></arg></mutation><value name="ARG0"><block type="ParaAbajo" id="72"></block></value><next><block type="procedures_callnoreturn" id="77" inline="true"><mutation name="Prender compus hacia"><arg name="direccion"></arg></mutation><value name="ARG0"><block type="ParaLaIzquierda" id="83"></block></value><next><block type="procedures_callnoreturn" id="92" inline="true"><mutation name="Prender compus hacia"><arg name="direccion"></arg></mutation><value name="ARG0"><block type="ParaArriba" id="89"></block></value></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="18" x="7" y="207"><mutation><arg name="direccion"></arg></mutation><field name="NAME">Prender compus hacia</field><statement name="STACK"><block type="MoverA" id="95" inline="true"><value name="direccion"><block type="param_get" id="99"><field name="VAR">direccion</field></block></value><next><block type="hasta" id="29" inline="true"><value name="condition"><block type="Estoyenunaesquina" id="31"></block></value><statement name="block"><block type="Prendercompu" id="41"><next><block type="MoverA" id="34" inline="true"><value name="direccion"><block type="param_get" id="38"><field name="VAR">direccion</field></block></value></block></next></block></statement></block></next></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/PrendiendoLasCompusParametrizado-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/PrendiendoLasCompusParametrizado-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/PrendiendoLasCompusParametrizado-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/PrendiendoLasFogatas-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

  var nombre = 'PrendiendoLasFogatas';

  (0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

  (0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
    solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="2" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="3" inline="true"><mutation name="Avanzar prendiendo hacia"><arg name="direccion"></arg></mutation><value name="ARG0"><block type="ParaLaDerecha" id="47"></block></value><next><block type="procedures_callnoreturn" id="4" inline="true"><mutation name="Avanzar prendiendo hacia"><arg name="direccion"></arg></mutation><value name="ARG0"><block type="ParaAbajo" id="65"></block></value><next><block type="procedures_callnoreturn" id="5" inline="true"><mutation name="Avanzar prendiendo hacia"><arg name="direccion"></arg></mutation><value name="ARG0"><block type="ParaLaIzquierda" id="53"></block></value><next><block type="procedures_callnoreturn" id="6" inline="true"><mutation name="Avanzar prendiendo hacia"><arg name="direccion"></arg></mutation><value name="ARG0"><block type="ParaArriba" id="77"></block></value></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="7" x="25" y="238"><mutation><arg name="direccion"></arg></mutation><field name="NAME">Avanzar prendiendo hacia</field><statement name="STACK"><block type="repetir" id="8" inline="true"><value name="count"><block type="math_number" id="9"><field name="NUM">6</field></block></value><statement name="block"><block type="procedures_callnoreturn" id="10" inline="true"><mutation name="Avanzar hacia"><arg name="direccion"></arg></mutation><value name="ARG0"><block type="param_get" id="11"><field name="VAR">direccion</field></block></value><next><block type="procedures_callnoreturn" id="12"><mutation name="Prender si hay fogata"></mutation></block></next></block></statement></block></statement></block><block type="procedures_defnoreturn" id="13" x="270" y="363"><mutation></mutation><field name="NAME">Prender si hay fogata</field><statement name="STACK"><block type="si" id="14" inline="true"><value name="condition"><block type="tocandoFogata" id="15"></block></value><statement name="block"><block type="Prenderfogata" id="16"></block></statement></block></statement></block><block type="procedures_defnoreturn" id="17" x="1" y="514"><mutation><arg name="direccion"></arg></mutation><field name="NAME">Avanzar hacia</field><statement name="STACK"><block type="si" id="18" inline="true"><value name="condition"><block type="logic_compare" id="19" inline="true"><field name="OP">EQ</field><value name="A"><block type="param_get" id="20"><field name="VAR">direccion</field></block></value><value name="B"><block type="ParaLaDerecha" id="93"></block></value></block></value><statement name="block"><block type="MoverACasillaDerecha" id="22"></block></statement><next><block type="si" id="23" inline="true"><value name="condition"><block type="logic_compare" id="24" inline="true"><field name="OP">EQ</field><value name="A"><block type="param_get" id="25"><field name="VAR">direccion</field></block></value><value name="B"><block type="ParaLaIzquierda" id="99"></block></value></block></value><statement name="block"><block type="MoverACasillaIzquierda" id="27"></block></statement><next><block type="si" id="28" inline="true"><value name="condition"><block type="logic_compare" id="29" inline="true"><field name="OP">EQ</field><value name="A"><block type="param_get" id="30"><field name="VAR">direccion</field></block></value><value name="B"><block type="ParaArriba" id="105"></block></value></block></value><statement name="block"><block type="MoverACasillaArriba" id="32"></block></statement><next><block type="si" id="33" inline="true"><value name="condition"><block type="logic_compare" id="34" inline="true"><field name="OP">EQ</field><value name="A"><block type="param_get" id="35"><field name="VAR">direccion</field></block></value><value name="B"><block type="ParaAbajo" id="111"></block></value></block></value><statement name="block"><block type="MoverACasillaAbajo" id="37"></block></statement></block></next></block></next></block></next></block></statement></block></xml>'
  });

  (0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
    descripcionAdicional: 'Da error al querer avanzar hacia la izquierda si no hay camino',
    solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="2" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="MoverACasillaIzquierda" id="32"></block></statement></block></xml>',
    errorEsperado: 'No puedo ir para la izquierda'
  });
});
define('pilas-engine-bloques/tests/integration/desafios/PrendiendoLasFogatas-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/PrendiendoLasFogatas-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/PrendiendoLasFogatas-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/ReparandoLaNave-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = 'ReparandoLaNave';

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="3" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="4" inline="true"><value name="count"><block type="math_number" id="5"><field name="NUM">3</field></block></value><statement name="block"><block type="procedures_callnoreturn" id="6"><mutation name="Buscar Hierro y volver"></mutation><next><block type="procedures_callnoreturn" id="7"><mutation name="Buscar Carbón y volver"></mutation></block></next></block></statement><next><block type="Escapar" id="8"></block></next></block></statement></block><block type="procedures_defnoreturn" id="9" x="344" y="6"><mutation></mutation><field name="NAME">Buscar Hierro y volver</field><statement name="STACK"><block type="repetir" id="10" inline="true"><value name="count"><block type="math_number" id="11"><field name="NUM">3</field></block></value><statement name="block"><block type="MoverACasillaArriba" id="12"></block></statement><next><block type="TomarHierro" id="13"><next><block type="repetir" id="14" inline="true"><value name="count"><block type="math_number" id="15"><field name="NUM">3</field></block></value><statement name="block"><block type="MoverACasillaAbajo" id="16"></block></statement><next><block type="Depositar" id="17"></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="18" x="35" y="199"><mutation></mutation><field name="NAME">Buscar Carbón y volver</field><statement name="STACK"><block type="repetir" id="19" inline="true"><value name="count"><block type="math_number" id="20"><field name="NUM">4</field></block></value><statement name="block"><block type="MoverACasillaDerecha" id="21"></block></statement><next><block type="repetir" id="22" inline="true"><value name="count"><block type="math_number" id="23"><field name="NUM">3</field></block></value><statement name="block"><block type="MoverACasillaArriba" id="24"></block></statement><next><block type="TomarCarbon" id="25"><next><block type="repetir" id="26" inline="true"><value name="count"><block type="math_number" id="27"><field name="NUM">3</field></block></value><statement name="block"><block type="MoverACasillaAbajo" id="28"></block></statement><next><block type="repetir" id="29" inline="true"><value name="count"><block type="math_number" id="30"><field name="NUM">4</field></block></value><statement name="block"><block type="MoverACasillaIzquierda" id="31"></block></statement><next><block type="Depositar" id="40"></block></next></block></next></block></next></block></next></block></next></block></statement></block></xml>'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'Da error al depositar cuando no tengo nada',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="25" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="Depositar" id="34"></block></statement></block></xml>',
		errorEsperado: 'No tengo nada en la mano'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/ReparandoLaNave-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/ReparandoLaNave-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/ReparandoLaNave-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/SalvandoLaNavidad-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = "SalvandoLaNavidad";

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="1" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="123" inline="true"><mutation name="dejar regalos en fila"><arg name="cant. casilleros"></arg></mutation><value name="ARG0"><block type="math_number" id="125"><field name="NUM">4</field></block></value><next><block type="SiguienteFila" id="79"><next><block type="procedures_callnoreturn" id="82" inline="true"><mutation name="dejar regalos en fila"><arg name="cant. casilleros"></arg></mutation><value name="ARG0"><block type="math_number" id="84"><field name="NUM">5</field></block></value><next><block type="SiguienteFila" id="88"><next><block type="procedures_callnoreturn" id="99" inline="true"><mutation name="dejar regalos en fila"><arg name="cant. casilleros"></arg></mutation><value name="ARG0"><block type="math_number" id="115"><field name="NUM">7</field></block></value><next><block type="SiguienteFila" id="96"><next><block type="procedures_callnoreturn" id="102" inline="true"><mutation name="dejar regalos en fila"><arg name="cant. casilleros"></arg></mutation><value name="ARG0"><block type="math_number" id="113"><field name="NUM">3</field></block></value><next><block type="SiguienteFila" id="92"><next><block type="procedures_callnoreturn" id="105" inline="true"><mutation name="dejar regalos en fila"><arg name="cant. casilleros"></arg></mutation><value name="ARG0"><block type="math_number" id="111"><field name="NUM">6</field></block></value></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="38" x="1" y="342"><mutation><arg name="cant. casilleros"></arg></mutation><field name="NAME">dejar regalos en fila</field><statement name="STACK"><block type="repetir" id="51" inline="true"><value name="count"><block type="param_get" id="56"><field name="VAR">cant. casilleros</field></block></value><statement name="block"><block type="MoverACasillaDerecha" id="60"></block></statement><next><block type="Dejarregalo" id="66"></block></next></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/SalvandoLaNavidad-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/SalvandoLaNavidad-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/SalvandoLaNavidad-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/SuperTito1-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = 'SuperTito1';

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="11" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="hasta" id="21" inline="true"><value name="condition"><block type="tocandoFinal" id="24"></block></value><statement name="block"><block type="EncenderLuz" id="27"><next><block type="MoverACasillaAbajo" id="30"></block></next></block></statement></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/SuperTito1-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/SuperTito1-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/SuperTito1-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/SuperTito2-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = 'SuperTito2';

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="76" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="hasta" id="77" inline="true"><value name="condition"><block type="tocandoFinal" id="78"></block></value><statement name="block"><block type="procedures_callnoreturn" id="79"><mutation name="Prender si hay luz"></mutation><next><block type="MoverACasillaAbajo" id="87"></block></next></block></statement></block></statement></block><block type="procedures_defnoreturn" id="81" x="-8" y="184"><mutation></mutation><field name="NAME">Prender si hay luz</field><statement name="STACK"><block type="si" id="82" inline="true"><value name="condition"><block type="tocandoLuz" id="83"></block></value><statement name="block"><block type="EncenderLuz" id="84"></block></statement></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/SuperTito2-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/SuperTito2-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/SuperTito2-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/TitoCuadrado-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = "TitoCuadrado";

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="13" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="14" inline="true"><mutation name="Prender luces hacia"><arg name="direccion"></arg></mutation><value name="ARG0"><block type="ParaLaDerecha" id="15"></block></value><next><block type="procedures_callnoreturn" id="20" inline="true"><mutation name="Prender luces hacia"><arg name="direccion"></arg></mutation><value name="ARG0"><block type="ParaAbajo" id="21"></block></value><next><block type="procedures_callnoreturn" id="16" inline="true"><mutation name="Prender luces hacia"><arg name="direccion"></arg></mutation><value name="ARG0"><block type="ParaLaIzquierda" id="17"></block></value><next><block type="procedures_callnoreturn" id="18" inline="true"><mutation name="Prender luces hacia"><arg name="direccion"></arg></mutation><value name="ARG0"><block type="ParaArriba" id="19"></block></value></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="22" x="0" y="196"><mutation><arg name="direccion"></arg></mutation><field name="NAME">Prender luces hacia</field><statement name="STACK"><block type="repetir" id="23" inline="true"><value name="count"><block type="math_number" id="24"><field name="NUM">6</field></block></value><statement name="block"><block type="MoverA" id="25" inline="true"><value name="direccion"><block type="param_get" id="26"><field name="VAR">direccion</field></block></value><next><block type="procedures_callnoreturn" id="27"><mutation name="Prender luz si hay"></mutation></block></next></block></statement></block></statement></block><block type="procedures_defnoreturn" id="28" x="2" y="363"><mutation></mutation><field name="NAME">Prender luz si hay</field><statement name="STACK"><block type="si" id="29" inline="true"><value name="condition"><block type="tocandoLuz" id="30"></block></value><statement name="block"><block type="EncenderLuz" id="31"></block></statement></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/TitoCuadrado-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/TitoCuadrado-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/TitoCuadrado-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/TitoEnciendeLasLuces-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = 'TitoEnciendeLuces';

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="45" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="MoverACasillaArriba" id="115"><next><block type="procedures_callnoreturn" id="59"><mutation name="encender diagonal"></mutation><next><block type="procedures_callnoreturn" id="144"><mutation name="acomodarse en la otra diagonal"></mutation><next><block type="procedures_callnoreturn" id="156"><mutation name="encender diagonal"></mutation></block></next></block></next></block></next></block></statement></block><block type="procedures_defnoreturn" id="56" x="22" y="172"><mutation></mutation><field name="NAME">encender diagonal</field><statement name="STACK"><block type="repetir" id="76" inline="true"><value name="count"><block type="math_number" id="77"><field name="NUM">3</field></block></value><statement name="block"><block type="EncenderLuz" id="65"><next><block type="MoverACasillaDerecha" id="86"><next><block type="MoverACasillaArriba" id="92"></block></next></block></next></block></statement><next><block type="EncenderLuz" id="98"></block></next></block></statement></block><block type="procedures_defnoreturn" id="109" x="22" y="380"><mutation></mutation><field name="NAME">acomodarse en la otra diagonal</field><statement name="STACK"><block type="repetir" id="122" inline="true"><value name="count"><block type="math_number" id="123"><field name="NUM">4</field></block></value><statement name="block"><block type="MoverACasillaAbajo" id="129"></block></statement><next><block type="MoverACasillaIzquierda" id="135"></block></next></block></statement></block></xml>'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/TitoEnciendeLasLuces-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/TitoEnciendeLasLuces-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/TitoEnciendeLasLuces-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/TitoRecargado-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = 'TitoRecargado';

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="2" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="13" inline="true"><value name="count"><block type="math_number" id="14"><field name="NUM">6</field></block></value><statement name="block"><block type="procedures_callnoreturn" id="25"><mutation name="Prender si es luz"></mutation><next><block type="MoverACasillaAbajo" id="22"></block></next></block></statement></block></statement></block><block type="procedures_defnoreturn" id="4" x="445" y="11"><mutation></mutation><field name="NAME">Prender si es luz</field><statement name="STACK"><block type="si" id="9" inline="true"><value name="condition"><block type="tocandoLuz" id="16"></block></value><statement name="block"><block type="EncenderLuz" id="19"></block></statement></block></statement></block></xml>'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'La actividad no está resuelta si no estoy al final',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="2" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="procedures_callnoreturn" id="60"><mutation name="Prender luz si esta apagada"></mutation><next><block type="repetir" id="45" inline="true"><value name="count"><block type="math_number" id="46"><field name="NUM">5</field></block></value><statement name="block"><block type="MoverACasillaAbajo" id="24"><next><block type="procedures_callnoreturn" id="38"><mutation name="Prender luz si esta apagada"></mutation></block></next></block></statement></block></next></block></statement></block><block type="procedures_defnoreturn" id="13" x="0" y="194"><mutation></mutation><field name="NAME">Prender luz si esta apagada</field><statement name="STACK"><block type="si" id="35" inline="true"><value name="condition"><block type="tocandoLuz" id="30"></block></value><statement name="block"><block type="EncenderLuz" id="5"></block></statement></block></statement></block></xml>',
		resuelveDesafio: false
	});
});
define('pilas-engine-bloques/tests/integration/desafios/TitoRecargado-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/TitoRecargado-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/TitoRecargado-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/desafios/TresNaranjas-test', ['exports', 'pilas-engine-bloques/tests/helpers/actividadTest'], function (exports, _pilasEngineBloquesTestsHelpersActividadTest) {

	var nombre = 'TresNaranjas';

	(0, _pilasEngineBloquesTestsHelpersActividadTest.moduloActividad)(nombre);

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="2" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="3" inline="true"><value name="count"><block type="math_number" id="4"><field name="NUM">3</field></block></value><statement name="block"><block type="MoverACasillaDerecha" id="5"><next><block type="si" id="6" inline="true"><value name="condition"><block type="TocandoNaranja" id="7"></block></value><statement name="block"><block type="ComerNaranja" id="8"></block></statement></block></next></block></statement></block></statement></block></xml>'
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'No debe marcar actividad resuelta si todavía no llegué al final',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="2" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="3" inline="true"><value name="count"><block type="math_number" id="4"><field name="NUM">2</field></block></value><statement name="block"><block type="MoverACasillaDerecha" id="5"><next><block type="si" id="6" inline="true"><value name="condition"><block type="TocandoNaranja" id="7"></block></value><statement name="block"><block type="ComerNaranja" id="8"></block></statement></block></next></block></statement></block></statement></block></xml>',
		resuelveDesafio: false
	});

	(0, _pilasEngineBloquesTestsHelpersActividadTest.actividadTest)(nombre, {
		descripcionAdicional: 'Da error al querer avanzar hacia la derecha cuando ya no hay camino',
		solucion: '<xml xmlns="http://www.w3.org/1999/xhtml"><block type="al_empezar_a_ejecutar" id="2" deletable="false" movable="false" editable="false" x="0" y="0"><statement name="program"><block type="repetir" id="3" inline="true"><value name="count"><block type="math_number" id="4"><field name="NUM">4</field></block></value><statement name="block"><block type="MoverACasillaDerecha" id="5"><next><block type="si" id="6" inline="true"><value name="condition"><block type="TocandoNaranja" id="7"></block></value><statement name="block"><block type="ComerNaranja" id="8"></block></statement></block></next></block></statement></block></statement></block></xml>',
		errorEsperado: 'No puedo ir para la derecha'
	});
});
define('pilas-engine-bloques/tests/integration/desafios/TresNaranjas-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/desafios/TresNaranjas-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/desafios/TresNaranjas-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/ejerciciosPilas/Casilla-test', ['exports', 'ember-qunit', 'pilas-engine-bloques/tests/helpers/ejerciciosPilasTest', 'pilas-engine-bloques/tests/helpers/createPilasTest'], function (exports, _emberQunit, _pilasEngineBloquesTestsHelpersEjerciciosPilasTest, _pilasEngineBloquesTestsHelpersCreatePilasTest) {

  var nombre = 'Casilla';

  (0, _pilasEngineBloquesTestsHelpersEjerciciosPilasTest.moduloEjerciciosPilas)(nombre);

  (0, _emberQunit.test)('propiedades', function (assert) {
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var Cuadricula = pilasService.evaluar("Cuadricula");
      var cuadricula = new Cuadricula(0, 0, 3, 5, { alto: 300, ancho: 200 }, { grilla: 'invisible.png', cantColumnas: 1 });

      var casilla = cuadricula.casilla(1, 2);
      var casilla2 = cuadricula.casilla(0, 0);
      cuadricula.setAlto(150);
      cuadricula.setAncho(100);

      assert.equal(casilla.alto, 50, 'resizea alto bien');
      assert.equal(casilla.ancho, 20, 'resizea ancho bien');
      assert.equal(casilla.x, 0, 'reposiciona x bien cuando es 0');
      assert.equal(casilla.y, 0, 'reposiciona y bien cuando es 0');
      assert.equal(casilla2.x, -40, 'reposiciona x bien');
      assert.equal(casilla2.y, 50, 'reposiciona y bien');
      resolve();
    });
  });
});
define('pilas-engine-bloques/tests/integration/ejerciciosPilas/Casilla-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/ejerciciosPilas/Casilla-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/ejerciciosPilas/Casilla-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/ejerciciosPilas/Cuadricula-test', ['exports', 'ember-qunit', 'pilas-engine-bloques/tests/helpers/ejerciciosPilasTest', 'pilas-engine-bloques/tests/helpers/createPilasTest'], function (exports, _emberQunit, _pilasEngineBloquesTestsHelpersEjerciciosPilasTest, _pilasEngineBloquesTestsHelpersCreatePilasTest) {

  var nombre = 'Cuadricula';

  (0, _pilasEngineBloquesTestsHelpersEjerciciosPilasTest.moduloEjerciciosPilas)(nombre);

  /**
   * Preparar cuadricula y actores para los tests de este archivo
   *
   * @return diccionario con todos los elementos de la escena
   */
  function prepararEscena(pilas, pilasService) {
    var escena = {};
    var Cuadricula = pilasService.evaluar("Cuadricula");
    var AlienAnimado = pilasService.evaluar("AlienAnimado");
    escena.cuadricula = new Cuadricula(0, 0, 3, 5, { alto: 300, ancho: 200 }, { grilla: 'invisible.png', cantColumnas: 1 });

    escena.actor1 = new AlienAnimado(0, 0);
    escena.actor2 = new AlienAnimado(0, 0);
    escena.actor3 = new AlienAnimado(0, 0);

    return escena;
  }

  (0, _emberQunit.test)('Set Ancho', function (assert) {
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var escena = prepararEscena(pilas, pilasService);

      escena.cuadricula.setAncho(100);
      assert.equal(escena.cuadricula.ancho, 100);
      assert.equal(escena.cuadricula.casilla(0, 0).ancho, 20);
      assert.equal(escena.cuadricula.casilla(0, 0).alto, 100);
      resolve();
    });
  });

  (0, _emberQunit.test)('Set Alto', function (assert) {
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var escena = prepararEscena(pilas, pilasService);

      escena.cuadricula.setAlto(600);
      assert.equal(escena.cuadricula.alto, 600);
      assert.equal(escena.cuadricula.casilla(0, 0).ancho, 40);
      assert.equal(escena.cuadricula.casilla(0, 0).alto, 200);
      resolve();
    });
  });

  (0, _emberQunit.test)('Colisionan', function (assert) {
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var escena = prepararEscena(pilas, pilasService);

      escena.cuadricula.agregarActor(escena.actor1, 0, 0);
      escena.cuadricula.agregarActor(escena.actor2, 0, 0);
      escena.cuadricula.agregarActor(escena.actor3, 0, 1);

      assert.equal(escena.cuadricula.colisionan(escena.actor1, escena.actor2), true);
      assert.equal(escena.cuadricula.colisionan(escena.actor2, escena.actor1), true);
      assert.equal(escena.cuadricula.colisionan(escena.actor1, escena.actor3), false);
      assert.equal(escena.cuadricula.colisionan(escena.actor3, escena.actor1), false);
      assert.equal(escena.cuadricula.colisionan(escena.actor3, escena.actor2), false);
      assert.equal(escena.cuadricula.colisionan(escena.actor2, escena.actor3), false);
      resolve();
    });
  });

  (0, _emberQunit.test)('Casilla', function (assert) {
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var escena = prepararEscena(pilas, pilasService);

      assert.equal(escena.cuadricula.casilla(0, 0) !== escena.cuadricula.casilla(0, 1), true, 'son distintas');
      assert.equal(escena.cuadricula.casilla(0, 0).nroFila, 0);
      assert.equal(escena.cuadricula.casilla(0, 0).nroColumna, 0);
      assert.equal(escena.cuadricula.casilla(0, 1).nroFila, 0);
      assert.equal(escena.cuadricula.casilla(0, 1).nroColumna, 1);
      assert.equal(escena.cuadricula.casilla(1, 1).nroColumna, 1);
      assert.equal(escena.cuadricula.casilla(1, 1).nroFila, 1);
      resolve();
    });
  });

  (0, _emberQunit.test)('Constructor', function (assert) {
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var escena = prepararEscena(pilas, pilasService);

      assert.equal(escena.cuadricula.casillas.length, 3 * 5, 'tiene la cantidad de casillas que debe');

      function estaFueraRango(casillas, index, filas, cols) {
        return casillas[index].nroFila < 0 || casillas[index].nroFila >= filas || casillas[index].nroColumna < 0 && casillas[index].nroColumna >= cols;
      }

      function sonLaMismaCasilla(casillas, i, j) {
        return casillas[i].nroFila === casillas[j].nroFila && casillas[i].nroColumna === casillas[j].nroColumna;
      }

      function todasCoordenadasDistintasEInRange(casillas, cantFilas, cantColumnas) {
        for (var i = 0; i < casillas.size; i++) {

          if (estaFueraRango(casillas, i, cantFilas, cantColumnas)) {
            return false;
          }

          for (var j = i; j < casillas.size; j++) {
            if (sonLaMismaCasilla(casillas, i, j)) {
              return false;
            }
          }
        }

        return true;
      }

      assert.equal(todasCoordenadasDistintasEInRange(escena.cuadricula.casillas, 3, 5), true, 'todas las casillas tienen coordenadas distintas e in_range');
      resolve();
    });
  });

  (0, _emberQunit.test)('Mover a la casilla derecha', function (assert) {
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var escena = prepararEscena(pilas, pilasService);

      var MoverACasillaDerecha = pilasService.evaluar("MoverACasillaDerecha");

      escena.cuadricula.agregarActor(escena.actor1, 0, 0);
      var x = escena.actor1.x;
      var y = escena.actor1.y;

      (0, _pilasEngineBloquesTestsHelpersEjerciciosPilasTest.hacerLuegoConCallback)(escena.actor1, MoverACasillaDerecha, {}, function () {
        assert.equal(escena.actor1.x, x + escena.cuadricula.casilla(0, 0).ancho, 'Movi a la derecha bien');
        assert.equal(escena.actor1.y, y, 'Me mantuve en altura');
        assert.equal(escena.actor1.casillaActual(), escena.cuadricula.casilla(0, 1), 'Mi casillaActual es la correspondiente');
        resolve();
      });
    });
  });

  (0, _emberQunit.test)('Mover a la casilla izquierda', function (assert) {
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var escena = prepararEscena(pilas, pilasService);

      var MoverACasillaIzquierda = pilasService.evaluar("MoverACasillaIzquierda");

      escena.cuadricula.agregarActor(escena.actor1, 0, 1);
      var x = escena.actor1.x;
      var y = escena.actor1.y;

      (0, _pilasEngineBloquesTestsHelpersEjerciciosPilasTest.hacerLuegoConCallback)(escena.actor1, MoverACasillaIzquierda, {}, function () {
        assert.equal(escena.actor1.x, x - escena.cuadricula.casilla(0, 0).ancho, 'Movi a la izquierda bien');
        assert.equal(escena.actor1.y, y, 'Me mantuve en altura');
        assert.equal(escena.actor1.casillaActual(), escena.cuadricula.casilla(0, 0), 'Mi casillaActual es la correspondiente');
        resolve();
      });
    });
  });

  (0, _emberQunit.test)('Mover a casilla abajo', function (assert) {
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var escena = prepararEscena(pilas, pilasService);

      var MoverACasillaAbajo = pilasService.evaluar("MoverACasillaAbajo");

      escena.cuadricula.agregarActor(escena.actor1, 1, 0);
      var x = escena.actor1.x;
      var y = escena.actor1.y;

      (0, _pilasEngineBloquesTestsHelpersEjerciciosPilasTest.hacerLuegoConCallback)(escena.actor1, MoverACasillaAbajo, {}, function () {
        assert.equal(escena.actor1.y, y - escena.cuadricula.casilla(0, 0).alto, 'Movi abajo bien');
        assert.equal(escena.actor1.x, x, 'Me mantuve en eje x');
        assert.equal(escena.actor1.casillaActual(), escena.cuadricula.casilla(2, 0), 'Mi casillaActual es la correspondiente');
        resolve();
      });
    });
  });

  (0, _emberQunit.test)('Mover a casilla arriba', function (assert) {
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var escena = prepararEscena(pilas, pilasService);

      var MoverACasillaArriba = pilasService.evaluar("MoverACasillaArriba");

      escena.cuadricula.agregarActor(escena.actor1, 1, 0);
      var x = escena.actor1.x;
      var y = escena.actor1.y;

      (0, _pilasEngineBloquesTestsHelpersEjerciciosPilasTest.hacerLuegoConCallback)(escena.actor1, MoverACasillaArriba, {}, function () {
        assert.equal(escena.actor1.y, y + escena.cuadricula.casilla(0, 0).alto, 'Movi arriba bien');
        assert.equal(escena.actor1.x, x, 'Me mantuve en eje x');
        assert.equal(escena.actor1.casillaActual(), escena.cuadricula.casilla(0, 0), 'Mi casillaActual es la correspondiente');
        resolve();
      });
    });
  });
});
define('pilas-engine-bloques/tests/integration/ejerciciosPilas/Cuadricula-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/ejerciciosPilas/Cuadricula-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/ejerciciosPilas/Cuadricula-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/ejerciciosPilas/CuadriculaEsparsa-test', ['exports', 'ember-qunit', 'pilas-engine-bloques/tests/helpers/ejerciciosPilasTest', 'pilas-engine-bloques/tests/helpers/createPilasTest'], function (exports, _emberQunit, _pilasEngineBloquesTestsHelpersEjerciciosPilasTest, _pilasEngineBloquesTestsHelpersCreatePilasTest) {

  var nombre = 'Cuadricula Esparsa';

  (0, _pilasEngineBloquesTestsHelpersEjerciciosPilasTest.moduloEjerciciosPilas)(nombre);

  (0, _emberQunit.test)('Constructor', function (assert) {
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var CuadriculaEsparsa = pilasService.evaluar("CuadriculaEsparsa");

      var matriz = [['T', 'T', 'T', 'T', 'T', 'T'], ['T', 'F', 'F', 'F', 'F', 'T'], ['T', 'T', 'T', 'T', 'T', 'T'], ['T', 'F', 'F', 'F', 'F', 'T'], ['T', 'T', 'T', 'T', 'T', 'T']];

      var cuadricula = new CuadriculaEsparsa(0, 0, { alto: 100 }, { grilla: 'invisible.png', cantColumnas: 1 }, matriz);
      assert.ok(cuadricula.casillas.length === 22);
      resolve();
    });
  });

  (0, _emberQunit.test)('Direcciones', function (assert) {
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var CuadriculaEsparsa = pilasService.evaluar("CuadriculaEsparsa");

      var matriz = [['T', 'T', 'T', 'T', 'T', 'T'], ['T', 'F', 'F', 'F', 'F', 'T'], ['T', 'T', 'T', 'T', 'T', 'T'], ['T', 'F', 'F', 'F', 'F', 'T'], ['T', 'T', 'T', 'T', 'T', 'T']];

      var cuadricula = new CuadriculaEsparsa(0, 0, { alto: 100 }, { grilla: 'invisible.png', cantColumnas: 1 }, matriz);

      /*Cuatro esquinas*/
      //izquierda arriba
      var casilla = cuadricula.casilla(0, 0);
      assert.ok(!cuadricula.hayArriba(casilla));
      assert.ok(cuadricula.hayAbajo(casilla));
      assert.ok(!cuadricula.hayIzquierda(casilla));
      assert.ok(cuadricula.hayDerecha(casilla));

      //izquierda abajo
      casilla = cuadricula.casilla(4, 0);
      assert.ok(cuadricula.hayArriba(casilla));
      assert.ok(!cuadricula.hayAbajo(casilla));
      assert.ok(!cuadricula.hayIzquierda(casilla));
      assert.ok(cuadricula.hayDerecha(casilla));

      //derecha arriba
      casilla = cuadricula.casilla(0, 5);
      assert.ok(!cuadricula.hayArriba(casilla));
      assert.ok(cuadricula.hayAbajo(casilla));
      assert.ok(cuadricula.hayIzquierda(casilla));
      assert.ok(!cuadricula.hayDerecha(casilla));

      //derecha abajo
      casilla = cuadricula.casilla(4, 5);
      assert.ok(cuadricula.hayArriba(casilla));
      assert.ok(!cuadricula.hayAbajo(casilla));
      assert.ok(cuadricula.hayIzquierda(casilla));
      assert.ok(!cuadricula.hayDerecha(casilla));

      casilla = cuadricula.casilla(1, 0);
      //assert.equal(cuadricula.hayIzquierda(casilla),false);
      assert.ok(cuadricula.hayArriba(casilla));
      assert.ok(cuadricula.hayAbajo(casilla));
      assert.ok(!cuadricula.hayIzquierda(casilla));
      assert.ok(!cuadricula.hayDerecha(casilla));

      casilla = cuadricula.casilla(2, 2);
      //assert.equal(cuadricula.hayIzquierda(casilla),false);
      assert.ok(!cuadricula.hayArriba(casilla));
      assert.ok(!cuadricula.hayAbajo(casilla));
      assert.ok(cuadricula.hayIzquierda(casilla));
      assert.ok(cuadricula.hayDerecha(casilla));

      resolve();
    });
  });
});
define('pilas-engine-bloques/tests/integration/ejerciciosPilas/CuadriculaEsparsa-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/ejerciciosPilas/CuadriculaEsparsa-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/ejerciciosPilas/CuadriculaEsparsa-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/ejerciciosPilas/Estado-test', ['exports', 'ember-qunit', 'pilas-engine-bloques/tests/helpers/ejerciciosPilasTest', 'pilas-engine-bloques/tests/helpers/createPilasTest'], function (exports, _emberQunit, _pilasEngineBloquesTestsHelpersEjerciciosPilasTest, _pilasEngineBloquesTestsHelpersCreatePilasTest) {

  var nombre = 'Estado';

  (0, _pilasEngineBloquesTestsHelpersEjerciciosPilasTest.moduloEjerciciosPilas)(nombre);

  (0, _emberQunit.test)('Agregar Transicion', function (assert) {
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var Estado = pilasService.evaluar("Estado");
      var EstadoConTransicion = pilasService.evaluar("EstadoConTransicion");
      var e2 = new Estado('id2');
      var e = new EstadoConTransicion('id');
      e.agregarTransicion(e2, 'transi');
      assert.equal(e.transiciones['transi']['estadoEntrada'], e2, "Por la etiqueta llego a destino");
      resolve();
    });
  });

  (0, _emberQunit.test)('Constructor', function (assert) {
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var EstadoConTransicion = pilasService.evaluar("EstadoConTransicion");
      var e = new EstadoConTransicion('id');

      assert.equal(Object.keys(e.transiciones).length, 0);
      assert.equal(e.identifier, 'id');
      resolve();
    });
  });
});
define('pilas-engine-bloques/tests/integration/ejerciciosPilas/Estado-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/ejerciciosPilas/Estado-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/ejerciciosPilas/Estado-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/integration/ejerciciosPilas/StatePattern-test', ['exports', 'ember-qunit', 'pilas-engine-bloques/tests/helpers/ejerciciosPilasTest', 'pilas-engine-bloques/tests/helpers/createPilasTest'], function (exports, _emberQunit, _pilasEngineBloquesTestsHelpersEjerciciosPilasTest, _pilasEngineBloquesTestsHelpersCreatePilasTest) {

  var nombre = 'State Pattern';

  (0, _pilasEngineBloquesTestsHelpersEjerciciosPilasTest.moduloEjerciciosPilas)(nombre);

  (0, _emberQunit.test)('Agregar Estado', function (assert) {
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var BuilderStatePattern = pilasService.evaluar("BuilderStatePattern");
      var builder = new BuilderStatePattern('inicial');
      builder.agregarEstado('estado1');
      assert.equal(builder.estados['estado1'].identifier, 'estado1', 'El estado que se agrega tiene el id correspondiente');
      assert.equal(Object.keys(builder.estados['estado1'].transiciones).length, 0, 'El nuevo estado no tiene transiciones');
      resolve();
    });
  });

  (0, _emberQunit.test)('Agregar Transicion', function (assert) {
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var BuilderStatePattern = pilasService.evaluar("BuilderStatePattern");
      var builder = new BuilderStatePattern('inicial');
      builder.agregarEstado('e1');
      builder.agregarEstado('e2');
      builder.agregarTransicion('e1', 'e2', 'transi');
      assert.equal(builder.estados['e1'].transiciones['transi']['estadoEntrada'], builder.estados['e2']);
      resolve();
    });
  });

  (0, _emberQunit.test)('Agregar Error', function (assert) {
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var BuilderStatePattern = pilasService.evaluar("BuilderStatePattern");
      var builder = new BuilderStatePattern('inicial');
      builder.agregarError('inicial', 'instalar', 'Primero hay que prender la computadora');
      assert.equal(builder.estados['inicial'].transiciones['instalar']['estadoEntrada'].mensajeError, 'Primero hay que prender la computadora');
      assert.equal(builder.estados['inicial'].transiciones['instalar']['estadoEntrada'].estadoAlQueVuelve, builder.estados['inicial']);
      resolve();
    });
  });

  (0, _emberQunit.test)('Agregar estados prefijados', function (assert) {
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var BuilderStatePattern = pilasService.evaluar("BuilderStatePattern");
      var builder = new BuilderStatePattern('inicial');
      builder.agregarEstadosPrefijados('prendido', 1, 3);
      assert.notEqual(builder.estados['prendido1'], undefined, "Lo que se agrega es lo prefijado");
      assert.notEqual(builder.estados['prendido2'], undefined, "Lo que se agrega es lo prefijado");
      assert.notEqual(builder.estados['prendido3'], undefined, "Lo que se agrega es lo prefijado");
      resolve();
    });
  });

  (0, _emberQunit.test)('Estado Inicial (construir state pattern)', function (assert) {
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var BuilderStatePattern = pilasService.evaluar("BuilderStatePattern");
      var builder = new BuilderStatePattern('inicial');
      assert.equal(builder.estadoInicial(), builder.estados['inicial']);
      resolve();
    });
  });

  (0, _emberQunit.test)('Agregar error a varios estados de salida', function (assert) {
    /*Caso de test donde, para tres estados prefijados e1, e2 y e3,
    se agregan con una instruccion transiciones con la etiqueta
    'transiError' a un estado de error con el mensaje 'te equivocaste'
    */
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var BuilderStatePattern = pilasService.evaluar("BuilderStatePattern");
      var builder = new BuilderStatePattern('inicial');
      builder.agregarEstadosPrefijados('e', 1, 3);
      builder.agregarErrorAVariosEstadosDeSalida('e', 'transiError', 'te equivocaste', 1, 3);
      assert.equal(builder.estados['e1'].transiciones['transiError']['estadoEntrada'].estadoAlQueVuelve, builder.estados['e1'], "El estado al que vuelve es correcto");
      assert.equal(builder.estados['e2'].transiciones['transiError']['estadoEntrada'].estadoAlQueVuelve, builder.estados['e2'], "El estado al que vuelve es correcto");
      assert.equal(builder.estados['e3'].transiciones['transiError']['estadoEntrada'].estadoAlQueVuelve, builder.estados['e3'], "El estado al que vuelve es correcto");
      assert.equal(builder.estados['e1'].transiciones['transiError']['estadoEntrada'].mensajeError, 'te equivocaste', "Los mensajes de error son correctos");
      assert.equal(builder.estados['e2'].transiciones['transiError']['estadoEntrada'].mensajeError, 'te equivocaste', "Los mensajes de error son correctos");
      assert.equal(builder.estados['e3'].transiciones['transiError']['estadoEntrada'].mensajeError, 'te equivocaste', "Los mensajes de error son correctos");
      resolve();
    });
  });

  (0, _emberQunit.test)('Agregar transiciones iteradas', function (assert) {
    /* Dados estados a1, a2, a3, b1, b2, b3, buscamos con una
    instrucción generar transiciones con etiqueta 't'
    de a_i a b_i 0<i<4
    */
    return (0, _pilasEngineBloquesTestsHelpersCreatePilasTest['default'])(this, 'EscenaTests', function (pilas, resolve, pilasService) {
      var BuilderStatePattern = pilasService.evaluar("BuilderStatePattern");
      var builder = new BuilderStatePattern('inicial');
      builder.agregarEstadosPrefijados('a', 1, 3);
      builder.agregarEstadosPrefijados('b', 1, 3);
      builder.agregarTransicionesIteradas('a', 'b', 't', 1, 3, 1, 3);
      assert.equal(builder.estados['a1'].transiciones['t']['estadoEntrada'].identifier, 'b1');
      assert.equal(builder.estados['a2'].transiciones['t']['estadoEntrada'].identifier, 'b2');
      assert.equal(builder.estados['a3'].transiciones['t']['estadoEntrada'].identifier, 'b3');
      resolve();
    });
  });
});
define('pilas-engine-bloques/tests/integration/ejerciciosPilas/StatePattern-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | integration/ejerciciosPilas/StatePattern-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'integration/ejerciciosPilas/StatePattern-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/models/desafio.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | models/desafio.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'models/desafio.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/models/grupo.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | models/grupo.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'models/grupo.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/page-object', ['exports', 'pilas-engine-bloques/tests/page-object/create', 'pilas-engine-bloques/tests/page-object/collection', 'pilas-engine-bloques/tests/page-object/properties/attribute', 'pilas-engine-bloques/tests/page-object/properties/click-on-text', 'pilas-engine-bloques/tests/page-object/properties/clickable', 'pilas-engine-bloques/tests/page-object/properties/component', 'pilas-engine-bloques/tests/page-object/properties/contains', 'pilas-engine-bloques/tests/page-object/properties/count', 'pilas-engine-bloques/tests/page-object/properties/custom-helper', 'pilas-engine-bloques/tests/page-object/properties/fillable', 'pilas-engine-bloques/tests/page-object/properties/has-class', 'pilas-engine-bloques/tests/page-object/properties/is-hidden', 'pilas-engine-bloques/tests/page-object/properties/is-visible', 'pilas-engine-bloques/tests/page-object/properties/not-has-class', 'pilas-engine-bloques/tests/page-object/properties/text', 'pilas-engine-bloques/tests/page-object/properties/text-list', 'pilas-engine-bloques/tests/page-object/properties/value', 'pilas-engine-bloques/tests/page-object/properties/visitable'], function (exports, _pilasEngineBloquesTestsPageObjectCreate, _pilasEngineBloquesTestsPageObjectCollection, _pilasEngineBloquesTestsPageObjectPropertiesAttribute, _pilasEngineBloquesTestsPageObjectPropertiesClickOnText, _pilasEngineBloquesTestsPageObjectPropertiesClickable, _pilasEngineBloquesTestsPageObjectPropertiesComponent, _pilasEngineBloquesTestsPageObjectPropertiesContains, _pilasEngineBloquesTestsPageObjectPropertiesCount, _pilasEngineBloquesTestsPageObjectPropertiesCustomHelper, _pilasEngineBloquesTestsPageObjectPropertiesFillable, _pilasEngineBloquesTestsPageObjectPropertiesHasClass, _pilasEngineBloquesTestsPageObjectPropertiesIsHidden, _pilasEngineBloquesTestsPageObjectPropertiesIsVisible, _pilasEngineBloquesTestsPageObjectPropertiesNotHasClass, _pilasEngineBloquesTestsPageObjectPropertiesText, _pilasEngineBloquesTestsPageObjectPropertiesTextList, _pilasEngineBloquesTestsPageObjectPropertiesValue, _pilasEngineBloquesTestsPageObjectPropertiesVisitable) {
  exports['default'] = {
    attribute: _pilasEngineBloquesTestsPageObjectPropertiesAttribute['default'],
    build: _pilasEngineBloquesTestsPageObjectCreate.build,
    clickOnText: _pilasEngineBloquesTestsPageObjectPropertiesClickOnText['default'],
    clickable: _pilasEngineBloquesTestsPageObjectPropertiesClickable['default'],
    collection: _pilasEngineBloquesTestsPageObjectCollection.collection,
    component: _pilasEngineBloquesTestsPageObjectPropertiesComponent['default'],
    contains: _pilasEngineBloquesTestsPageObjectPropertiesContains['default'],
    count: _pilasEngineBloquesTestsPageObjectPropertiesCount['default'],
    create: _pilasEngineBloquesTestsPageObjectCreate.create,
    customHelper: _pilasEngineBloquesTestsPageObjectPropertiesCustomHelper['default'],
    fillable: _pilasEngineBloquesTestsPageObjectPropertiesFillable['default'],
    hasClass: _pilasEngineBloquesTestsPageObjectPropertiesHasClass['default'],
    isHidden: _pilasEngineBloquesTestsPageObjectPropertiesIsHidden['default'],
    isVisible: _pilasEngineBloquesTestsPageObjectPropertiesIsVisible['default'],
    notHasClass: _pilasEngineBloquesTestsPageObjectPropertiesNotHasClass['default'],
    selectable: _pilasEngineBloquesTestsPageObjectPropertiesFillable['default'],
    text: _pilasEngineBloquesTestsPageObjectPropertiesText['default'],
    textList: _pilasEngineBloquesTestsPageObjectPropertiesTextList['default'],
    value: _pilasEngineBloquesTestsPageObjectPropertiesValue['default'],
    visitable: _pilasEngineBloquesTestsPageObjectPropertiesVisitable['default']
  };
});
define('pilas-engine-bloques/tests/page-object/collection', ['exports', 'ember', 'pilas-engine-bloques/tests/page-object/descriptor', 'pilas-engine-bloques/tests/page-object/create', 'pilas-engine-bloques/tests/page-object/properties/count', 'pilas-engine-bloques/tests/page-object/helpers'], function (exports, _ember, _pilasEngineBloquesTestsPageObjectDescriptor, _pilasEngineBloquesTestsPageObjectCreate, _pilasEngineBloquesTestsPageObjectPropertiesCount, _pilasEngineBloquesTestsPageObjectHelpers) {
  exports.collection = collection;

  var copy = _ember['default'].copy;

  function isNullOrUndefined(value) {
    return typeof value === 'undefined' || value === null;
  }

  function scopeWithIndex(base, index) {
    return base + ':eq(' + (index - 1) + ')';
  }

  function extract(object, name) {
    var attribute = object[name];

    delete object[name];

    return attribute;
  }

  function preProcess(target, key, options) {
    var definition = extract(options, 'definition');

    // don't mutate original definition
    definition = copy(definition);

    options.itemDefinition = extract(definition, 'item');
    options.itemScope = extract(definition, 'itemScope');

    if (isNullOrUndefined(definition.scope)) {
      definition.scope = target.scope;
    }

    options.scope = definition.scope;

    if (!definition.count) {
      definition.count = (0, _pilasEngineBloquesTestsPageObjectPropertiesCount['default'])(options.itemScope);
    }

    options.collectionComponent = definition;
  }

  function getCollection(target, key, options, index) {
    var component = undefined;

    if (index === 0) {
      throw new Error('ember-cli-page-object collections are 1-based arrays. Use index 1 to access the first item.');
    }

    if (index) {
      if (target.__forceScopeToChildren) {
        options.scope = target.scope;
      }

      component = copy(options.itemDefinition);
      component.scope = (0, _pilasEngineBloquesTestsPageObjectHelpers.qualifySelector)(options.scope, scopeWithIndex(options.itemScope, index));
      component.__forceScopeToChildren = true;
      component = (0, _pilasEngineBloquesTestsPageObjectCreate.create)(component);
    } else {
      if (target.__forceScopeToChildren) {
        options.collectionComponent.scope = target.scope;
      }

      component = (0, _pilasEngineBloquesTestsPageObjectCreate.create)(options.collectionComponent);
    }

    return component;
  }

  function collection(definition) {
    var options = { definition: copy(definition) };

    return new _pilasEngineBloquesTestsPageObjectDescriptor['default'](getCollection, options, preProcess);
  }
});
define('pilas-engine-bloques/tests/page-object/create', ['exports', 'ember', 'pilas-engine-bloques/tests/page-object/properties/is-hidden', 'pilas-engine-bloques/tests/page-object/properties/is-visible', 'pilas-engine-bloques/tests/page-object/properties/click-on-text', 'pilas-engine-bloques/tests/page-object/properties/clickable', 'pilas-engine-bloques/tests/page-object/properties/contains', 'pilas-engine-bloques/tests/page-object/properties/text'], function (exports, _ember, _pilasEngineBloquesTestsPageObjectPropertiesIsHidden, _pilasEngineBloquesTestsPageObjectPropertiesIsVisible, _pilasEngineBloquesTestsPageObjectPropertiesClickOnText, _pilasEngineBloquesTestsPageObjectPropertiesClickable, _pilasEngineBloquesTestsPageObjectPropertiesContains, _pilasEngineBloquesTestsPageObjectPropertiesText) {
  exports.create = create;
  exports.build = build;
  var $ = _ember['default'].$;

  function Node() {
    this.isHidden = (0, _pilasEngineBloquesTestsPageObjectPropertiesIsHidden['default'])().propertyFor(this, 'isHidden');
    this.isVisible = (0, _pilasEngineBloquesTestsPageObjectPropertiesIsVisible['default'])().propertyFor(this, 'isVisible');
    this.clickOn = (0, _pilasEngineBloquesTestsPageObjectPropertiesClickOnText['default'])().propertyFor(this, 'clickOn');
    this.click = (0, _pilasEngineBloquesTestsPageObjectPropertiesClickable['default'])().propertyFor(this, 'click');
    this.contains = (0, _pilasEngineBloquesTestsPageObjectPropertiesContains['default'])().propertyFor(this, 'contains');
    this.text = (0, _pilasEngineBloquesTestsPageObjectPropertiesText['default'])().propertyFor(this, 'text');
  }

  Node.prototype.then = function () {
    var _wait;

    return (_wait = wait()).then.apply(_wait, arguments);
  };

  Node.prototype.toFunction = function () {
    var tmp = buildPageObject(this);

    return function () {
      return tmp;
    };
  };

  /**
   * Converts properties of type `component` to plain objects (`component` is
   * mantained for backwards compatibility)
   *
   * @param [Object] definition - The definition to pre-process
   * @return [Object] A new pre-processed representation of definition
   */
  function preProcess(definition) {
    var node = {},
        keys = Object.keys(definition);

    keys.forEach(function (key) {
      var attr = definition[key];

      if (attr && attr.unfoldPageObjectDefinition) {
        attr = attr.unfoldPageObjectDefinition();
      }

      if ($.isPlainObject(attr)) {
        node[key] = preProcess(attr);
      } else {
        node[key] = attr;
      }
    });

    return node;
  }

  function setScopes(definition) {
    var keys = Object.keys(definition);

    keys.forEach(function (key) {
      var attr = definition[key];

      if ($.isPlainObject(attr)) {

        if (definition.__forceScopeToChildren) {
          attr.scope = [definition.scope, attr.scope].join(' ');
        } else if (typeof attr.scope === 'undefined' && typeof definition.scope !== 'undefined') {
          attr.scope = definition.scope;
        }

        setScopes(attr);
      }
    });

    return definition;
  }

  /**
   * Creates a tree of `Node`s and `Property`s
   *
   * @param [Object] definition - The definition of the page object
   * @return [Node] A new tree representation of the page object
   */
  function buildTree(definition) {
    var keys = Object.keys(definition),
        root = new Node();

    keys.forEach(function (key) {
      var attr = definition[key];

      if (typeof attr === 'undefined') {
        // continue
      } else if (attr.propertyFor) {
          root[key] = attr.propertyFor(root, key);
        } else if ($.isPlainObject(attr)) {
          root[key] = buildTree(attr);
        } else {
          root[key] = attr;
        }
    });

    return root;
  }

  /**
   * Makes everything invokable (toFunction) but keeps a reference to the tree
   * structure to allow instrospection.
   *
   * @param [Node] definition - The page object definition
   * @return [Node] The representation of the page object
   */
  function buildPageObject(definition) {
    var keys = Object.keys(definition);

    keys.forEach(function (key) {
      var attr = definition[key];

      if (typeof attr === 'undefined') {
        // continue
      } else if (attr.toFunction) {
          definition[key] = attr.toFunction();
        } else {
          definition[key] = attr;
        }
    });

    return definition;
  }

  function create(definition) {
    var copy = undefined;

    copy = preProcess(definition);
    copy = setScopes(copy);
    copy = buildTree(copy);
    copy = buildPageObject(copy);

    return copy;
  }

  function build(definition) {
    _ember['default'].deprecate('`build` is deprecated in favor of `create`.');

    return create(definition);
  }
});
/* global wait */
define('pilas-engine-bloques/tests/page-object/descriptor', ['exports', 'ember', 'pilas-engine-bloques/tests/page-object/property'], function (exports, _ember, _pilasEngineBloquesTestsPageObjectProperty) {
  var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

  var copy = _ember['default'].copy,
      isFunction = _ember['default'].$.isFunction;

  /**
   * Represents a definition of a property
   */

  var Descriptor = (function () {
    function Descriptor(action, options) {
      var preProcess = arguments.length <= 2 || arguments[2] === undefined ? null : arguments[2];

      _classCallCheck(this, Descriptor);

      this.action = action;
      this.options = options;
      this.preProcess = preProcess;
    }

    _createClass(Descriptor, [{
      key: 'propertyFor',
      value: function propertyFor(target, key) {
        // don't mutate options hash
        var optionsCopy = copy(this.options);

        if (isFunction(this.preProcess)) {
          this.preProcess(target, key, optionsCopy);
        }

        return new _pilasEngineBloquesTestsPageObjectProperty['default'](target, key, optionsCopy, this.action);
      }
    }]);

    return Descriptor;
  })();

  exports['default'] = Descriptor;
});
define('pilas-engine-bloques/tests/page-object/helpers', ['exports', 'ember'], function (exports, _ember) {
  exports.qualifySelector = qualifySelector;
  exports.findElementWithAssert = findElementWithAssert;
  exports.findElement = findElement;
  exports.trim = trim;
  exports.indexedSelector = indexedSelector;
  var $ = _ember['default'].$;

  function qualifySelector() {
    for (var _len = arguments.length, selectors = Array(_len), _key = 0; _key < _len; _key++) {
      selectors[_key] = arguments[_key];
    }

    return selectors.filter(function (item) {
      return !!item;
    }).join(' ');
  }

  function findElementWithAssert(options, target) {
    var selector = qualifySelector(options.scope || target.scope, indexedSelector(options.selector, options.index));

    /* global findWithAssert */
    return findWithAssert(selector);
  }

  function findElement(options, target) {
    var selector = qualifySelector(options.scope || target.scope, indexedSelector(options.selector, options.index));

    /* global find */
    return find(selector);
  }

  /**
   * Trim whitespaces at both ends and normalize whitespaces inside `text`
   *
   * Due to variations in the HTML parsers in different browsers, the text
   * returned may vary in newlines and other white space.
   *
   * @see http://api.jquery.com/text/
   */

  function trim(text) {
    return _ember['default'].$.trim(text).replace(/\n/g, ' ').replace(/\s\s*/g, ' ');
  }

  function indexedSelector(baseSelector, index) {
    var selector = undefined;

    if ($.isNumeric(index) && index > 0) {
      selector = baseSelector + ':eq(' + (index - 1) + ')';
    } else {
      selector = baseSelector;
    }

    return selector;
  }
});
define('pilas-engine-bloques/tests/page-object/properties/attribute', ['exports', 'pilas-engine-bloques/tests/page-object/descriptor', 'pilas-engine-bloques/tests/page-object/helpers'], function (exports, _pilasEngineBloquesTestsPageObjectDescriptor, _pilasEngineBloquesTestsPageObjectHelpers) {
  exports['default'] = attribute;

  /**
   * Gets the value of an attribute from an element
   *
   * @param {Object} target - Component that owns the property
   * @param {string} key - Name of the key associated to this property
   * @param {Object} options - Additional options
   * @param {string} selector - CSS selector of the element to check
   * @param {string} options.attributeName - Name of the attribute to get
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @return {string} value of the attribute
   */
  function getAttribute(target, key, options) {
    var element = (0, _pilasEngineBloquesTestsPageObjectHelpers.findElementWithAssert)(options, target);

    return element.attr(options.attributeName);
  }

  /**
   * Creates a predicate to get an attribute of an element
   *
   * @example
   *
   *   var page = PageObject.create({
   *     imageAlternateText: attribute('alt', '.img')
   *   });
   *
   *   assert.equal(page.imageAlternateText(), 'Logo');
   *
   * @param {string} attributeName - Name of the attribute to get
   * @param {string} selector - CSS selector of the element to check
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @return {Descriptor}
   */

  function attribute(attributeName, selector) {
    var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

    options.attributeName = attributeName;
    options.selector = selector;

    return new _pilasEngineBloquesTestsPageObjectDescriptor['default'](getAttribute, options);
  }
});
define('pilas-engine-bloques/tests/page-object/properties/click-on-text', ['exports', 'pilas-engine-bloques/tests/page-object/descriptor', 'pilas-engine-bloques/tests/page-object/helpers'], function (exports, _pilasEngineBloquesTestsPageObjectDescriptor, _pilasEngineBloquesTestsPageObjectHelpers) {
  exports['default'] = clickOnText;

  /**
   * Clicks an element by text
   *
   * @param {Object} target - Component that owns the property
   * @param {string} key - Name of the key associated to this property
   * @param {Object} options - Additional options
   * @param {string} options.selector - CSS selector of the container of the element to click
   * @param {string} options.scope - Overrides parent scope
   * @param {string} textToClick - Text to find the element to click
   * @return {Object} target component (this allows chaining)
   */
  function doClick(target, key, options, textToClick) {
    // Suppose that we have something like `<form><button>Submit</button></form>`
    // In this case <form> and <button> elements contains "Submit" text, so, we'll
    // want to __always__ click on the __last__ element that contains the text.
    var selector = (0, _pilasEngineBloquesTestsPageObjectHelpers.qualifySelector)(options.scope || target.scope, options.selector, ':contains("' + textToClick + '"):last');

    click(selector);

    return target;
  }

  /**
   * Creates an action to click an element
   *
   * @example
   *
   *   var page = PageObject.create({
   *     click: clickOnText('button[type=submit]')
   *   });
   *
   *   page.click('Save');
   *
   * @param {string} selector - CSS selector of the element to click
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @return {Descriptor}
   */

  function clickOnText(selector) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    options.selector = selector;

    return new _pilasEngineBloquesTestsPageObjectDescriptor['default'](doClick, options);
  }
});
/* global click */
define('pilas-engine-bloques/tests/page-object/properties/clickable', ['exports', 'pilas-engine-bloques/tests/page-object/descriptor', 'pilas-engine-bloques/tests/page-object/helpers'], function (exports, _pilasEngineBloquesTestsPageObjectDescriptor, _pilasEngineBloquesTestsPageObjectHelpers) {
  exports['default'] = clickable;

  /**
   * Clicks an element
   *
   * @param {Object} target - Component that owns the property
   * @param {string} key - Name of the key associated to this property
   * @param {Object} options - Additional options
   * @param {string} options.selector - CSS selector of the element to click
   * @param {string} options.scope - Overrides parent scope
   * @return {Object} target component (this allows chaining)
   */
  function doClick(target, key, options) {
    var selector = (0, _pilasEngineBloquesTestsPageObjectHelpers.qualifySelector)(options.scope || target.scope, options.selector);

    click(selector);

    return target;
  }

  /**
   * Creates an action to click an element
   *
   * @example
   *
   *   var page = PageObject.create({
   *     submit: clickable('button[type=submit]')
   *   });
   *
   *   page.submit();
   *
   * @param {string} selector - CSS selector of the element to click
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @return {Descriptor}
   */

  function clickable(selector) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    options.selector = selector;

    return new _pilasEngineBloquesTestsPageObjectDescriptor['default'](doClick, options);
  }
});
/* global click */
define('pilas-engine-bloques/tests/page-object/properties/component', ['exports', 'ember'], function (exports, _ember) {
  exports['default'] = component;

  function component(definition) {
    _ember['default'].deprecate('`component` is deprecated in favor of using plain JavaScript objects');

    return {
      unfoldPageObjectDefinition: function unfoldPageObjectDefinition() {
        return definition;
      }
    };
  }
});
define('pilas-engine-bloques/tests/page-object/properties/contains', ['exports', 'pilas-engine-bloques/tests/page-object/descriptor', 'pilas-engine-bloques/tests/page-object/helpers'], function (exports, _pilasEngineBloquesTestsPageObjectDescriptor, _pilasEngineBloquesTestsPageObjectHelpers) {
  exports['default'] = contains;

  /**
   * Checks if an element has a subtext
   *
   * @param {Object} target - Component that owns the property
   * @param {string} key - Name of the key associated to this property
   * @param {Object} options - Additional options
   * @param {string} options.selector - CSS selector of the element to check
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @param {number} textToSearch - Text to search
   * @return {Boolean} true if the element has a subtext
   */
  function doContains(target, key, options, textToSearch) {
    var element = (0, _pilasEngineBloquesTestsPageObjectHelpers.findElementWithAssert)(options, target);

    return element.text().indexOf(textToSearch) >= 0;
  }

  /**
   * Creates a predicate to validate if an element contains a subtext
   *
   * @example
   *   <h1> Page Title </h1>
   *
   *   var page = PageObject.create({
   *     titleIncludes: contains('h1')
   *   });
   *
   *   assert.ok(page.titleIncludes('Page'));
   *
   * @param {string} selector - CSS selector of the element to check
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @return {Descriptor}
   */

  function contains(selector) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    options.selector = selector;

    return new _pilasEngineBloquesTestsPageObjectDescriptor['default'](doContains, options);
  }
});
define('pilas-engine-bloques/tests/page-object/properties/count', ['exports', 'pilas-engine-bloques/tests/page-object/descriptor', 'pilas-engine-bloques/tests/page-object/helpers'], function (exports, _pilasEngineBloquesTestsPageObjectDescriptor, _pilasEngineBloquesTestsPageObjectHelpers) {
  exports['default'] = count;

  /**
   * Gets the count of matched elements
   *
   * @param {Object} target - Component that owns the property
   * @param {string} key - Name of the key associated to this property
   * @param {Object} options - Additional options
   * @param {string} selector - CSS selector of the element to check
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @return {string} value of the attribute
   */
  function getCount(target, key, options) {
    var element = (0, _pilasEngineBloquesTestsPageObjectHelpers.findElement)(options, target);

    return element.length;
  }

  /**
   * Creates a predicate to get the count of matched elements
   *
   * @example
   *
   *   var page = PageObject.create({
   *     imageCount: count('.img')
   *   });
   *
   *   assert.equal(page.imageCount(), 2);
   *
   * @param {string} selector - CSS selector of the element to check
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @return {Descriptor}
   */

  function count(selector) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    options.selector = selector;

    return new _pilasEngineBloquesTestsPageObjectDescriptor['default'](getCount, options);
  }
});
define('pilas-engine-bloques/tests/page-object/properties/custom-helper', ['exports', 'pilas-engine-bloques/tests/page-object/create', 'pilas-engine-bloques/tests/page-object/descriptor', 'ember', 'pilas-engine-bloques/tests/page-object/helpers'], function (exports, _pilasEngineBloquesTestsPageObjectCreate, _pilasEngineBloquesTestsPageObjectDescriptor, _ember, _pilasEngineBloquesTestsPageObjectHelpers) {
  exports['default'] = customHelper;
  var $ = _ember['default'].$;

  function action(target, key, options) {
    var selector = (0, _pilasEngineBloquesTestsPageObjectHelpers.qualifySelector)(options.scope || target.scope, options.selector);

    var response = options.userDefinedFunction(selector, options);

    if ($.isPlainObject(response)) {
      var definition = $.extend({ scope: selector }, response);

      return (0, _pilasEngineBloquesTestsPageObjectCreate.create)(definition);
    } else if ($.isFunction(response)) {
      for (var _len = arguments.length, args = Array(_len > 3 ? _len - 3 : 0), _key = 3; _key < _len; _key++) {
        args[_key - 3] = arguments[_key];
      }

      return response.apply(undefined, args);
    } else {
      return response;
    }
  }

  function customHelper(userDefinedFunction) {
    return function (selector) {
      var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

      options.selector = selector;
      options.userDefinedFunction = userDefinedFunction;

      return new _pilasEngineBloquesTestsPageObjectDescriptor['default'](action, options);
    };
  }
});
define('pilas-engine-bloques/tests/page-object/properties/fillable', ['exports', 'pilas-engine-bloques/tests/page-object/descriptor', 'pilas-engine-bloques/tests/page-object/helpers'], function (exports, _pilasEngineBloquesTestsPageObjectDescriptor, _pilasEngineBloquesTestsPageObjectHelpers) {
  exports['default'] = fillable;

  /**
   * Fills in an input
   *
   * @param {Object} target - Component that owns the property
   * @param {string} key - Name of the key associated to this property
   * @param {Object} options - Additional options
   * @param {string} options.selector - CSS selector of the element to fill
   * @param {string} options.scope - Overrides parent scope
   * @param {string} textToUse - Text to use to fill the input
   * @return {Object} target component (this allows chaining)
   */
  function doFillIn(target, key, options, textToUse) {
    var selector = (0, _pilasEngineBloquesTestsPageObjectHelpers.qualifySelector)(options.scope || target.scope, options.selector);

    fillIn(selector, textToUse);

    return target;
  }

  /**
   * Creates an action to fill in an input
   *
   * @example
   *
   *   var page = PageObject.create({
   *     name: fillable('#name')
   *   });
   *
   *   page.name('John Doe');
   *
   * @param {string} selector - CSS selector of the element to fill
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @return {Descriptor}
   */

  function fillable(selector) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    options.selector = selector;

    return new _pilasEngineBloquesTestsPageObjectDescriptor['default'](doFillIn, options);
  }
});
/* global fillIn */
define('pilas-engine-bloques/tests/page-object/properties/has-class', ['exports', 'pilas-engine-bloques/tests/page-object/descriptor', 'pilas-engine-bloques/tests/page-object/helpers'], function (exports, _pilasEngineBloquesTestsPageObjectDescriptor, _pilasEngineBloquesTestsPageObjectHelpers) {
  exports['default'] = hasClass;

  /**
   * Checks if an element has the CSS class name
   *
   * @param {Object} target - Component that owns the property
   * @param {string} key - Name of the key associated to this property
   * @param {Object} options - Additional options
   * @param {string} selector - CSS selector of the element to check
   * @param {string} options.cssClass - Name of the CSS class to look for
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @return {Boolean} true if the element has the CSS class
   */
  function doHasClass(target, key, options) {
    var element = (0, _pilasEngineBloquesTestsPageObjectHelpers.findElementWithAssert)(options, target);

    return element.hasClass(options.cssClass);
  }

  /**
   * Creates a predicate to validate if an element has a given CSS class
   *
   * @example
   *
   *   var page = PageObject.create({
   *     isImageActive: hasClass('is-active', '.img')
   *   });
   *
   *   assert.ok(page.isImageActive(), 'Image is active');
   *
   * @param {string} cssClass - Name of the CSS class to look for
   * @param {string} selector - CSS selector of the element to check
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @return {Descriptor}
   */

  function hasClass(cssClass, selector) {
    var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

    options.cssClass = cssClass;
    options.selector = selector;

    return new _pilasEngineBloquesTestsPageObjectDescriptor['default'](doHasClass, options);
  }
});
define('pilas-engine-bloques/tests/page-object/properties/is-hidden', ['exports', 'pilas-engine-bloques/tests/page-object/descriptor', 'pilas-engine-bloques/tests/page-object/helpers'], function (exports, _pilasEngineBloquesTestsPageObjectDescriptor, _pilasEngineBloquesTestsPageObjectHelpers) {
  exports['default'] = isHidden;

  /**
   * Checks if an element is hidden
   *
   * @param {Object} target - Component that owns the property
   * @param {string} key - Name of the key associated to this property
   * @param {Object} options - Additional options
   * @param {string} selector - CSS selector of the element to check
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @return {Boolean} true if the element is hidden
   */
  function doIsHidden(target, key, options) {
    var element = (0, _pilasEngineBloquesTestsPageObjectHelpers.findElement)(options, target);

    return element.length > 0 ? element.is(':hidden') : true;
  }

  /**
   * Creates a predicate to validate if an element is hidden
   *
   * @example
   *
   *   var page = PageObject.create({
   *     isImageVisible: isVisible('.img')
   *   });
   *
   *   assert.ok(page.isImageVisible(), 'Image is visible');
   *
   * @param {string} selector - CSS selector of the element to check
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @return {Descriptor}
   */

  function isHidden(selector) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    options.selector = selector;

    return new _pilasEngineBloquesTestsPageObjectDescriptor['default'](doIsHidden, options);
  }
});
define('pilas-engine-bloques/tests/page-object/properties/is-visible', ['exports', 'pilas-engine-bloques/tests/page-object/descriptor', 'pilas-engine-bloques/tests/page-object/helpers'], function (exports, _pilasEngineBloquesTestsPageObjectDescriptor, _pilasEngineBloquesTestsPageObjectHelpers) {
  exports['default'] = isVisible;

  /**
   * Checks if an element is visible
   *
   * @param {Object} target - Component that owns the property
   * @param {string} key - Name of the key associated to this property
   * @param {Object} options - Additional options
   * @param {string} selector - CSS selector of the element to check
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @return {Boolean} true if the element is visible
   */
  function doIsVisible(target, key, options) {
    var element = (0, _pilasEngineBloquesTestsPageObjectHelpers.findElementWithAssert)(options, target);

    return element.is(':visible');
  }

  /**
   * Creates a predicate to validate if an element is visible
   *
   * @example
   *
   *   var page = PageObject.create({
   *     isImageVisible: isVisible('.img')
   *   });
   *
   *   assert.ok(page.isImageVisible(), 'Image is visible');
   *
   * @param {string} selector - CSS selector of the element to check
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @return {Descriptor}
   */

  function isVisible(selector) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    options.selector = selector;

    return new _pilasEngineBloquesTestsPageObjectDescriptor['default'](doIsVisible, options);
  }
});
define('pilas-engine-bloques/tests/page-object/properties/not-has-class', ['exports', 'pilas-engine-bloques/tests/page-object/descriptor', 'pilas-engine-bloques/tests/page-object/helpers'], function (exports, _pilasEngineBloquesTestsPageObjectDescriptor, _pilasEngineBloquesTestsPageObjectHelpers) {
  exports['default'] = notHasClass;

  /**
   * Checks if an element doesn't have the CSS class name
   *
   * @param {Object} target - Component that owns the property
   * @param {string} key - Name of the key associated to this property
   * @param {Object} options - Additional options
   * @param {string} options.selector - CSS selector of the container of the element to click
   * @param {string} options.cssClass - Name of the CSS class to look for
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @return {Boolean} true if the element doesn't have the CSS class
   */
  function doNotHasClass(target, key, options) {
    var element = (0, _pilasEngineBloquesTestsPageObjectHelpers.findElementWithAssert)(options, target);

    return !element.hasClass(options.cssClass);
  }

  /**
   * Creates a predicate to validate if an element doesn't have a given CSS class
   *
   * @example
   *
   *   var page = PageObject.create({
   *     isImageDeactivated: notHasClass('is-active', '.img')
   *   });
   *
   *   assert.ok(page.isImageDeactivated(), 'Image is not active');
   *
   * @param {string} cssClass - Name of the CSS class to look for
   * @param {string} selector - CSS selector of the element to check
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @return {Descriptor}
   */

  function notHasClass(cssClass, selector) {
    var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

    options.cssClass = cssClass;
    options.selector = selector;

    return new _pilasEngineBloquesTestsPageObjectDescriptor['default'](doNotHasClass, options);
  }
});
define('pilas-engine-bloques/tests/page-object/properties/text-list', ['exports', 'ember', 'pilas-engine-bloques/tests/page-object/descriptor', 'pilas-engine-bloques/tests/page-object/helpers'], function (exports, _ember, _pilasEngineBloquesTestsPageObjectDescriptor, _pilasEngineBloquesTestsPageObjectHelpers) {
  exports['default'] = textList;

  /**
   * Gets an array whose members are matched elements' text
   *
   * @param {Object} target - Component that owns the property
   * @param {string} key - Name of the key associated to this property
   * @param {Object} options - Additional options
   * @param {string} options.selector - CSS selector of the element to check
   * @param {string} options.scope - Overrides parent scope
   * @return {array} array of text strings for the selected elements
   */
  function getTextList(target, key, options) {
    var elements = (0, _pilasEngineBloquesTestsPageObjectHelpers.findElementWithAssert)(options, target);

    var textStrings = new Array(elements.length);
    for (var i = 0, l = textStrings.length; i < l; i++) {
      textStrings[i] = (0, _pilasEngineBloquesTestsPageObjectHelpers.trim)(_ember['default'].$(elements[i]).text());
    }
    return textStrings;
  }

  /**
   * Creates a predicate to get the text of each matched elements as an array element
   *
   * @example
   *
   *   var page = PageObject.create({
   *     movieTitles: textList('ul.movies li')
   *   });
   *
   *   assert.equal(page.movieTitles(), ['Ran', 'Apocalyse Now','Star Wars']);
   *
   * @param {string} selector - CSS selector of the element to check
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @return {Descriptor}
   */

  function textList(selector) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    options.selector = selector;

    return new _pilasEngineBloquesTestsPageObjectDescriptor['default'](getTextList, options);
  }
});
define('pilas-engine-bloques/tests/page-object/properties/text', ['exports', 'pilas-engine-bloques/tests/page-object/descriptor', 'pilas-engine-bloques/tests/page-object/helpers'], function (exports, _pilasEngineBloquesTestsPageObjectDescriptor, _pilasEngineBloquesTestsPageObjectHelpers) {
  exports['default'] = text;

  /**
   * Gets the text of the matched element
   *
   * @param {Object} target - Component that owns the property
   * @param {string} key - Name of the key associated to this property
   * @param {Object} options - Additional options
   * @param {string} selector - CSS selector of the element to check
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @return {string} value of the attribute
   */
  function getText(target, key, options) {
    var element = (0, _pilasEngineBloquesTestsPageObjectHelpers.findElementWithAssert)(options, target);

    return (0, _pilasEngineBloquesTestsPageObjectHelpers.trim)(element.text());
  }

  /**
   * Creates a predicate to get the text of the matched element
   *
   * @example
   *
   *   var page = PageObject.create({
   *     title: text('h1')
   *   });
   *
   *   assert.equal(page.title(), 'Page title');
   *
   * @param {string} selector - CSS selector of the element to check
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @return {Descriptor}
   */

  function text(selector) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    options.selector = selector;

    return new _pilasEngineBloquesTestsPageObjectDescriptor['default'](getText, options);
  }
});
define('pilas-engine-bloques/tests/page-object/properties/value', ['exports', 'pilas-engine-bloques/tests/page-object/descriptor', 'pilas-engine-bloques/tests/page-object/helpers'], function (exports, _pilasEngineBloquesTestsPageObjectDescriptor, _pilasEngineBloquesTestsPageObjectHelpers) {
  exports['default'] = value;

  /**
   * Gets the value of the matched element
   *
   * @param {Object} target - Component that owns the property
   * @param {string} key - Name of the key associated to this property
   * @param {Object} options - Additional options
   * @param {string} selector - CSS selector of the element to check
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @return {string} value of the element
   */
  function getValue(target, key, options) {
    var element = (0, _pilasEngineBloquesTestsPageObjectHelpers.findElementWithAssert)(options, target);

    return (0, _pilasEngineBloquesTestsPageObjectHelpers.trim)(element.val());
  }

  /**
   * Creates a predicate to get the value of the matched element
   *
   * @example
   *
   *   var page = PageObject.create({
   *     name: value('#name')
   *   });
   *
   *   assert.equal(page.name(), 'John Doe');
   *
   * @param {string} selector - CSS selector of the element to check
   * @param {Object} options - Additional options
   * @param {string} options.scope - Overrides parent scope
   * @param {number} options.index - Reduce the set of matched elements to the one at the specified index
   * @return {Descriptor}
   */

  function value(selector) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    options.selector = selector;

    return new _pilasEngineBloquesTestsPageObjectDescriptor['default'](getValue, options);
  }
});
define('pilas-engine-bloques/tests/page-object/properties/visitable', ['exports', 'ember', 'pilas-engine-bloques/tests/page-object/descriptor'], function (exports, _ember, _pilasEngineBloquesTestsPageObjectDescriptor) {
  exports['default'] = visitable;

  function fillInDynamicSegments(path, params) {
    return path.split('/').map(function (segment) {
      var match = segment.match(/^:(.+)$/);

      if (match) {
        var key = match[1];

        if (!params[key]) {
          throw new Error('Missing parameter for \'' + key + '\'');
        }

        return params[key];
      }

      return segment;
    }).join('/');
  }

  /**
   * Loads a path
   *
   * @param {Object} target - Component that owns the property
   * @param {string} key - Name of the key associated to this property
   * @param {Object} options - Additional options
   * @param {Object} params - Key and values to use to replace the dynamic segments
   * @param {Object} queryParams - Key and values to use as the Query Params
   * @return {Object} target component (this allows chaining)
   */
  function doVisit(target, key, options) {
    var params = arguments.length <= 3 || arguments[3] === undefined ? {} : arguments[3];
    var queryParams = arguments.length <= 4 || arguments[4] === undefined ? {} : arguments[4];

    var path = options.path;

    if (path.indexOf(':') !== -1) {
      path = fillInDynamicSegments(path, params);
    }

    if (Object.keys(queryParams).length > 0) {
      path += "?" + _ember['default'].$.param(queryParams);
    }

    visit(path);

    return target;
  }

  /**
   * Creates an action to load a path
   *
   * @example
   *
   *   var page = PageObject.create({
   *     visit: visitalbe('/users')
   *   });
   *
   *   page.visit();
   *
   * @param {string} path - Full path of the route to visit
   * @return {Descriptor}
   */

  function visitable(path) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    options.path = path;

    return new _pilasEngineBloquesTestsPageObjectDescriptor['default'](doVisit, options);
  }
});
/* global visit */
define("pilas-engine-bloques/tests/page-object/property", ["exports"], function (exports) {
  var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  /**
   * Represents a definition of a property associated to a target object
   */

  var Property = (function () {
    function Property(target, key, options, action) {
      _classCallCheck(this, Property);

      this.target = target;
      this.key = key;
      this.options = options;
      this.action = action;
    }

    _createClass(Property, [{
      key: "invoke",
      value: function invoke() {
        for (var _len = arguments.length, params = Array(_len), _key = 0; _key < _len; _key++) {
          params[_key] = arguments[_key];
        }

        return this.action.apply(this, [this.target, this.key, this.options].concat(params));
      }
    }, {
      key: "toFunction",
      value: function toFunction() {
        var property = this;

        return function () {
          return property.invoke.apply(property, arguments);
        };
      }
    }]);

    return Property;
  })();

  exports["default"] = Property;
});
define('pilas-engine-bloques/tests/pages/acerca-de', ['exports', 'pilas-engine-bloques/tests/page-object'], function (exports, _pilasEngineBloquesTestsPageObject) {
  var visitable = _pilasEngineBloquesTestsPageObject['default'].visitable;
  var text = _pilasEngineBloquesTestsPageObject['default'].text;
  var count = _pilasEngineBloquesTestsPageObject['default'].count;
  exports['default'] = _pilasEngineBloquesTestsPageObject['default'].create({
    scope: '.contenido-principal',
    visit: visitable('/acercade'),
    titulo: text("h1"),

    cantidadDeBotones: count('button')
  });
});
define('pilas-engine-bloques/tests/pages/acerca-de.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | pages/acerca-de.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'pages/acerca-de.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/pages/desafios', ['exports', 'pilas-engine-bloques/tests/page-object'], function (exports, _pilasEngineBloquesTestsPageObject) {
  var visitable = _pilasEngineBloquesTestsPageObject['default'].visitable;
  var count = _pilasEngineBloquesTestsPageObject['default'].count;
  exports['default'] = _pilasEngineBloquesTestsPageObject['default'].create({
    visit: visitable('/desafios'),
    cantidadDeDesafiosDisponibles: count('.desafio a')
  });
});
define('pilas-engine-bloques/tests/pages/desafios.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | pages/desafios.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'pages/desafios.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/pages/principal', ['exports', 'pilas-engine-bloques/tests/page-object'], function (exports, _pilasEngineBloquesTestsPageObject) {
  var visitable = _pilasEngineBloquesTestsPageObject['default'].visitable;
  var count = _pilasEngineBloquesTestsPageObject['default'].count;
  var text = _pilasEngineBloquesTestsPageObject['default'].text;
  exports['default'] = _pilasEngineBloquesTestsPageObject['default'].create({
    scope: '.contenido-principal',
    visit: visitable('/'),
    tituloModal: text('h4', { scope: '.ember-modal-dialog', resetScope: true }),

    cantidadDeImagenes: count('img'),
    cantidadDeLinks: count('a'),

    abrirAyuda: function abrirAyuda() {
      click("button#abrir-ayuda");
      return this;
    },

    cerrarDialogo: function cerrarDialogo() {
      click("button#cerrar-modal");
      return this;
    },

    abrirOpciones: function abrirOpciones() {
      click("button#abrir-opciones");
      return this;
    }

  });
});
define('pilas-engine-bloques/tests/pages/principal.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | pages/principal.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'pages/principal.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/resolver.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | resolver.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'resolver.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/router.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | router.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'router.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/routes/acercade.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | routes/acercade.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'routes/acercade.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/routes/desafio.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | routes/desafio.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'routes/desafio.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/routes/desafios/curso-alumno.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | routes/desafios/curso-alumno.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'routes/desafios/curso-alumno.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/routes/desafios/curso-docente.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | routes/desafios/curso-docente.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'routes/desafios/curso-docente.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/routes/desafios/desafio-por-nombre.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | routes/desafios/desafio-por-nombre.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'routes/desafios/desafio-por-nombre.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/routes/desafios/index.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | routes/desafios/index.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'routes/desafios/index.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/routes/desafios/mensaje-guardado.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | routes/desafios/mensaje-guardado.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'routes/desafios/mensaje-guardado.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/routes/index.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | routes/index.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'routes/index.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/services/actividades.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | services/actividades.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'services/actividades.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/services/curso-api.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | services/curso-api.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'services/curso-api.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/services/notificador.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | services/notificador.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'services/notificador.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/services/pilas.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | services/pilas.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'services/pilas.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/services/twitter.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | services/twitter.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'services/twitter.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/services/zoom.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | services/zoom.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'services/zoom.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/test-helper', ['exports', 'pilas-engine-bloques/tests/helpers/resolver', 'pilas-engine-bloques/tests/helpers/responsive', 'ember-qunit'], function (exports, _pilasEngineBloquesTestsHelpersResolver, _pilasEngineBloquesTestsHelpersResponsive, _emberQunit) {
  /* global QUnit */

  QUnit.config.testTimeout = 100 * 60 * 1000; // 60000 es el valor por omisión =
  (0, _emberQunit.setResolver)(_pilasEngineBloquesTestsHelpersResolver['default']);
});
define('pilas-engine-bloques/tests/test-helper.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | test-helper.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'test-helper.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/unit/controllers/acercade-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleFor)('controller:acercade', 'Unit | Controller | acercade', {
    // Specify the other units that are required for this test.
    // needs: ['controller:foo']
  });

  // Replace this with your real tests.
  (0, _emberQunit.test)('it exists', function (assert) {
    var controller = this.subject();
    assert.ok(controller);
  });
});
define('pilas-engine-bloques/tests/unit/controllers/acercade-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | unit/controllers/acercade-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/controllers/acercade-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/unit/controllers/test-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleFor)('controller:test', {
    // Specify the other units that are required for this test.
    // needs: ['controller:foo']
  });

  // Replace this with your real tests.
  (0, _emberQunit.test)('it exists', function (assert) {
    var controller = this.subject();
    assert.ok(controller);
  });
});
define('pilas-engine-bloques/tests/unit/controllers/test-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | unit/controllers/test-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/controllers/test-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/unit/helpers/prism-test', ['exports', 'pilas-engine-bloques/helpers/prism', 'qunit'], function (exports, _pilasEngineBloquesHelpersPrism, _qunit) {

  (0, _qunit.module)('Unit | Helper | prism');

  // Replace this with your real tests.
  (0, _qunit.test)('it works', function (assert) {

    var result = (0, _pilasEngineBloquesHelpersPrism.prism)(["hola"]);
    assert.equal(result, "hola", "Retorna el mismo texto si no hay nada de sintaxis especial.");

    var result_code = (0, _pilasEngineBloquesHelpersPrism.prism)(["var hola"]);
    assert.equal(result_code.toString(), '<span class="token keyword" >var</span> hola', "Puede generar codigo html desde la sintaxis.");
  });
});
define('pilas-engine-bloques/tests/unit/helpers/prism-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | unit/helpers/prism-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/helpers/prism-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/unit/models/desafio-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleForModel)('desafio', 'Unit | Model | desafio', {
    // Specify the other units that are required for this test.
    needs: ['model:grupo']
  });

  (0, _emberQunit.test)('it exists', function (assert) {
    var model = this.subject();
    // let store = this.store();
    assert.ok(!!model);
  });
});
define('pilas-engine-bloques/tests/unit/models/desafio-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | unit/models/desafio-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/models/desafio-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/unit/routes/acercade-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleFor)('route:acercade', 'Unit | Route | acercade', {
    // Specify the other units that are required for this test.
    // needs: ['controller:foo']
  });

  (0, _emberQunit.test)('it exists', function (assert) {
    var route = this.subject();
    assert.ok(route);
  });
});
define('pilas-engine-bloques/tests/unit/routes/acercade-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | unit/routes/acercade-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/routes/acercade-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/unit/routes/desafio-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleFor)('route:desafio', 'Unit | Route | desafio', {
    // Specify the other units that are required for this test.
    // needs: ['controller:foo']
  });

  (0, _emberQunit.test)('it exists', function (assert) {
    var route = this.subject();
    assert.ok(route);
  });
});
define('pilas-engine-bloques/tests/unit/routes/desafio-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | unit/routes/desafio-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/routes/desafio-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/unit/routes/index-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleFor)('route:index', 'Unit | Route | index', {
    // Specify the other units that are required for this test.
    // needs: ['controller:foo']
  });

  (0, _emberQunit.test)('it exists', function (assert) {
    var route = this.subject();
    assert.ok(route);
  });
});
define('pilas-engine-bloques/tests/unit/routes/index-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | unit/routes/index-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/routes/index-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/unit/services/actividades-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleFor)('service:actividades', 'Unit | Service | actividades', {
    // Specify the other units that are required for this test.
    // needs: ['service:foo']
  });

  // Replace this with your real tests.
  (0, _emberQunit.test)('it exists', function (assert) {
    var service = this.subject();
    assert.ok(service);
  });
});
define('pilas-engine-bloques/tests/unit/services/actividades-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | unit/services/actividades-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/services/actividades-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/unit/services/notificador-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleFor)('service:notificador', 'Unit | Service | notificador', {});

  // Replace this with your real tests.
  (0, _emberQunit.test)('it exists', function (assert) {
    var service = this.subject();

    assert.ok(service);

    assert.ok(service.esVersionAnterior("1.0.0", "1.1.1"), "La versión 1.1.1 es superior a la 1.0.0.");
    assert.ok(service.esVersionAnterior("1.0.0", "2.0.0"), "La versión 2.0.0 es superior a la 1.0.0.");
    assert.ok(service.esVersionAnterior("1.0.0", "2"), "La versión 2 es superior a la 1.0.0.");

    assert.notOk(service.esVersionAnterior("1.0.0", "1"), "Es la misma versión, no hay que actualizar.");
    assert.notOk(service.esVersionAnterior("1.2.0", "1.0.0"), "Hay una versión más nueva en ejecución, no hay que actualizar.");

    assert.notOk(service.esVersionAnterior("1.0.1", "1.0.1+c6e44"), "Asume que son la misma versión, porque es una versión  en desarrollo.");
    assert.notOk(service.esVersionAnterior("1.0.1+a33ce", "1.0.1+c6e44"), "Asume que son la misma versión, porque es una versión  en desarrollo.");
    assert.notOk(service.esVersionAnterior("1.1.0+b398e2bc", "1.0.8"), "Mismo major, minor mayor, patch menor debe dar false");
  });
});
define('pilas-engine-bloques/tests/unit/services/notificador-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | unit/services/notificador-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/services/notificador-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/unit/services/pilas-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleFor)('service:pilas', 'Unit | Service | pilas', {
    // Specify the other units that are required for this test.
    // needs: ['service:foo']
  });

  // Replace this with your real tests.
  (0, _emberQunit.test)('it exists', function (assert) {
    var service = this.subject();
    assert.ok(service);
  });
});
define('pilas-engine-bloques/tests/unit/services/pilas-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | unit/services/pilas-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/services/pilas-test.js should pass jshint.');
  });
});
define('pilas-engine-bloques/tests/unit/services/zoom-test', ['exports', 'ember-qunit'], function (exports, _emberQunit) {

  (0, _emberQunit.moduleFor)('service:zoom', 'Unit | Service | zoom', {
    // Specify the other units that are required for this test.
    // needs: ['service:foo']
  });

  // Replace this with your real tests.
  (0, _emberQunit.test)('it exists', function (assert) {
    var service = this.subject();
    assert.ok(service);
  });
});
define('pilas-engine-bloques/tests/unit/services/zoom-test.jshint', ['exports'], function (exports) {
  'use strict';

  QUnit.module('JSHint | unit/services/zoom-test.js');
  QUnit.test('should pass jshint', function (assert) {
    assert.expect(1);
    assert.ok(true, 'unit/services/zoom-test.js should pass jshint.');
  });
});
/* jshint ignore:start */

require('pilas-engine-bloques/tests/test-helper');
EmberENV.TESTS_FILE_LOADED = true;

/* jshint ignore:end */
//# sourceMappingURL=tests.map
